
SET CURRENT SCHEMA $RIASSET;


CREATE TABLE ACTION_TYPE(
	ACTION_TYPE_ID INTEGER NOT NULL,
	REFERENCE_ID VARCHAR(50),
	EXTERNAL_ID VARCHAR(100),
	NAME VARCHAR(255) DEFAULT 'Action Name Missing' NOT NULL,
	EXTERNAL_KEY1 INTEGER DEFAULT -1 NOT NULL,                    
    EXTERNAL_KEY2 CHAR(40) DEFAULT '-1' NOT NULL,             
    SOURCE_ID VARCHAR(36) DEFAULT '-1' NOT NULL,              
    URL VARCHAR(2048),                                        
    REC_DATETIME TIMESTAMP DEFAULT NOT NULL,
    ISSOFTDELETED SMALLINT DEFAULT NOT NULL                 
)IN DATABASE $DBNAME; 

CREATE TABLE ASSET_ROLE (
	ASSET_ROLE_ID INTEGER NOT NULL,
	REFERENCE_ID VARCHAR(50),
	EXTERNAL_ID VARCHAR(100),
	NAME VARCHAR(255) DEFAULT 'Asset Role Name Missing' NOT NULL,
	PROJECT_ID INTEGER DEFAULT -1 NOT NULL,
	EXTERNAL_KEY1 INTEGER DEFAULT -1 NOT NULL,                    
    EXTERNAL_KEY2 CHAR(40) DEFAULT '-1' NOT NULL,             
    SOURCE_ID VARCHAR(36) DEFAULT '-1' NOT NULL,              
    URL VARCHAR(2048),                                        
    REC_DATETIME TIMESTAMP DEFAULT NOT NULL,
    ISSOFTDELETED SMALLINT DEFAULT NOT NULL                 
)IN DATABASE $DBNAME;      

CREATE TABLE ASSET_ROLE_RESOURCE_LOOKUP (
	ASSET_ROLE_ID INTEGER NOT NULL,
	RESOURCE_ID INTEGER NOT NULL
)IN DATABASE $DBNAME;	

CREATE TABLE ASSET_ROLE_TEAM_LOOKUP (
	ASSET_ROLE_ID INTEGER NOT NULL,
	TEAM_ID INTEGER NOT NULL
)IN DATABASE $DBNAME;	  

CREATE TABLE ASSET_ROLE_ASSIGNMENT_HISTORY (
	HISTORY_ID INTEGER NOT NULL,
	REFERENCE_ID VARCHAR(50),
	EXTERNAL_ID VARCHAR(100),
    ASSET_ROLE_ID INTEGER DEFAULT -1 NOT NULL,
    PROJECT_ID INTEGER DEFAULT -1 NOT NULL,
    TEAM_ID INTEGER DEFAULT -1 NOT NULL,
    ASSIGNEE_ID INTEGER DEFAULT -1 NOT NULL,
    ASSIGNER_ID INTEGER DEFAULT -1 NOT NULL,
    ACTION_TYPE_ID INTEGER DEFAULT -1 NOT NULL,
    ASSIGNMENT_DATE TIMESTAMP,
	EXTERNAL_KEY1 INTEGER DEFAULT -1 NOT NULL,                    
    EXTERNAL_KEY2 CHAR(40) DEFAULT '-1' NOT NULL,             
    SOURCE_ID VARCHAR(36) DEFAULT '-1' NOT NULL,              
    URL VARCHAR(2048),                                        
    REC_DATETIME TIMESTAMP DEFAULT NOT NULL,
    ISSOFTDELETED SMALLINT DEFAULT NOT NULL                 
)IN DATABASE $DBNAME;        

CREATE TABLE ENTITLEMENT (
	ENTITLEMENT_ID INTEGER NOT NULL,
	REFERENCE_ID VARCHAR(50),
	EXTERNAL_ID VARCHAR(100),
	NAME VARCHAR(255) DEFAULT 'Entitlement Name Missing' NOT NULL,
	EXTERNAL_KEY1 INTEGER DEFAULT -1 NOT NULL,                    
    EXTERNAL_KEY2 CHAR(40) DEFAULT '-1' NOT NULL,             
    SOURCE_ID VARCHAR(36) DEFAULT '-1' NOT NULL,              
    URL VARCHAR(2048),                                        
    REC_DATETIME TIMESTAMP DEFAULT NOT NULL,
    ISSOFTDELETED SMALLINT DEFAULT NOT NULL                 
)IN DATABASE $DBNAME;   

CREATE TABLE ENTITLEMENT_HISTORY (
	HISTORY_ID INTEGER NOT NULL,
	REFERENCE_ID VARCHAR(50),
	EXTERNAL_ID VARCHAR(100),
    ASSET_ROLE_ID INTEGER DEFAULT -1 NOT NULL,
    ACTION_TYPE_ID INTEGER DEFAULT -1 NOT NULL,
    CHANGE_DATE TIMESTAMP,
    RESOURCE_ID INTEGER DEFAULT -1 NOT NULL,
	EXTERNAL_KEY1 INTEGER DEFAULT -1 NOT NULL,                    
    EXTERNAL_KEY2 CHAR(40) DEFAULT '-1' NOT NULL,             
    SOURCE_ID VARCHAR(36) DEFAULT '-1' NOT NULL,              
    URL VARCHAR(2048),                                        
    REC_DATETIME TIMESTAMP DEFAULT NOT NULL,
    ISSOFTDELETED SMALLINT DEFAULT NOT NULL                 
)IN DATABASE $DBNAME; 


CREATE TABLE ENTITLEMENT_HISTORY_LOOKUP (
	HISTORY_ID INTEGER NOT NULL,
  	ENTITLEMENT_ID INTEGER NOT NULL,
  	ENTITLEMENT_TYPE VARCHAR(255) NOT NULL
)IN DATABASE $DBNAME;

CREATE TABLE ASSET_ROLE_ENTITLEMENT_LOOKUP(
	ASSET_ROLE_ID INTEGER NOT NULL,
	ENTITLEMENT_ID INTEGER NOT NULL
)IN DATABASE $DBNAME;

CREATE TABLE ASSET_LOOKUP(
	PRED_ASSET_ID INTEGER NOT NULL,
	SUCC_ASSET_ID INTEGER NOT NULL,
	LINK_TYPE VARCHAR(255)
)IN DATABASE $DBNAME;	

CREATE TABLE ASSET_TYPE (
	ASSET_TYPE_ID INTEGER NOT NULL,
	REFERENCE_ID VARCHAR(80),
	EXTERNAL_ID VARCHAR(100),
	NAME VARCHAR(255) DEFAULT 'Asset Type Name Missing' NOT NULL,
	EXTERNAL_KEY1 INTEGER DEFAULT -1 NOT NULL,                    
    EXTERNAL_KEY2 CHAR(80) DEFAULT '-1' NOT NULL,             
    SOURCE_ID VARCHAR(36) DEFAULT '-1' NOT NULL,              
    URL VARCHAR(2048),                                        
    REC_DATETIME TIMESTAMP DEFAULT NOT NULL,
    ISSOFTDELETED SMALLINT DEFAULT NOT NULL                 
)IN DATABASE $DBNAME; 

CREATE TABLE ASSET (
	ASSET_ID INTEGER NOT NULL,
	REFERENCE_ID VARCHAR(80),
	EXTERNAL_ID VARCHAR(100),
	NAME VARCHAR(255) DEFAULT 'Asset Name Missing' NOT NULL,
	PROJECT_ID INTEGER DEFAULT -1 NOT NULL,
	VERSION VARCHAR(255),
	ASSET_TYPE_ID INTEGER DEFAULT -1 NOT NULL,
	ASSET_STATE VARCHAR(255),
	LAST_MODIFIED TIMESTAMP,
	EXTERNAL_KEY1 INTEGER DEFAULT -1 NOT NULL,                    
    EXTERNAL_KEY2 CHAR(80) DEFAULT '-1' NOT NULL,             
    SOURCE_ID VARCHAR(36) DEFAULT '-1' NOT NULL,              
    URL VARCHAR(2048),                                        
    REC_DATETIME TIMESTAMP DEFAULT NOT NULL,
    ISSOFTDELETED SMALLINT DEFAULT NOT NULL                 
)IN DATABASE $DBNAME; 

CREATE TABLE ASSET_RESOURCE_LOOKUP(
		ASSET_ID INTEGER NOT NULL,
		OWNER_ID INTEGER NOT NULL
)IN DATABASE $DBNAME;	

CREATE TABLE ASSET_HISTORY (
	HISTORY_ID INTEGER NOT NULL,
	REFERENCE_ID VARCHAR(50),
	EXTERNAL_ID VARCHAR(100),
    ASSET_ID INTEGER NOT NULL,
    ACTION_TYPE_ID INTEGER DEFAULT -1 NOT NULL,
    RESOURCE_ID INTEGER DEFAULT -1 NOT NULL,
    ACTION_DATE TIMESTAMP,
	EXTERNAL_KEY1 INTEGER DEFAULT -1 NOT NULL,                    
    EXTERNAL_KEY2 CHAR(40) DEFAULT '-1' NOT NULL,             
    SOURCE_ID VARCHAR(36) DEFAULT '-1' NOT NULL,              
    URL VARCHAR(2048),                                        
    REC_DATETIME TIMESTAMP DEFAULT NOT NULL,
    ISSOFTDELETED SMALLINT DEFAULT NOT NULL                 
)IN DATABASE $DBNAME;
		                          
CREATE TABLE LICENSE_HISTORY (
	HISTORY_ID INTEGER NOT NULL,
	REFERENCE_ID VARCHAR(50),
	EXTERNAL_ID VARCHAR(100),
    ASSET_ID INTEGER DEFAULT -1 NOT NULL,
    ACTION_TYPE_ID INTEGER DEFAULT -1 NOT NULL,
    USAGE_DATE TIMESTAMP,
    RESOURCE_ID INTEGER DEFAULT -1 NOT NULL,
	EXTERNAL_KEY1 INTEGER DEFAULT -1 NOT NULL,                    
    EXTERNAL_KEY2 CHAR(40) DEFAULT '-1' NOT NULL,             
    SOURCE_ID VARCHAR(36) DEFAULT '-1' NOT NULL,              
    URL VARCHAR(2048),                                        
    REC_DATETIME TIMESTAMP DEFAULT NOT NULL,
    ISSOFTDELETED SMALLINT DEFAULT NOT NULL                 
)IN DATABASE $DBNAME; 

CREATE TABLE ASSET_REQUEST_LOOKUP(
	ASSET_ID INTEGER NOT NULL,
	REQUEST_ID INTEGER NOT NULL,
	LINK_TYPE VARCHAR(255)
)IN DATABASE $DBNAME;		   

CREATE TABLE ASSET_TESTCASE_LOOKUP(
	ASSET_ID INTEGER NOT NULL,
	TESTCASE_ID INTEGER NOT NULL,
	LINK_TYPE VARCHAR(255)
)IN DATABASE $DBNAME;		    

CREATE TABLE ASSET_TESTPLAN_LOOKUP(
	ASSET_ID INTEGER NOT NULL,
	TESTPLAN_ID INTEGER NOT NULL,
	LINK_TYPE VARCHAR(255)
)IN DATABASE $DBNAME;		  

CREATE TABLE ASSET_REQUIREMENT_LOOKUP(
	ASSET_ID INTEGER NOT NULL,
	REQUIREMENT_ID INTEGER NOT NULL,
	LINK_TYPE VARCHAR(255)
)IN DATABASE $DBNAME;		

CREATE TABLE ASSET_CATEGORY (
		ASSET_CATEGORY_ID INTEGER NOT NULL,
		REFERENCE_ID VARCHAR(50),
		EXTERNAL_ID VARCHAR(100),
		NAME VARCHAR(255) DEFAULT 'Asset Category Name Missing' NOT NULL,
		FULL_PATH VARCHAR (2048),
		ROOT_FLAG INTEGER DEFAULT NOT NULL,
		LEAF_FLAG INTEGER DEFAULT NOT NULL,
		EXTERNAL_KEY1 INTEGER DEFAULT -1 NOT NULL,
		EXTERNAL_KEY2 CHAR(40) DEFAULT '-1' NOT NULL,
		SOURCE_ID VARCHAR(36) DEFAULT '-1' NOT NULL,
		URL VARCHAR(2048),
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL,
		ISSOFTDELETED SMALLINT DEFAULT NOT NULL
)IN DATABASE $DBNAME;

CREATE TABLE ASSET_CAT_HIERARCHY (
		PARENT_CATEGORY_ID INTEGER NOT NULL,
		CHILD_CATEGORY_ID INTEGER NOT NULL
)IN DATABASE $DBNAME;

CREATE TABLE ASSET_ATTRIBUTE (
		ASSET_ATTRIBUTE_ID INTEGER NOT NULL,
		REFERENCE_ID VARCHAR(50),
		EXTERNAL_ID VARCHAR(100),
		NAME VARCHAR(255) DEFAULT 'Asset Attribute Name Missing' NOT NULL,
		ASSET_ID INTEGER DEFAULT -1 NOT NULL,
		EXTERNAL_KEY1 INTEGER DEFAULT -1 NOT NULL,
		EXTERNAL_KEY2 CHAR(40) DEFAULT '-1' NOT NULL,
		SOURCE_ID VARCHAR(36) DEFAULT '-1' NOT NULL,
		URL VARCHAR(2048),
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL,
		ISSOFTDELETED SMALLINT DEFAULT NOT NULL
)IN DATABASE $DBNAME;


CREATE TABLE ASSET_ATTRIBUTE_VALUE (
		ASSET_ATTRIBUTE_VALUE_ID INTEGER NOT NULL,
		REFERENCE_ID VARCHAR(50),
		EXTERNAL_ID VARCHAR(100),
		NAME VARCHAR(255) DEFAULT 'Asset Attribute Value Name Missing' NOT NULL,
		ASSET_ATTRIBUTE_ID INTEGER DEFAULT -1 NOT NULL,
		EXTERNAL_KEY1 INTEGER DEFAULT -1 NOT NULL,
		EXTERNAL_KEY2 CHAR(40) DEFAULT '-1' NOT NULL,
		SOURCE_ID VARCHAR(36) DEFAULT '-1' NOT NULL,
		URL VARCHAR(2048),
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL,
		ISSOFTDELETED SMALLINT DEFAULT NOT NULL
)IN DATABASE $DBNAME;

CREATE TABLE ASSET_CAT_ASSET_LOOKUP (
		ASSET_CATEGORY_ID INTEGER NOT NULL,
		ASSET_ID INTEGER NOT NULL,
		FULL_PATH VARCHAR(2048) NOT NULL
)IN DATABASE $DBNAME;

-- INDEXES

CREATE INDEX ACTTYPE_IDX3 ON ACTION_TYPE (EXTERNAL_KEY2) ;    
CREATE INDEX ASSETTP_IDX3 ON ASSET_TYPE (EXTERNAL_KEY2) ;                                                                                  
CREATE INDEX ASSET_IDX3 ON ASSET (EXTERNAL_KEY2) ;                                                 
CREATE INDEX ASSETHIST_IDX3 ON ASSET_HISTORY (EXTERNAL_KEY2) ;                                 
CREATE INDEX ASSETROLE_IDX3 ON ASSET_ROLE (EXTERNAL_KEY2) ;                                       
CREATE INDEX ASSETRLASSIH_IDX3 ON ASSET_ROLE_ASSIGNMENT_HISTORY (EXTERNAL_KEY2) ; 
CREATE INDEX ENTITLEMENT_IDX3 ON ENTITLEMENT (EXTERNAL_KEY2) ;                                     
CREATE INDEX ENTITHST_IDX3 ON ENTITLEMENT_HISTORY (EXTERNAL_KEY2) ;                     
CREATE INDEX LICENSEH_IDX3 ON LICENSE_HISTORY (EXTERNAL_KEY2) ;
CREATE INDEX ASSTCAT_IDX3 ON ASSET_CATEGORY        (EXTERNAL_KEY2);
CREATE INDEX ASSTATTR_IDX3 ON ASSET_ATTRIBUTE       (EXTERNAL_KEY2);
CREATE INDEX ASSTATRVAL_IDX3 ON ASSET_ATTRIBUTE_VALUE (EXTERNAL_KEY2);

CREATE INDEX ACTTYPE_IDX4 ON ACTION_TYPE (EXTERNAL_KEY1,SOURCE_ID) ;  
CREATE INDEX ASSETTP_IDX4 ON ASSET_TYPE (EXTERNAL_KEY1,SOURCE_ID) ;                                        
CREATE INDEX ASSET_IDX4 ON ASSET (EXTERNAL_KEY1,SOURCE_ID) ;                                                 
CREATE INDEX ASSETHIST_IDX4 ON ASSET_HISTORY (EXTERNAL_KEY1,SOURCE_ID) ;                                 
CREATE INDEX ASSETROLE_IDX4 ON ASSET_ROLE (EXTERNAL_KEY1,SOURCE_ID) ;                                       
CREATE INDEX ASSETRLASSIH_IDX4 ON ASSET_ROLE_ASSIGNMENT_HISTORY (EXTERNAL_KEY1,SOURCE_ID) ; 
CREATE INDEX ENTITLEMENT_IDX4 ON ENTITLEMENT (EXTERNAL_KEY1,SOURCE_ID) ;                                     
CREATE INDEX ENTITHST_IDX4 ON ENTITLEMENT_HISTORY (EXTERNAL_KEY1,SOURCE_ID) ;                     
CREATE INDEX LICENSEH_IDX4 ON LICENSE_HISTORY (EXTERNAL_KEY1,SOURCE_ID) ;
CREATE INDEX ASSTCAT_IDX4 ON ASSET_CATEGORY        (EXTERNAL_KEY1,SOURCE_ID); 
CREATE INDEX ASSTATTR_IDX4 ON ASSET_ATTRIBUTE       (EXTERNAL_KEY1,SOURCE_ID); 
CREATE INDEX ASSTATRVAL_IDX4 ON ASSET_ATTRIBUTE_VALUE (EXTERNAL_KEY1,SOURCE_ID); 

CREATE INDEX ACTTYPE_IDX5 ON ACTION_TYPE (EXTERNAL_KEY2,SOURCE_ID) ;     
CREATE INDEX ASSETTP_IDX5 ON ASSET_TYPE (EXTERNAL_KEY2,SOURCE_ID) ;                                 
CREATE INDEX ASSET_IDX5 ON ASSET (EXTERNAL_KEY2,SOURCE_ID) ;                                                 
CREATE INDEX ASSETHIST_IDX5 ON ASSET_HISTORY (EXTERNAL_KEY2,SOURCE_ID) ;                                 
CREATE INDEX ASSETROLE_IDX5 ON ASSET_ROLE (EXTERNAL_KEY2,SOURCE_ID) ;                                       
CREATE INDEX ASSETRLASSIH_IDX5 ON ASSET_ROLE_ASSIGNMENT_HISTORY (EXTERNAL_KEY2,SOURCE_ID) ; 
CREATE INDEX ENTITLEMENT_IDX5 ON ENTITLEMENT (EXTERNAL_KEY2,SOURCE_ID) ;                                     
CREATE INDEX ENTITHST_IDX5 ON ENTITLEMENT_HISTORY (EXTERNAL_KEY2,SOURCE_ID) ;                     
CREATE INDEX LICENSEH_IDX5 ON LICENSE_HISTORY (EXTERNAL_KEY2,SOURCE_ID) ;
CREATE INDEX ASSTCAT_IDX5 ON ASSET_CATEGORY        (EXTERNAL_KEY2,SOURCE_ID); 
CREATE INDEX ASSTATTR_IDX5 ON ASSET_ATTRIBUTE       (EXTERNAL_KEY2,SOURCE_ID); 
CREATE INDEX ASSTATRVAL_IDX5 ON ASSET_ATTRIBUTE_VALUE (EXTERNAL_KEY2,SOURCE_ID);

CREATE INDEX ACTTYPE_IDX2 ON ACTION_TYPE (EXTERNAL_ID) ;   
CREATE INDEX ASSETTP_IDX2 ON ASSET_TYPE (EXTERNAL_ID) ;                      
CREATE INDEX ASSET_IDX2 ON ASSET (EXTERNAL_ID) ;                                
CREATE INDEX ASSETHIST_IDX2 ON ASSET_HISTORY (EXTERNAL_ID) ;                    
CREATE INDEX ASSETROLE_IDX2 ON ASSET_ROLE (EXTERNAL_ID) ;                       
CREATE INDEX ASSETRLASSIH_IDX2 ON ASSET_ROLE_ASSIGNMENT_HISTORY (EXTERNAL_ID) ; 
CREATE INDEX ENTITLEMENT_IDX2 ON ENTITLEMENT (EXTERNAL_ID) ;                    
CREATE INDEX ENTITHST_IDX2 ON ENTITLEMENT_HISTORY (EXTERNAL_ID) ;               
CREATE INDEX LICENSEH_IDX2 ON LICENSE_HISTORY (EXTERNAL_ID) ;      
CREATE INDEX ASSTCAT_IDX2 ON ASSET_CATEGORY        (EXTERNAL_ID); 
CREATE INDEX ASSTATTR_IDX2 ON ASSET_ATTRIBUTE       (EXTERNAL_ID); 
CREATE INDEX ASSTATRVAL_IDX2 ON ASSET_ATTRIBUTE_VALUE (EXTERNAL_ID);              


-- PRIMARY KEY CONSTRAINTS

CREATE UNIQUE INDEX ACTIONTP_PK ON ACTION_TYPE (ACTION_TYPE_ID);
CREATE UNIQUE INDEX ASSETTP_PK ON ASSET_TYPE (ASSET_TYPE_ID); 
CREATE UNIQUE INDEX ASSET_PK ON ASSET (ASSET_ID);          
CREATE UNIQUE INDEX ASSETROLE_PK ON ASSET_ROLE (ASSET_ROLE_ID);      
CREATE UNIQUE INDEX ASSETRLASSIH_PK ON ASSET_ROLE_ASSIGNMENT_HISTORY (HISTORY_ID); 
CREATE UNIQUE INDEX ENTITLEMENT_PK ON ENTITLEMENT (ENTITLEMENT_ID);                          
CREATE UNIQUE INDEX ENTITLEHIST_PK ON ENTITLEMENT_HISTORY (HISTORY_ID);            
CREATE UNIQUE INDEX LICENSEHIST_PK ON LICENSE_HISTORY (HISTORY_ID);      
CREATE UNIQUE INDEX ASSERLENTLK_PK ON ASSET_ROLE_ENTITLEMENT_LOOKUP (ASSET_ROLE_ID,ENTITLEMENT_ID); 
CREATE UNIQUE INDEX ASSETLKUP_PK ON ASSET_LOOKUP (PRED_ASSET_ID,SUCC_ASSET_ID);                          
CREATE UNIQUE INDEX ASSERESLK_PK ON ASSET_RESOURCE_LOOKUP (ASSET_ID,OWNER_ID);                  
CREATE UNIQUE INDEX ASSEREQULK_PK ON ASSET_REQUEST_LOOKUP (ASSET_ID,REQUEST_ID);           
CREATE UNIQUE INDEX ASSETCASELK_PK ON ASSET_TESTCASE_LOOKUP (ASSET_ID,TESTCASE_ID);        
CREATE UNIQUE INDEX ASSETPLANLK_PK ON ASSET_TESTPLAN_LOOKUP (ASSET_ID,TESTPLAN_ID); 
CREATE UNIQUE INDEX ENTHISTLK_PK ON ENTITLEMENT_HISTORY_LOOKUP (HISTORY_ID,ENTITLEMENT_ID,ENTITLEMENT_TYPE);
CREATE UNIQUE INDEX ASSETRLRESLK_PK ON ASSET_ROLE_RESOURCE_LOOKUP (ASSET_ROLE_ID,RESOURCE_ID);
CREATE UNIQUE INDEX ASSETRLTEAMLK_PK ON ASSET_ROLE_TEAM_LOOKUP (ASSET_ROLE_ID,TEAM_ID);
CREATE UNIQUE INDEX ASSETHIST_PK ON ASSET_HISTORY (HISTORY_ID);
CREATE UNIQUE INDEX ASSTCAT_PK ON ASSET_CATEGORY (ASSET_CATEGORY_ID);
CREATE UNIQUE INDEX ASTCATCATLK_PK ON ASSET_CAT_HIERARCHY (PARENT_CATEGORY_ID,CHILD_CATEGORY_ID);
CREATE UNIQUE INDEX ASSTATTR_PK ON ASSET_ATTRIBUTE (ASSET_ATTRIBUTE_ID);
CREATE UNIQUE INDEX ASSTATRVAL_PK ON ASSET_ATTRIBUTE_VALUE (ASSET_ATTRIBUTE_VALUE_ID);
CREATE UNIQUE INDEX ASTCATASSTLK_PK ON ASSET_CAT_ASSET_LOOKUP (ASSET_CATEGORY_ID,ASSET_ID);

ALTER TABLE ACTION_TYPE ADD PRIMARY KEY (ACTION_TYPE_ID);
ALTER TABLE ASSET_TYPE ADD PRIMARY KEY (ASSET_TYPE_ID); 
ALTER TABLE ASSET ADD PRIMARY KEY (ASSET_ID);          
ALTER TABLE ASSET_ROLE ADD PRIMARY KEY (ASSET_ROLE_ID);      
ALTER TABLE ASSET_ROLE_ASSIGNMENT_HISTORY ADD PRIMARY KEY (HISTORY_ID); 
ALTER TABLE ENTITLEMENT ADD PRIMARY KEY (ENTITLEMENT_ID);                          
ALTER TABLE ENTITLEMENT_HISTORY ADD PRIMARY KEY (HISTORY_ID);            
ALTER TABLE LICENSE_HISTORY ADD PRIMARY KEY (HISTORY_ID);      
ALTER TABLE ASSET_ROLE_ENTITLEMENT_LOOKUP ADD PRIMARY KEY (ASSET_ROLE_ID,ENTITLEMENT_ID); 
ALTER TABLE ASSET_LOOKUP ADD PRIMARY KEY (PRED_ASSET_ID,SUCC_ASSET_ID);                          
ALTER TABLE ASSET_RESOURCE_LOOKUP ADD PRIMARY KEY (ASSET_ID,OWNER_ID);                  
ALTER TABLE ASSET_REQUEST_LOOKUP ADD PRIMARY KEY (ASSET_ID,REQUEST_ID);           
ALTER TABLE ASSET_TESTCASE_LOOKUP ADD PRIMARY KEY (ASSET_ID,TESTCASE_ID);        
ALTER TABLE ASSET_TESTPLAN_LOOKUP ADD PRIMARY KEY (ASSET_ID,TESTPLAN_ID); 
ALTER TABLE ENTITLEMENT_HISTORY_LOOKUP ADD PRIMARY KEY (HISTORY_ID,ENTITLEMENT_ID,ENTITLEMENT_TYPE);
ALTER TABLE ASSET_ROLE_RESOURCE_LOOKUP ADD PRIMARY KEY (ASSET_ROLE_ID,RESOURCE_ID);
ALTER TABLE ASSET_ROLE_TEAM_LOOKUP ADD PRIMARY KEY (ASSET_ROLE_ID,TEAM_ID);
ALTER TABLE ASSET_HISTORY ADD PRIMARY KEY (HISTORY_ID);
ALTER TABLE ASSET_CATEGORY ADD PRIMARY KEY (ASSET_CATEGORY_ID);
ALTER TABLE ASSET_CAT_HIERARCHY ADD PRIMARY KEY (PARENT_CATEGORY_ID,CHILD_CATEGORY_ID);
ALTER TABLE ASSET_ATTRIBUTE ADD PRIMARY KEY (ASSET_ATTRIBUTE_ID);
ALTER TABLE ASSET_ATTRIBUTE_VALUE ADD PRIMARY KEY (ASSET_ATTRIBUTE_VALUE_ID);
ALTER TABLE ASSET_CAT_ASSET_LOOKUP ADD PRIMARY KEY (ASSET_CATEGORY_ID,ASSET_ID);


--FOREIGN KEY

ALTER TABLE ASSET ADD CONSTRAINT ASSET_FK1 FOREIGN KEY (PROJECT_ID) 
	REFERENCES $NF_SCHEMA.PROJECT (PROJECT_ID) ;  

ALTER TABLE ASSET ADD CONSTRAINT ASSET_FK2 FOREIGN KEY (ASSET_TYPE_ID) 
	REFERENCES ASSET_TYPE (ASSET_TYPE_ID) ;  
	                                                                 
ALTER TABLE ASSET_ROLE ADD CONSTRAINT ASSETROLE_FK1 FOREIGN KEY (PROJECT_ID) 
	REFERENCES $NF_SCHEMA.PROJECT (PROJECT_ID) ; 
	                                                    
ALTER TABLE ASSET_ROLE_ASSIGNMENT_HISTORY ADD CONSTRAINT ASSETRLASSIH_FK1 FOREIGN KEY (ASSET_ROLE_ID) 
	REFERENCES ASSET_ROLE (ASSET_ROLE_ID) ; 
	
ALTER TABLE ASSET_ROLE_ASSIGNMENT_HISTORY ADD CONSTRAINT ASSETRLASSIH_FK2 FOREIGN KEY (PROJECT_ID) 
	REFERENCES $NF_SCHEMA.PROJECT (PROJECT_ID) ;   
	       
ALTER TABLE ASSET_ROLE_ASSIGNMENT_HISTORY ADD CONSTRAINT ASSETRLASSIH_FK3 FOREIGN KEY (TEAM_ID) 
	REFERENCES $NF_SCHEMA.TEAM (TEAM_ID) ;          
	         
ALTER TABLE ASSET_ROLE_ASSIGNMENT_HISTORY ADD CONSTRAINT ASSETRLASSIH_FK4 FOREIGN KEY (ASSIGNEE_ID) 
	REFERENCES $NF_SCHEMA.RESOURCE (RESOURCE_ID) ;  
	     
ALTER TABLE ASSET_ROLE_ASSIGNMENT_HISTORY ADD CONSTRAINT ASSETRLASSIH_FK5 FOREIGN KEY (ASSIGNER_ID) 
	REFERENCES $NF_SCHEMA.RESOURCE (RESOURCE_ID) ;
	
ALTER TABLE ASSET_ROLE_ASSIGNMENT_HISTORY ADD CONSTRAINT ASSETRLASSIH_FK6 FOREIGN KEY (ACTION_TYPE_ID) 
	REFERENCES ACTION_TYPE (ACTION_TYPE_ID) ;		 
	      
ALTER TABLE ENTITLEMENT_HISTORY ADD CONSTRAINT ENTITLEHIST_FK1 FOREIGN KEY (ASSET_ROLE_ID) 
	REFERENCES ASSET_ROLE (ASSET_ROLE_ID) ;   
	    
ALTER TABLE ENTITLEMENT_HISTORY ADD CONSTRAINT ENTITLEHIST_FK2 FOREIGN KEY (RESOURCE_ID) 
	REFERENCES $NF_SCHEMA.RESOURCE (RESOURCE_ID) ;    
	
ALTER TABLE ENTITLEMENT_HISTORY ADD CONSTRAINT ENTITLEHIST_FK3 FOREIGN KEY (ACTION_TYPE_ID) 
	REFERENCES ACTION_TYPE (ACTION_TYPE_ID) ; 	  
	                     
ALTER TABLE LICENSE_HISTORY ADD CONSTRAINT LICENSEHIST_FK1 FOREIGN KEY (ASSET_ID) 
	REFERENCES ASSET (ASSET_ID) ;            
	                                
ALTER TABLE LICENSE_HISTORY ADD CONSTRAINT LICENSEHIST_FK2 FOREIGN KEY (RESOURCE_ID) 
	REFERENCES $NF_SCHEMA.RESOURCE (RESOURCE_ID) ;  
	
ALTER TABLE LICENSE_HISTORY ADD CONSTRAINT LICENSEHIST_FK3 FOREIGN KEY (ACTION_TYPE_ID) 
	REFERENCES ACTION_TYPE (ACTION_TYPE_ID) ;	                                 
                 
ALTER TABLE ASSET_LOOKUP ADD CONSTRAINT ASSETLKUP_FK1 FOREIGN KEY (PRED_ASSET_ID) 
	REFERENCES ASSET (ASSET_ID) ;  
	                                    
ALTER TABLE ASSET_LOOKUP ADD CONSTRAINT ASSETLKUP_FK2 FOREIGN KEY (SUCC_ASSET_ID) 
	REFERENCES ASSET (ASSET_ID) ;
	                                      
ALTER TABLE ASSET_REQUEST_LOOKUP ADD CONSTRAINT ASSEREQULK_FK1 FOREIGN KEY (ASSET_ID) 
	REFERENCES ASSET (ASSET_ID) ;      
	                               
ALTER TABLE ASSET_REQUEST_LOOKUP ADD CONSTRAINT ASSEREQULK_FK2 FOREIGN KEY (REQUEST_ID) 
	REFERENCES $NF_SCHEMA.REQUEST (REQUEST_ID) ;   
	                            
ALTER TABLE ASSET_RESOURCE_LOOKUP ADD CONSTRAINT ASSERESLK_FK1 FOREIGN KEY (ASSET_ID) 
	REFERENCES ASSET (ASSET_ID) ;     
	                              
ALTER TABLE ASSET_RESOURCE_LOOKUP ADD CONSTRAINT ASSERESLK_FK2 FOREIGN KEY (OWNER_ID) 
	REFERENCES $NF_SCHEMA.RESOURCE (RESOURCE_ID) ;  
	                                 
ALTER TABLE ASSET_ROLE_ENTITLEMENT_LOOKUP ADD CONSTRAINT ASSERLENTLK_FK1 FOREIGN KEY (ASSET_ROLE_ID) 
	REFERENCES ASSET_ROLE(ASSET_ROLE_ID) ;  
	  
ALTER TABLE ASSET_ROLE_ENTITLEMENT_LOOKUP ADD CONSTRAINT ASSERLENTLK_FK2 FOREIGN KEY (ENTITLEMENT_ID) 
	REFERENCES ENTITLEMENT (ENTITLEMENT_ID) ; 
	
ALTER TABLE ASSET_TESTCASE_LOOKUP ADD CONSTRAINT ASSETCASELK_FK1 FOREIGN KEY (ASSET_ID) 
	REFERENCES ASSET (ASSET_ID) ;        
	                           
ALTER TABLE ASSET_TESTCASE_LOOKUP ADD CONSTRAINT ASSETCASELK_FK2 FOREIGN KEY (TESTCASE_ID) 
	REFERENCES $NF_SCHEMA.TESTCASE (TESTCASE_ID) ; 
	                         
ALTER TABLE ASSET_TESTPLAN_LOOKUP ADD CONSTRAINT ASSETPLANLK_FK1 FOREIGN KEY (ASSET_ID) 
	REFERENCES ASSET (ASSET_ID) ;              
	                     
ALTER TABLE ASSET_TESTPLAN_LOOKUP ADD CONSTRAINT ASSETPLANLK_FK2 FOREIGN KEY (TESTPLAN_ID) 
	REFERENCES $NF_SCHEMA.TESTPLAN (TESTPLAN_ID) ;   
	
ALTER TABLE ENTITLEMENT_HISTORY_LOOKUP ADD CONSTRAINT ENTHISTLK_FK1 FOREIGN KEY (HISTORY_ID)
	REFERENCES ENTITLEMENT_HISTORY (HISTORY_ID);	 
	
ALTER TABLE ENTITLEMENT_HISTORY_LOOKUP ADD CONSTRAINT ENTHISTLK_FK2 FOREIGN KEY (ENTITLEMENT_ID)
	REFERENCES ENTITLEMENT (ENTITLEMENT_ID);	    
	
ALTER TABLE ASSET_ROLE_RESOURCE_LOOKUP ADD CONSTRAINT ASSETRLRESLK_FK1 FOREIGN KEY (ASSET_ROLE_ID)
	REFERENCES ASSET_ROLE (ASSET_ROLE_ID);
	
ALTER TABLE ASSET_ROLE_RESOURCE_LOOKUP ADD CONSTRAINT ASSETRLRESLK_FK2 FOREIGN KEY (RESOURCE_ID)
	REFERENCES $NF_SCHEMA.RESOURCE;	

ALTER TABLE ASSET_ROLE_TEAM_LOOKUP ADD CONSTRAINT ASSETRLTEAMLK_FK1 FOREIGN KEY (ASSET_ROLE_ID)
	REFERENCES ASSET_ROLE (ASSET_ROLE_ID);	
	
ALTER TABLE ASSET_ROLE_TEAM_LOOKUP ADD CONSTRAINT ASSETRLTEAMLK_FK2 FOREIGN KEY (TEAM_ID)
	REFERENCES $NF_SCHEMA.TEAM (TEAM_ID);		
	
ALTER TABLE ASSET_HISTORY ADD CONSTRAINT ASSETHIST_FK1 FOREIGN KEY (ASSET_ID)
	REFERENCES ASSET (ASSET_ID);	    

ALTER TABLE ASSET_HISTORY ADD CONSTRAINT ASSETHIST_FK2 FOREIGN KEY (ACTION_TYPE_ID)
	REFERENCES ACTION_TYPE (ACTION_TYPE_ID);
	
ALTER TABLE ASSET_HISTORY ADD CONSTRAINT ASSETHIST_FK3 FOREIGN KEY (RESOURCE_ID)
	REFERENCES $NF_SCHEMA.RESOURCE (RESOURCE_ID);		               
                 
ALTER TABLE ASSET_ATTRIBUTE_VALUE ADD CONSTRAINT ASSTATRVAL_FK1 FOREIGN KEY (ASSET_ATTRIBUTE_ID)
	REFERENCES ASSET_ATTRIBUTE (ASSET_ATTRIBUTE_ID);
	
ALTER TABLE ASSET_ATTRIBUTE ADD CONSTRAINT ASSTATTR_FK1 FOREIGN KEY (ASSET_ID)
	REFERENCES ASSET (ASSET_ID);	
	
ALTER TABLE ASSET_CAT_HIERARCHY ADD CONSTRAINT ASTCATCATLK_FK1 FOREIGN KEY (PARENT_CATEGORY_ID)
	REFERENCES ASSET_CATEGORY (ASSET_CATEGORY_ID);

ALTER TABLE ASSET_CAT_HIERARCHY ADD CONSTRAINT ASTCATCATLK_FK2 FOREIGN KEY (CHILD_CATEGORY_ID)
	REFERENCES ASSET_CATEGORY (ASSET_CATEGORY_ID);	
	
ALTER TABLE ASSET_CAT_ASSET_LOOKUP ADD CONSTRAINT ASTCATASSTLK_FK1 FOREIGN KEY (ASSET_CATEGORY_ID)
	REFERENCES ASSET_CATEGORY (ASSET_CATEGORY_ID);

ALTER TABLE ASSET_CAT_ASSET_LOOKUP ADD CONSTRAINT ASTCATASSTLK_FK2 FOREIGN KEY (ASSET_ID)
	REFERENCES ASSET (ASSET_ID);	
                 
                 
                 
--TRIGGERS


CREATE TRIGGER TRG_ASSETLK
	AFTER UPDATE OF REC_DATETIME ON ASSET
	REFERENCING  NEW AS NEWROW                                                           
		OLD AS OLDROW                                                                      
	FOR EACH ROW MODE DB2SQL                                                             
BEGIN ATOMIC                                                                           
    DELETE FROM ASSET_LOOKUP WHERE (PRED_ASSET_ID=NEWROW.ASSET_ID OR SUCC_ASSET_ID=NEWROW.ASSET_ID); END;
    
CREATE TRIGGER TRG_ASSREQUELK	                           
 AFTER UPDATE OF REC_DATETIME ON ASSET     
 REFERENCING  NEW AS NEWROW                                                           
		OLD AS OLDROW                                                                      
	FOR EACH ROW MODE DB2SQL                                                             
BEGIN ATOMIC                                                                           
    DELETE FROM ASSET_REQUEST_LOOKUP WHERE ASSET_ID=NEWROW.ASSET_ID; END;                                                                                          

CREATE TRIGGER TRG_ASSRESOULK 
 AFTER UPDATE OF REC_DATETIME ON ASSET   
 REFERENCING  NEW AS NEWROW                                                           
		OLD AS OLDROW                                                                      
	FOR EACH ROW MODE DB2SQL                                                             
BEGIN ATOMIC                                                                           
    DELETE FROM ASSET_RESOURCE_LOOKUP WHERE ASSET_ID=NEWROW.ASSET_ID; END;      

CREATE TRIGGER TRG_ASSENTITLK 
 AFTER UPDATE OF REC_DATETIME ON ASSET_ROLE
 REFERENCING  NEW AS NEWROW                                                           
		OLD AS OLDROW                                                                      
	FOR EACH ROW MODE DB2SQL                                                             
BEGIN ATOMIC                                                                           
    DELETE FROM ASSET_ROLE_ENTITLEMENT_LOOKUP WHERE ASSET_ROLE_ID=NEWROW.ASSET_ROLE_ID; END; 

CREATE TRIGGER TRG_ASSTSTCASELK 
 AFTER UPDATE OF REC_DATETIME ON ASSET       
 REFERENCING  NEW AS NEWROW                                                           
		OLD AS OLDROW                                                                      
	FOR EACH ROW MODE DB2SQL                                                             
BEGIN ATOMIC                                                                           
    DELETE FROM ASSET_TESTCASE_LOOKUP WHERE ASSET_ID=NEWROW.ASSET_ID; END;  

CREATE TRIGGER TRG_TSTPLNLK 
 AFTER UPDATE OF REC_DATETIME ON ASSET    
 REFERENCING  NEW AS NEWROW                                                           
		OLD AS OLDROW                                                                      
	FOR EACH ROW MODE DB2SQL                                                             
BEGIN ATOMIC                                                                           
    DELETE FROM ASSET_TESTPLAN_LOOKUP WHERE ASSET_ID=NEWROW.ASSET_ID; END;
    
CREATE TRIGGER TRG_ASSRLRESELK 
 AFTER UPDATE OF REC_DATETIME ON ASSET_ROLE    
 REFERENCING  NEW AS NEWROW                                                           
		OLD AS OLDROW                                                                      
	FOR EACH ROW MODE DB2SQL                                                             
BEGIN ATOMIC                                                                           
    DELETE FROM ASSET_ROLE_RESOURCE_LOOKUP WHERE ASSET_ROLE_ID=NEWROW.ASSET_ROLE_ID; END;    
      
CREATE TRIGGER TRG_ASSRLTEAMLK 
 AFTER UPDATE OF REC_DATETIME ON ASSET_ROLE    
 REFERENCING  NEW AS NEWROW                                                           
		OLD AS OLDROW                                                                      
	FOR EACH ROW MODE DB2SQL                                                             
BEGIN ATOMIC                                                                           
    DELETE FROM ASSET_ROLE_TEAM_LOOKUP WHERE ASSET_ROLE_ID=NEWROW.ASSET_ROLE_ID; END; 

CREATE TRIGGER TRG_ASSREQUILK 
 AFTER UPDATE OF REC_DATETIME ON ASSET  
 REFERENCING  NEW AS NEWROW                                                           
		OLD AS OLDROW                                                                      
	FOR EACH ROW MODE DB2SQL                                                             
BEGIN ATOMIC                                                                           
    DELETE FROM ASSET_REQUIREMENT_LOOKUP WHERE ASSET_ID=NEWROW.ASSET_ID; END;
    
      
CREATE TRIGGER TRG_ASSTCAT 
AFTER UPDATE OF REC_DATETIME ON ASSET_CATEGORY
	REFERENCING  NEW AS NEWROW
		OLD AS OLDROW
	FOR EACH ROW MODE DB2SQL
BEGIN ATOMIC    
	DELETE FROM ASSET_CAT_HIERARCHY WHERE (PARENT_CATEGORY_ID=NEWROW.ASSET_CATEGORY_ID) OR (CHILD_CATEGORY_ID=NEWROW.ASSET_CATEGORY_ID) ; END;
      
CREATE TRIGGER TRG_ASSTCATAST 
AFTER UPDATE OF REC_DATETIME ON ASSET
	REFERENCING  NEW AS NEWROW
		OLD AS OLDROW
	FOR EACH ROW MODE DB2SQL
BEGIN ATOMIC    
	DELETE FROM ASSET_CAT_ASSET_LOOKUP WHERE (ASSET_ID=NEWROW.ASSET_ID); END;
      
       
      