---******************************************************************************************************************************
--* Licensed Materials - Property of IBM                                                                                       *
--* (c) Copyright IBM Corp. 2008, 2009 All Rights Reserved.                                                                    *
--*                                                                                                                            *
--*US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp*
--******************************************************************************************************************************

--=============  Create the model for STAR schema 

SET CURRENT SCHEMA $STAR_SCHEMA;

CREATE TABLE D_DATE (
		DATE_ID INTEGER NOT NULL,
		PERIOD_START_DATE DATE NOT NULL,
		DAY_OF_WEEK INTEGER NOT NULL,
		DAY_OF_WEEK_ISO INTEGER NOT NULL,
		DAY_OF_MONTH INTEGER NOT NULL,
		DAY_OF_YEAR INTEGER NOT NULL,
		DAY_NAME VARCHAR(60) NOT NULL,
		WEEK_OF_MONTH INTEGER NOT NULL,
		WEEK_OF_MONTH_ISO INTEGER NOT NULL,
		WEEK_OF_YEAR INTEGER NOT NULL,
		WEEK_OF_YEAR_ISO INTEGER NOT NULL,
		WEEK_NO INTEGER NOT NULL,
		WEEK_NO_ISO INTEGER NOT NULL,
		MONTH_OF_YEAR INTEGER NOT NULL,
		MONTH_NAME VARCHAR(60) NOT NULL,
		MONTH_NO INTEGER NOT NULL,
		QUARTER_OF_YEAR INTEGER NOT NULL,
		QUARTER_NO INTEGER NOT NULL,
		YEAR_OF INTEGER NOT NULL
	)
	IN DATABASE $DBNAME;

CREATE TABLE D_CURRENCY (
		CURRENCY_ID INTEGER NOT NULL,
		NAME VARCHAR(255) NOT NULL,
		ISSOFTDELETED SMALLINT DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;

CREATE TABLE D_BUILD (
		BUILD_ID INTEGER NOT NULL,
		NAME VARCHAR(255) NOT NULL,
		TYPE_NAME VARCHAR(255),
		ISSOFTDELETED SMALLINT DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;
	
CREATE TABLE D_ACTIVITY (
		ACTIVITY_ID INTEGER NOT NULL,
		NAME VARCHAR(255) NOT NULL,
		TYPE_NAME VARCHAR(255),
		ISSOFTDELETED SMALLINT DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;	
		
CREATE TABLE D_FILE (
		FILE_ID INTEGER NOT NULL,
		NAME VARCHAR(255) NOT NULL,
		TYPE_NAME VARCHAR(255),
		ISSOFTDELETED SMALLINT DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;	
	
CREATE TABLE D_FILE_VERSION (
		FILE_VERSION_ID INTEGER NOT NULL,
		NAME VARCHAR(255) NOT NULL,
		TYPE_NAME VARCHAR(255),
		ISSOFTDELETED SMALLINT DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;		
	
CREATE TABLE D_FILE_STREAM (
		FILE_STREAM_ID INTEGER NOT NULL,
		NAME VARCHAR(255) NOT NULL,
		TYPE_NAME VARCHAR(255),
		ISSOFTDELETED SMALLINT DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;	
	
CREATE TABLE D_FILE_BASELINE (
		FILE_BASELINE_ID INTEGER NOT NULL,
		NAME VARCHAR(255) NOT NULL,
		ISSOFTDELETED SMALLINT DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;		

CREATE TABLE D_REQUEST_STATE (
		STATE_ID INTEGER NOT NULL,
		NAME VARCHAR(255) NOT NULL
	)
	IN DATABASE $DBNAME;

CREATE TABLE D_REQUIREMENT_STATE (
		STATE_ID INTEGER NOT NULL,
		NAME VARCHAR(255) NOT NULL
	)
	IN DATABASE $DBNAME;

CREATE TABLE D_RESOURCE (
		RESOURCE_ID INTEGER NOT NULL,
		FULL_NAME VARCHAR(110) NOT NULL,
		ISSOFTDELETED SMALLINT DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;

CREATE TABLE D_PRIORITY (
		PRIORITY_ID INTEGER NOT NULL,
		NAME VARCHAR(255) NOT NULL,
		ISSOFTDELETED SMALLINT DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;

CREATE TABLE D_STABILITY (
		STABILITY_ID INTEGER NOT NULL,
		NAME VARCHAR(255) NOT NULL,
		ISSOFTDELETED SMALLINT DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;

CREATE TABLE D_DIFFICULTY (
		DIFFICULTY_ID INTEGER NOT NULL,
		NAME VARCHAR(255) NOT NULL,
		ISSOFTDELETED SMALLINT DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;

CREATE TABLE D_CUSTOMER_PRIORITY (
		CUSTOMER_PRIORITY_ID INTEGER NOT NULL,
		NAME VARCHAR(255) NOT NULL,
		ISSOFTDELETED SMALLINT DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;

CREATE TABLE D_ITERATION (
		ITERATION_ID INTEGER NOT NULL,
		NAME VARCHAR(255) NOT NULL,
		ISSOFTDELETED SMALLINT DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;

CREATE TABLE D_TEAM (
		TEAM_ID INTEGER NOT NULL,
		NAME VARCHAR(255) NOT NULL,
		ISSOFTDELETED SMALLINT DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;

CREATE TABLE D_RELEASE (
		RELEASE_ID INTEGER NOT NULL,
		NAME VARCHAR(255) NOT NULL,
		ISSOFTDELETED SMALLINT DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;

CREATE TABLE D_PLATFORM (
		PLATFORM_ID INTEGER NOT NULL,
		NAME VARCHAR(255) NOT NULL,
		ISSOFTDELETED SMALLINT DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;

CREATE TABLE D_SEVERITY (
		SEVERITY_ID INTEGER NOT NULL,
		NAME VARCHAR(255) NOT NULL,
		ISSOFTDELETED SMALLINT DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;

CREATE TABLE D_STATUS (
		STATUS_ID INTEGER NOT NULL,
		NAME VARCHAR(255) NOT NULL
	)
	IN DATABASE $DBNAME;

CREATE TABLE D_PROJECT (
		PROJECT_ID INTEGER NOT NULL,
		NAME VARCHAR(255) NOT NULL,
		PROGRAM_ID INTEGER NOT NULL,
		TYPE_NAME VARCHAR(255),
		ISSOFTDELETED SMALLINT DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;

CREATE TABLE D_CUSTOMER (
		CUSTOMER_ID INTEGER NOT NULL,
		NAME VARCHAR(255) NOT NULL,
		ISSOFTDELETED SMALLINT DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;

CREATE TABLE D_PRODUCT (
		PRODUCT_ID INTEGER NOT NULL,
		NAME VARCHAR(255) NOT NULL,
		ISSOFTDELETED SMALLINT DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;

CREATE TABLE D_COMPONENT (
		COMPONENT_ID INTEGER NOT NULL,
		PARENT_COMPONENT_ID INTEGER NOT NULL,
		PRODUCT_ID INTEGER NOT NULL,
		NAME VARCHAR(255) NOT NULL,
		TYPE_NAME VARCHAR(255),
		ISSOFTDELETED SMALLINT DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;
	

CREATE TABLE D_REQUEST_CLASSIFICATION (
		REQUEST_CLASS_ID INTEGER NOT NULL,
		NAME VARCHAR(50) NOT NULL
	)
	IN DATABASE $DBNAME;

CREATE TABLE D_REQUIREMENT_CLASSIFICATION (
		REQUIREMENT_CLASS_ID INTEGER NOT NULL,
		NAME VARCHAR(50) NOT NULL
	)
	IN DATABASE $DBNAME;

CREATE TABLE D_TASK_CLASSIFICATION (
		TASK_CLASS_ID INTEGER NOT NULL,
		NAME VARCHAR(50) NOT NULL
	)
	IN DATABASE $DBNAME;

CREATE TABLE D_REQUIREMENT (
		REQUIREMENT_ID INTEGER NOT NULL,
		NAME VARCHAR(255) NOT NULL,
		TYPE_NAME VARCHAR(255),
		ISSOFTDELETED SMALLINT DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;
	
CREATE TABLE D_COMPONENT_CLASSIFICATION (
		COMPONENT_CLASS_ID INTEGER NOT NULL,
		NAME VARCHAR(50) NOT NULL
	)
	IN DATABASE $DBNAME;	

CREATE TABLE D_TESTCASE (
		TESTCASE_ID INTEGER NOT NULL,
		NAME VARCHAR(255) NOT NULL,
		TYPE_NAME VARCHAR(255),
		ISSOFTDELETED SMALLINT DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;

CREATE TABLE D_TESTSUITE (
		TESTSUITE_ID INTEGER NOT NULL,
		NAME VARCHAR(255) NOT NULL,
		TYPE_NAME VARCHAR(255),
		ISSOFTDELETED SMALLINT DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;

CREATE TABLE D_EXECUTION_WORKITEM (
		EXECWORKITEM_ID INTEGER NOT NULL,
		NAME VARCHAR(255) NOT NULL,
		TYPE_NAME VARCHAR(255),
		ISSOFTDELETED SMALLINT DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;

CREATE TABLE D_EXECUTION_RESULT (
		EXECUTION_RESULT_ID INTEGER NOT NULL,
		NAME VARCHAR(255) NOT NULL,
		TYPE_NAME VARCHAR(255),
		ISSOFTDELETED SMALLINT DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;

CREATE TABLE D_TESTSUITELOG (
		TESTSUITELOG_ID INTEGER NOT NULL,
		NAME VARCHAR(255) NOT NULL,
		TYPE_NAME VARCHAR(255),
		ISSOFTDELETED SMALLINT DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;

CREATE TABLE D_TESTPLAN (
		TESTPLAN_ID INTEGER NOT NULL,
		NAME VARCHAR(255) NOT NULL,
		TYPE_NAME VARCHAR(255),
		ISSOFTDELETED SMALLINT DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;

CREATE TABLE D_VERDICT (
		VERDICT_ID INTEGER NOT NULL,
		NAME VARCHAR(255) NOT NULL,
		ISSOFTDELETED SMALLINT DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;

CREATE TABLE D_REQUEST_SOURCE (
		REQUEST_SOURCE_ID INTEGER NOT NULL,
		NAME VARCHAR(255) NOT NULL,
		ISSOFTDELETED SMALLINT DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;

CREATE TABLE D_RESOLUTION (
		RESOLUTION_ID INTEGER NOT NULL,
		NAME VARCHAR(255) NOT NULL,
		ISSOFTDELETED SMALLINT DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;

CREATE TABLE D_REQUEST (
		REQUEST_ID INTEGER NOT NULL,
		NAME VARCHAR(255) NOT NULL,
		TYPE_NAME VARCHAR(255),
		ISSOFTDELETED SMALLINT DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;

CREATE TABLE D_ASSETREGISTRY (
		ASSETREGISTRY_ID INTEGER NOT NULL,
		NAME VARCHAR(255) NOT NULL,
		ISSOFTDELETED SMALLINT DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;

CREATE TABLE D_TESTCASE_STATE (
		STATE_ID INTEGER NOT NULL,
		NAME VARCHAR(255) NOT NULL
	)
	IN DATABASE $DBNAME;

CREATE TABLE D_EXECUTIONWKITEM_STATE (
		STATE_ID INTEGER NOT NULL,
		NAME VARCHAR(255) NOT NULL
	)
	IN DATABASE $DBNAME;

CREATE TABLE D_TESTPLAN_STATE (
		STATE_ID INTEGER NOT NULL,
		NAME VARCHAR(255) NOT NULL
	)
	IN DATABASE $DBNAME;

CREATE TABLE D_TESTSUITE_STATE (
		STATE_ID INTEGER NOT NULL,
		NAME VARCHAR(255) NOT NULL
	)
	IN DATABASE $DBNAME;

CREATE TABLE D_TASK_STATE (
		STATE_ID INTEGER NOT NULL,
		NAME VARCHAR(255) NOT NULL
	)
	IN DATABASE $DBNAME;

CREATE TABLE D_TASK (
		TASK_ID INTEGER NOT NULL,
		NAME VARCHAR(255) NOT NULL,
		TYPE_NAME VARCHAR(255),
		ISSOFTDELETED SMALLINT DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;

CREATE TABLE D_FACTOR (
		FACTOR_ID INTEGER NOT NULL,
		NAME VARCHAR(255) NOT NULL,
		ISSOFTDELETED SMALLINT DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;
	
CREATE TABLE D_ACTIVITY_STATE (
		STATE_ID INTEGER NOT NULL,
		NAME VARCHAR(255) NOT NULL
	)
	IN DATABASE $DBNAME;	
	
CREATE TABLE D_ACTIVITY_CLASSIFICATION (
		ACTIVITY_CLASS_ID INTEGER NOT NULL,
		NAME VARCHAR(50) NOT NULL
	)
	IN DATABASE $DBNAME;		
	
CREATE TABLE D_PROJECT_CLASSIFICATION (
		PROJECT_CLASS_ID INTEGER NOT NULL,
		NAME VARCHAR(50) NOT NULL
	)
	IN DATABASE $DBNAME;		

CREATE TABLE D_TASK_TYPE(
		TASK_TYPE_ID INTEGER NOT NULL,
		NAME VARCHAR(255),
		ISSOFTDELETED SMALLINT DEFAULT NOT NULL
)IN DATABASE $DBNAME;

CREATE TABLE D_BUILD_TYPE(
		BUILD_TYPE_ID INTEGER NOT NULL,
		NAME VARCHAR(255),
		ISSOFTDELETED SMALLINT DEFAULT NOT NULL
)IN DATABASE $DBNAME;

CREATE TABLE D_TESTCASE_CLASSIFICATION (
		TESTCASE_CLASS_ID INTEGER NOT NULL,
		NAME VARCHAR(50) NOT NULL
)IN DATABASE $DBNAME;

CREATE TABLE D_EXECWORKITEM_CLASSIFICATION (
		EXECWORKIT_CLASS_ID INTEGER NOT NULL,
		NAME VARCHAR(50) NOT NULL
)IN DATABASE $DBNAME;

CREATE TABLE D_EXECRESULT_CLASSIFICATION (
		EXECRES_CLASS_ID INTEGER NOT NULL,
		NAME VARCHAR(50) NOT NULL
)IN DATABASE $DBNAME;

CREATE TABLE D_TESTSUITE_CLASSIFICATION (
		TESTSUITE_CLASS_ID INTEGER NOT NULL,
		NAME VARCHAR(50) NOT NULL
)IN DATABASE $DBNAME;

CREATE TABLE D_REQUEST_TYPE (
		REQUEST_TYPE_ID INTEGER NOT NULL,
		NAME VARCHAR(255) NOT NULL,
		ISSOFTDELETED SMALLINT DEFAULT NOT NULL
)IN DATABASE $DBNAME;

CREATE TABLE D_CONFIGURATION (
		CONFIGURATION_ID INTEGER NOT NULL,
		NAME VARCHAR(255) NOT NULL,
		ISSOFTDELETED SMALLINT DEFAULT NOT NULL
)IN DATABASE $DBNAME;

CREATE TABLE D_RESOURCE_GROUP (
		RESOURCE_GROUP_ID INTEGER NOT NULL,
		NAME VARCHAR(255) NOT NULL,
		ISSOFTDELETED SMALLINT DEFAULT NOT NULL
)IN DATABASE $DBNAME;

CREATE TABLE D_LAB_RESOURCE (
		LAB_RESOURCE_ID INTEGER NOT NULL,
		NAME VARCHAR(255) NOT NULL,
		ISSOFTDELETED SMALLINT DEFAULT NOT NULL
)IN DATABASE $DBNAME;

CREATE TABLE D_OS_TYPE (
		OS_TYPE_ID INTEGER NOT NULL,
		NAME VARCHAR(255) NOT NULL,
		ISSOFTDELETED SMALLINT DEFAULT NOT NULL
)IN DATABASE $DBNAME;

CREATE TABLE D_REQUEST_CATEGORY (
		REQUEST_CATEGORY_ID INTEGER NOT NULL,
		NAME VARCHAR(255) NOT NULL,
		ISSOFTDELETED SMALLINT DEFAULT NOT NULL
)IN DATABASE $DBNAME;

CREATE TABLE D_FILE_CLASSIFICATION (
		FILE_CLASS_ID INTEGER NOT NULL,
		NAME VARCHAR(50) NOT NULL
)IN DATABASE $DBNAME;

CREATE TABLE D_FILE_STREAM_CLASSIFICATION (
		FILE_STREAM_CLASS_ID INTEGER NOT NULL,
		NAME VARCHAR(50) NOT NULL
)IN DATABASE $DBNAME;

CREATE TABLE D_BUILD_CLASSIFICATION(
		BUILD_CLASS_ID INTEGER NOT NULL,
		NAME VARCHAR(50) NOT NULL,
		ISSOFTDELETED SMALLINT DEFAULT NOT NULL
)IN DATABASE $DBNAME;

CREATE TABLE D_JOB (
		JOB_ID INTEGER NOT NULL,
		NAME VARCHAR(255) NOT NULL,
		ISSOFTDELETED SMALLINT DEFAULT NOT NULL
)IN DATABASE $DBNAME;

CREATE TABLE D_JOB_RESULT (
		JOB_RESULT_ID INTEGER NOT NULL,
		NAME VARCHAR(255) NOT NULL,
		ISSOFTDELETED SMALLINT DEFAULT NOT NULL
)IN DATABASE $DBNAME;

CREATE TABLE D_JOB_RESULT_STATE (
		STATE_ID INTEGER NOT NULL,
		NAME VARCHAR(255) NOT NULL
)IN DATABASE $DBNAME;

CREATE TABLE D_PROGRAM (
		PROGRAM_ID INTEGER NOT NULL,
		NAME VARCHAR(255) NOT NULL,
		ISSOFTDELETED SMALLINT DEFAULT NOT NULL
)IN DATABASE $DBNAME;

CREATE TABLE D_TIMESHEET_STATE (
		STATE_ID INTEGER NOT NULL,
		NAME VARCHAR(255) NOT NULL
	) IN DATABASE $DBNAME;
	
CREATE TABLE D_PROJECT_ALLOCATION (
		PROJECT_ALLOCATION_ID INTEGER NOT NULL,
		NAME VARCHAR(255) DEFAULT 'Info not available',
		ISSOFTDELETED SMALLINT DEFAULT NOT NULL
)IN DATABASE $DBNAME;

CREATE TABLE D_SKILL (
		SKILL_ID INTEGER NOT NULL,
		NAME VARCHAR(255) DEFAULT 'Info not available',
		ISSOFTDELETED SMALLINT DEFAULT NOT NULL
)IN DATABASE $DBNAME;

CREATE TABLE D_COMPETENCY (
		COMPETENCY_ID INTEGER NOT NULL,
		NAME VARCHAR(255) DEFAULT 'Info not available',
		ISSOFTDELETED SMALLINT DEFAULT NOT NULL
)IN DATABASE $DBNAME;

CREATE TABLE D_POOL (
		POOL_ID INTEGER NOT NULL,
		NAME VARCHAR(255) DEFAULT 'Info not available',
		ISSOFTDELETED SMALLINT DEFAULT NOT NULL
)IN DATABASE $DBNAME;

CREATE TABLE D_BASELINE (
		BASELINE_ID INTEGER NOT NULL,
		NAME VARCHAR(255) DEFAULT 'Info not available',
		ISSOFTDELETED SMALLINT DEFAULT NOT NULL
)IN DATABASE $DBNAME;

CREATE TABLE D_CHARGECODE (
		CHARGECODE_ID INTEGER NOT NULL,
		NAME VARCHAR(255) DEFAULT 'Info not available',
		ISSOFTDELETED SMALLINT DEFAULT NOT NULL
)IN DATABASE $DBNAME;

CREATE TABLE D_TIMECODE (
		TIMECODE_ID INTEGER NOT NULL,
		NAME VARCHAR(255) DEFAULT 'Info not available',
		ISSOFTDELETED SMALLINT DEFAULT NOT NULL
)IN DATABASE $DBNAME;

CREATE TABLE D_RISK(
		RISK_ID INTEGER NOT NULL,
		NAME VARCHAR(255) NOT NULL,
		ISSOFTDELETED SMALLINT DEFAULT NOT NULL
)IN DATABASE $DBNAME;

CREATE TABLE D_RISK_STATE (
		STATE_ID INTEGER NOT NULL,
		NAME VARCHAR(255) NOT NULL
)IN DATABASE $DBNAME;

CREATE TABLE D_PROBABILITY_RANK (
		PROBABILITY_RANK_ID INTEGER NOT NULL,
		NAME VARCHAR(255) NOT NULL,
		ISSOFTDELETED SMALLINT DEFAULT NOT NULL
)IN DATABASE $DBNAME;

CREATE TABLE D_IMPACT_RANK (
		IMPACT_RANK_ID INTEGER NOT NULL,
		NAME VARCHAR(255) NOT NULL,
		ISSOFTDELETED SMALLINT DEFAULT NOT NULL
)IN DATABASE $DBNAME;
	
CREATE TABLE D_PROBABILITY_COST_RANK (
		PROBABILITY_COST_RANK_ID INTEGER NOT NULL,
		NAME VARCHAR(255) NOT NULL,
		ISSOFTDELETED SMALLINT DEFAULT NOT NULL
)IN DATABASE $DBNAME;

CREATE TABLE D_SCORE_RANK (
		SCORE_RANK_ID INTEGER NOT NULL,
		NAME VARCHAR(255) NOT NULL,
		ISSOFTDELETED SMALLINT DEFAULT NOT NULL
)IN DATABASE $DBNAME;

CREATE TABLE D_OPERATING_TERRITORY(
		TERRITORY_ID INTEGER NOT NULL,
		NAME VARCHAR(255) DEFAULT 'Territory Name Missing' NOT NULL,
		ISSOFTDELETED SMALLINT DEFAULT NOT NULL
)IN DATABASE $DBNAME;  

CREATE TABLE D_COUNTRY (
		COUNTRY_ID INTEGER NOT NULL,
		NAME VARCHAR(255) DEFAULT 'Country Name Missing' NOT NULL,
		TERRITORY_ID INTEGER NOT NULL,
		ISSOFTDELETED SMALLINT DEFAULT NOT NULL
)IN DATABASE $DBNAME;  

CREATE TABLE D_PROVINCE_STATE (
		PROVINCE_STATE_ID INTEGER NOT NULL,
		NAME VARCHAR(255) DEFAULT 'Province or State Name Missing' NOT NULL,
		COUNTRY_ID INTEGER NOT NULL,
		ISSOFTDELETED SMALLINT DEFAULT NOT NULL
)IN DATABASE $DBNAME;  

CREATE TABLE D_CITY (
		CITY_ID INTEGER NOT NULL,
		NAME VARCHAR(255) DEFAULT 'City Name Missing' NOT NULL,
		PROVINCE_STATE_ID INTEGER NOT NULL,
		ISSOFTDELETED SMALLINT DEFAULT NOT NULL
)IN DATABASE $DBNAME;
	
CREATE TABLE D_ORGANIZATION (
		ORGANIZATION_ID INTEGER NOT NULL,
		NAME VARCHAR(255) DEFAULT 'City Name Missing' NOT NULL,
		ISSOFTDELETED SMALLINT DEFAULT NOT NULL
)IN DATABASE $DBNAME;
	
CREATE TABLE D_AGE_RANK (
		AGE_RANK_ID INTEGER NOT NULL,
		NAME VARCHAR (255) DEFAULT 'Age Rank Name Missing' NOT NULL,
		ISSOFTDELETED SMALLINT DEFAULT NOT NULL
) IN DATABASE $DBNAME;

CREATE TABLE D_PORTFOLIO (
		PORTFOLIO_ID INTEGER NOT NULL,
		NAME VARCHAR (255) DEFAULT 'Portfolio Name Missing' NOT NULL,
		ISSOFTDELETED SMALLINT DEFAULT NOT NULL
) IN DATABASE $DBNAME;

CREATE TABLE BD_PORTFOLIO (
		PORTFOLIO_ID INTEGER NOT NULL,
		PROGRAM_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL
) IN DATABASE $DBNAME;
	
CREATE TABLE D_REQUIREMENT_TYPE(
		REQUIREMENT_TYPE_ID INTEGER NOT NULL,
		NAME VARCHAR(255),
		ISSOFTDELETED SMALLINT DEFAULT NOT NULL
)IN DATABASE $DBNAME;	
	
CREATE TABLE D_ASSET(
		ASSET_ID INTEGER NOT NULL,
		NAME VARCHAR(255),
		ISSOFTDELETED SMALLINT DEFAULT NOT NULL
)IN DATABASE $DBNAME;	

CREATE TABLE D_ASSET_TYPE(
		ASSET_TYPE_ID INTEGER NOT NULL,
		NAME VARCHAR(255),
		ISSOFTDELETED SMALLINT DEFAULT NOT NULL
)IN DATABASE $DBNAME;	

CREATE TABLE D_ACTION_TYPE(
		ACTION_TYPE_ID INTEGER NOT NULL,
		NAME VARCHAR(255),
		TYPE INTEGER,
		ISSOFTDELETED SMALLINT DEFAULT NOT NULL
)IN DATABASE $DBNAME;	
	
	
CREATE TABLE D_REQUEST_PRIORITY (
		PRIORITY_ID INTEGER NOT NULL,
		NAME VARCHAR(255) NOT NULL,
		ISSOFTDELETED SMALLINT DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;

CREATE TABLE D_REQUEST_SEVERITY (
		SEVERITY_ID INTEGER NOT NULL,
		NAME VARCHAR(255) NOT NULL,
		ISSOFTDELETED SMALLINT DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;

CREATE TABLE D_REQUEST_STATUS (
		STATUS_ID INTEGER NOT NULL,
		NAME VARCHAR(255) NOT NULL,
		ISSOFTDELETED SMALLINT DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;		
	
CREATE TABLE D_BALLOT_TAB (
		BALLOT_TAB_ID INTEGER NOT NULL,
		NAME VARCHAR(255) NOT NULL,
		ISSOFTDELETED SMALLINT DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;		
		
CREATE TABLE F_REQUEST_METRICS (
		REQUEST_METRIC_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		REQUEST_CLASS_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		COMPONENT_ID INTEGER NOT NULL,
		SEVERITY_ID INTEGER NOT NULL,
		STATE_ID INTEGER NOT NULL,
		PRIORITY_ID INTEGER NOT NULL,
		PLATFORM_ID INTEGER NOT NULL,
		RESOURCE_ID INTEGER NOT NULL,
		TEAM_ID INTEGER NOT NULL,
		ITERATION_ID INTEGER NOT NULL,
		RELEASE_ID INTEGER NOT NULL,
		FIXEDINRELEASE_ID INTEGER NOT NULL,
		STATUS_ID INTEGER NOT NULL,
		REQUEST_TYPE_ID INTEGER NOT NULL,
		REQUEST_CATEGORY_ID INTEGER NOT NULL,
		PLANNED_WORK INTEGER DEFAULT NOT NULL,
		ACTUAL_WORK INTEGER DEFAULT NOT NULL,
		TOTAL_REQUESTS INTEGER DEFAULT NOT NULL,
		TOTAL_BLOCKING INTEGER DEFAULT NOT NULL,
		EXTERNAL_KEY1 INTEGER DEFAULT -1 NOT NULL,
		SOURCE_ID VARCHAR(36) DEFAULT '-1' NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;
	
CREATE TABLE F_C_REQUEST_METRICS (
		REQUEST_METRIC_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		REQUEST_CLASS_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		COMPONENT_ID INTEGER NOT NULL,
		SEVERITY_ID INTEGER NOT NULL,
		STATE_ID INTEGER NOT NULL,
		PRIORITY_ID INTEGER NOT NULL,
		PLATFORM_ID INTEGER NOT NULL,
		RESOURCE_ID INTEGER NOT NULL,
		TEAM_ID INTEGER NOT NULL,
		ITERATION_ID INTEGER NOT NULL,
		RELEASE_ID INTEGER NOT NULL,
		FIXEDINRELEASE_ID INTEGER NOT NULL,
		STATUS_ID INTEGER NOT NULL,
		REQUEST_TYPE_ID INTEGER NOT NULL,
		REQUEST_CATEGORY_ID INTEGER NOT NULL,
		PLANNED_WORK INTEGER DEFAULT NOT NULL,
		ACTUAL_WORK INTEGER DEFAULT NOT NULL,
		TOTAL_REQUESTS INTEGER DEFAULT NOT NULL,
		TOTAL_BLOCKING INTEGER DEFAULT NOT NULL,
		EXTERNAL_KEY1 INTEGER DEFAULT -1 NOT NULL,
		SOURCE_ID VARCHAR(36) DEFAULT '-1' NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;	

CREATE TABLE H_REQUEST_METRICS_TOTAL (
		REQUEST_METRIC_ID INTEGER NOT NULL,
		REQUEST_ID INTEGER NOT NULL
	)
	IN DATABASE $DBNAME;
	
CREATE TABLE H_REQUEST_METRICS_BLOCKING (
		REQUEST_METRIC_ID INTEGER NOT NULL,
		REQUEST_ID INTEGER NOT NULL
	)
	IN DATABASE $DBNAME;	
	
CREATE TABLE F_REQUEST_REQUI_METRICS (
		REQUEST_METRIC_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		REQUEST_CLASS_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		COMPONENT_ID INTEGER NOT NULL,
		SEVERITY_ID INTEGER NOT NULL,
		STATE_ID INTEGER NOT NULL,
		PRIORITY_ID INTEGER NOT NULL,
		PLATFORM_ID INTEGER NOT NULL,
		RESOURCE_ID INTEGER NOT NULL,
		TEAM_ID INTEGER NOT NULL,
		ITERATION_ID INTEGER NOT NULL,
		RELEASE_ID INTEGER NOT NULL,
		FIXEDINRELEASE_ID INTEGER NOT NULL,
		STATUS_ID INTEGER NOT NULL,
		REQUIREMENT_ID INTEGER NOT NULL,
		REQUEST_TYPE_ID INTEGER NOT NULL,
		REQUEST_CATEGORY_ID INTEGER NOT NULL,
		PLANNED_WORK INTEGER DEFAULT NOT NULL,
		ACTUAL_WORK INTEGER DEFAULT NOT NULL,
		TOTAL_REQUESTS INTEGER DEFAULT NOT NULL,
		TOTAL_BLOCKING INTEGER DEFAULT NOT NULL,
		EXTERNAL_KEY1 INTEGER DEFAULT -1 NOT NULL,
		SOURCE_ID VARCHAR(36) DEFAULT '-1' NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;
	
CREATE TABLE F_C_REQUEST_REQUI_METRICS (
		REQUEST_METRIC_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		REQUEST_CLASS_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		COMPONENT_ID INTEGER NOT NULL,
		SEVERITY_ID INTEGER NOT NULL,
		STATE_ID INTEGER NOT NULL,
		PRIORITY_ID INTEGER NOT NULL,
		PLATFORM_ID INTEGER NOT NULL,
		RESOURCE_ID INTEGER NOT NULL,
		TEAM_ID INTEGER NOT NULL,
		ITERATION_ID INTEGER NOT NULL,
		RELEASE_ID INTEGER NOT NULL,
		FIXEDINRELEASE_ID INTEGER NOT NULL,
		STATUS_ID INTEGER NOT NULL,
		REQUIREMENT_ID INTEGER NOT NULL,
		REQUEST_TYPE_ID INTEGER NOT NULL,
		REQUEST_CATEGORY_ID INTEGER NOT NULL,
		PLANNED_WORK INTEGER DEFAULT NOT NULL,
		ACTUAL_WORK INTEGER DEFAULT NOT NULL,
		TOTAL_REQUESTS INTEGER DEFAULT NOT NULL,
		TOTAL_BLOCKING INTEGER DEFAULT NOT NULL,
		EXTERNAL_KEY1 INTEGER DEFAULT -1 NOT NULL,
		SOURCE_ID VARCHAR(36) DEFAULT '-1' NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;	

CREATE TABLE H_REQUEST_REQUI_METRICS_TOTAL (
		REQUEST_METRIC_ID INTEGER NOT NULL,
		REQUEST_ID INTEGER NOT NULL
	)
	IN DATABASE $DBNAME;
	
CREATE TABLE H_REQUEST_REQUI_METRICS_BLOCK (
		REQUEST_METRIC_ID INTEGER NOT NULL,
		REQUEST_ID INTEGER NOT NULL
	)
	IN DATABASE $DBNAME;	
	
CREATE TABLE F_REQUEST_CUST_METRICS (
		REQUEST_METRIC_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		REQUEST_CLASS_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		COMPONENT_ID INTEGER NOT NULL,
		SEVERITY_ID INTEGER NOT NULL,
		STATE_ID INTEGER NOT NULL,
		PRIORITY_ID INTEGER NOT NULL,
		CUSTOMER_ID INTEGER NOT NULL,
		PLATFORM_ID INTEGER NOT NULL,
		RESOURCE_ID INTEGER NOT NULL,
		TEAM_ID INTEGER NOT NULL,
		ITERATION_ID INTEGER NOT NULL,
		RELEASE_ID INTEGER NOT NULL,
		FIXEDINRELEASE_ID INTEGER NOT NULL,
		STATUS_ID INTEGER NOT NULL,
		REQUEST_TYPE_ID INTEGER NOT NULL,
		REQUEST_CATEGORY_ID INTEGER NOT NULL,
		PLANNED_WORK INTEGER DEFAULT NOT NULL,
		ACTUAL_WORK INTEGER DEFAULT NOT NULL,
		TOTAL_REQUESTS INTEGER DEFAULT NOT NULL,
		TOTAL_BLOCKING INTEGER DEFAULT NOT NULL,
		EXTERNAL_KEY1 INTEGER DEFAULT -1 NOT NULL,
		SOURCE_ID VARCHAR(36) DEFAULT '-1' NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;
	
CREATE TABLE F_C_REQUEST_CUST_METRICS (
		REQUEST_METRIC_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		REQUEST_CLASS_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		COMPONENT_ID INTEGER NOT NULL,
		SEVERITY_ID INTEGER NOT NULL,
		STATE_ID INTEGER NOT NULL,
		PRIORITY_ID INTEGER NOT NULL,
		CUSTOMER_ID INTEGER NOT NULL,
		PLATFORM_ID INTEGER NOT NULL,
		RESOURCE_ID INTEGER NOT NULL,
		TEAM_ID INTEGER NOT NULL,
		ITERATION_ID INTEGER NOT NULL,
		RELEASE_ID INTEGER NOT NULL,
		FIXEDINRELEASE_ID INTEGER NOT NULL,
		STATUS_ID INTEGER NOT NULL,
		REQUEST_TYPE_ID INTEGER NOT NULL,
		REQUEST_CATEGORY_ID INTEGER NOT NULL,
		PLANNED_WORK INTEGER DEFAULT NOT NULL,
		ACTUAL_WORK INTEGER DEFAULT NOT NULL,
		TOTAL_REQUESTS INTEGER DEFAULT NOT NULL,
		TOTAL_BLOCKING INTEGER DEFAULT NOT NULL,
		EXTERNAL_KEY1 INTEGER DEFAULT -1 NOT NULL,
		SOURCE_ID VARCHAR(36) DEFAULT '-1' NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;	

CREATE TABLE H_REQUEST_CUST_METRICS_TOTAL (
		REQUEST_METRIC_ID INTEGER NOT NULL,
		REQUEST_ID INTEGER NOT NULL
	)
	IN DATABASE $DBNAME;
	
CREATE TABLE H_REQUEST_CUST_METRICS_BLOCK (
		REQUEST_METRIC_ID INTEGER NOT NULL,
		REQUEST_ID INTEGER NOT NULL
	)
	IN DATABASE $DBNAME;		
	
CREATE TABLE F_REQUEST_TPLN_METRICS (
		REQUEST_METRIC_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		REQUEST_CLASS_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		COMPONENT_ID INTEGER NOT NULL,
		SEVERITY_ID INTEGER NOT NULL,
		STATE_ID INTEGER NOT NULL,
		PRIORITY_ID INTEGER NOT NULL,
		PLATFORM_ID INTEGER NOT NULL,
		RESOURCE_ID INTEGER NOT NULL,
		TEAM_ID INTEGER NOT NULL,
		ITERATION_ID INTEGER NOT NULL,
		RELEASE_ID INTEGER NOT NULL,
		FIXEDINRELEASE_ID INTEGER NOT NULL,
		STATUS_ID INTEGER NOT NULL,
		REQUEST_TYPE_ID INTEGER NOT NULL,
		REQUEST_CATEGORY_ID INTEGER NOT NULL,
		TESTPLAN_ID INTEGER NOT NULL,
		PLANNED_WORK INTEGER DEFAULT NOT NULL,
		ACTUAL_WORK INTEGER DEFAULT NOT NULL,
		TOTAL_REQUESTS INTEGER DEFAULT NOT NULL,
		TOTAL_BLOCKING INTEGER DEFAULT NOT NULL,
		EXTERNAL_KEY1 INTEGER DEFAULT -1 NOT NULL,
		SOURCE_ID VARCHAR(36) DEFAULT '-1' NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;
	
CREATE TABLE F_C_REQUEST_TPLN_METRICS (
		REQUEST_METRIC_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		REQUEST_CLASS_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		COMPONENT_ID INTEGER NOT NULL,
		SEVERITY_ID INTEGER NOT NULL,
		STATE_ID INTEGER NOT NULL,
		PRIORITY_ID INTEGER NOT NULL,
		PLATFORM_ID INTEGER NOT NULL,
		RESOURCE_ID INTEGER NOT NULL,
		TEAM_ID INTEGER NOT NULL,
		ITERATION_ID INTEGER NOT NULL,
		RELEASE_ID INTEGER NOT NULL,
		FIXEDINRELEASE_ID INTEGER NOT NULL,
		STATUS_ID INTEGER NOT NULL,
		REQUEST_TYPE_ID INTEGER NOT NULL,
		REQUEST_CATEGORY_ID INTEGER NOT NULL,
		PLANNED_WORK INTEGER DEFAULT NOT NULL,
		TESTPLAN_ID INTEGER NOT NULL,
		ACTUAL_WORK INTEGER DEFAULT NOT NULL,
		TOTAL_REQUESTS INTEGER DEFAULT NOT NULL,
		TOTAL_BLOCKING INTEGER DEFAULT NOT NULL,
		EXTERNAL_KEY1 INTEGER DEFAULT -1 NOT NULL,
		SOURCE_ID VARCHAR(36) DEFAULT '-1' NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;	

CREATE TABLE H_REQUEST_TPLN_METRICS_TOTAL (
		REQUEST_METRIC_ID INTEGER NOT NULL,
		REQUEST_ID INTEGER NOT NULL
	)
	IN DATABASE $DBNAME;
	
CREATE TABLE H_REQUEST_TPLN_METRICS_BLOCK (
		REQUEST_METRIC_ID INTEGER NOT NULL,
		REQUEST_ID INTEGER NOT NULL
	)
	IN DATABASE $DBNAME;			

CREATE TABLE F_REQUEST_AGING (
		AGING_METRIC_ID INTEGER NOT NULL,
		REQUEST_CLASS_ID INTEGER NOT NULL,
		STATE_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		COMPONENT_ID INTEGER NOT NULL,
		RESOURCE_ID INTEGER NOT NULL,
		SEVERITY_ID INTEGER NOT NULL,
		PRIORITY_ID INTEGER NOT NULL,
		ITERATION_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		REQUEST_TYPE_ID INTEGER NOT NULL,
		STATE_MIN INTEGER DEFAULT NOT NULL,
		STATE_MAX INTEGER DEFAULT NOT NULL,
		STATE_TOTAL_DAYS INTEGER DEFAULT NOT NULL,
		TOTAL_REQUESTS INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;
	
CREATE TABLE F_C_REQUEST_AGING (
		AGING_METRIC_ID INTEGER NOT NULL,
		REQUEST_CLASS_ID INTEGER NOT NULL,
		STATE_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		COMPONENT_ID INTEGER NOT NULL,
		RESOURCE_ID INTEGER NOT NULL,
		SEVERITY_ID INTEGER NOT NULL,
		PRIORITY_ID INTEGER NOT NULL,
		ITERATION_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		REQUEST_TYPE_ID INTEGER NOT NULL,
		STATE_MIN INTEGER DEFAULT NOT NULL,
		STATE_MAX INTEGER DEFAULT NOT NULL,
		STATE_TOTAL_DAYS INTEGER DEFAULT NOT NULL,
		TOTAL_REQUESTS INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;	

CREATE TABLE H_REQUEST_AGING_TOTAL(
		AGING_METRIC_ID INTEGER NOT NULL,
		REQUEST_ID INTEGER NOT NULL
)IN DATABASE $DBNAME;

CREATE TABLE H_REQUEST_AGING_MIN(
		AGING_METRIC_ID INTEGER NOT NULL,
		REQUEST_ID INTEGER NOT NULL
)IN DATABASE $DBNAME;

CREATE TABLE H_REQUEST_AGING_MAX(
		AGING_METRIC_ID INTEGER NOT NULL,
		REQUEST_ID INTEGER NOT NULL
)IN DATABASE $DBNAME;

CREATE TABLE F_REQUEST_TPLN_AGING (
		AGING_METRIC_ID INTEGER NOT NULL,
		REQUEST_CLASS_ID INTEGER NOT NULL,
		STATE_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		COMPONENT_ID INTEGER NOT NULL,
		RESOURCE_ID INTEGER NOT NULL,
		SEVERITY_ID INTEGER NOT NULL,
		PRIORITY_ID INTEGER NOT NULL,
		ITERATION_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		REQUEST_TYPE_ID INTEGER NOT NULL,
		TESTPLAN_ID INTEGER NOT NULL,
		STATE_MIN INTEGER DEFAULT NOT NULL,
		STATE_MAX INTEGER DEFAULT NOT NULL,
		STATE_TOTAL_DAYS INTEGER DEFAULT NOT NULL,
		TOTAL_REQUESTS INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;
	
CREATE TABLE F_C_REQUEST_TPLN_AGING (
		AGING_METRIC_ID INTEGER NOT NULL,
		REQUEST_CLASS_ID INTEGER NOT NULL,
		STATE_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		COMPONENT_ID INTEGER NOT NULL,
		RESOURCE_ID INTEGER NOT NULL,
		SEVERITY_ID INTEGER NOT NULL,
		PRIORITY_ID INTEGER NOT NULL,
		ITERATION_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		REQUEST_TYPE_ID INTEGER NOT NULL,
		TESTPLAN_ID INTEGER NOT NULL,
		STATE_MIN INTEGER DEFAULT NOT NULL,
		STATE_MAX INTEGER DEFAULT NOT NULL,
		STATE_TOTAL_DAYS INTEGER DEFAULT NOT NULL,
		TOTAL_REQUESTS INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;	

CREATE TABLE H_REQUEST_AGING_TPLN_TOTAL(
		AGING_METRIC_ID INTEGER NOT NULL,
		REQUEST_ID INTEGER NOT NULL
)IN DATABASE $DBNAME;

CREATE TABLE H_REQUEST_AGING_TPLN_MIN(
		AGING_METRIC_ID INTEGER NOT NULL,
		REQUEST_ID INTEGER NOT NULL
)IN DATABASE $DBNAME;

CREATE TABLE H_REQUEST_AGING_TPLN_MAX(
		AGING_METRIC_ID INTEGER NOT NULL,
		REQUEST_ID INTEGER NOT NULL
)IN DATABASE $DBNAME;
	
CREATE TABLE F_REQUEST_TURNAROUND (
		TURNAROUND_METRIC_ID INTEGER NOT NULL,
		REQUEST_CLASS_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		COMPONENT_ID INTEGER NOT NULL,
		RESOURCE_ID INTEGER NOT NULL,
		SEVERITY_ID INTEGER NOT NULL,
		PRIORITY_ID INTEGER NOT NULL,
		ITERATION_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		REQUEST_TYPE_ID INTEGER NOT NULL,
		TURNAROUND_MIN INTEGER DEFAULT NOT NULL,
		TURNAROUND_MAX INTEGER DEFAULT NOT NULL,
		TOTAL_DAYS INTEGER DEFAULT NOT NULL,
		TOTAL_REQUESTS INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;	
	
CREATE TABLE F_C_REQUEST_TURNAROUND (
		TURNAROUND_METRIC_ID INTEGER NOT NULL,
		REQUEST_CLASS_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		COMPONENT_ID INTEGER NOT NULL,
		RESOURCE_ID INTEGER NOT NULL,
		SEVERITY_ID INTEGER NOT NULL,
		PRIORITY_ID INTEGER NOT NULL,
		ITERATION_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		REQUEST_TYPE_ID INTEGER NOT NULL,
		TURNAROUND_MIN INTEGER DEFAULT NOT NULL,
		TURNAROUND_MAX INTEGER DEFAULT NOT NULL,
		TOTAL_DAYS INTEGER DEFAULT NOT NULL,
		TOTAL_REQUESTS INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;		

CREATE TABLE H_REQUEST_TURNAROUND_TOTAL(
		TURNAROUND_METRIC_ID INTEGER NOT NULL,
		REQUEST_ID INTEGER NOT NULL
)IN DATABASE $DBNAME;

CREATE TABLE H_REQUEST_TURNAROUND_MIN(
		TURNAROUND_METRIC_ID INTEGER NOT NULL,
		REQUEST_ID INTEGER NOT NULL
)IN DATABASE $DBNAME;

CREATE TABLE H_REQUEST_TURNAROUND_MAX(
		TURNAROUND_METRIC_ID INTEGER NOT NULL,
		REQUEST_ID INTEGER NOT NULL
)IN DATABASE $DBNAME;

CREATE TABLE F_REQUEST_TPLN_TURNAROUND (
		TURNAROUND_METRIC_ID INTEGER NOT NULL,
		REQUEST_CLASS_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		COMPONENT_ID INTEGER NOT NULL,
		RESOURCE_ID INTEGER NOT NULL,
		SEVERITY_ID INTEGER NOT NULL,
		PRIORITY_ID INTEGER NOT NULL,
		ITERATION_ID INTEGER NOT NULL,
		TESTPLAN_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		REQUEST_TYPE_ID INTEGER NOT NULL,
		TURNAROUND_MIN INTEGER DEFAULT NOT NULL,
		TURNAROUND_MAX INTEGER DEFAULT NOT NULL,
		TOTAL_DAYS INTEGER DEFAULT NOT NULL,
		TOTAL_REQUESTS INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;	
	
CREATE TABLE F_C_REQUEST_TPLN_TURNAROUND (
		TURNAROUND_METRIC_ID INTEGER NOT NULL,
		REQUEST_CLASS_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		COMPONENT_ID INTEGER NOT NULL,
		RESOURCE_ID INTEGER NOT NULL,
		SEVERITY_ID INTEGER NOT NULL,
		PRIORITY_ID INTEGER NOT NULL,
		ITERATION_ID INTEGER NOT NULL,
		TESTPLAN_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		REQUEST_TYPE_ID INTEGER NOT NULL,
		TURNAROUND_MIN INTEGER DEFAULT NOT NULL,
		TURNAROUND_MAX INTEGER DEFAULT NOT NULL,
		TOTAL_DAYS INTEGER DEFAULT NOT NULL,
		TOTAL_REQUESTS INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;		

CREATE TABLE H_REQUEST_TPLN_TURNAROUND_TOT(
		TURNAROUND_METRIC_ID INTEGER NOT NULL,
		REQUEST_ID INTEGER NOT NULL
)IN DATABASE $DBNAME;

CREATE TABLE H_REQUEST_TPLN_TURNAROUND_MIN(
		TURNAROUND_METRIC_ID INTEGER NOT NULL,
		REQUEST_ID INTEGER NOT NULL
)IN DATABASE $DBNAME;

CREATE TABLE H_REQUEST_TPLN_TURNAROUND_MAX(
		TURNAROUND_METRIC_ID INTEGER NOT NULL,
		REQUEST_ID INTEGER NOT NULL
)IN DATABASE $DBNAME;

CREATE TABLE F_REQUEST_CLOSURE_DATE_METRICS (
		REQCDT_METRIC_ID INTEGER NOT NULL,
		REQUEST_CLASS_ID INTEGER NOT NULL,
		RELEASE_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		COMPONENT_ID INTEGER NOT NULL,
		STATUS_ID INTEGER NOT NULL,
		CUSTOMER_PRIORITY_ID INTEGER NOT NULL,
		SEVERITY_ID INTEGER NOT NULL,
		ITERATION_ID INTEGER NOT NULL,
		CLOSED_DATE_ID INTEGER NOT NULL,
		REQUEST_TYPE_ID INTEGER NOT NULL,
		TOTAL_COUNT INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;

CREATE TABLE H_REQUEST_CLOSURE_DATE_METRICS (
		REQCDT_METRIC_ID INTEGER NOT NULL,
        REQUEST_ID INTEGER NOT NULL
       )IN DATABASE $DBNAME;
       
CREATE TABLE F_REQUE_CLOSE_REQUI_DT_METRICS (
		REQCDT_METRIC_ID INTEGER NOT NULL,
		REQUEST_CLASS_ID INTEGER NOT NULL,
		RELEASE_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		COMPONENT_ID INTEGER NOT NULL,
		REQUIREMENT_ID INTEGER NOT NULL,
		STATUS_ID INTEGER NOT NULL,
		CUSTOMER_PRIORITY_ID INTEGER NOT NULL,
		SEVERITY_ID INTEGER NOT NULL,
		ITERATION_ID INTEGER NOT NULL,
		CLOSED_DATE_ID INTEGER NOT NULL,
		REQUEST_TYPE_ID INTEGER NOT NULL,
		TOTAL_COUNT INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;	

CREATE TABLE H_REQUE_CLOSE_REQUI_DT_METRICS (
		REQCDT_METRIC_ID INTEGER NOT NULL,
        REQUEST_ID INTEGER NOT NULL
       )IN DATABASE $DBNAME;
       
CREATE TABLE F_REQUE_CLOSE_TPLN_DT_METRICS (
		REQCDT_METRIC_ID INTEGER NOT NULL,
		REQUEST_CLASS_ID INTEGER NOT NULL,
		RELEASE_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		COMPONENT_ID INTEGER NOT NULL,
		STATUS_ID INTEGER NOT NULL,
		CUSTOMER_PRIORITY_ID INTEGER NOT NULL,
		SEVERITY_ID INTEGER NOT NULL,
		TESTPLAN_ID INTEGER NOT NULL,
		ITERATION_ID INTEGER NOT NULL,
		CLOSED_DATE_ID INTEGER NOT NULL,
		REQUEST_TYPE_ID INTEGER NOT NULL,
		TOTAL_COUNT INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;	

CREATE TABLE H_REQUE_CLOSE_TPLN_DT_METRICS (
		REQCDT_METRIC_ID INTEGER NOT NULL,
        REQUEST_ID INTEGER NOT NULL
       )IN DATABASE $DBNAME;       
       
CREATE TABLE F_EXECUTION_RESULT_METRICS (
		EXERES_METRICS_ID INTEGER NOT NULL,
		EXECRES_CLASS_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		ASSETREGISTRY_ID INTEGER NOT NULL,
		TESTCASE_ID INTEGER NOT NULL,
		VERDICT_ID INTEGER NOT NULL,
		TESTPLAN_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		TOTAL_EXERES INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;
	
CREATE TABLE F_C_EXECUTION_RESULT_METRICS (
		EXERES_METRICS_ID INTEGER NOT NULL,
		EXECRES_CLASS_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		ASSETREGISTRY_ID INTEGER NOT NULL,
		TESTCASE_ID INTEGER NOT NULL,
		VERDICT_ID INTEGER NOT NULL,
		TESTPLAN_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		TOTAL_EXERES INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;	
	
CREATE TABLE F_EXECUTION_RES_ITER_METRICS (
		EXERES_METRICS_ID INTEGER NOT NULL,
		EXECRES_CLASS_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		ITERATION_ID INTEGER NOT NULL,
		ASSETREGISTRY_ID INTEGER NOT NULL,
		TESTCASE_ID INTEGER NOT NULL,
		VERDICT_ID INTEGER NOT NULL,
		TESTPLAN_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		TOTAL_EXERES INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;
	
CREATE TABLE F_C_EXEC_RESULT_ITER_METRICS (
		EXERES_METRICS_ID INTEGER NOT NULL,
		EXECRES_CLASS_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		ITERATION_ID INTEGER NOT NULL,
		ASSETREGISTRY_ID INTEGER NOT NULL,
		TESTCASE_ID INTEGER NOT NULL,
		VERDICT_ID INTEGER NOT NULL,
		TESTPLAN_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		TOTAL_EXERES INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;		

CREATE TABLE F_REQUEST_CREATION_DT_METRICS (
		REQDT_METRIC_ID INTEGER NOT NULL,
		REQUEST_CLASS_ID INTEGER NOT NULL,
		RELEASE_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		COMPONENT_ID INTEGER NOT NULL,
		STATUS_ID INTEGER NOT NULL,
		SEVERITY_ID INTEGER NOT NULL,
		CUSTOMER_PRIORITY_ID INTEGER NOT NULL,
		CREATION_DATE_ID INTEGER NOT NULL,
		REQUEST_TYPE_ID INTEGER NOT NULL,
		TEAM_ID INTEGER NOT NULL,
		REQUEST_CATEGORY_ID INTEGER NOT NULL,
		STATE_ID  INTEGER NOT NULL,
		PRIORITY_ID INTEGER NOT NULL,
		ITERATION_ID INTEGER NOT NULL,
		PLANNED_DURATION INTEGER DEFAULT NOT NULL,
		ACTUAL_DURATION INTEGER  DEFAULT NOT NULL,
		STORY_POINTS INTEGER  DEFAULT NOT NULL,
		TOTAL_COUNT INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;

CREATE TABLE H_REQUEST_CREATION_DT_METRICS (
		REQDT_METRIC_ID INTEGER NOT NULL,
        REQUEST_ID INTEGER NOT NULL
       )IN DATABASE $DBNAME;
       
CREATE TABLE F_REQU_CREATI_TPLN_DT_METRICS (
		REQDT_METRIC_ID INTEGER NOT NULL,
		REQUEST_CLASS_ID INTEGER NOT NULL,
		RELEASE_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		COMPONENT_ID INTEGER NOT NULL,
		STATUS_ID INTEGER NOT NULL,
		SEVERITY_ID INTEGER NOT NULL,
		CUSTOMER_PRIORITY_ID INTEGER NOT NULL,
		CREATION_DATE_ID INTEGER NOT NULL,
		REQUEST_TYPE_ID INTEGER NOT NULL,
		TEAM_ID INTEGER NOT NULL,
		REQUEST_CATEGORY_ID INTEGER NOT NULL,
		STATE_ID  INTEGER NOT NULL,
		PRIORITY_ID INTEGER NOT NULL,
		ITERATION_ID INTEGER NOT NULL,
		TESTPLAN_ID INTEGER NOT NULL,
		PLANNED_DURATION INTEGER DEFAULT NOT NULL,
		ACTUAL_DURATION INTEGER  DEFAULT NOT NULL,
		STORY_POINTS INTEGER  DEFAULT NOT NULL,
		TOTAL_COUNT INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;

CREATE TABLE H_REQU_CREATI_TPLN_DT_METRICS (
		REQDT_METRIC_ID INTEGER NOT NULL,
        REQUEST_ID INTEGER NOT NULL
       )IN DATABASE $DBNAME; 
       
CREATE TABLE F_REQU_CREATI_REQUI_DT_METRICS (
		REQDT_METRIC_ID INTEGER NOT NULL,
		REQUEST_CLASS_ID INTEGER NOT NULL,
		RELEASE_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		COMPONENT_ID INTEGER NOT NULL,
		REQUIREMENT_ID INTEGER NOT NULL,
		STATUS_ID INTEGER NOT NULL,
		SEVERITY_ID INTEGER NOT NULL,
		CUSTOMER_PRIORITY_ID INTEGER NOT NULL,
		CREATION_DATE_ID INTEGER NOT NULL,
		REQUEST_TYPE_ID INTEGER NOT NULL,
		TEAM_ID INTEGER NOT NULL,
		REQUEST_CATEGORY_ID INTEGER NOT NULL,
		STATE_ID  INTEGER NOT NULL,
		PRIORITY_ID INTEGER NOT NULL,
		ITERATION_ID INTEGER NOT NULL,
		PLANNED_DURATION INTEGER DEFAULT NOT NULL,
		ACTUAL_DURATION INTEGER  DEFAULT NOT NULL,
		STORY_POINTS INTEGER  DEFAULT NOT NULL,
		TOTAL_COUNT INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;

CREATE TABLE H_REQU_CREATI_REQUI_DT_METRICS (
		REQDT_METRIC_ID INTEGER NOT NULL,
        REQUEST_ID INTEGER NOT NULL
       )IN DATABASE $DBNAME;              
       
CREATE TABLE F_REQUEST_FAILURE_METRICS (
		REQFAIL_METRIC_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		RELEASE_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		COMPONENT_ID INTEGER NOT NULL,
		ITERATION_ID INTEGER NOT NULL,
		TOTAL_RE_FAILED INTEGER,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;
	
CREATE TABLE F_C_REQUEST_FAILURE_METRICS (
		REQFAIL_METRIC_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		RELEASE_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		COMPONENT_ID INTEGER NOT NULL,
		ITERATION_ID INTEGER NOT NULL,
		TOTAL_RE_FAILED INTEGER,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;	

CREATE TABLE H_REQUEST_FAILURE_METRICS (
		REQFAIL_METRIC_ID INTEGER NOT NULL,
		REQUEST_ID INTEGER NOT NULL
	)
	IN DATABASE $DBNAME;
	
CREATE TABLE F_REQUEST_TPLN_FAIL_METRICS (
		REQFAIL_METRIC_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		RELEASE_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		COMPONENT_ID INTEGER NOT NULL,
		ITERATION_ID INTEGER NOT NULL,
		TESTPLAN_ID INTEGER NOT NULL,
		TOTAL_RE_FAILED INTEGER,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;
	
CREATE TABLE F_C_REQUEST_TPLN_FAIL_METRICS (
		REQFAIL_METRIC_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		RELEASE_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		COMPONENT_ID INTEGER NOT NULL,
		ITERATION_ID INTEGER NOT NULL,
		TESTPLAN_ID INTEGER NOT NULL,
		TOTAL_RE_FAILED INTEGER,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;	

CREATE TABLE H_REQUEST_TPLN_FAIL_METRICS (
		REQFAIL_METRIC_ID INTEGER NOT NULL,
		REQUEST_ID INTEGER NOT NULL
	)
	IN DATABASE $DBNAME;
	
CREATE TABLE F_REQUEST_REQUI_FAIL_METRICS (
		REQFAIL_METRIC_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		RELEASE_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		COMPONENT_ID INTEGER NOT NULL,
		REQUIREMENT_ID INTEGER NOT NULL,
		ITERATION_ID INTEGER NOT NULL,
		TOTAL_RE_FAILED INTEGER,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;
	
CREATE TABLE F_C_REQUEST_REQUI_FAIL_METRICS (
		REQFAIL_METRIC_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		RELEASE_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		COMPONENT_ID INTEGER NOT NULL,
		REQUIREMENT_ID INTEGER NOT NULL,
		ITERATION_ID INTEGER NOT NULL,
		TOTAL_RE_FAILED INTEGER,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;	

CREATE TABLE H_REQUEST_REQUI_FAIL_METRICS (
		REQFAIL_METRIC_ID INTEGER NOT NULL,
		REQUEST_ID INTEGER NOT NULL
	)
	IN DATABASE $DBNAME;		

CREATE TABLE F_REQUIREMENT_METRICS (
		REQ_METRIC_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		REQUIREMENT_CLASS_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		COMPONENT_ID INTEGER NOT NULL,
		ITERATION_ID INTEGER NOT NULL,
		RELEASE_ID INTEGER NOT NULL,
		RESOURCE_ID INTEGER NOT NULL,
		STATE_ID INTEGER NOT NULL,
		STATUS_ID INTEGER NOT NULL,
		STABILITY_ID INTEGER NOT NULL,
		DIFFICULTY_ID INTEGER NOT NULL,
		PRIORITY_ID INTEGER NOT NULL,
		REQUIREMENT_TYPE_ID INTEGER NOT NULL,
		TOTAL_CHANGES INTEGER DEFAULT NOT NULL,
		TOTAL_REQUIREMENTS INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;
	
CREATE TABLE F_C_REQUIREMENT_METRICS (
		REQ_METRIC_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		REQUIREMENT_CLASS_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		COMPONENT_ID INTEGER NOT NULL,
		ITERATION_ID INTEGER NOT NULL,
		RELEASE_ID INTEGER NOT NULL,
		RESOURCE_ID INTEGER NOT NULL,
		STATE_ID INTEGER NOT NULL,
		STATUS_ID INTEGER NOT NULL,
		STABILITY_ID INTEGER NOT NULL,
		DIFFICULTY_ID INTEGER NOT NULL,
		PRIORITY_ID INTEGER NOT NULL,
		REQUIREMENT_TYPE_ID INTEGER NOT NULL,
		TOTAL_CHANGES INTEGER DEFAULT NOT NULL,
		TOTAL_REQUIREMENTS INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;	

CREATE TABLE H_REQUIREMENT_METRICS_TOTAL (
		REQ_METRIC_ID INTEGER NOT NULL,
		REQUIREMENT_ID INTEGER NOT NULL
	)
	IN DATABASE $DBNAME;
	
CREATE TABLE H_REQUIREMENT_METRICS_CHANGES (
		REQ_METRIC_ID INTEGER NOT NULL,
		REQUIREMENT_ID INTEGER NOT NULL
	)
	IN DATABASE $DBNAME;	
	
CREATE TABLE F_REQUI_TCASE_METRICS (
		REQ_METRIC_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		REQUIREMENT_CLASS_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		COMPONENT_ID INTEGER NOT NULL,
		ITERATION_ID INTEGER NOT NULL,
		RELEASE_ID INTEGER NOT NULL,
		RESOURCE_ID INTEGER NOT NULL,
		STATE_ID INTEGER NOT NULL,
		STATUS_ID INTEGER NOT NULL,
		STABILITY_ID INTEGER NOT NULL,
		DIFFICULTY_ID INTEGER NOT NULL,
		PRIORITY_ID INTEGER NOT NULL,
		TESTCASE_ID INTEGER NOT NULL,
		REQUIREMENT_TYPE_ID INTEGER NOT NULL,
		TOTAL_CHANGES INTEGER DEFAULT NOT NULL,
		TOTAL_REQUIREMENTS INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;
	
CREATE TABLE F_C_REQUI_TCASE_METRICS (
		REQ_METRIC_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		REQUIREMENT_CLASS_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		COMPONENT_ID INTEGER NOT NULL,
		ITERATION_ID INTEGER NOT NULL,
		RELEASE_ID INTEGER NOT NULL,
		RESOURCE_ID INTEGER NOT NULL,
		STATE_ID INTEGER NOT NULL,
		STATUS_ID INTEGER NOT NULL,
		STABILITY_ID INTEGER NOT NULL,
		DIFFICULTY_ID INTEGER NOT NULL,
		PRIORITY_ID INTEGER NOT NULL,
		TESTCASE_ID INTEGER NOT NULL,
		REQUIREMENT_TYPE_ID INTEGER NOT NULL,
		TOTAL_CHANGES INTEGER DEFAULT NOT NULL,
		TOTAL_REQUIREMENTS INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;	

CREATE TABLE H_REQUI_TCASE_METRICS_TOTAL (
		REQ_METRIC_ID INTEGER NOT NULL,
		REQUIREMENT_ID INTEGER NOT NULL
	)
	IN DATABASE $DBNAME;
	
CREATE TABLE H_REQUI_TCASE_METRICS_CHANGES (
		REQ_METRIC_ID INTEGER NOT NULL,
		REQUIREMENT_ID INTEGER NOT NULL
	)
	IN DATABASE $DBNAME;	
	
CREATE TABLE F_REQUIREMENT_TPLN_METRICS (
		REQ_METRIC_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		REQUIREMENT_CLASS_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		COMPONENT_ID INTEGER NOT NULL,
		ITERATION_ID INTEGER NOT NULL,
		RELEASE_ID INTEGER NOT NULL,
		RESOURCE_ID INTEGER NOT NULL,
		STATE_ID INTEGER NOT NULL,
		STATUS_ID INTEGER NOT NULL,
		STABILITY_ID INTEGER NOT NULL,
		DIFFICULTY_ID INTEGER NOT NULL,
		PRIORITY_ID INTEGER NOT NULL,
		TESTPLAN_ID INTEGER NOT NULL,
		REQUIREMENT_TYPE_ID INTEGER NOT NULL,
		TOTAL_CHANGES INTEGER DEFAULT NOT NULL,
		TOTAL_REQUIREMENTS INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;
	
CREATE TABLE F_C_REQUIREMENT_TPLN_METRICS (
		REQ_METRIC_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		REQUIREMENT_CLASS_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		COMPONENT_ID INTEGER NOT NULL,
		ITERATION_ID INTEGER NOT NULL,
		RELEASE_ID INTEGER NOT NULL,
		RESOURCE_ID INTEGER NOT NULL,
		STATE_ID INTEGER NOT NULL,
		STATUS_ID INTEGER NOT NULL,
		STABILITY_ID INTEGER NOT NULL,
		DIFFICULTY_ID INTEGER NOT NULL,
		PRIORITY_ID INTEGER NOT NULL,
		TESTPLAN_ID INTEGER NOT NULL,
		REQUIREMENT_TYPE_ID INTEGER NOT NULL,
		TOTAL_CHANGES INTEGER DEFAULT NOT NULL,
		TOTAL_REQUIREMENTS INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;	

CREATE TABLE H_REQUI_TPLN_METRICS_TOTAL (
		REQ_METRIC_ID INTEGER NOT NULL,
		REQUIREMENT_ID INTEGER NOT NULL
	)
	IN DATABASE $DBNAME;
	
CREATE TABLE H_REQUI_TPLN_METRICS_CHANGES (
		REQ_METRIC_ID INTEGER NOT NULL,
		REQUIREMENT_ID INTEGER NOT NULL
	)
	IN DATABASE $DBNAME;			

CREATE TABLE F_EXECUTION_WORKITEM_METRICS (
		EXECWORKITEM_METRIC_ID INTEGER NOT NULL,
		EXECWORKIT_CLASS_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		TESTPLAN_ID INTEGER NOT NULL,
		VERDICT_ID INTEGER NOT NULL,
		CONFIGURATION_ID INTEGER NOT NULL,
		SUM_WEIGHT INTEGER DEFAULT NOT NULL ,
		NUMBER_EXECWKITM INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;
	
CREATE TABLE F_C_EXECUTION_WORKITEM_METRICS (
		EXECWORKITEM_METRIC_ID INTEGER NOT NULL,
		EXECWORKIT_CLASS_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		TESTPLAN_ID INTEGER NOT NULL,
		VERDICT_ID INTEGER NOT NULL,
		CONFIGURATION_ID INTEGER NOT NULL,
		SUM_WEIGHT INTEGER DEFAULT NOT NULL ,
		NUMBER_EXECWKITM INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;	

CREATE TABLE H_EXECUTION_WORKITEM_METRICS (
		EXECWORKITEM_METRIC_ID INTEGER NOT NULL,
		EXECWORKITEM_ID INTEGER NOT NULL
	)
	IN DATABASE $DBNAME;

CREATE TABLE F_EXEC_WORKITEM_ITER_METRICS (
		EXECWORKITEM_METRIC_ID INTEGER NOT NULL,
		EXECWORKIT_CLASS_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		ITERATION_ID INTEGER NOT NULL,
		TESTPLAN_ID INTEGER NOT NULL,
		VERDICT_ID INTEGER NOT NULL,
		CONFIGURATION_ID INTEGER NOT NULL,
		SUM_WEIGHT INTEGER DEFAULT NOT NULL ,
		NUMBER_EXECWKITM INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;
	
CREATE TABLE F_C_EXEC_WORKITEM_ITER_METRICS (
		EXECWORKITEM_METRIC_ID INTEGER NOT NULL,
		EXECWORKIT_CLASS_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		ITERATION_ID INTEGER NOT NULL,
		TESTPLAN_ID INTEGER NOT NULL,
		VERDICT_ID INTEGER NOT NULL,
		CONFIGURATION_ID INTEGER NOT NULL,
		SUM_WEIGHT INTEGER DEFAULT NOT NULL ,
		NUMBER_EXECWKITM INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;	

CREATE TABLE H_EXEC_WORKITEM_ITER_METRICS (
		EXECWORKITEM_METRIC_ID INTEGER NOT NULL,
		EXECWORKITEM_ID INTEGER NOT NULL
	)
	IN DATABASE $DBNAME;
	
CREATE TABLE F_EXEC_WORKITEM_REQU_METRICS (
		EXECWORKITEM_METRIC_ID INTEGER NOT NULL,
		EXECWORKIT_CLASS_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		RELEASE_ID INTEGER NOT NULL,
		REQUIREMENT_ID INTEGER NOT NULL,
		TESTPLAN_ID INTEGER NOT NULL,
		VERDICT_ID INTEGER NOT NULL,
		CONFIGURATION_ID INTEGER NOT NULL,
		SUM_WEIGHT INTEGER DEFAULT NOT NULL ,
		NUMBER_EXECWKITM INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;
	
CREATE TABLE F_C_EXEC_WORKITEM_REQU_METRICS (
		EXECWORKITEM_METRIC_ID INTEGER NOT NULL,
		EXECWORKIT_CLASS_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		RELEASE_ID INTEGER NOT NULL,
		REQUIREMENT_ID INTEGER NOT NULL,
		TESTPLAN_ID INTEGER NOT NULL,
		VERDICT_ID INTEGER NOT NULL,
		CONFIGURATION_ID INTEGER NOT NULL,
		SUM_WEIGHT INTEGER DEFAULT NOT NULL ,
		NUMBER_EXECWKITM INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;	

CREATE TABLE H_EXEC_WORKITEM_REQU_METRICS (
		EXECWORKITEM_METRIC_ID INTEGER NOT NULL,
		EXECWORKITEM_ID INTEGER NOT NULL
	)
	IN DATABASE $DBNAME;	

CREATE TABLE F_TESTCASE_METRICS (
		TSTCASE_METRIC_ID INTEGER NOT NULL,
		TESTCASE_CLASS_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		TESTPLAN_ID INTEGER NOT NULL,
		STATE_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		TOTAL_TESTCASES INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;
	
CREATE TABLE F_C_TESTCASE_METRICS (
		TSTCASE_METRIC_ID INTEGER NOT NULL,
		TESTCASE_CLASS_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		TESTPLAN_ID INTEGER NOT NULL,
		STATE_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		TOTAL_TESTCASES INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;	

CREATE TABLE H_TESTCASE_METRICS (
		TSTCASE_METRIC_ID INTEGER NOT NULL,
		TESTCASE_ID INTEGER NOT NULL
	)
	IN DATABASE $DBNAME;
	
CREATE TABLE F_TESTCASE_ITER_METRICS (
		TSTCASE_METRIC_ID INTEGER NOT NULL,
		TESTCASE_CLASS_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		ITERATION_ID INTEGER NOT NULL,
		TESTPLAN_ID INTEGER NOT NULL,
		STATE_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		TOTAL_TESTCASES INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;
	
CREATE TABLE F_C_TESTCASE_ITER_METRICS (
		TSTCASE_METRIC_ID INTEGER NOT NULL,
		TESTCASE_CLASS_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		ITERATION_ID INTEGER NOT NULL,
		TESTPLAN_ID INTEGER NOT NULL,
		STATE_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		TOTAL_TESTCASES INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;	

CREATE TABLE H_TESTCASE_ITER_METRICS (
		TSTCASE_METRIC_ID INTEGER NOT NULL,
		TESTCASE_ID INTEGER NOT NULL
	)
	IN DATABASE $DBNAME;	
	
CREATE TABLE F_TESTCASE_REQUI_METRICS (
		TSTCASE_METRIC_ID INTEGER NOT NULL,
		TESTCASE_CLASS_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		TESTPLAN_ID INTEGER NOT NULL,
		REQUIREMENT_ID INTEGER NOT NULL,
		STATE_ID INTEGER NOT NULL,
		TOTAL_TESTCASES INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;
	
CREATE TABLE F_C_TESTCASE_REQUI_METRICS (
		TSTCASE_METRIC_ID INTEGER NOT NULL,
		TESTCASE_CLASS_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		TESTPLAN_ID INTEGER NOT NULL,
		REQUIREMENT_ID INTEGER NOT NULL,
		STATE_ID INTEGER NOT NULL,
		TOTAL_TESTCASES INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;	

CREATE TABLE H_TESTCASE_REQUI_METRICS (
		TSTCASE_METRIC_ID INTEGER NOT NULL,
		TESTCASE_ID INTEGER NOT NULL
	)
	IN DATABASE $DBNAME;	

CREATE TABLE F_BUILD_METRICS (
		BUILD_METRIC_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		BUILD_CLASS_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		COMPONENT_ID INTEGER NOT NULL,
		BUILD_TYPE_ID INTEGER NOT NULL,
		NUMBER_ATTEMPTS INTEGER DEFAULT NOT NULL,
		NUMBER_FAIL INTEGER DEFAULT NOT NULL,
		NUMBER_PASS INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;
	
CREATE TABLE F_C_BUILD_METRICS (
		BUILD_METRIC_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		BUILD_CLASS_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		COMPONENT_ID INTEGER NOT NULL,
		BUILD_TYPE_ID INTEGER NOT NULL,
		NUMBER_ATTEMPTS INTEGER DEFAULT NOT NULL,
		NUMBER_FAIL INTEGER DEFAULT NOT NULL,
		NUMBER_PASS INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;	

CREATE TABLE H_BUILD_ATTEMPTS (
		BUILD_METRIC_ID INTEGER NOT NULL,
		BUILD_ID INTEGER NOT NULL
	)
	IN DATABASE $DBNAME;
	
CREATE TABLE H_BUILD_FAIL (
		BUILD_METRIC_ID INTEGER NOT NULL,
		BUILD_ID INTEGER NOT NULL
	)
	IN DATABASE $DBNAME;	

CREATE TABLE H_BUILD_PASS (
		BUILD_METRIC_ID INTEGER NOT NULL,
		BUILD_ID INTEGER NOT NULL
	)
	IN DATABASE $DBNAME;
	
	
CREATE TABLE F_BUILD_REQU_METRICS (
		BUILD_METRIC_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		BUILD_CLASS_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		COMPONENT_ID INTEGER NOT NULL,
		RELEASE_ID INTEGER NOT NULL,
		ITERATION_ID INTEGER NOT NULL,
		BUILD_TYPE_ID INTEGER NOT NULL,
		NUMBER_ATTEMPTS INTEGER DEFAULT NOT NULL,
		NUMBER_FAIL INTEGER DEFAULT NOT NULL,
		NUMBER_PASS INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;
	
CREATE TABLE F_C_BUILD_REQU_METRICS (
		BUILD_METRIC_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		BUILD_CLASS_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		COMPONENT_ID INTEGER NOT NULL,
		RELEASE_ID INTEGER NOT NULL,
		ITERATION_ID INTEGER NOT NULL,
		BUILD_TYPE_ID INTEGER NOT NULL,
		NUMBER_ATTEMPTS INTEGER DEFAULT NOT NULL,
		NUMBER_FAIL INTEGER DEFAULT NOT NULL,
		NUMBER_PASS INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;	

CREATE TABLE H_BUILD_REQU_ATTEMPTS (
		BUILD_METRIC_ID INTEGER NOT NULL,
		BUILD_ID INTEGER NOT NULL
	)
	IN DATABASE $DBNAME;
	
CREATE TABLE H_BUILD_REQU_FAIL (
		BUILD_METRIC_ID INTEGER NOT NULL,
		BUILD_ID INTEGER NOT NULL
	)
	IN DATABASE $DBNAME;	

CREATE TABLE H_BUILD_REQU_PASS (
		BUILD_METRIC_ID INTEGER NOT NULL,
		BUILD_ID INTEGER NOT NULL
	)
	IN DATABASE $DBNAME;
		
CREATE TABLE F_BUILD_REQUI_METRICS (
		BUILD_METRIC_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		BUILD_CLASS_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		COMPONENT_ID INTEGER NOT NULL,
		RELEASE_ID INTEGER NOT NULL,
		ITERATION_ID INTEGER NOT NULL,
		REQUIREMENT_ID INTEGER NOT NULL,
		BUILD_TYPE_ID INTEGER NOT NULL,
		NUMBER_ATTEMPTS INTEGER DEFAULT NOT NULL,
		NUMBER_FAIL INTEGER DEFAULT NOT NULL,
		NUMBER_PASS INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;	
	
CREATE TABLE F_C_BUILD_REQUI_METRICS (
		BUILD_METRIC_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		BUILD_CLASS_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		COMPONENT_ID INTEGER NOT NULL,
		RELEASE_ID INTEGER NOT NULL,
		ITERATION_ID INTEGER NOT NULL,
		REQUIREMENT_ID INTEGER NOT NULL,
		BUILD_TYPE_ID INTEGER NOT NULL,
		NUMBER_ATTEMPTS INTEGER DEFAULT NOT NULL,
		NUMBER_FAIL INTEGER DEFAULT NOT NULL,
		NUMBER_PASS INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;	
	

CREATE TABLE H_BUILD_REQUI_ATTEMPTS (
		BUILD_METRIC_ID INTEGER NOT NULL,
		BUILD_ID INTEGER NOT NULL
	)
	IN DATABASE $DBNAME;
	
CREATE TABLE H_BUILD_REQUI_FAIL (
		BUILD_METRIC_ID INTEGER NOT NULL,
		BUILD_ID INTEGER NOT NULL
	)
	IN DATABASE $DBNAME;	

CREATE TABLE H_BUILD_REQUI_PASS (
		BUILD_METRIC_ID INTEGER NOT NULL,
		BUILD_ID INTEGER NOT NULL
	)
	IN DATABASE $DBNAME;		
	
CREATE TABLE F_BUILD_EXECUTION_DT_METRICS (
		BUILD_EXEC_METRIC_ID INTEGER NOT NULL,
		END_DATE_ID INTEGER NOT NULL,
		BUILD_CLASS_ID INTEGER NOT NULL,		
		PROJECT_ID INTEGER NOT NULL,
		BUILD_TYPE_ID INTEGER NOT NULL,
		STATUS_ID INTEGER NOT NULL,
		NUMBER_ATTEMPTS INTEGER DEFAULT NOT NULL,
		NUMBER_FAIL INTEGER DEFAULT NOT NULL,
		NUMBER_PASS INTEGER DEFAULT NOT NULL,
		TOTAL_BUILDS INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;	

CREATE TABLE H_BUILD_EXEC_DT_METRICS_TOT (
		BUILD_EXEC_METRIC_ID INTEGER NOT NULL,
		BUILD_ID INTEGER NOT NULL
)IN DATABASE $DBNAME;	

CREATE TABLE F_BUILD_REQU_EXEC_DT_METRICS (
		BUILD_EXEC_METRIC_ID INTEGER NOT NULL,
		END_DATE_ID INTEGER NOT NULL,
		BUILD_CLASS_ID INTEGER NOT NULL,		
		PROJECT_ID INTEGER NOT NULL,
		COMPONENT_ID INTEGER NOT NULL,
		RELEASE_ID INTEGER NOT NULL,
		ITERATION_ID INTEGER NOT NULL,
		BUILD_TYPE_ID INTEGER NOT NULL,
		STATUS_ID INTEGER NOT NULL,
		NUMBER_ATTEMPTS INTEGER DEFAULT NOT NULL,
		NUMBER_FAIL INTEGER DEFAULT NOT NULL,
		NUMBER_PASS INTEGER DEFAULT NOT NULL,
		TOTAL_BUILDS INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;	

CREATE TABLE H_BUILD_REQU_EXEC_DT_MET_TOT (
		BUILD_EXEC_METRIC_ID INTEGER NOT NULL,
		BUILD_ID INTEGER NOT NULL
)IN DATABASE $DBNAME;
	
CREATE TABLE F_PROJECT_PERFORMANCE_METRICS  (
		  PERF_METRICS_ID INTEGER NOT NULL, 
		  DATE_ID INTEGER  NOT NULL, 
		  PROJECT_ID INTEGER NOT NULL, 
		  VAC DECIMAL(18,2) , 
		  BAC DECIMAL(18,2) , 
		  EAC DECIMAL(18,2) , 
		  BCWS DECIMAL(18,2) , 
		  BCWP DECIMAL(18,2) , 
		  ACWP DECIMAL(18,2) , 
		  CPI DECIMAL(18,2) , 
		  SPI DECIMAL(18,2) , 
		  CV DECIMAL(18,2) , 
		  SV DECIMAL(18,2) , 
		  REC_DATETIME TIMESTAMP DEFAULT NOT NULL)    
IN DATABASE $DBNAME ; 

CREATE TABLE F_C_PROJECT_PERFORM_METRICS  (
		  PERF_METRICS_ID INTEGER NOT NULL, 
		  DATE_ID INTEGER  NOT NULL, 
		  PROJECT_ID INTEGER NOT NULL, 
		  VAC DECIMAL(18,2) , 
		  BAC DECIMAL(18,2) , 
		  EAC DECIMAL(18,2) , 
		  BCWS DECIMAL(18,2) , 
		  BCWP DECIMAL(18,2) , 
		  ACWP DECIMAL(18,2) , 
		  CPI DECIMAL(18,2) , 
		  SPI DECIMAL(18,2) , 
		  CV DECIMAL(18,2) , 
		  SV DECIMAL(18,2) , 
		  REC_DATETIME TIMESTAMP DEFAULT NOT NULL)    
IN DATABASE $DBNAME ; 

CREATE TABLE F_CHILDREQUIREMENT_METRICS (
		CHILDREQ_METRICS_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		REQUIREMENT_CLASS_ID INTEGER NOT NULL,
		PARENT_REQUIREMENT_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		RELEASE_ID INTEGER NOT NULL,
		ITERATION_ID INTEGER NOT NULL,
		COMPONENT_ID INTEGER NOT NULL,
		REQUIREMENT_TYPE_ID INTEGER NOT NULL,
		TOTAL_CHILDREQUIREMENTS INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)
IN DATABASE $DBNAME;

CREATE TABLE F_C_CHILDREQUIREMENT_METRICS (
		CHILDREQ_METRICS_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		REQUIREMENT_CLASS_ID INTEGER NOT NULL,
		PARENT_REQUIREMENT_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		RELEASE_ID INTEGER NOT NULL,
		ITERATION_ID INTEGER NOT NULL,
		COMPONENT_ID INTEGER NOT NULL,
		REQUIREMENT_TYPE_ID INTEGER NOT NULL,
		TOTAL_CHILDREQUIREMENTS INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)
IN DATABASE $DBNAME;

CREATE TABLE H_EXECUTION_RESULT_METRICS (
		EXERES_METRICS_ID INTEGER NOT NULL,
        EXECUTION_RESULT_ID INTEGER NOT NULL
)IN DATABASE $DBNAME;

CREATE TABLE H_EXECUTION_RES_ITER_METRICS (
		EXERES_METRICS_ID INTEGER NOT NULL,
        EXECUTION_RESULT_ID INTEGER NOT NULL
)IN DATABASE $DBNAME;

CREATE TABLE H_CHILDREQUIREMENT_METRICS (
		CHILDREQ_METRICS_ID INTEGER NOT NULL,
        REQUIREMENT_ID INTEGER NOT NULL
)IN DATABASE $DBNAME;

CREATE TABLE F_TEXT_FILE_VERSION_METRICS (
		SLOC_METRICS_ID INTEGER NOT NULL,
		FILE_CLASS_ID INTEGER NOT NULL,
        FILE_ID INTEGER NOT NULL,
        RESOURCE_ID INTEGER NOT NULL,
        FILE_STREAM_ID INTEGER NOT NULL,
        PROJECT_ID INTEGER NOT NULL,
        COMPONENT_ID INTEGER NOT NULL,
        DATE_ID INTEGER NOT NULL,
        ACTIVITY_ID INTEGER NOT NULL,
        SLOC_CHANGED INTEGER DEFAULT NOT NULL,
        SLOC_TOTAL INTEGER DEFAULT NOT NULL,
        ACTUAL_WORK INTEGER NOT NULL DEFAULT,
        REC_DATETIME  TIMESTAMP DEFAULT NOT NULL
)IN DATABASE $DBNAME;

CREATE TABLE F_C_TEXT_FILE_VERSION_METRICS (
		SLOC_METRICS_ID INTEGER NOT NULL,
		FILE_CLASS_ID INTEGER NOT NULL,
        FILE_ID INTEGER NOT NULL,
        RESOURCE_ID INTEGER NOT NULL,
        FILE_STREAM_ID INTEGER NOT NULL,
        PROJECT_ID INTEGER NOT NULL,
        COMPONENT_ID INTEGER NOT NULL,
        DATE_ID INTEGER NOT NULL,
        ACTIVITY_ID INTEGER NOT NULL,
        SLOC_CHANGED INTEGER DEFAULT NOT NULL,
        SLOC_TOTAL INTEGER DEFAULT NOT NULL,
        ACTUAL_WORK INTEGER NOT NULL DEFAULT,
        REC_DATETIME  TIMESTAMP DEFAULT NOT NULL
)IN DATABASE $DBNAME;

CREATE TABLE H_TEXT_FILE_VERSION_METRICS_CH (
		SLOC_METRICS_ID INTEGER NOT NULL,
		FILE_VERSION_ID INTEGER NOT NULL
	)IN DATABASE $DBNAME;
	
CREATE TABLE H_TEXT_FILE_VERSION_METRICS_TO (
		SLOC_METRICS_ID INTEGER NOT NULL,
		FILE_VERSION_ID INTEGER NOT NULL
	)IN DATABASE $DBNAME;	

CREATE TABLE F_TEXT_FILE_VER_BSLN_METRICS (
		SLOC_METRICS_ID INTEGER NOT NULL,
		FILE_CLASS_ID INTEGER NOT NULL,
        FILE_ID INTEGER NOT NULL,
        RESOURCE_ID INTEGER NOT NULL,
        FILE_STREAM_ID INTEGER NOT NULL,
        PROJECT_ID INTEGER NOT NULL,
        COMPONENT_ID INTEGER NOT NULL,
        DATE_ID INTEGER NOT NULL,
        ACTIVITY_ID INTEGER NOT NULL,
        FILE_BASELINE_ID INTEGER NOT NULL,
        SLOC_CHANGED INTEGER DEFAULT NOT NULL,
        SLOC_TOTAL INTEGER DEFAULT NOT NULL,
        ACTUAL_WORK INTEGER NOT NULL DEFAULT,
        REC_DATETIME  TIMESTAMP DEFAULT NOT NULL
)IN DATABASE $DBNAME;

CREATE TABLE F_C_TEXT_FILE_VERBSLN_METRICS (
		SLOC_METRICS_ID INTEGER NOT NULL,
		FILE_CLASS_ID INTEGER NOT NULL,
        FILE_ID INTEGER NOT NULL,
        RESOURCE_ID INTEGER NOT NULL,
        FILE_STREAM_ID INTEGER NOT NULL,
        PROJECT_ID INTEGER NOT NULL,
        COMPONENT_ID INTEGER NOT NULL,
        DATE_ID INTEGER NOT NULL,
        ACTIVITY_ID INTEGER NOT NULL,
        FILE_BASELINE_ID INTEGER NOT NULL,
        SLOC_CHANGED INTEGER DEFAULT NOT NULL,
        SLOC_TOTAL INTEGER DEFAULT NOT NULL,
        ACTUAL_WORK INTEGER NOT NULL DEFAULT,
        REC_DATETIME  TIMESTAMP DEFAULT NOT NULL
)IN DATABASE $DBNAME;

CREATE TABLE H_TEXT_FILE_VERBSLN_METRICS_CH (
		SLOC_METRICS_ID INTEGER NOT NULL,
		FILE_VERSION_ID INTEGER NOT NULL
	)IN DATABASE $DBNAME;
	
CREATE TABLE H_TEXT_FILE_VERBSLN_METRICS_TO (
		SLOC_METRICS_ID INTEGER NOT NULL,
		FILE_VERSION_ID INTEGER NOT NULL
	)IN DATABASE $DBNAME;	
	
CREATE TABLE F_TEXT_FILE_VER_REQU_METRICS (
		SLOC_METRICS_ID INTEGER NOT NULL,
		FILE_CLASS_ID INTEGER NOT NULL,
        FILE_ID INTEGER NOT NULL,
        RESOURCE_ID INTEGER NOT NULL,
        FILE_STREAM_ID INTEGER NOT NULL,
        PROJECT_ID INTEGER NOT NULL,
        COMPONENT_ID INTEGER NOT NULL,
        REQUEST_ID INTEGER NOT NULL,
        DATE_ID INTEGER NOT NULL,
        ACTIVITY_ID INTEGER NOT NULL,
        SLOC_CHANGED INTEGER DEFAULT NOT NULL,
        SLOC_TOTAL INTEGER DEFAULT NOT NULL,
        ACTUAL_WORK INTEGER NOT NULL DEFAULT,
        REC_DATETIME  TIMESTAMP DEFAULT NOT NULL
)IN DATABASE $DBNAME;

CREATE TABLE F_C_TEXT_FILE_VER_REQU_METRICS (
		SLOC_METRICS_ID INTEGER NOT NULL,
		FILE_CLASS_ID INTEGER NOT NULL,
        FILE_ID INTEGER NOT NULL,
        RESOURCE_ID INTEGER NOT NULL,
        FILE_STREAM_ID INTEGER NOT NULL,
        PROJECT_ID INTEGER NOT NULL,
        COMPONENT_ID INTEGER NOT NULL,
        REQUEST_ID INTEGER NOT NULL,
        DATE_ID INTEGER NOT NULL,
        ACTIVITY_ID INTEGER NOT NULL,
        SLOC_CHANGED INTEGER DEFAULT NOT NULL,
        SLOC_TOTAL INTEGER DEFAULT NOT NULL,
        ACTUAL_WORK INTEGER NOT NULL DEFAULT,
        REC_DATETIME  TIMESTAMP DEFAULT NOT NULL
)IN DATABASE $DBNAME;

CREATE TABLE H_TEXT_FILE_VER_REQ_METRICS_CH (
		SLOC_METRICS_ID INTEGER NOT NULL,
		FILE_VERSION_ID INTEGER NOT NULL
	)IN DATABASE $DBNAME;
	
CREATE TABLE H_TEXT_FILE_VER_REQ_METRICS_TO (
		SLOC_METRICS_ID INTEGER NOT NULL,
		FILE_VERSION_ID INTEGER NOT NULL
	)IN DATABASE $DBNAME;			
	
CREATE TABLE F_TEXT_FILE_VERSION_DT_METRICS (
		SLOC_METRICS_ID INTEGER NOT NULL,
		FILE_CLASS_ID INTEGER NOT NULL,
        FILE_ID INTEGER NOT NULL,
        RESOURCE_ID INTEGER NOT NULL,
        FILE_STREAM_ID INTEGER NOT NULL,
        PROJECT_ID INTEGER NOT NULL,
        COMPONENT_ID INTEGER NOT NULL,
        DATE_ID INTEGER NOT NULL,
        ACTIVITY_ID INTEGER NOT NULL,
        SLOC_CHANGED INTEGER DEFAULT NOT NULL,
        SLOC_TOTAL INTEGER DEFAULT NOT NULL,
        ACTUAL_WORK INTEGER NOT NULL DEFAULT,
        REC_DATETIME  TIMESTAMP DEFAULT NOT NULL
)IN DATABASE $DBNAME;

CREATE TABLE H_TEXT_FILE_VERS_DT_METRICS_CH (
		SLOC_METRICS_ID INTEGER NOT NULL,
		FILE_VERSION_ID INTEGER NOT NULL
	)IN DATABASE $DBNAME;
	
CREATE TABLE H_TEXT_FILE_VERS_DT_METRICS_TO (
		SLOC_METRICS_ID INTEGER NOT NULL,
		FILE_VERSION_ID INTEGER NOT NULL
	)IN DATABASE $DBNAME;	
	
CREATE TABLE F_TEXT_FILE_VERSREQ_DT_METRICS (
		SLOC_METRICS_ID INTEGER NOT NULL,
		FILE_CLASS_ID INTEGER NOT NULL,
        FILE_ID INTEGER NOT NULL,
        RESOURCE_ID INTEGER NOT NULL,
        FILE_STREAM_ID INTEGER NOT NULL,
        PROJECT_ID INTEGER NOT NULL,
        COMPONENT_ID INTEGER NOT NULL,
        DATE_ID INTEGER NOT NULL,
        ACTIVITY_ID INTEGER NOT NULL,
        REQUEST_ID INTEGER NOT NULL,
        SLOC_CHANGED INTEGER DEFAULT NOT NULL,
        SLOC_TOTAL INTEGER DEFAULT NOT NULL,
        ACTUAL_WORK INTEGER NOT NULL DEFAULT,
        REC_DATETIME  TIMESTAMP DEFAULT NOT NULL
)IN DATABASE $DBNAME;

CREATE TABLE H_TXT_FILE_VERSREQ_DT_METR_CH (
		SLOC_METRICS_ID INTEGER NOT NULL,
		FILE_VERSION_ID INTEGER NOT NULL
	)IN DATABASE $DBNAME;
	
CREATE TABLE H_TXT_FILE_VERSREQ_DT_METR_TO (
		SLOC_METRICS_ID INTEGER NOT NULL,
		FILE_VERSION_ID INTEGER NOT NULL
	)IN DATABASE $DBNAME;		
						
CREATE TABLE F_EXECRESULT_DATE_METRICS(		
		EXECRESDT_METRICS_ID INTEGER NOT NULL,
		EXECRES_CLASS_ID INTEGER NOT NULL,
 		TESTCASE_ID    INTEGER NOT NULL,
 		COMPONENT_ID   INTEGER NOT NULL,
 		DAY_OF_ID INTEGER NOT NULL,
 		TESTPLAN_ID INTEGER NOT NULL,
 		PROJECT_ID INTEGER NOT NULL,
 		TOTAL_EXERES     INTEGER NOT NULL,
 		SUM_POINTS_BLOCKED INTEGER DEFAULT NOT NULL,
		SUM_POINTS_INCONCLUSIVE INTEGER DEFAULT NOT NULL,
		SUM_POINTS_ATTEMPTED INTEGER DEFAULT NOT NULL,
		SUM_POINTS_FAILED INTEGER DEFAULT NOT NULL,
		SUM_POINTS_PASSED INTEGER DEFAULT NOT NULL,
		SUM_POINTS_PERMFAILED INTEGER DEFAULT NOT NULL,
 		REC_DATETIME  TIMESTAMP DEFAULT NOT NULL)
 	IN DATABASE $DBNAME; 
 	
CREATE TABLE H_EXECRESULT_DATE_METRICS (
		EXECRESDT_METRICS_ID INTEGER NOT NULL,
		EXECUTION_RESULT_ID INTEGER NOT NULL
	)IN DATABASE $DBNAME;
	
CREATE TABLE F_EXECRESPOINTS_METRICS
(		EXECRES_METRIC_ID INTEGER NOT NULL,
		EXECRES_CLASS_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		TESTCASE_ID INTEGER NOT NULL,
		TESTPLAN_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		VERDICT_ID INTEGER NOT NULL,
		SUM_POINTS_PASSED INTEGER DEFAULT NOT NULL,
		SUM_POINTS_BLOCKED INTEGER DEFAULT NOT NULL,
		SUM_POINTS_INCONCLUSIVE INTEGER DEFAULT NOT NULL, 
		SUM_POINTS_ATTEMPTED INTEGER DEFAULT NOT NULL,
		SUM_POINTS_FAILED INTEGER DEFAULT NOT NULL,
		SUM_POINTS_PERMFAILED INTEGER DEFAULT NOT NULL,
		TOTAL_CURRENT_EXECRES INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL )
IN DATABASE $DBNAME;

CREATE TABLE F_C_EXECRESPOINTS_METRICS
(		EXECRES_METRIC_ID INTEGER NOT NULL,
		EXECRES_CLASS_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		TESTCASE_ID INTEGER NOT NULL,
		TESTPLAN_ID INTEGER NOT NULL,
		VERDICT_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		SUM_POINTS_PASSED INTEGER DEFAULT NOT NULL,
		SUM_POINTS_BLOCKED INTEGER DEFAULT NOT NULL,
		SUM_POINTS_INCONCLUSIVE INTEGER DEFAULT NOT NULL, 
		SUM_POINTS_ATTEMPTED INTEGER DEFAULT NOT NULL,
		SUM_POINTS_FAILED INTEGER DEFAULT NOT NULL,
		SUM_POINTS_PERMFAILED INTEGER DEFAULT NOT NULL,
		TOTAL_CURRENT_EXECRES INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL )
IN DATABASE $DBNAME;

CREATE TABLE H_EXECRESPOINTS_METRICS
(		EXECRES_METRIC_ID INTEGER NOT NULL,
		EXECUTION_RESULT_ID INTEGER NOT NULL
)IN DATABASE $DBNAME;
	
CREATE TABLE F_EXECRESPOINTS_ITER_METRICS
(		EXECRES_METRIC_ID INTEGER NOT NULL,
		EXECRES_CLASS_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		TESTCASE_ID INTEGER NOT NULL,
		ITERATION_ID INTEGER NOT NULL,
		TESTPLAN_ID INTEGER NOT NULL,
		VERDICT_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		SUM_POINTS_PASSED INTEGER DEFAULT NOT NULL,
		SUM_POINTS_BLOCKED INTEGER DEFAULT NOT NULL,
		SUM_POINTS_INCONCLUSIVE INTEGER DEFAULT NOT NULL, 
		SUM_POINTS_ATTEMPTED INTEGER DEFAULT NOT NULL,
		SUM_POINTS_FAILED INTEGER DEFAULT NOT NULL,
		SUM_POINTS_PERMFAILED INTEGER DEFAULT NOT NULL,
		TOTAL_CURRENT_EXECRES INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL )
IN DATABASE $DBNAME;

CREATE TABLE F_C_EXECRESPOINTS_ITER_METRICS
(		EXECRES_METRIC_ID INTEGER NOT NULL,
		EXECRES_CLASS_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		TESTCASE_ID INTEGER NOT NULL,
		ITERATION_ID INTEGER NOT NULL,
		TESTPLAN_ID INTEGER NOT NULL,
		VERDICT_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		SUM_POINTS_PASSED INTEGER DEFAULT NOT NULL,
		SUM_POINTS_BLOCKED INTEGER DEFAULT NOT NULL,
		SUM_POINTS_INCONCLUSIVE INTEGER DEFAULT NOT NULL, 
		SUM_POINTS_ATTEMPTED INTEGER DEFAULT NOT NULL,
		SUM_POINTS_FAILED INTEGER DEFAULT NOT NULL,
		SUM_POINTS_PERMFAILED INTEGER DEFAULT NOT NULL,
		TOTAL_CURRENT_EXECRES INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL )
IN DATABASE $DBNAME;

CREATE TABLE H_EXECRESPOINTS_ITER_METRICS
(		EXECRES_METRIC_ID INTEGER NOT NULL,
		EXECUTION_RESULT_ID INTEGER NOT NULL
)IN DATABASE $DBNAME;	
	
CREATE TABLE F_ACTIVITY_METRICS(
		ACTIVITY_METRICS_ID INTEGER NOT NULL,
		ACTIVITY_CLASS_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		RESOURCE_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		STATE_ID INTEGER NOT NULL,
		PRIORITY_ID INTEGER NOT NULL,
		TOTAL_ACTIVITIES INTEGER NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)IN DATABASE $DBNAME;
	
CREATE TABLE F_C_ACTIVITY_METRICS(
		ACTIVITY_METRICS_ID INTEGER NOT NULL,
		ACTIVITY_CLASS_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		RESOURCE_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		STATE_ID INTEGER NOT NULL,
		PRIORITY_ID INTEGER NOT NULL,
		TOTAL_ACTIVITIES INTEGER NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)IN DATABASE $DBNAME;	
	
CREATE TABLE H_ACTIVITY_METRICS (
		ACTIVITY_METRICS_ID INTEGER NOT NULL,
		ACTIVITY_ID INTEGER NOT NULL)
	IN DATABASE $DBNAME;
	
CREATE TABLE F_ACTIVITY_COMP_METRICS(
		ACTIVITY_METRICS_ID INTEGER NOT NULL,
		ACTIVITY_CLASS_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		RESOURCE_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		STATE_ID INTEGER NOT NULL,
		PRIORITY_ID INTEGER NOT NULL,
		COMPONENT_ID INTEGER NOT NULL,
		TOTAL_ACTIVITIES INTEGER NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)IN DATABASE $DBNAME;
	
CREATE TABLE F_C_ACTIVITY_COMP_METRICS(
		ACTIVITY_METRICS_ID INTEGER NOT NULL,
		ACTIVITY_CLASS_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		RESOURCE_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		STATE_ID INTEGER NOT NULL,
		PRIORITY_ID INTEGER NOT NULL,
		COMPONENT_ID INTEGER NOT NULL,
		TOTAL_ACTIVITIES INTEGER NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)IN DATABASE $DBNAME;	
	
CREATE TABLE H_ACTIVITY_COMP_METRICS (
		ACTIVITY_METRICS_ID INTEGER NOT NULL,
		ACTIVITY_ID INTEGER NOT NULL)
	IN DATABASE $DBNAME;
	
CREATE TABLE F_ACTIVITY_ITER_METRICS(
		ACTIVITY_METRICS_ID INTEGER NOT NULL,
		ACTIVITY_CLASS_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		RESOURCE_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		STATE_ID INTEGER NOT NULL,
		PRIORITY_ID INTEGER NOT NULL,
		ITERATION_ID INTEGER NOT NULL,
		TOTAL_ACTIVITIES INTEGER NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)IN DATABASE $DBNAME;
	
CREATE TABLE F_C_ACTIVITY_ITER_METRICS(
		ACTIVITY_METRICS_ID INTEGER NOT NULL,
		ACTIVITY_CLASS_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		RESOURCE_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		STATE_ID INTEGER NOT NULL,
		PRIORITY_ID INTEGER NOT NULL,
		ITERATION_ID INTEGER NOT NULL,
		TOTAL_ACTIVITIES INTEGER NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)IN DATABASE $DBNAME;	
	
CREATE TABLE H_ACTIVITY_ITER_METRICS (
		ACTIVITY_METRICS_ID INTEGER NOT NULL,
		ACTIVITY_ID INTEGER NOT NULL)
	IN DATABASE $DBNAME;

CREATE TABLE F_ACTIVITY_REQ_METRICS(
		ACTIVITY_METRICS_ID INTEGER NOT NULL,
		ACTIVITY_CLASS_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		REQUIREMENT_ID INTEGER NOT NULL,
		RESOURCE_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		STATE_ID INTEGER NOT NULL,
		PRIORITY_ID INTEGER NOT NULL,
		ITERATION_ID INTEGER NOT NULL,
		TOTAL_ACTIVITIES INTEGER NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)IN DATABASE $DBNAME;
	
CREATE TABLE F_C_ACTIVITY_REQ_METRICS(
		ACTIVITY_METRICS_ID INTEGER NOT NULL,
		ACTIVITY_CLASS_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		REQUIREMENT_ID INTEGER NOT NULL,
		RESOURCE_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		STATE_ID INTEGER NOT NULL,
		PRIORITY_ID INTEGER NOT NULL,
		ITERATION_ID INTEGER NOT NULL,
		TOTAL_ACTIVITIES INTEGER NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)IN DATABASE $DBNAME;	
	
CREATE TABLE H_ACTIVITY_REQ_METRICS (
		ACTIVITY_METRICS_ID INTEGER NOT NULL,
		ACTIVITY_ID INTEGER NOT NULL)
	IN DATABASE $DBNAME;


CREATE TABLE F_ACTIVITY_CREATION_DT_METRICS(
		ACTIVITYCRD_METRICS_ID INTEGER NOT NULL,
		ACTIVITY_CLASS_ID INTEGER NOT NULL,
		CREATION_DATE_ID INTEGER,
		STATE_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		RESOURCE_ID INTEGER NOT NULL,
		PRIORITY_ID INTEGER NOT NULL,
		TOTAL_ACTIVITIES INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)IN DATABASE $DBNAME;


CREATE TABLE H_ACTIVITY_CREATION_DT_METRICS (
		ACTIVITYCRD_METRICS_ID INTEGER NOT NULL,
		ACTIVITY_ID INTEGER NOT NULL)
	IN DATABASE $DBNAME;
	
CREATE TABLE F_ACT_COM_CREATION_DT_METRICS(
		ACTIVITYCRD_METRICS_ID INTEGER NOT NULL,
		ACTIVITY_CLASS_ID INTEGER NOT NULL,
		CREATION_DATE_ID INTEGER,
		STATE_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		RESOURCE_ID INTEGER NOT NULL,
		PRIORITY_ID INTEGER NOT NULL,
		COMPONENT_ID INTEGER NOT NULL,
		TOTAL_ACTIVITIES INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)IN DATABASE $DBNAME;


CREATE TABLE H_ACT_COM_CREATION_DT_METRICS (
		ACTIVITYCRD_METRICS_ID INTEGER NOT NULL,
		ACTIVITY_ID INTEGER NOT NULL)
	IN DATABASE $DBNAME;
		
CREATE TABLE F_ACT_ITER_CREATION_DT_METRICS(
		ACTIVITYCRD_METRICS_ID INTEGER NOT NULL,
		ACTIVITY_CLASS_ID INTEGER NOT NULL,
		CREATION_DATE_ID INTEGER,
		STATE_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		RESOURCE_ID INTEGER NOT NULL,
		PRIORITY_ID INTEGER NOT NULL,
		ITERATION_ID INTEGER NOT NULL,
		TOTAL_ACTIVITIES INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)IN DATABASE $DBNAME;

CREATE TABLE H_ACT_ITER_CREATION_DT_METRICS (
		ACTIVITYCRD_METRICS_ID INTEGER NOT NULL,
		ACTIVITY_ID INTEGER NOT NULL)
	IN DATABASE $DBNAME;	
	
CREATE TABLE F_ACT_REQU_CREATION_DT_METRICS(
		ACTIVITYCRD_METRICS_ID INTEGER NOT NULL,
		ACTIVITY_CLASS_ID INTEGER NOT NULL,
		CREATION_DATE_ID INTEGER,
		STATE_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		RESOURCE_ID INTEGER NOT NULL,
		PRIORITY_ID INTEGER NOT NULL,
		REQUIREMENT_ID INTEGER NOT NULL,
		TOTAL_ACTIVITIES INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)IN DATABASE $DBNAME;

CREATE TABLE H_ACT_REQUI_CREAT_DT_METRICS (
		ACTIVITYCRD_METRICS_ID INTEGER NOT NULL,
		ACTIVITY_ID INTEGER NOT NULL)
	IN DATABASE $DBNAME;	
	
CREATE TABLE F_TASK_METRICS(
		TASK_METRICS_ID INTEGER NOT NULL,
		TASK_CLASS_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		RESOURCE_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		STATE_ID INTEGER NOT NULL,
		PRIORITY_ID INTEGER NOT NULL,
		ITERATION_ID INTEGER NOT NULL,
		TASK_TYPE_ID INTEGER NOT NULL,
		TOTAL_TASKS INTEGER NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)IN DATABASE $DBNAME;
	
CREATE TABLE F_C_TASK_METRICS(
		TASK_METRICS_ID INTEGER NOT NULL,
		TASK_CLASS_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		RESOURCE_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		STATE_ID INTEGER NOT NULL,
		PRIORITY_ID INTEGER NOT NULL,
		ITERATION_ID INTEGER NOT NULL,
		TASK_TYPE_ID INTEGER NOT NULL,
		TOTAL_TASKS INTEGER NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)IN DATABASE $DBNAME;
	
CREATE TABLE H_TASK_METRICS (
		TASK_METRICS_ID INTEGER NOT NULL,
		TASK_ID INTEGER NOT NULL)
	IN DATABASE $DBNAME;
	
CREATE TABLE F_TASK_COMP_METRICS(
		TASK_METRICS_ID INTEGER NOT NULL,
		TASK_CLASS_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		RESOURCE_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		COMPONENT_ID INTEGER NOT NULL,
		STATE_ID INTEGER NOT NULL,
		PRIORITY_ID INTEGER NOT NULL,
		ITERATION_ID INTEGER NOT NULL,
		TASK_TYPE_ID INTEGER NOT NULL,
		TOTAL_TASKS INTEGER NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)IN DATABASE $DBNAME;
	
CREATE TABLE F_C_TASK_COMP_METRICS(
		TASK_METRICS_ID INTEGER NOT NULL,
		TASK_CLASS_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		RESOURCE_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		COMPONENT_ID INTEGER NOT NULL,
		STATE_ID INTEGER NOT NULL,
		PRIORITY_ID INTEGER NOT NULL,
		ITERATION_ID INTEGER NOT NULL,
		TASK_TYPE_ID INTEGER NOT NULL,
		TOTAL_TASKS INTEGER NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)IN DATABASE $DBNAME;
	
CREATE TABLE H_TASK_COMP_METRICS (
		TASK_METRICS_ID INTEGER NOT NULL,
		TASK_ID INTEGER NOT NULL)
	IN DATABASE $DBNAME;
	

CREATE TABLE F_TASK_CREATION_DT_METRICS(
		TASKCRD_METRICS_ID INTEGER NOT NULL,
		TASK_CLASS_ID INTEGER NOT NULL,
		CREATION_DATE_ID INTEGER,
		STATE_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		RESOURCE_ID INTEGER NOT NULL,
		PRIORITY_ID INTEGER NOT NULL,
		ITERATION_ID INTEGER NOT NULL,
		TASK_TYPE_ID INTEGER NOT NULL,
		TOTAL_TASKS INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)IN DATABASE $DBNAME;

CREATE TABLE H_TASK_CREATION_DT_METRICS (
		TASKCRD_METRICS_ID INTEGER NOT NULL,
		TASK_ID INTEGER NOT NULL)
	IN DATABASE $DBNAME;
	
CREATE TABLE F_TASK_CREATE_COMP_DT_METRICS(
		TASKCRD_METRICS_ID INTEGER NOT NULL,
		TASK_CLASS_ID INTEGER NOT NULL,
		CREATION_DATE_ID INTEGER,
		STATE_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		COMPONENT_ID INTEGER NOT NULL,
		RESOURCE_ID INTEGER NOT NULL,
		PRIORITY_ID INTEGER NOT NULL,
		ITERATION_ID INTEGER NOT NULL,
		TASK_TYPE_ID INTEGER NOT NULL,
		TOTAL_TASKS INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)IN DATABASE $DBNAME;

CREATE TABLE H_TASK_CREATE_COMP_DT_METRICS (
		TASKCRD_METRICS_ID INTEGER NOT NULL,
		TASK_ID INTEGER NOT NULL)
	IN DATABASE $DBNAME;	
	
CREATE TABLE F_TASK_CLOSURE_DT_METRICS(
		TASKCLS_METRICS_ID INTEGER NOT NULL,
		TASK_CLASS_ID INTEGER NOT NULL,
		CLOSURE_DATE_ID INTEGER,
		STATE_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		RESOURCE_ID INTEGER NOT NULL,
		PRIORITY_ID INTEGER NOT NULL,
		ITERATION_ID INTEGER NOT NULL,
		TASK_TYPE_ID INTEGER NOT NULL,
		TOTAL_TASKS INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)IN DATABASE $DBNAME;

CREATE TABLE H_TASK_CLOSURE_DT_METRICS (
		TASKCLS_METRICS_ID INTEGER NOT NULL,
		TASK_ID INTEGER NOT NULL)
	IN DATABASE $DBNAME;	
		
CREATE TABLE F_TASK_CLOSE_COMP_DT_METRICS(
		TASKCLS_METRICS_ID INTEGER NOT NULL,
		TASK_CLASS_ID INTEGER NOT NULL,
		CLOSURE_DATE_ID INTEGER,
		STATE_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		COMPONENT_ID INTEGER NOT NULL,
		RESOURCE_ID INTEGER NOT NULL,
		PRIORITY_ID INTEGER NOT NULL,
		ITERATION_ID INTEGER NOT NULL,
		TASK_TYPE_ID INTEGER NOT NULL,
		TOTAL_TASKS INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)IN DATABASE $DBNAME;

CREATE TABLE H_TASK_CLOSE_COMP_DT_METRICS (
		TASKCLS_METRICS_ID INTEGER NOT NULL,
		TASK_ID INTEGER NOT NULL)
	IN DATABASE $DBNAME;		

CREATE TABLE F_LAB_RESUTILIZATION_METRICS (
		LAB_RESUTIL_ID INTEGER NOT NULL,
		RESOURCE_GROUP_ID INTEGER NOT NULL, 
		OWNER_ID INTEGER NOT NULL,
		OS_TYPE_ID INTEGER NOT NULL,
		RESERVATION_DATE_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		TOTAL_MACHINES INTEGER DEFAULT NOT NULL,
		TOTAL_RESERVED_MACHINES INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
) IN DATABASE $DBNAME;

CREATE TABLE F_C_LAB_RESUTILIZATION_METRICS (
		LAB_RESUTIL_ID INTEGER NOT NULL,
		RESOURCE_GROUP_ID INTEGER NOT NULL, 
		OWNER_ID INTEGER NOT NULL,
		OS_TYPE_ID INTEGER NOT NULL,
		RESERVATION_DATE_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		TOTAL_MACHINES INTEGER DEFAULT NOT NULL,
		TOTAL_RESERVED_MACHINES INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
) IN DATABASE $DBNAME;

CREATE TABLE H_LAB_RESUTILIZATION_METRICS (
		LAB_RESUTIL_ID INTEGER NOT NULL,
		LAB_RESOURCE_ID INTEGER NOT NULL
)IN DATABASE $DBNAME;	

CREATE TABLE F_TEXT_FILE_CHANGE_METRICS (
		FTEXTCHNG_METRICS_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		PROJECT_ID  INTEGER NOT NULL,
		TEAM_ID INTEGER NOT NULL,
		FILE_STREAM_ID  INTEGER NOT NULL,
		COMPONENT_ID  INTEGER NOT NULL,
		CHANGE_SET_ADDITION_COUNT BIGINT DEFAULT NOT NULL,
		CHANGE_SET_DELETION_COUNT BIGINT DEFAULT NOT NULL,
		FILE_ADDITION_COUNT BIGINT DEFAULT NOT NULL,      
		FILE_DELETION_COUNT BIGINT DEFAULT NOT NULL,      
		FILE_MODIFICATION_COUNT BIGINT DEFAULT NOT NULL,  
		FOLDER_ADDITION_COUNT BIGINT DEFAULT NOT NULL,    
		FOLDER_DELETION_COUNT BIGINT DEFAULT NOT NULL,     
		FOLDER_MODIFICATION_COUNT BIGINT DEFAULT NOT NULL, 
		SIZE_DECREASE BIGINT DEFAULT NOT NULL,             
		SIZE_INCREASE BIGINT DEFAULT NOT NULL,             
		FILE_CLASS_ID INTEGER DEFAULT NOT NULL,
		EXTERNAL_KEY1 INTEGER  DEFAULT -1 NOT NULL,
		SOURCE_ID VARCHAR(36) DEFAULT '-1' NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
)IN DATABASE $DBNAME;

CREATE TABLE F_C_TEXT_FILE_CHANGE_METRICS (
		FTEXTCHNG_METRICS_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		PROJECT_ID  INTEGER NOT NULL,
		TEAM_ID INTEGER NOT NULL,
		FILE_STREAM_ID  INTEGER NOT NULL,
		COMPONENT_ID  INTEGER NOT NULL,
		CHANGE_SET_ADDITION_COUNT BIGINT DEFAULT NOT NULL,
		CHANGE_SET_DELETION_COUNT BIGINT DEFAULT NOT NULL,
		FILE_ADDITION_COUNT BIGINT DEFAULT NOT NULL,      
		FILE_DELETION_COUNT BIGINT DEFAULT NOT NULL,      
		FILE_MODIFICATION_COUNT BIGINT DEFAULT NOT NULL,  
		FOLDER_ADDITION_COUNT BIGINT DEFAULT NOT NULL,    
		FOLDER_DELETION_COUNT BIGINT DEFAULT NOT NULL,     
		FOLDER_MODIFICATION_COUNT BIGINT DEFAULT NOT NULL, 
		SIZE_DECREASE BIGINT DEFAULT NOT NULL,             
		SIZE_INCREASE BIGINT DEFAULT NOT NULL,             
		FILE_CLASS_ID INTEGER DEFAULT NOT NULL,
		EXTERNAL_KEY1 INTEGER  DEFAULT -1 NOT NULL,
		SOURCE_ID VARCHAR(36) DEFAULT '-1' NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
)IN DATABASE $DBNAME;

CREATE TABLE H_TEXT_FILE_CHANGE_METRICS	(
		FTEXTCHNG_METRICS_ID INTEGER NOT NULL,
		FILE_ID INTEGER NOT NULL
)IN DATABASE $DBNAME;		

CREATE TABLE F_FILE_STREAM_METRICS (
		FSTREAM_METRICS_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		FILE_STREAM_CLASS_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		TEAM_ID INTEGER NOT NULL,
		FILE_STREAM_ID INTEGER NOT NULL,
		COMPONENT_ID INTEGER NOT NULL,
		TOTALS_ITEM_COUNT BIGINT DEFAULT NOT NULL,                 
		TOTALS_CONTENT_COMPRESSED_SUM BIGINT DEFAULT NOT NULL,     
		TOTALS_CONTENT_UNCOMPRESSE_SUM BIGINT DEFAULT NOT NULL,    
		EXTERNAL_KEY1 INTEGER DEFAULT -1 NOT NULL,
		SOURCE_ID VARCHAR(36) DEFAULT '-1' NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
)IN DATABASE $DBNAME;		

CREATE TABLE F_C_FILE_STREAM_METRICS (
		FSTREAM_METRICS_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		FILE_STREAM_CLASS_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		TEAM_ID INTEGER NOT NULL,
		FILE_STREAM_ID INTEGER NOT NULL,
		COMPONENT_ID INTEGER NOT NULL,
		TOTALS_ITEM_COUNT BIGINT DEFAULT NOT NULL,                 
		TOTALS_CONTENT_COMPRESSED_SUM BIGINT DEFAULT NOT NULL,     
		TOTALS_CONTENT_UNCOMPRESSE_SUM BIGINT DEFAULT NOT NULL,    
		EXTERNAL_KEY1 INTEGER DEFAULT -1 NOT NULL,
		SOURCE_ID VARCHAR(36) DEFAULT '-1' NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
)IN DATABASE $DBNAME;		

CREATE TABLE H_FILE_STREAM_METRICS (
		FSTREAM_METRICS_ID INTEGER NOT NULL,
		FILE_STREAM_ID INTEGER NOT NULL
)IN DATABASE $DBNAME;	

CREATE TABLE F_REPORT_PLANNED_DATA (
		TARGET DECIMAL(18,2),
		UPPER_LIMIT DECIMAL(18,2),
		LOWER_LIMIT DECIMAL(18,2),
		METRIC_LABEL VARCHAR(255),
		DATE_ID INTEGER,
		PROJECT_ID INTEGER,
		COMPONENT_ID INTEGER,
		CUSTOMER_PRIORITY_ID INTEGER,
		PRIORITY_ID INTEGER,
		PRODUCT_ID INTEGER,
		RELEASE_ID INTEGER,
		RESOLUTION_ID INTEGER,
		SEVERITY_ID INTEGER,
		STATE_ID INTEGER,
		STATUS_ID INTEGER,
		TEAM_ID INTEGER,
		VERDICT_ID INTEGER,
		ITERATION_ID INTEGER
)IN DATABASE $DBNAME;		

CREATE TABLE F_JOB_EXECUTION_DT_METRICS (
		F_JOBRES_METRIC_ID INTEGER NOT NULL,
		OWNER_ID INTEGER NOT NULL,
		JOB_ID INTEGER NOT NULL,
		LAB_RESOURCE_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		VERDICT_ID INTEGER NOT NULL,
		STATE_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		TOTAL_JOB_RESULTS INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
)
IN DATABASE $DBNAME;

CREATE TABLE H_JOB_EXECUTION_DT_METRICS (
	F_JOBRES_METRIC_ID INTEGER NOT NULL,
	JOB_RESULT_ID INTEGER NOT NULL
)
IN DATABASE $DBNAME;

CREATE TABLE F_REQUEST_RESOLUTIO_DT_METRICS (
		REQDT_METRIC_ID INTEGER NOT NULL,
		REQUEST_CLASS_ID INTEGER NOT NULL,
		RELEASE_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		COMPONENT_ID INTEGER NOT NULL,
		STATUS_ID INTEGER NOT NULL,
		SEVERITY_ID INTEGER NOT NULL,
		CUSTOMER_PRIORITY_ID INTEGER NOT NULL,
		RESOLUTION_DATE_ID INTEGER NOT NULL,
		REQUEST_TYPE_ID INTEGER NOT NULL,
		TEAM_ID INTEGER NOT NULL,
		REQUEST_CATEGORY_ID INTEGER NOT NULL,
		STATE_ID  INTEGER NOT NULL,
		PRIORITY_ID INTEGER NOT NULL,
		ITERATION_ID INTEGER NOT NULL,
		PLANNED_DURATION INTEGER DEFAULT NOT NULL,
		ACTUAL_DURATION INTEGER  DEFAULT NOT NULL,
		STORY_POINTS INTEGER  DEFAULT NOT NULL,
		TOTAL_COUNT INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;

CREATE TABLE H_REQUEST_RESOLUTIO_DT_METRICS (
		REQDT_METRIC_ID INTEGER NOT NULL,
        REQUEST_ID INTEGER NOT NULL
       )IN DATABASE $DBNAME;
       
CREATE TABLE F_REQUEST_RES_TPLN_DT_METRICS (
		REQDT_METRIC_ID INTEGER NOT NULL,
		REQUEST_CLASS_ID INTEGER NOT NULL,
		RELEASE_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		COMPONENT_ID INTEGER NOT NULL,
		STATUS_ID INTEGER NOT NULL,
		SEVERITY_ID INTEGER NOT NULL,
		CUSTOMER_PRIORITY_ID INTEGER NOT NULL,
		RESOLUTION_DATE_ID INTEGER NOT NULL,
		REQUEST_TYPE_ID INTEGER NOT NULL,
		TEAM_ID INTEGER NOT NULL,
		REQUEST_CATEGORY_ID INTEGER NOT NULL,
		STATE_ID  INTEGER NOT NULL,
		PRIORITY_ID INTEGER NOT NULL,
		ITERATION_ID INTEGER NOT NULL,
		TESTPLAN_ID INTEGER NOT NULL,
		PLANNED_DURATION INTEGER DEFAULT NOT NULL,
		ACTUAL_DURATION INTEGER  DEFAULT NOT NULL,
		STORY_POINTS INTEGER  DEFAULT NOT NULL,
		TOTAL_COUNT INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;

CREATE TABLE H_REQUEST_RES_TPLN_DT_METRICS (
		REQDT_METRIC_ID INTEGER NOT NULL,
        REQUEST_ID INTEGER NOT NULL
       )IN DATABASE $DBNAME;

CREATE TABLE F_REQUEST_RES_REQUI_DT_METRICS (
		REQDT_METRIC_ID INTEGER NOT NULL,
		REQUEST_CLASS_ID INTEGER NOT NULL,
		RELEASE_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		COMPONENT_ID INTEGER NOT NULL,
		REQUIREMENT_ID INTEGER NOT NULL,
		STATUS_ID INTEGER NOT NULL,
		SEVERITY_ID INTEGER NOT NULL,
		CUSTOMER_PRIORITY_ID INTEGER NOT NULL,
		RESOLUTION_DATE_ID INTEGER NOT NULL,
		REQUEST_TYPE_ID INTEGER NOT NULL,
		TEAM_ID INTEGER NOT NULL,
		REQUEST_CATEGORY_ID INTEGER NOT NULL,
		STATE_ID  INTEGER NOT NULL,
		PRIORITY_ID INTEGER NOT NULL,
		ITERATION_ID INTEGER NOT NULL,
		PLANNED_DURATION INTEGER DEFAULT NOT NULL,
		ACTUAL_DURATION INTEGER  DEFAULT NOT NULL,
		STORY_POINTS INTEGER  DEFAULT NOT NULL,
		TOTAL_COUNT INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;

CREATE TABLE H_REQUEST_RES_REQUI_DT_METRICS (
		REQDT_METRIC_ID INTEGER NOT NULL,
        REQUEST_ID INTEGER NOT NULL
       )IN DATABASE $DBNAME;
       

CREATE TABLE F_RELEASE_REQUEST_METRICS (
		F_RELREQ_METRIC_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		REQUEST_CLASS_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		RELEASE_ID INTEGER NOT NULL,
		PRODUCT_ID INTEGER NOT NULL,
		STATE_ID INTEGER NOT NULL,
		SEVERITY_ID INTEGER NOT NULL,
		REQUEST_TYPE_ID INTEGER NOT NULL,
		TOTAL_PRE_RELEASE_REQUESTS INTEGER DEFAULT NOT NULL,
		TOTAL_POST_RELEASE_REQUESTS INTEGER DEFAULT NOT NULL,
		TOTAL_WORK INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP
)IN DATABASE $DBNAME;

CREATE TABLE F_C_RELEASE_REQUEST_METRICS (
		F_RELREQ_METRIC_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		REQUEST_CLASS_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		RELEASE_ID INTEGER NOT NULL,
		PRODUCT_ID INTEGER NOT NULL,
		STATE_ID INTEGER NOT NULL,
		SEVERITY_ID INTEGER NOT NULL,
		REQUEST_TYPE_ID INTEGER NOT NULL,
		TOTAL_PRE_RELEASE_REQUESTS INTEGER DEFAULT NOT NULL,
		TOTAL_POST_RELEASE_REQUESTS INTEGER DEFAULT NOT NULL,
		TOTAL_WORK INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP
)IN DATABASE $DBNAME;

CREATE TABLE H_RELEASE_REQUEST_METRICS (
		F_RELREQ_METRIC_ID INTEGER NOT NULL,
		REQUEST_ID INTEGER NOT NULL
)IN DATABASE $DBNAME;

CREATE TABLE F_REL_REQUEST_TURN_METRICS (
		F_RELREQ_TURN_METRIC_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		REQUEST_CLASS_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		RELEASE_ID INTEGER NOT NULL,
		PRODUCT_ID INTEGER NOT NULL,
		STATE_ID INTEGER NOT NULL,
		SEVERITY_ID INTEGER NOT NULL,
		REQUEST_TYPE_ID INTEGER NOT NULL,
		PRE_TOTAL_DAYS INTEGER DEFAULT NOT NULL,
		PRE_MIN_DAYS INTEGER DEFAULT NOT NULL,
		PRE_MAX_DAYS INTEGER DEFAULT NOT NULL,
		PRE_TOTAL_REQUESTS INTEGER DEFAULT NOT NULL,
		POST_TOTAL_DAYS INTEGER DEFAULT NOT NULL,
		POST_MIN_DAYS INTEGER DEFAULT NOT NULL,
		POST_MAX_DAYS INTEGER DEFAULT NOT NULL,
		POST_TOTAL_REQUESTS INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP
)IN DATABASE $DBNAME;

CREATE TABLE F_C_REL_REQUEST_TURN_METRICS (
		F_RELREQ_TURN_METRIC_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		REQUEST_CLASS_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		RELEASE_ID INTEGER NOT NULL,
		PRODUCT_ID INTEGER NOT NULL,
		STATE_ID INTEGER NOT NULL,
		SEVERITY_ID INTEGER NOT NULL,
		REQUEST_TYPE_ID INTEGER NOT NULL,
		PRE_TOTAL_DAYS INTEGER DEFAULT NOT NULL,
		PRE_MIN_DAYS INTEGER DEFAULT NOT NULL,
		PRE_MAX_DAYS INTEGER DEFAULT NOT NULL,
		PRE_TOTAL_REQUESTS INTEGER DEFAULT NOT NULL,
		POST_TOTAL_DAYS INTEGER DEFAULT NOT NULL,
		POST_MIN_DAYS INTEGER DEFAULT NOT NULL,
		POST_MAX_DAYS INTEGER DEFAULT NOT NULL,
		POST_TOTAL_REQUESTS INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP
)IN DATABASE $DBNAME;

CREATE TABLE H_REL_REQUEST_TURN_METRICS (
		F_RELREQ_TURN_METRIC_ID INTEGER NOT NULL,
		REQUEST_ID INTEGER NOT NULL
)IN DATABASE $DBNAME;
						
CREATE TABLE F_TIME_TO_MARKET_RELEA_METRICS (
		F_TIME_TO_MRKT_METRIC_ID INTEGER NOT NULL,
		RELEASE_DATE_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		PRODUCT_ID INTEGER NOT NULL,
		TOTAL_DAYS INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP
)IN DATABASE $DBNAME;

CREATE TABLE H_TIME_TO_MARKET_REL_METRICS (
		F_TIME_TO_MRKT_METRIC_ID INTEGER NOT NULL,
		RELEASE_ID INTEGER NOT NULL
)IN DATABASE $DBNAME;

CREATE TABLE F_MISSING_TIMESHEET_METRICS ( 
		TIMESHEET_METRICS_ID INTEGER NOT NULL,
		WEEK_ID INTEGER NOT NULL,
		RESOURCE_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		CHARGECODE_ID INTEGER NOT NULL,
		POOL_ID INTEGER NOT NULL, 
		CITY_ID INTEGER NOT NULL,
		ORGANIZATION_ID INTEGER NOT NULL,
		TOTAL_WORK INTEGER DEFAULT NOT NULL,
		TOTAL_TIMESHEETS INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
) IN DATABASE $DBNAME;    

CREATE TABLE H_MISSING_TIMESHEET_METRICS (
		TIMESHEET_METRICS_ID INTEGER NOT NULL,
        ACTIVITY_ID INTEGER NOT NULL
      )IN DATABASE $DBNAME;  
      
CREATE TABLE F_TIMESHEET_METRICS ( 
		TIMESHEET_METRICS_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		STATE_ID INTEGER NOT NULL,
		RESOURCE_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		CHARGECODE_ID INTEGER NOT NULL,
		POOL_ID INTEGER NOT NULL,
		CITY_ID INTEGER NOT NULL,
		ORGANIZATION_ID INTEGER NOT NULL,
		TOTAL_WORK INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
) IN DATABASE $DBNAME;    

CREATE TABLE H_TIMESHEET_METRICS (
		TIMESHEET_METRICS_ID INTEGER NOT NULL,
    ACTIVITY_ID INTEGER NOT NULL
)IN DATABASE $DBNAME;  

CREATE TABLE F_TIMESHEET_TIMECODE_METRICS ( 
		TIMESHEET_METRICS_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		STATE_ID INTEGER NOT NULL,
		RESOURCE_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		CHARGECODE_ID INTEGER NOT NULL,
		POOL_ID INTEGER NOT NULL,
		CITY_ID INTEGER NOT NULL,
		ORGANIZATION_ID INTEGER NOT NULL,
		TIMECODE_ID INTEGER NOT NULL,                          
		TOTAL_WORK INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
) IN DATABASE $DBNAME;

CREATE TABLE H_TIMESHEET_TIMECODE_METRICS (
	TIMESHEET_METRICS_ID INTEGER NOT NULL,
    ACTIVITY_ID INTEGER NOT NULL
)IN DATABASE $DBNAME; 
		
CREATE TABLE F_WK_PROJ_RESDEMSUPP_METRICS(
		F_PROJDS_MET_ID INTEGER NOT NULL,
		WEEK_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		CITY_ID INTEGER NOT NULL,
		ORGANIZATION_ID INTEGER NOT NULL,
		TOTAL_DEMAND INTEGER DEFAULT NOT NULL,
		TOTAL_ASSIGNED INTEGER DEFAULT NOT NULL,
		TOTAL_ALLOCATION INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
) IN DATABASE $DBNAME;    

CREATE TABLE H_WK_PROJ_RESDEMSUPP_METRICS(
		F_PROJDS_MET_ID INTEGER NOT NULL,
		PROJECT_ALLOCATION_ID INTEGER NOT NULL
) IN DATABASE $DBNAME;  


CREATE TABLE F_MO_PROJ_RESDEMSUPP_METRICS(
		F_PROJDS_MET_ID INTEGER NOT NULL,
		MONTH_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		CITY_ID INTEGER NOT NULL,
		ORGANIZATION_ID INTEGER NOT NULL,
		TOTAL_DEMAND INTEGER DEFAULT NOT NULL,
		TOTAL_ASSIGNED INTEGER DEFAULT NOT NULL,
		TOTAL_ALLOCATION INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
) IN DATABASE $DBNAME;    

CREATE TABLE H_MO_PROJ_RESDEMSUPP_METRICS(
		F_PROJDS_MET_ID INTEGER NOT NULL,
		PROJECT_ALLOCATION_ID INTEGER NOT NULL
) IN DATABASE $DBNAME;  

CREATE TABLE F_WK_RESOURCE_UTIL_METRICS(
		F_RESUTIL_MET_ID INTEGER NOT NULL,
		WEEK_ID INTEGER NOT NULL,
		POOL_ID INTEGER NOT NULL,
		CITY_ID INTEGER NOT NULL,
		ORGANIZATION_ID INTEGER NOT NULL,
		TOTAL_AVAILABILITY INTEGER DEFAULT NOT NULL,
		TOTAL_ALLOCATION INTEGER DEFAULT NOT NULL,
		TOTAL_ASSIGNED INTEGER DEFAULT NOT NULL,
		TOTAL_ACTUAL INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
) IN DATABASE $DBNAME;    

CREATE TABLE H_WK_RESOURCE_UTIL_METRICS(
		F_RESUTIL_MET_ID INTEGER NOT NULL,
		RESOURCE_ID INTEGER NOT NULL
) IN DATABASE $DBNAME;  		

CREATE TABLE F_MO_RESOURCE_UTIL_METRICS(
		F_RESUTIL_MET_ID INTEGER NOT NULL,
		MONTH_ID INTEGER NOT NULL,
		POOL_ID INTEGER NOT NULL,
		CITY_ID INTEGER NOT NULL,
		ORGANIZATION_ID INTEGER NOT NULL,
		TOTAL_AVAILABILITY INTEGER DEFAULT NOT NULL,
		TOTAL_ALLOCATION INTEGER DEFAULT NOT NULL,
		TOTAL_ASSIGNED INTEGER DEFAULT NOT NULL,
		TOTAL_ACTUAL INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
) IN DATABASE $DBNAME;    

CREATE TABLE H_MO_RESOURCE_UTIL_METRICS(
		F_RESUTIL_MET_ID INTEGER NOT NULL,
	    RESOURCE_ID INTEGER NOT NULL
) IN DATABASE $DBNAME;  

CREATE TABLE F_WK_SCPROJ_RESDEMSUP_METRICS(
		F_PROJDS_MET_ID INTEGER NOT NULL,
		WEEK_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		CITY_ID INTEGER NOT NULL,
		ORGANIZATION_ID INTEGER NOT NULL,
		SKILL_ID INTEGER NOT NULL,
		COMPETENCY_ID INTEGER NOT NULL,
		TOTAL_DEMAND INTEGER DEFAULT NOT NULL,
		TOTAL_ASSIGNED INTEGER DEFAULT NOT NULL,
		TOTAL_ALLOCATION INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
) IN DATABASE $DBNAME;   

CREATE TABLE H_WK_SCPROJ_RESDEMSUP_METRICS(
		F_PROJDS_MET_ID INTEGER NOT NULL,
		PROJECT_ALLOCATION_ID INTEGER NOT NULL
) IN DATABASE $DBNAME;  

CREATE TABLE F_WK_SKPROJ_RESDEMSUP_METRICS(
		F_PROJDS_MET_ID INTEGER NOT NULL,
		WEEK_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		CITY_ID INTEGER NOT NULL,
		ORGANIZATION_ID INTEGER NOT NULL,
		SKILL_ID INTEGER NOT NULL,
		TOTAL_DEMAND INTEGER DEFAULT NOT NULL,
		TOTAL_ASSIGNED INTEGER DEFAULT NOT NULL,
		TOTAL_ALLOCATION INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
) IN DATABASE $DBNAME;     

CREATE TABLE H_WK_SKPROJ_RESDEMSUP_METRICS(
		F_PROJDS_MET_ID INTEGER NOT NULL,
		PROJECT_ALLOCATION_ID INTEGER NOT NULL
) IN DATABASE $DBNAME;

CREATE TABLE F_WK_COPROJ_RESDEMSUP_METRICS(
		F_PROJDS_MET_ID INTEGER NOT NULL,
		WEEK_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		CITY_ID INTEGER NOT NULL,
		ORGANIZATION_ID INTEGER NOT NULL,
		COMPETENCY_ID INTEGER NOT NULL,
		TOTAL_DEMAND INTEGER DEFAULT NOT NULL,
		TOTAL_ASSIGNED INTEGER DEFAULT NOT NULL,
		TOTAL_ALLOCATION INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
) IN DATABASE $DBNAME;  

CREATE TABLE H_WK_COPROJ_RESDEMSUP_METRICS(
		F_PROJDS_MET_ID INTEGER NOT NULL,
		PROJECT_ALLOCATION_ID INTEGER NOT NULL
) IN DATABASE $DBNAME;

CREATE TABLE F_MO_SCPROJ_RESDEMSUP_METRICS(
		F_PROJDS_MET_ID INTEGER NOT NULL,
		MONTH_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		CITY_ID INTEGER NOT NULL,
		ORGANIZATION_ID INTEGER NOT NULL,
		SKILL_ID INTEGER NOT NULL,
		COMPETENCY_ID INTEGER NOT NULL,
		TOTAL_DEMAND INTEGER DEFAULT NOT NULL,
		TOTAL_ASSIGNED INTEGER DEFAULT NOT NULL,
		TOTAL_ALLOCATION INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
) IN DATABASE $DBNAME;     

CREATE TABLE H_MO_SCPROJ_RESDEMSUP_METRICS(
		F_PROJDS_MET_ID INTEGER NOT NULL,
		PROJECT_ALLOCATION_ID INTEGER NOT NULL
) IN DATABASE $DBNAME; 

CREATE TABLE F_MO_SKPROJ_RESDEMSUP_METRICS(
		F_PROJDS_MET_ID INTEGER NOT NULL,
		MONTH_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		CITY_ID INTEGER NOT NULL,
		ORGANIZATION_ID INTEGER NOT NULL,
		SKILL_ID INTEGER NOT NULL,
		TOTAL_DEMAND INTEGER DEFAULT NOT NULL,
		TOTAL_ASSIGNED INTEGER DEFAULT NOT NULL,
		TOTAL_ALLOCATION INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
) IN DATABASE $DBNAME;     

CREATE TABLE H_MO_SKPROJ_RESDEMSUP_METRICS(
		F_PROJDS_MET_ID INTEGER NOT NULL,
		PROJECT_ALLOCATION_ID INTEGER NOT NULL
) IN DATABASE $DBNAME;

CREATE TABLE F_MO_COPROJ_RESDEMSUP_METRICS(
		F_PROJDS_MET_ID INTEGER NOT NULL,
		MONTH_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		CITY_ID INTEGER NOT NULL,
		ORGANIZATION_ID INTEGER NOT NULL,
		COMPETENCY_ID INTEGER NOT NULL,
		TOTAL_DEMAND INTEGER DEFAULT NOT NULL,
		TOTAL_ASSIGNED INTEGER DEFAULT NOT NULL,
		TOTAL_ALLOCATION INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
) IN DATABASE $DBNAME;  

CREATE TABLE H_MO_COPROJ_RESDEMSUP_METRICS(
		F_PROJDS_MET_ID INTEGER NOT NULL,
		PROJECT_ALLOCATION_ID INTEGER NOT NULL
) IN DATABASE $DBNAME;


CREATE TABLE F_WK_SCRESOURCE_UTIL_METRICS(
		F_RESUTIL_MET_ID INTEGER NOT NULL,
		WEEK_ID INTEGER NOT NULL,
		POOL_ID INTEGER NOT NULL,
		CITY_ID INTEGER NOT NULL,
		ORGANIZATION_ID INTEGER NOT NULL,
		SKILL_ID INTEGER NOT NULL,
		COMPETENCY_ID INTEGER NOT NULL,
		TOTAL_AVAILABILITY INTEGER DEFAULT NOT NULL,
		TOTAL_ALLOCATION INTEGER DEFAULT NOT NULL,
		TOTAL_ASSIGNED INTEGER DEFAULT NOT NULL,
		TOTAL_ACTUAL INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
) IN DATABASE $DBNAME;     

CREATE TABLE H_WK_SCRESOURCE_UTIL_METRICS(
		F_RESUTIL_MET_ID INTEGER NOT NULL,
		RESOURCE_ID INTEGER NOT NULL
) IN DATABASE $DBNAME; 

CREATE TABLE F_WK_SKRESOURCE_UTIL_METRICS(
		F_RESUTIL_MET_ID INTEGER NOT NULL,
		WEEK_ID INTEGER NOT NULL,
		POOL_ID INTEGER NOT NULL,
		CITY_ID INTEGER NOT NULL,
		ORGANIZATION_ID INTEGER NOT NULL,
		SKILL_ID INTEGER NOT NULL,
		TOTAL_AVAILABILITY INTEGER DEFAULT NOT NULL,
		TOTAL_ALLOCATION INTEGER DEFAULT NOT NULL,
		TOTAL_ASSIGNED INTEGER DEFAULT NOT NULL,
		TOTAL_ACTUAL INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
) IN DATABASE $DBNAME;   

CREATE TABLE H_WK_SKRESOURCE_UTIL_METRICS(
		F_RESUTIL_MET_ID INTEGER NOT NULL,
		RESOURCE_ID INTEGER NOT NULL
) IN DATABASE $DBNAME;	

CREATE TABLE F_WK_CORESOURCE_UTIL_METRICS(
		F_RESUTIL_MET_ID INTEGER NOT NULL,
		WEEK_ID INTEGER NOT NULL,
		POOL_ID INTEGER NOT NULL,
		CITY_ID INTEGER NOT NULL,
		ORGANIZATION_ID INTEGER NOT NULL,
		COMPETENCY_ID INTEGER NOT NULL,
		TOTAL_AVAILABILITY INTEGER DEFAULT NOT NULL,
		TOTAL_ALLOCATION INTEGER DEFAULT NOT NULL,
		TOTAL_ASSIGNED INTEGER DEFAULT NOT NULL,
		TOTAL_ACTUAL INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
) IN DATABASE $DBNAME;     

CREATE TABLE H_WK_CORESOURCE_UTIL_METRICS(
		F_RESUTIL_MET_ID INTEGER NOT NULL,
		RESOURCE_ID INTEGER NOT NULL
) IN DATABASE $DBNAME;

CREATE TABLE F_MO_SCRESOURCE_UTIL_METRICS(
		F_RESUTIL_MET_ID INTEGER NOT NULL,
		MONTH_ID INTEGER NOT NULL,
		POOL_ID INTEGER NOT NULL,
		CITY_ID INTEGER NOT NULL,
		ORGANIZATION_ID INTEGER NOT NULL,
		SKILL_ID INTEGER NOT NULL,
		COMPETENCY_ID INTEGER NOT NULL,
		TOTAL_AVAILABILITY INTEGER DEFAULT NOT NULL,
		TOTAL_ALLOCATION INTEGER DEFAULT NOT NULL,
		TOTAL_ASSIGNED INTEGER DEFAULT NOT NULL,
		TOTAL_ACTUAL INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
) IN DATABASE $DBNAME;   

CREATE TABLE H_MO_SCRESOURCE_UTIL_METRICS(
		F_RESUTIL_MET_ID INTEGER NOT NULL,
		RESOURCE_ID INTEGER NOT NULL
) IN DATABASE $DBNAME; 

CREATE TABLE F_MO_SKRESOURCE_UTIL_METRICS(
		F_RESUTIL_MET_ID INTEGER NOT NULL,
		MONTH_ID INTEGER NOT NULL,
		POOL_ID INTEGER NOT NULL,
		CITY_ID INTEGER NOT NULL,
		ORGANIZATION_ID INTEGER NOT NULL,
		SKILL_ID INTEGER NOT NULL,
		TOTAL_AVAILABILITY INTEGER DEFAULT NOT NULL,
		TOTAL_ALLOCATION INTEGER DEFAULT NOT NULL,
		TOTAL_ASSIGNED INTEGER DEFAULT NOT NULL,
		TOTAL_ACTUAL INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
) IN DATABASE $DBNAME;     

CREATE TABLE H_MO_SKRESOURCE_UTIL_METRICS(
		F_RESUTIL_MET_ID INTEGER NOT NULL,
		RESOURCE_ID INTEGER NOT NULL
) IN DATABASE $DBNAME;

CREATE TABLE F_MO_CORESOURCE_UTIL_METRICS(
		F_RESUTIL_MET_ID INTEGER NOT NULL,
		MONTH_ID INTEGER NOT NULL,
		POOL_ID INTEGER NOT NULL,
		CITY_ID INTEGER NOT NULL,
		ORGANIZATION_ID INTEGER NOT NULL,
		COMPETENCY_ID INTEGER NOT NULL,
		TOTAL_AVAILABILITY INTEGER DEFAULT NOT NULL,
		TOTAL_ALLOCATION INTEGER DEFAULT NOT NULL,
		TOTAL_ASSIGNED INTEGER DEFAULT NOT NULL,
		TOTAL_ACTUAL INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
) IN DATABASE $DBNAME;     

CREATE TABLE H_MO_CORESOURCE_UTIL_METRICS(
		F_RESUTIL_MET_ID INTEGER NOT NULL,
		RESOURCE_ID INTEGER NOT NULL
) IN DATABASE $DBNAME;

CREATE TABLE F_RISK_METRICS(
		F_RISKMET_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		STATE_ID INTEGER NOT NULL,
		PRIORITY_ID INTEGER NOT NULL,
		OWNER_ID INTEGER NOT NULL,
		RELEASE_ID INTEGER NOT NULL,
		IMPACT_RANK_ID INTEGER NOT NULL,
		PROBABILITY_RANK_ID INTEGER NOT NULL,
		PROBABILITY_COST_RANK_ID INTEGER NOT NULL,
		SCORE_RANK_ID INTEGER NOT NULL,
		TOTAL_RISKS INTEGER DEFAULT NOT NULL ,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
) IN DATABASE $DBNAME;    

CREATE TABLE H_RISK_METRICS(
		F_RISKMET_ID INTEGER NOT NULL,
		RISK_ID INTEGER NOT NULL
) IN DATABASE $DBNAME;  
		
CREATE TABLE F_C_RISK_METRICS(
		F_RISKMET_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		STATE_ID INTEGER NOT NULL,
		PRIORITY_ID INTEGER NOT NULL,
		OWNER_ID INTEGER NOT NULL,
		RELEASE_ID INTEGER NOT NULL,
		IMPACT_RANK_ID INTEGER NOT NULL,
		PROBABILITY_RANK_ID INTEGER NOT NULL,
		PROBABILITY_COST_RANK_ID INTEGER NOT NULL,
		SCORE_RANK_ID INTEGER NOT NULL,
		TOTAL_RISKS INTEGER DEFAULT NOT NULL ,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
) IN DATABASE $DBNAME;    

CREATE TABLE F_TASK_ITER_VARIANCE_METRICS (
		F_TASKVAR_MET_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		BASELINE_ID INTEGER NOT NULL,
		ITERATION_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		ACTUAL_FINISH_VARIANCE INTEGER DEFAULT NOT NULL,
		PLANNED_FINISH_VARIANCE INTEGER DEFAULT NOT NULL,
		BASELINE_FINISH_VARIANCE INTEGER DEFAULT NOT NULL,
		ACTUAL_COST_VARIANCE DECIMAL(18,2) DEFAULT NOT NULL,
		PLANNED_COST_VARIANCE DECIMAL(18,2) DEFAULT NOT NULL,
		BASELINE_COST_VARIANCE DECIMAL(18,2) DEFAULT NOT NULL,
		TOTAL_ACTUAL_COST DECIMAL(18,2) DEFAULT NOT NULL,
		TOTAL_PLANNED_COST DECIMAL(18,2) DEFAULT NOT NULL,
		TOTAL_BASELINE_COST DECIMAL(18,2) DEFAULT NOT NULL,
		ACTUAL_WORK_VARIANCE INTEGER DEFAULT NOT NULL,
		PLANNED_WORK_VARIANCE INTEGER DEFAULT NOT NULL,
		BASELINE_WORK_VARIANCE INTEGER DEFAULT NOT NULL,
		TOTAL_ACTUAL_WORK INTEGER DEFAULT NOT NULL,
		TOTAL_PLANNED_WORK INTEGER DEFAULT NOT NULL,
		TOTAL_BASELINE_WORK INTEGER DEFAULT NOT NULL,
		BASELINE_DURATION INTEGER DEFAULT NOT NULL,
		ACTUAL_DURATION INTEGER DEFAULT NOT NULL,
		PLANNED_DURATION  INTEGER DEFAULT NOT NULL, 
		TOTAL_TASKS INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
) IN DATABASE $DBNAME;    		

CREATE TABLE H_TASK_ITER_VARIANCE_METRICS (
		F_TASKVAR_MET_ID INTEGER NOT NULL,
		TASK_ID INTEGER NOT NULL
) IN DATABASE $DBNAME; 

CREATE TABLE F_C_TASK_ITE_VARIANCE_METRICS (
		F_TASKVAR_MET_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		BASELINE_ID INTEGER NOT NULL,
		ITERATION_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		ACTUAL_FINISH_VARIANCE INTEGER DEFAULT NOT NULL,
		PLANNED_FINISH_VARIANCE INTEGER DEFAULT NOT NULL,
		BASELINE_FINISH_VARIANCE INTEGER DEFAULT NOT NULL,
		ACTUAL_COST_VARIANCE DECIMAL(18,2) DEFAULT NOT NULL,
		PLANNED_COST_VARIANCE DECIMAL(18,2) DEFAULT NOT NULL,
		BASELINE_COST_VARIANCE DECIMAL(18,2) DEFAULT NOT NULL,
		TOTAL_ACTUAL_COST DECIMAL(18,2) DEFAULT NOT NULL,
		TOTAL_PLANNED_COST DECIMAL(18,2) DEFAULT NOT NULL,
		TOTAL_BASELINE_COST DECIMAL(18,2) DEFAULT NOT NULL,
		ACTUAL_WORK_VARIANCE INTEGER DEFAULT NOT NULL,
		PLANNED_WORK_VARIANCE INTEGER DEFAULT NOT NULL,
		BASELINE_WORK_VARIANCE INTEGER DEFAULT NOT NULL,
		TOTAL_ACTUAL_WORK INTEGER DEFAULT NOT NULL,
		TOTAL_PLANNED_WORK INTEGER DEFAULT NOT NULL,
		TOTAL_BASELINE_WORK INTEGER DEFAULT NOT NULL,
		BASELINE_DURATION INTEGER DEFAULT NOT NULL,
		ACTUAL_DURATION INTEGER DEFAULT NOT NULL,
		PLANNED_DURATION  INTEGER DEFAULT NOT NULL, 
		TOTAL_TASKS INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
) IN DATABASE $DBNAME;
		
CREATE TABLE F_TASK_PROJ_VARIANCE_METRICS (
		F_TASKVAR_MET_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		BASELINE_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		ACTUAL_FINISH_VARIANCE INTEGER DEFAULT NOT NULL,
		PLANNED_FINISH_VARIANCE INTEGER DEFAULT NOT NULL,
		BASELINE_FINISH_VARIANCE INTEGER DEFAULT NOT NULL,
		ACTUAL_COST_VARIANCE DECIMAL(18,2) DEFAULT NOT NULL,
		PLANNED_COST_VARIANCE DECIMAL(18,2) DEFAULT NOT NULL,
		BASELINE_COST_VARIANCE DECIMAL(18,2) DEFAULT NOT NULL,
		TOTAL_ACTUAL_COST DECIMAL(18,2) DEFAULT NOT NULL,
		TOTAL_PLANNED_COST DECIMAL(18,2) DEFAULT NOT NULL,
		TOTAL_BASELINE_COST DECIMAL(18,2) DEFAULT NOT NULL,
		ACTUAL_WORK_VARIANCE INTEGER DEFAULT NOT NULL,
		PLANNED_WORK_VARIANCE INTEGER DEFAULT NOT NULL,
		BASELINE_WORK_VARIANCE INTEGER DEFAULT NOT NULL,
		TOTAL_ACTUAL_WORK INTEGER DEFAULT NOT NULL,
		TOTAL_PLANNED_WORK INTEGER DEFAULT NOT NULL,
		TOTAL_BASELINE_WORK INTEGER DEFAULT NOT NULL,
		BASELINE_DURATION INTEGER DEFAULT NOT NULL,
		ACTUAL_DURATION INTEGER DEFAULT NOT NULL,
		PLANNED_DURATION  INTEGER DEFAULT NOT NULL, 
		TOTAL_TASKS INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
) IN DATABASE $DBNAME; 		

CREATE TABLE H_TASK_PROJ_VARIANCE_METRICS (
		F_TASKVAR_MET_ID INTEGER NOT NULL,
		TASK_ID INTEGER NOT NULL
) IN DATABASE $DBNAME; 	

CREATE TABLE F_C_TASK_PRO_VARIANCE_METRICS (
		F_TASKVAR_MET_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		BASELINE_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		ACTUAL_FINISH_VARIANCE INTEGER DEFAULT NOT NULL,
		PLANNED_FINISH_VARIANCE INTEGER DEFAULT NOT NULL,
		BASELINE_FINISH_VARIANCE INTEGER DEFAULT NOT NULL,
		ACTUAL_COST_VARIANCE DECIMAL(18,2) DEFAULT NOT NULL,
		PLANNED_COST_VARIANCE DECIMAL(18,2) DEFAULT NOT NULL,
		BASELINE_COST_VARIANCE DECIMAL(18,2) DEFAULT NOT NULL,
		TOTAL_ACTUAL_COST DECIMAL(18,2) DEFAULT NOT NULL,
		TOTAL_PLANNED_COST DECIMAL(18,2) DEFAULT NOT NULL,
		TOTAL_BASELINE_COST DECIMAL(18,2) DEFAULT NOT NULL,
		ACTUAL_WORK_VARIANCE INTEGER DEFAULT NOT NULL,
		PLANNED_WORK_VARIANCE INTEGER DEFAULT NOT NULL,
		BASELINE_WORK_VARIANCE INTEGER DEFAULT NOT NULL,
		TOTAL_ACTUAL_WORK INTEGER DEFAULT NOT NULL,
		TOTAL_PLANNED_WORK INTEGER DEFAULT NOT NULL,
		TOTAL_BASELINE_WORK INTEGER DEFAULT NOT NULL,
		BASELINE_DURATION INTEGER DEFAULT NOT NULL,
		ACTUAL_DURATION INTEGER DEFAULT NOT NULL,
		PLANNED_DURATION  INTEGER DEFAULT NOT NULL, 
		TOTAL_TASKS INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
) IN DATABASE $DBNAME; 		

CREATE TABLE F_STORY_METRICS (
		F_STORY_METRIC_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		ITERATION_ID INTEGER NOT NULL,
		TEAM_ID INTEGER NOT NULL,
		OWNER_ID INTEGER NOT NULL,
		REQUEST_CLASS_ID INTEGER NOT NULL,
		REQUEST_TYPE_ID INTEGER NOT NULL,
		REQUEST_CATEGORY_ID INTEGER NOT NULL,
		STATE_ID INTEGER NOT NULL,
		SEVERITY_ID INTEGER NOT NULL,
		PRIORITY_ID INTEGER NOT NULL,
		TOTAL_STORY_POINTS DECIMAL(18,2) DEFAULT NOT NULL,
		TOTAL_COMMENTS INTEGER DEFAULT NOT NULL,
		TOTAL_SUBSCRIBERS INTEGER DEFAULT NOT NULL,
		TOTAL_TAGS INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;

CREATE TABLE F_C_STORY_METRICS (
		F_STORY_METRIC_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		ITERATION_ID INTEGER NOT NULL,
		TEAM_ID INTEGER NOT NULL,
		OWNER_ID INTEGER NOT NULL,
		REQUEST_CLASS_ID INTEGER NOT NULL,
		REQUEST_TYPE_ID INTEGER NOT NULL,
		REQUEST_CATEGORY_ID INTEGER NOT NULL,
		STATE_ID INTEGER NOT NULL,
		SEVERITY_ID INTEGER NOT NULL,
		PRIORITY_ID INTEGER NOT NULL,
		TOTAL_STORY_POINTS DECIMAL(18,2) DEFAULT NOT NULL,
		TOTAL_COMMENTS INTEGER DEFAULT NOT NULL,
		TOTAL_SUBSCRIBERS INTEGER DEFAULT NOT NULL,
		TOTAL_TAGS INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;

CREATE TABLE H_STORY_METRICS (
		F_STORY_METRIC_ID INTEGER NOT NULL,
		REQUEST_ID INTEGER NOT NULL
	)
	IN DATABASE $DBNAME;
	
CREATE TABLE F_REQUEST_FAILURE_DT_METRICS (
		REQFAIL_METRIC_ID INTEGER NOT NULL,
		FAIL_DATE_ID INTEGER NOT NULL,
		RELEASE_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		COMPONENT_ID INTEGER NOT NULL,
		ITERATION_ID INTEGER NOT NULL,
		TOTAL_RE_FAILED INTEGER,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;

CREATE TABLE H_REQUEST_FAILURE_DT_METRICS (
		REQFAIL_METRIC_ID INTEGER NOT NULL,
		REQUEST_ID INTEGER NOT NULL
	)
	IN DATABASE $DBNAME;

CREATE TABLE F_REQUEST_TPLN_FAILDT_METRICS (
		REQFAIL_METRIC_ID INTEGER NOT NULL,
		FAIL_DATE_ID INTEGER NOT NULL,
		RELEASE_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		COMPONENT_ID INTEGER NOT NULL,
		ITERATION_ID INTEGER NOT NULL,
		TESTPLAN_ID INTEGER NOT NULL,
		TOTAL_RE_FAILED INTEGER,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;

CREATE TABLE H_REQUEST_TPLN_FAILDT_METRICS (
		REQFAIL_METRIC_ID INTEGER NOT NULL,
		REQUEST_ID INTEGER NOT NULL
	)
	IN DATABASE $DBNAME;

CREATE TABLE F_REQUEST_REQUI_FAILDT_METRICS (
		REQFAIL_METRIC_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		RELEASE_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		COMPONENT_ID INTEGER NOT NULL,
		REQUIREMENT_ID INTEGER NOT NULL,
		ITERATION_ID INTEGER NOT NULL,
		TOTAL_RE_FAILED INTEGER,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;

CREATE TABLE H_REQUEST_REQUI_FAILDT_METRICS (
		REQFAIL_METRIC_ID INTEGER NOT NULL,
		REQUEST_ID INTEGER NOT NULL
	)
	IN DATABASE $DBNAME;

CREATE TABLE F_REQUIR_MODIF_DT_METRICS (
		REQ_METRIC_ID INTEGER NOT NULL,
		MODIFICATION_DATE_ID INTEGER NOT NULL,
		REQUIREMENT_CLASS_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		COMPONENT_ID INTEGER NOT NULL,
		ITERATION_ID INTEGER NOT NULL,
		RELEASE_ID INTEGER NOT NULL,
		RESOURCE_ID INTEGER NOT NULL,
		STATE_ID INTEGER NOT NULL,
		STATUS_ID INTEGER NOT NULL,
		STABILITY_ID INTEGER NOT NULL,
		DIFFICULTY_ID INTEGER NOT NULL,
		PRIORITY_ID INTEGER NOT NULL,
		REQUIREMENT_TYPE_ID INTEGER NOT NULL,
		TOTAL_REQUIREMENTS INTEGER DEFAULT NOT NULL,
		TOTAL_REQUIREMENT_CHANGES INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;
	
CREATE TABLE H_REQUIR_MODIF_DT_METRICS (
		REQ_METRIC_ID INTEGER NOT NULL,
		REQUIREMENT_ID INTEGER NOT NULL
	)
	IN DATABASE $DBNAME;

CREATE TABLE F_PROJECT_FINANCIAL_METRICS(
		F_PROJFIN_METRIC_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		BUDGETED_REVENUE DECIMAL(18 , 2) DEFAULT NOT NULL,
		PLANNED_REVENUE DECIMAL(18 , 2) DEFAULT NOT NULL,
		ACTUAL_REVENUE DECIMAL(18 , 2) DEFAULT NOT NULL,
		BUDGETED_COST DECIMAL(18 , 2) DEFAULT NOT NULL,
		PLANNED_COST DECIMAL(18 , 2) DEFAULT NOT NULL,
		ACTUAL_COST DECIMAL(18 , 2) DEFAULT NOT NULL,
		NET_PRESENT_VALUE DECIMAL(18 , 2) DEFAULT NOT NULL,
		INTERNAL_RATE_OF_RETURN DECIMAL(18 , 2) DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
)IN DATABASE $DBNAME;            

CREATE TABLE F_C_PROJECT_FINANCIAL_METRICS(
		F_PROJFIN_METRIC_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		BUDGETED_REVENUE DECIMAL(18 , 2) DEFAULT NOT NULL,
		PLANNED_REVENUE DECIMAL(18 , 2) DEFAULT NOT NULL,
		ACTUAL_REVENUE DECIMAL(18 , 2) DEFAULT NOT NULL,
		BUDGETED_COST DECIMAL(18 , 2) DEFAULT NOT NULL,
		PLANNED_COST DECIMAL(18 , 2) DEFAULT NOT NULL,
		ACTUAL_COST DECIMAL(18 , 2) DEFAULT NOT NULL,
		NET_PRESENT_VALUE DECIMAL(18 , 2) DEFAULT NOT NULL,
		INTERNAL_RATE_OF_RETURN DECIMAL(18 , 2) DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
)IN DATABASE $DBNAME;    


CREATE TABLE H_PROJECT_FINANCIAL_METRICS(
		F_PROJFIN_METRIC_ID INTEGER NOT NULL,     
		PROJECT_ID INTEGER NOT NULL 
)IN DATABASE $DBNAME;     

CREATE TABLE F_TP_PROJECT_FINANCIAL_METRICS(
		F_TPPROJFIN_METRIC_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		BUDGETED_REVENUE DECIMAL(18 , 2) DEFAULT NOT NULL,
		PLANNED_REVENUE DECIMAL(18 , 2) DEFAULT NOT NULL,
		ACTUAL_REVENUE DECIMAL(18 , 2) DEFAULT NOT NULL,
		BUDGETED_COST DECIMAL(18 , 2) DEFAULT NOT NULL,
		PLANNED_COST DECIMAL(18 , 2) DEFAULT NOT NULL,
		ACTUAL_COST DECIMAL(18 , 2) DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
)IN DATABASE $DBNAME;    


CREATE TABLE H_TP_PROJECT_FINANCIAL_METRICS(
		F_TPPROJFIN_METRIC_ID INTEGER NOT NULL,     
		PROJECT_ID INTEGER NOT NULL 
)IN DATABASE $DBNAME;    

CREATE TABLE F_ASSET_UTIL_DT_METRICS(
		F_ASSET_METRIC_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
    	ACTION_TYPE_ID INTEGER NOT NULL,
    	RESOURCE_ID INTEGER NOT NULL,
    	ASSET_ID INTEGER NOT NULL,
    	ASSET_TYPE_ID INTEGER NOT NULL,
		TOTAL_UTILIZATION INTEGER DEFAULT NOT NULL ,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
)IN DATABASE $DBNAME; 

CREATE TABLE F_LICENSE_DT_METRICS(
		F_LICENSE_METRIC_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
    	ACTION_TYPE_ID INTEGER NOT NULL,
    	RESOURCE_ID INTEGER NOT NULL,
		TOTAL_LICENSES INTEGER DEFAULT NOT NULL ,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
)IN DATABASE $DBNAME;

CREATE TABLE F_SC_BALLOT_TAB_RESULT_METRICS (
		BALLOT_TAB_RESULT_METRICS_ID INTEGER DEFAULT -1 NOT NULL,
 		DATE_ID INTEGER DEFAULT -1 NOT NULL,
 		TEAM_ID INTEGER DEFAULT -1 NOT NULL,
		BALLOT_TAB_ID INTEGER DEFAULT -1 NOT NULL,
		AGG_STDEV_AVG DECIMAL (18,2) DEFAULT NOT NULL,
		AGG_AVERAGE_AVG DECIMAL (18,2) DEFAULT NOT NULL,
 		TOTAL_RESULTS INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
)IN DATABASE $DBNAME; 
						
CREATE TABLE F_PROJ_TESTCASE_TPLN_METRICS (
		TSTCASE_METRIC_ID INTEGER NOT NULL,
		TESTCASE_CLASS_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		TESTPLAN_ID INTEGER NOT NULL,
		STATE_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		TOTAL_TESTCASES INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;
	
CREATE TABLE F_C_PROJ_TESTCASE_TPLN_METRICS (
		TSTCASE_METRIC_ID INTEGER NOT NULL,
		TESTCASE_CLASS_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		TESTPLAN_ID INTEGER NOT NULL,
		STATE_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		TOTAL_TESTCASES INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;	

CREATE TABLE H_PROJ_TESTCASE_TPLN_METRICS (
		TSTCASE_METRIC_ID INTEGER NOT NULL,
		TESTCASE_ID INTEGER NOT NULL
	)
	IN DATABASE $DBNAME;						

CREATE TABLE F_PROJ_TESTCASE_METRICS (
		TSTCASE_METRIC_ID INTEGER NOT NULL,
		TESTCASE_CLASS_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		STATE_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		TOTAL_TESTCASES INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;
	
CREATE TABLE F_C_PROJ_TESTCASE_METRICS (
		TSTCASE_METRIC_ID INTEGER NOT NULL,
		TESTCASE_CLASS_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		STATE_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		TOTAL_TESTCASES INTEGER DEFAULT NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	)
	IN DATABASE $DBNAME;	

CREATE TABLE H_PROJ_TESTCASE_METRICS (
		TSTCASE_METRIC_ID INTEGER NOT NULL,
		TESTCASE_ID INTEGER NOT NULL
	)
	IN DATABASE $DBNAME;
						

CREATE INDEX DT_DOMIDX ON D_DATE (DAY_OF_MONTH );
CREATE INDEX DT_DOWIDX ON D_DATE (DAY_OF_WEEK );
CREATE  INDEX DT_PSDIDX ON D_DATE (PERIOD_START_DATE );
CREATE INDEX DT_MOYDOMIDX ON D_DATE (MONTH_OF_YEAR , DAY_OF_MONTH );
CREATE INDEX DT_PSDWIDX ON D_DATE(PERIOD_START_DATE, WEEK_NO) ;
CREATE INDEX DT_PSDMIDX ON D_DATE(PERIOD_START_DATE, MONTH_NO) ;
CREATE INDEX DT_PSDDIDX ON D_DATE(PERIOD_START_DATE, DATE_ID DESC) ;
CREATE  INDEX F_REQ_METR_IDX1 ON F_REQUEST_METRICS (DATE_ID,TEAM_ID ,SEVERITY_ID ,STATE_ID ,STATUS_ID ,PRIORITY_ID ,PLATFORM_ID ,REQUEST_CLASS_ID ,PROJECT_ID ,COMPONENT_ID ,RESOURCE_ID ,ITERATION_ID ,RELEASE_ID);
CREATE  INDEX F_REQUI_METR_IDX1 ON F_REQUIREMENT_METRICS (DATE_ID);
CREATE  INDEX F_ACT_METR_IDX1 ON F_ACTIVITY_METRICS (DATE_ID ,ACTIVITY_CLASS_ID ,RESOURCE_ID,STATE_ID ,PRIORITY_ID);
CREATE  INDEX F_CHREQ_METR_IDX1 ON F_CHILDREQUIREMENT_METRICS (DATE_ID ,PARENT_REQUIREMENT_ID ,REQUIREMENT_CLASS_ID ,PROJECT_ID ,RELEASE_ID ,ITERATION_ID ,COMPONENT_ID);
CREATE  INDEX F_REQAG_METR_IDX1 ON F_REQUEST_AGING (DATE_ID ,REQUEST_CLASS_ID ,PROJECT_ID ,COMPONENT_ID ,RESOURCE_ID ,ITERATION_ID);
CREATE  INDEX F_REQ_METR_IDX2 ON F_REQUEST_METRICS (DATE_ID ,TEAM_ID ,SEVERITY_ID ,STATE_ID ,STATUS_ID ,PRIORITY_ID ,PLATFORM_ID ,COMPONENT_ID);
CREATE INDEX F_BLDMETR_IDX ON F_BUILD_METRICS (DATE_ID, PROJECT_ID, COMPONENT_ID, BUILD_TYPE_ID, BUILD_CLASS_ID);	
CREATE INDEX F_TXTF_CHGMET_IDX ON F_TEXT_FILE_CHANGE_METRICS (EXTERNAL_KEY1,SOURCE_ID);	
CREATE INDEX F_FSTREAMMET_IDX ON F_FILE_STREAM_METRICS (EXTERNAL_KEY1,SOURCE_ID);
CREATE INDEX F_REQ_METR_IDX3 ON F_REQUEST_METRICS (EXTERNAL_KEY1,SOURCE_ID);
CREATE INDEX F_ERI_MET_IDX1 ON F_EXECUTION_RES_ITER_METRICS  (ITERATION_ID ,TESTPLAN_ID ,VERDICT_ID ,DATE_ID ,PROJECT_ID ,EXECRES_CLASS_ID ,ASSETREGISTRY_ID ,TESTCASE_ID ,EXERES_METRICS_ID ) ;
CREATE INDEX F_EXERES_IDX1 ON F_EXECUTION_RESULT_METRICS (DATE_ID ,ASSETREGISTRY_ID ,VERDICT_ID ,EXERES_METRICS_ID ,PROJECT_ID ,TESTPLAN_ID ,TESTCASE_ID ,EXECRES_CLASS_ID ) ;				

CREATE UNIQUE INDEX D_DATE_PK ON D_DATE (DATE_ID);                                                                                
CREATE UNIQUE INDEX D_CURRENCY_PK ON D_CURRENCY (CURRENCY_ID);                                                                    
CREATE UNIQUE INDEX D_BUILD_PK ON D_BUILD (BUILD_ID);                                                                             
CREATE UNIQUE INDEX D_REQSTATE_PK ON D_REQUEST_STATE (STATE_ID);                                                                  
CREATE UNIQUE INDEX D_REQISTATE_PK ON D_REQUIREMENT_STATE (STATE_ID);                                                             
CREATE UNIQUE INDEX D_RESOURCE_PK ON D_RESOURCE (RESOURCE_ID);                                                                    
CREATE UNIQUE INDEX D_PRIORITY_PK ON D_PRIORITY (PRIORITY_ID);                                                                    
CREATE UNIQUE INDEX D_STABILITY_PK ON D_STABILITY (STABILITY_ID);                                                                 
CREATE UNIQUE INDEX D_DIFFICULTY_PK ON D_DIFFICULTY (DIFFICULTY_ID);                                                              
CREATE UNIQUE INDEX D_CPRIORITY_PK ON D_CUSTOMER_PRIORITY (CUSTOMER_PRIORITY_ID);                                                 
CREATE UNIQUE INDEX D_ITERATION_PK ON D_ITERATION (ITERATION_ID);                                                                 
CREATE UNIQUE INDEX D_CMPTEAM_PK ON D_TEAM (TEAM_ID);                                                                             
CREATE UNIQUE INDEX D_RELEASE_PK ON D_RELEASE (RELEASE_ID);                                                                       
CREATE UNIQUE INDEX D_PLATFORM_PK ON D_PLATFORM (PLATFORM_ID);                                                                    
CREATE UNIQUE INDEX D_SEVERITY_PK ON D_SEVERITY (SEVERITY_ID);                                                                    
CREATE UNIQUE INDEX D_STATUS_PK ON D_STATUS (STATUS_ID);                                                                          
CREATE UNIQUE INDEX PROGRAM_PK ON D_PROGRAM (PROGRAM_ID);                                                                         
CREATE UNIQUE INDEX PROJECT_PK ON D_PROJECT (PROJECT_ID);                                                                         
CREATE UNIQUE INDEX D_CUSTOMER_PK ON D_CUSTOMER (CUSTOMER_ID);                                                                    
CREATE UNIQUE INDEX D_PRODUCT_PK ON D_PRODUCT (PRODUCT_ID);                                                                       
CREATE UNIQUE INDEX D_COMPONENT_PK ON D_COMPONENT (COMPONENT_ID);                                                                 
CREATE UNIQUE INDEX D_REQ_CL_PK ON D_REQUEST_CLASSIFICATION (REQUEST_CLASS_ID);                                                   
CREATE UNIQUE INDEX D_REQUI_CL_PK ON D_REQUIREMENT_CLASSIFICATION (REQUIREMENT_CLASS_ID);                                         
CREATE UNIQUE INDEX TSK_CLASS_PK ON D_TASK_CLASSIFICATION (TASK_CLASS_ID);                                                        
CREATE UNIQUE INDEX D_REQUIREMENT_PK ON D_REQUIREMENT (REQUIREMENT_ID);                                                           
CREATE UNIQUE INDEX D_TESTCASE_PK ON D_TESTCASE (TESTCASE_ID);                                                                    
CREATE UNIQUE INDEX D_TESTSUITE_PK ON D_TESTSUITE (TESTSUITE_ID);                                                                 
CREATE UNIQUE INDEX D_CFGTEST_PK ON D_EXECUTION_WORKITEM (EXECWORKITEM_ID);                                                       
CREATE UNIQUE INDEX D_EXERES_PK ON D_EXECUTION_RESULT (EXECUTION_RESULT_ID);                                                      
CREATE UNIQUE INDEX D_SUITELG_PK ON D_TESTSUITELOG (TESTSUITELOG_ID);                                                             
CREATE UNIQUE INDEX D_TSTPLN_PK ON D_TESTPLAN (TESTPLAN_ID);                                                                      
CREATE UNIQUE INDEX D_VERD_PK ON D_VERDICT (VERDICT_ID);                                                                          
CREATE UNIQUE INDEX D_REQSRC_PK ON D_REQUEST_SOURCE (REQUEST_SOURCE_ID);                                                          
CREATE UNIQUE INDEX D_RESOLUTION_PK ON D_RESOLUTION (RESOLUTION_ID);                                                              
CREATE UNIQUE INDEX D_REQUEST_PK ON D_REQUEST (REQUEST_ID);                                                                       
CREATE UNIQUE INDEX D_ASSETRG_PK ON D_ASSETREGISTRY (ASSETREGISTRY_ID);                                                           
CREATE UNIQUE INDEX D_TSTSTATE_PK ON D_TESTCASE_STATE (STATE_ID);                                                                 
CREATE UNIQUE INDEX D_ACTIVITY_PK ON D_ACTIVITY (ACTIVITY_ID);                                                                    
CREATE UNIQUE INDEX D_FILE_PK ON D_FILE (FILE_ID);                                                                                
CREATE UNIQUE INDEX D_FILESTR_PK ON D_FILE_STREAM (FILE_STREAM_ID);                                                               
CREATE UNIQUE INDEX D_FILEBASE_PK ON D_FILE_BASELINE (FILE_BASELINE_ID);                                                          
CREATE UNIQUE INDEX D_FILE_VER_PK ON D_FILE_VERSION (FILE_VERSION_ID);                                                            
CREATE UNIQUE INDEX D_CFGTSTSTATE_PK ON D_EXECUTIONWKITEM_STATE (STATE_ID);                                                       
CREATE UNIQUE INDEX D_TSTPLN_STATE_PK ON D_TESTPLAN_STATE (STATE_ID);                                                             
CREATE UNIQUE INDEX D_TSTSUI_STATE_PK ON D_TESTSUITE_STATE (STATE_ID);                                                            
CREATE UNIQUE INDEX D_TASK_STATE_PK ON D_TASK_STATE (STATE_ID);                                                                   
CREATE UNIQUE INDEX D_TASK_PK ON D_TASK (TASK_ID);                                                                                
CREATE UNIQUE INDEX D_FACTOR_PK ON D_FACTOR (FACTOR_ID);                                                                          
CREATE UNIQUE INDEX D_BUILDTYPE_PK ON D_BUILD_TYPE (BUILD_TYPE_ID);                                                               
CREATE UNIQUE INDEX D_REQTYPE_PK ON D_REQUEST_TYPE (REQUEST_TYPE_ID);                  
CREATE UNIQUE INDEX D_CONFIG_PK ON D_CONFIGURATION (CONFIGURATION_ID);                                                            
CREATE UNIQUE INDEX D_RESGROUP_PK ON D_RESOURCE_GROUP (RESOURCE_GROUP_ID);                                                        
CREATE UNIQUE INDEX D_LABRES_PK ON D_LAB_RESOURCE (LAB_RESOURCE_ID);                                                              
CREATE UNIQUE INDEX D_OSTYPE_PK ON D_OS_TYPE (OS_TYPE_ID);                                                                        
CREATE UNIQUE INDEX D_REQCAT_PK ON D_REQUEST_CATEGORY (REQUEST_CATEGORY_ID);                                                      
CREATE UNIQUE INDEX D_FILECLS_PK ON D_FILE_CLASSIFICATION (FILE_CLASS_ID);                                                        
CREATE UNIQUE INDEX D_FILESTRMCLS_PK ON D_FILE_STREAM_CLASSIFICATION (FILE_STREAM_CLASS_ID);                                      
CREATE UNIQUE INDEX D_JOB_PK ON D_JOB (JOB_ID);                                                                                   
CREATE UNIQUE INDEX D_JOBRES_PK ON D_JOB_RESULT (JOB_RESULT_ID);                                                                  
CREATE UNIQUE INDEX D_RESULT_PK ON D_JOB_RESULT_STATE (STATE_ID);	                                                              
                                                                                                                                  
CREATE UNIQUE INDEX D_TIMESHEETST_PK ON D_TIMESHEET_STATE (STATE_ID);                                                             
CREATE UNIQUE INDEX D_PROJALLO_PK ON D_PROJECT_ALLOCATION (PROJECT_ALLOCATION_ID);                                                
CREATE UNIQUE INDEX D_SKILL_PK ON D_SKILL (SKILL_ID);                                                                             
CREATE UNIQUE INDEX D_COMPETENCY_PK ON D_COMPETENCY (COMPETENCY_ID);                                                              
CREATE UNIQUE INDEX D_POOL_PK ON D_POOL (POOL_ID);                                                                                
CREATE UNIQUE INDEX D_BASELINE_PK ON D_BASELINE                       	(BASELINE_ID);                                            
CREATE UNIQUE INDEX D_CHARGECODE_PK ON D_CHARGECODE                     	(CHARGECODE_ID);                                        
CREATE UNIQUE INDEX D_TIMECODE_PK ON D_TIMECODE                       	(TIMECODE_ID);                                            
CREATE UNIQUE INDEX D_PORTFOLIO_PK ON D_PORTFOLIO                      	(PORTFOLIO_ID);                                           
CREATE UNIQUE INDEX BD_PORTFOLIO_PK ON BD_PORTFOLIO                     	(PORTFOLIO_ID,PROGRAM_ID,PROJECT_ID);                   
CREATE UNIQUE INDEX D_REQUITYPE_PK ON D_REQUIREMENT_TYPE               	(REQUIREMENT_TYPE_ID);                                    
CREATE UNIQUE INDEX F_REQU_METRIC_PK ON F_REQUEST_METRICS (REQUEST_METRIC_ID);                                                    
CREATE UNIQUE INDEX HREQMETRIC_PK ON H_REQUEST_METRICS_TOTAL (REQUEST_METRIC_ID, REQUEST_ID);                                     
CREATE UNIQUE INDEX HREQMETRICB_PK ON H_REQUEST_METRICS_BLOCKING (REQUEST_METRIC_ID, REQUEST_ID);                                 
CREATE UNIQUE INDEX F_DEF_AG_PK ON F_REQUEST_AGING (AGING_METRIC_ID);                                                             
CREATE UNIQUE INDEX HREQAG_PK ON H_REQUEST_AGING_TOTAL (AGING_METRIC_ID,REQUEST_ID);                                              
CREATE UNIQUE INDEX HREQAGM_PK ON H_REQUEST_AGING_MIN (AGING_METRIC_ID,REQUEST_ID);                                               
CREATE UNIQUE INDEX HREQAGX_PK ON H_REQUEST_AGING_MAX (AGING_METRIC_ID,REQUEST_ID);                                               
CREATE UNIQUE INDEX F_REQCDT_PK ON F_REQUEST_CLOSURE_DATE_METRICS (REQCDT_METRIC_ID);                                             
CREATE UNIQUE INDEX F_EXERES_PK ON F_EXECUTION_RESULT_METRICS (EXERES_METRICS_ID);                                                
CREATE UNIQUE INDEX F_REQDT_PK ON F_REQUEST_CREATION_DT_METRICS (REQDT_METRIC_ID);                                                
CREATE UNIQUE INDEX F_REQFL_PK ON F_REQUEST_FAILURE_METRICS (REQFAIL_METRIC_ID);                                                  
CREATE UNIQUE INDEX HREQFMETRIC_PK ON H_REQUEST_FAILURE_METRICS (REQFAIL_METRIC_ID, REQUEST_ID);                                  
CREATE UNIQUE INDEX F_REQMET_PK ON F_REQUIREMENT_METRICS (REQ_METRIC_ID);                                                         
CREATE UNIQUE INDEX HREQUIMETTOT_PK ON H_REQUIREMENT_METRICS_TOTAL (REQ_METRIC_ID, REQUIREMENT_ID);                               
CREATE UNIQUE INDEX HREQUIMETCH_PK ON H_REQUIREMENT_METRICS_CHANGES (REQ_METRIC_ID, REQUIREMENT_ID);                              
CREATE UNIQUE INDEX F_EXECWK_PK ON F_EXECUTION_WORKITEM_METRICS (EXECWORKITEM_METRIC_ID);                                         
CREATE UNIQUE INDEX HEXECWKMETRIC_PK ON H_EXECUTION_WORKITEM_METRICS (EXECWORKITEM_METRIC_ID, EXECWORKITEM_ID);                   
CREATE UNIQUE INDEX F_TSTCASE_PK ON F_TESTCASE_METRICS (TSTCASE_METRIC_ID);                                                       
CREATE UNIQUE INDEX F_PTSTCASEPLN_PK ON F_PROJ_TESTCASE_TPLN_METRICS (TSTCASE_METRIC_ID);                                         
CREATE UNIQUE INDEX F_CPTSTCASEPL_PK ON F_C_PROJ_TESTCASE_TPLN_METRICS (TSTCASE_METRIC_ID);                                       
CREATE UNIQUE INDEX F_PTSTCASE_PK ON F_PROJ_TESTCASE_METRICS (TSTCASE_METRIC_ID);                                                 
CREATE UNIQUE INDEX F_CPTSTCASE_PK ON F_C_PROJ_TESTCASE_METRICS (TSTCASE_METRIC_ID);                                              
CREATE UNIQUE INDEX HTSTCMETRIC_PK ON H_TESTCASE_METRICS (TSTCASE_METRIC_ID, TESTCASE_ID);                                        
CREATE UNIQUE INDEX HPTSTCASEPLN_PK ON H_PROJ_TESTCASE_TPLN_METRICS (TSTCASE_METRIC_ID, TESTCASE_ID);                             
CREATE UNIQUE INDEX HPTSTCASE_PK ON H_PROJ_TESTCASE_METRICS (TSTCASE_METRIC_ID, TESTCASE_ID);                                     
CREATE UNIQUE INDEX F_BUILD_PK ON F_BUILD_METRICS (BUILD_METRIC_ID);                                                              
CREATE UNIQUE INDEX HBLDATTE_PK ON H_BUILD_ATTEMPTS (BUILD_METRIC_ID, BUILD_ID);                                                  
CREATE UNIQUE INDEX HBLDPAS_PK ON H_BUILD_PASS (BUILD_METRIC_ID, BUILD_ID);                                                       
CREATE UNIQUE INDEX HBLDFAIL_PK ON H_BUILD_FAIL (BUILD_METRIC_ID, BUILD_ID);                                                      
CREATE UNIQUE INDEX F_TFV_MET_PK ON F_TEXT_FILE_VERSION_METRICS (SLOC_METRICS_ID);                                                
CREATE UNIQUE INDEX H_TFVCH_PK ON H_TEXT_FILE_VERSION_METRICS_CH (SLOC_METRICS_ID,FILE_VERSION_ID);                               
CREATE UNIQUE INDEX H_TFVT_PK ON H_TEXT_FILE_VERSION_METRICS_TO (SLOC_METRICS_ID,FILE_VERSION_ID);                                
CREATE UNIQUE INDEX F_CHREQM_PK ON F_CHILDREQUIREMENT_METRICS (CHILDREQ_METRICS_ID);                                              
CREATE UNIQUE INDEX F_PPM_PK ON F_PROJECT_PERFORMANCE_METRICS (PERF_METRICS_ID);                                                  
CREATE UNIQUE INDEX H_REQCLD_PK ON H_REQUEST_CLOSURE_DATE_METRICS (REQCDT_METRIC_ID, REQUEST_ID);                                 
CREATE UNIQUE INDEX H_REQDT_PK ON H_REQUEST_CREATION_DT_METRICS (REQDT_METRIC_ID, REQUEST_ID);                                    
CREATE UNIQUE INDEX H_EXERES_PK ON H_EXECUTION_RESULT_METRICS (EXERES_METRICS_ID, EXECUTION_RESULT_ID);                           
CREATE UNIQUE INDEX H_CHREQ_PK ON H_CHILDREQUIREMENT_METRICS (CHILDREQ_METRICS_ID, REQUIREMENT_ID);                               
CREATE UNIQUE INDEX D_ACT_STATE_PK ON D_ACTIVITY_STATE (STATE_ID);                                                                
CREATE UNIQUE INDEX D_ACT_CLASS_PK ON D_ACTIVITY_CLASSIFICATION (ACTIVITY_CLASS_ID);                                              
CREATE UNIQUE INDEX D_COMP_STATE_PK ON D_COMPONENT_CLASSIFICATION (COMPONENT_CLASS_ID);                                           
CREATE UNIQUE INDEX D_PRJ_CLASS_PK ON D_PROJECT_CLASSIFICATION (PROJECT_CLASS_ID);                                                
CREATE UNIQUE INDEX DTASKTYPE_PK ON D_TASK_TYPE (TASK_TYPE_ID);                                                                   
CREATE UNIQUE INDEX D_AGE_RANK_PK ON D_AGE_RANK (AGE_RANK_ID);                                                                    
CREATE UNIQUE INDEX F_ACTM_PK ON F_ACTIVITY_METRICS (ACTIVITY_METRICS_ID);                                                        
CREATE UNIQUE INDEX H_ACTM_STATE_PK ON H_ACTIVITY_METRICS (ACTIVITY_METRICS_ID,ACTIVITY_ID);                                      
CREATE UNIQUE INDEX F_ACTCRDM_PK ON F_ACTIVITY_CREATION_DT_METRICS (ACTIVITYCRD_METRICS_ID);                                      
CREATE UNIQUE INDEX H_ACTCRDM_PK ON H_ACTIVITY_CREATION_DT_METRICS (ACTIVITYCRD_METRICS_ID,ACTIVITY_ID);                          
CREATE UNIQUE INDEX F_EXECRESDT_PK ON F_EXECRESULT_DATE_METRICS (EXECRESDT_METRICS_ID);                                           
CREATE UNIQUE INDEX H_EXECRESDTK_PK ON H_EXECRESULT_DATE_METRICS (EXECRESDT_METRICS_ID,EXECUTION_RESULT_ID);                      
CREATE UNIQUE INDEX F_EXECPTS_PK ON F_EXECRESPOINTS_METRICS (EXECRES_METRIC_ID);                                                  
CREATE UNIQUE INDEX H_EXECPTS_PK ON H_EXECRESPOINTS_METRICS (EXECRES_METRIC_ID,EXECUTION_RESULT_ID);                              
CREATE UNIQUE INDEX F_REQTURN_PK ON F_REQUEST_TURNAROUND (TURNAROUND_METRIC_ID);                                                  
CREATE UNIQUE INDEX H_REQTURNTOT_PK ON H_REQUEST_TURNAROUND_TOTAL (TURNAROUND_METRIC_ID,REQUEST_ID);                              
CREATE UNIQUE INDEX H_REQTURNMIN_PK ON H_REQUEST_TURNAROUND_MIN (TURNAROUND_METRIC_ID,REQUEST_ID);	                              
CREATE UNIQUE INDEX H_REQTURNMAX_PK ON H_REQUEST_TURNAROUND_MAX (TURNAROUND_METRIC_ID,REQUEST_ID);                                
CREATE UNIQUE INDEX F_TSKMET_PK ON F_TASK_METRICS (TASK_METRICS_ID);                                                              
CREATE UNIQUE INDEX H_TSKMET_PK ON H_TASK_METRICS (TASK_METRICS_ID,TASK_ID);                                                      
CREATE UNIQUE INDEX F_TSKCRDTMET_PK ON F_TASK_CREATION_DT_METRICS (TASKCRD_METRICS_ID);                                           
CREATE UNIQUE INDEX H_TSKCRDTMET_PK ON H_TASK_CREATION_DT_METRICS (TASKCRD_METRICS_ID,TASK_ID);                                   
CREATE UNIQUE INDEX F_TSKCLDTMET_PK ON F_TASK_CLOSURE_DT_METRICS (TASKCLS_METRICS_ID);                                            
CREATE UNIQUE INDEX H_TSKCLDTMET_PK ON H_TASK_CLOSURE_DT_METRICS (TASKCLS_METRICS_ID,TASK_ID);                                    
CREATE UNIQUE INDEX H_BLDEXDTMET_PK ON H_BUILD_EXEC_DT_METRICS_TOT (BUILD_EXEC_METRIC_ID,BUILD_ID);                               
CREATE UNIQUE INDEX F_BLDEXDTMET_PK ON F_BUILD_EXECUTION_DT_METRICS (BUILD_EXEC_METRIC_ID);                                       
CREATE UNIQUE INDEX  D_TSTCCLASS_PK ON D_TESTCASE_CLASSIFICATION (TESTCASE_CLASS_ID);                                            
                                                                                                                                  
CREATE UNIQUE INDEX D_EXWKITCLASS_PK ON D_EXECWORKITEM_CLASSIFICATION (EXECWORKIT_CLASS_ID);                                     
                                                                                                                                  
CREATE UNIQUE INDEX D_EXECRESCLASS_PK ON D_EXECRESULT_CLASSIFICATION (EXECRES_CLASS_ID);                                         
                                                                                                                                  
CREATE UNIQUE INDEX D_TESTSUCLASS_PK ON D_TESTSUITE_CLASSIFICATION (TESTSUITE_CLASS_ID);                                          
CREATE UNIQUE INDEX F_LABRESUTL_PK ON F_LAB_RESUTILIZATION_METRICS (LAB_RESUTIL_ID);                                              
CREATE UNIQUE INDEX H_LABRESUTL_PK ON H_LAB_RESUTILIZATION_METRICS (LAB_RESUTIL_ID,LAB_RESOURCE_ID);                              
CREATE UNIQUE INDEX FFTXTCHNGM_PK ON F_TEXT_FILE_CHANGE_METRICS (FTEXTCHNG_METRICS_ID);                                           
CREATE UNIQUE INDEX HFTXTCHNGM_PK ON H_TEXT_FILE_CHANGE_METRICS (FTEXTCHNG_METRICS_ID,FILE_ID);                                   
CREATE UNIQUE INDEX FFILESTRMET_PK ON F_FILE_STREAM_METRICS (FSTREAM_METRICS_ID);                                                 
CREATE UNIQUE INDEX HFILESTRMET_PK ON H_FILE_STREAM_METRICS (FSTREAM_METRICS_ID,FILE_STREAM_ID);                                  
CREATE UNIQUE INDEX D_BUILDCLASS_PK ON D_BUILD_CLASSIFICATION (BUILD_CLASS_ID);                                                   
CREATE UNIQUE INDEX F_JOBEXECRES_PK ON F_JOB_EXECUTION_DT_METRICS (F_JOBRES_METRIC_ID);                                           
CREATE UNIQUE INDEX H_JOBEXECRES_PK ON H_JOB_EXECUTION_DT_METRICS (F_JOBRES_METRIC_ID,JOB_RESULT_ID);                             
CREATE UNIQUE INDEX F_REQRESDT_PK ON F_REQUEST_RESOLUTIO_DT_METRICS (REQDT_METRIC_ID);                                            
CREATE UNIQUE INDEX H_REQRESDT_PK ON H_REQUEST_RESOLUTIO_DT_METRICS (REQDT_METRIC_ID, REQUEST_ID);                                
CREATE UNIQUE INDEX F_RELREQ_PK ON F_RELEASE_REQUEST_METRICS (F_RELREQ_METRIC_ID);                                                
CREATE UNIQUE INDEX H_RELREQ_PK ON H_RELEASE_REQUEST_METRICS (F_RELREQ_METRIC_ID,REQUEST_ID);                                     
CREATE UNIQUE INDEX F_RELREQTU_PK ON F_REL_REQUEST_TURN_METRICS (F_RELREQ_TURN_METRIC_ID);                                        
CREATE UNIQUE INDEX H_RELREQTU_PK ON H_REL_REQUEST_TURN_METRICS (F_RELREQ_TURN_METRIC_ID,REQUEST_ID);                             
CREATE UNIQUE INDEX F_TTMKTREL_PK ON F_TIME_TO_MARKET_RELEA_METRICS (F_TIME_TO_MRKT_METRIC_ID);                                   
CREATE UNIQUE INDEX H_TTMKTREL_PK ON H_TIME_TO_MARKET_REL_METRICS (F_TIME_TO_MRKT_METRIC_ID,RELEASE_ID);                          
CREATE UNIQUE INDEX F_C_REQU_METRIC_PK ON F_C_REQUEST_METRICS (REQUEST_METRIC_ID);                                                
CREATE UNIQUE INDEX F_C_DEF_AG_PK ON F_C_REQUEST_AGING (AGING_METRIC_ID);                                                         
CREATE UNIQUE INDEX F_C_REQTURN_PK ON F_C_REQUEST_TURNAROUND (TURNAROUND_METRIC_ID);                                              
CREATE UNIQUE INDEX F_C_EXERES_PK ON F_C_EXECUTION_RESULT_METRICS (EXERES_METRICS_ID);                                            
CREATE UNIQUE INDEX F_C_REQFL_PK ON F_C_REQUEST_FAILURE_METRICS (REQFAIL_METRIC_ID);                                              
CREATE UNIQUE INDEX F_C_REQMET_PK ON F_C_REQUIREMENT_METRICS (REQ_METRIC_ID);                                                     
CREATE UNIQUE INDEX F_C_EXECWK_PK ON F_C_EXECUTION_WORKITEM_METRICS (EXECWORKITEM_METRIC_ID);                                     
CREATE UNIQUE INDEX F_C_TSTCASE_PK ON F_C_TESTCASE_METRICS (TSTCASE_METRIC_ID);                                                   
CREATE UNIQUE INDEX F_C_BUILD_PK ON F_C_BUILD_METRICS (BUILD_METRIC_ID);                                                          
CREATE UNIQUE INDEX F_C_PPM_PK ON F_C_PROJECT_PERFORM_METRICS (PERF_METRICS_ID);                                                  
CREATE UNIQUE INDEX F_C_CHREQM_PK ON F_C_CHILDREQUIREMENT_METRICS (CHILDREQ_METRICS_ID);                                          
CREATE UNIQUE INDEX F_C_EXECPTS_PK ON F_C_EXECRESPOINTS_METRICS (EXECRES_METRIC_ID);                                              
CREATE UNIQUE INDEX F_C_ACTM_PK ON F_C_ACTIVITY_METRICS (ACTIVITY_METRICS_ID);                                                    
CREATE UNIQUE INDEX F_C_TSKMET_PK ON F_C_TASK_METRICS (TASK_METRICS_ID);                                                          
CREATE UNIQUE INDEX F_C_LABRESUTL_PK ON F_C_LAB_RESUTILIZATION_METRICS (LAB_RESUTIL_ID);                                          
CREATE UNIQUE INDEX FCFTXTCHNGM_PK ON F_C_TEXT_FILE_CHANGE_METRICS (FTEXTCHNG_METRICS_ID);                                        
CREATE UNIQUE INDEX FCFILESTRMET_PK ON F_C_FILE_STREAM_METRICS (FSTREAM_METRICS_ID);                                              
CREATE UNIQUE INDEX F_C_RELREQ_PK ON F_C_RELEASE_REQUEST_METRICS (F_RELREQ_METRIC_ID);                                            
CREATE UNIQUE INDEX F_C_RELREQTU_PK ON F_C_REL_REQUEST_TURN_METRICS (F_RELREQ_TURN_METRIC_ID);                                    
CREATE UNIQUE INDEX  F_ACTITER_MET_PK ON F_ACTIVITY_ITER_METRICS (ACTIVITY_METRICS_ID);                                           
CREATE UNIQUE INDEX  F_ACTREQ_MET_PK ON F_ACTIVITY_REQ_METRICS (ACTIVITY_METRICS_ID);                                             
CREATE UNIQUE INDEX  F_AICRDT_MET_PK ON F_ACT_ITER_CREATION_DT_METRICS (ACTIVITYCRD_METRICS_ID);                                  
CREATE UNIQUE INDEX  F_ARCRDT_MET_PK ON F_ACT_REQU_CREATION_DT_METRICS (ACTIVITYCRD_METRICS_ID);                                  
CREATE UNIQUE INDEX  F_BLDREQUI_MET_PK ON F_BUILD_REQUI_METRICS (BUILD_METRIC_ID);                                                
CREATE UNIQUE INDEX  F_BREDT_MET_PK ON F_BUILD_REQU_EXEC_DT_METRICS (BUILD_EXEC_METRIC_ID);                                       
CREATE UNIQUE INDEX  F_BLDREQU_MET_PK ON F_BUILD_REQU_METRICS (BUILD_METRIC_ID);                                                  
CREATE UNIQUE INDEX  F_C_ACTITER_MET_PK ON F_C_ACTIVITY_ITER_METRICS (ACTIVITY_METRICS_ID);                                       
CREATE UNIQUE INDEX  F_C_ACTREQ_MET_PK ON F_C_ACTIVITY_REQ_METRICS (ACTIVITY_METRICS_ID);                                         
CREATE UNIQUE INDEX  F_CBLDREQ_MET_PK ON F_C_BUILD_REQUI_METRICS (BUILD_METRIC_ID);                                               
CREATE UNIQUE INDEX  F_C_BLDREQU_MET_PK ON F_C_BUILD_REQU_METRICS (BUILD_METRIC_ID);                                              
CREATE UNIQUE INDEX  F_CEPTI_MET_PK ON F_C_EXECRESPOINTS_ITER_METRICS (EXECRES_METRIC_ID);                                        
CREATE UNIQUE INDEX  F_CEREI_MET_PK ON F_C_EXEC_RESULT_ITER_METRICS (EXERES_METRICS_ID);                                          
CREATE UNIQUE INDEX  F_CEWI_MET_PK ON F_C_EXEC_WORKITEM_ITER_METRICS (EXECWORKITEM_METRIC_ID);                                    
CREATE UNIQUE INDEX  F_CEWIR_MET_PK ON F_C_EXEC_WORKITEM_REQU_METRICS (EXECWORKITEM_METRIC_ID);                                   
CREATE UNIQUE INDEX  F_C_REQCUST_MET_PK ON F_C_REQUEST_CUST_METRICS (REQUEST_METRIC_ID);                                          
CREATE UNIQUE INDEX  F_CREQRQF_MET_PK ON F_C_REQUEST_REQUI_FAIL_METRICS (REQFAIL_METRIC_ID);                                      
CREATE UNIQUE INDEX  F_CREQRQU_MET_PK ON F_C_REQUEST_REQUI_METRICS (REQUEST_METRIC_ID);                                           
CREATE UNIQUE INDEX  F_C_REQTPLN_AG_PK ON F_C_REQUEST_TPLN_AGING (AGING_METRIC_ID);                                               
CREATE UNIQUE INDEX  F_CREQTPF_MET_PK ON F_C_REQUEST_TPLN_FAIL_METRICS (REQFAIL_METRIC_ID);                                       
CREATE UNIQUE INDEX  F_C_REQTPLN_MET_PK ON F_C_REQUEST_TPLN_METRICS (REQUEST_METRIC_ID);                                          
CREATE UNIQUE INDEX  F_CREQTPT_MET_PK ON F_C_REQUEST_TPLN_TURNAROUND (TURNAROUND_METRIC_ID);                                      
CREATE UNIQUE INDEX  F_CREQUTP_MET_PK ON F_C_REQUIREMENT_TPLN_METRICS (REQ_METRIC_ID);                                            
CREATE UNIQUE INDEX  F_CREQTC_MET_PK ON F_C_REQUI_TCASE_METRICS (REQ_METRIC_ID);                                                  
CREATE UNIQUE INDEX  F_CTKCM_MET_PK ON F_C_TASK_COMP_METRICS (TASK_METRICS_ID);                                                   
CREATE UNIQUE INDEX  F_CTSI_MET_PK ON F_C_TESTCASE_ITER_METRICS (TSTCASE_METRIC_ID);                                              
CREATE UNIQUE INDEX  F_CTPJR_MET_PK ON F_C_TESTCASE_REQUI_METRICS (TSTCASE_METRIC_ID);                                            
CREATE UNIQUE INDEX  F_CTXFV_MET_PK ON F_C_TEXT_FILE_VERSION_METRICS (SLOC_METRICS_ID);                                           
CREATE UNIQUE INDEX  F_CTXFVR_MET_PK ON F_C_TEXT_FILE_VER_REQU_METRICS (SLOC_METRICS_ID);                                         
CREATE UNIQUE INDEX  F_EXPI_MET_PK ON F_EXECRESPOINTS_ITER_METRICS (EXECRES_METRIC_ID);                                           
CREATE UNIQUE INDEX  F_ERI_MET_PK ON F_EXECUTION_RES_ITER_METRICS (EXERES_METRICS_ID);                                            
CREATE UNIQUE INDEX  F_EWI_MET_PK ON F_EXEC_WORKITEM_ITER_METRICS (EXECWORKITEM_METRIC_ID);                                       
CREATE UNIQUE INDEX  F_EWR_MET_PK ON F_EXEC_WORKITEM_REQU_METRICS (EXECWORKITEM_METRIC_ID);                                       
CREATE UNIQUE INDEX  F_REQCUST_MET_PK ON F_REQUEST_CUST_METRICS (REQUEST_METRIC_ID);                                              
CREATE UNIQUE INDEX  F_RQRUF_MET_PK ON F_REQUEST_REQUI_FAIL_METRICS (REQFAIL_METRIC_ID);                                          
CREATE UNIQUE INDEX  F_REQREQUI_MET_PK ON F_REQUEST_REQUI_METRICS (REQUEST_METRIC_ID);                                            
CREATE UNIQUE INDEX  F_RRERD_MET_PK ON F_REQUEST_RES_REQUI_DT_METRICS (REQDT_METRIC_ID);                                          
CREATE UNIQUE INDEX  F_RRETD_MET_PK ON F_REQUEST_RES_TPLN_DT_METRICS (REQDT_METRIC_ID);                                           
CREATE UNIQUE INDEX  F_REQTPLN_AG_PK ON F_REQUEST_TPLN_AGING (AGING_METRIC_ID);                                                   
CREATE UNIQUE INDEX  F_RPLF_MET_PK ON F_REQUEST_TPLN_FAIL_METRICS (REQFAIL_METRIC_ID);                                            
CREATE UNIQUE INDEX  F_REQTPLN_MET_PK ON F_REQUEST_TPLN_METRICS (REQUEST_METRIC_ID);                                              
CREATE UNIQUE INDEX  F_RQTPT_PK ON F_REQUEST_TPLN_TURNAROUND (TURNAROUND_METRIC_ID);                                              
CREATE UNIQUE INDEX  F_RCRDT_MET_PK ON F_REQUE_CLOSE_REQUI_DT_METRICS (REQCDT_METRIC_ID);                                         
CREATE UNIQUE INDEX  F_RCTD_MET_PK ON F_REQUE_CLOSE_TPLN_DT_METRICS (REQCDT_METRIC_ID);                                           
CREATE UNIQUE INDEX  F_REQUITPLN_MET_PK ON F_REQUIREMENT_TPLN_METRICS (REQ_METRIC_ID);                                            
CREATE UNIQUE INDEX  F_RTC_MET_PK ON F_REQUI_TCASE_METRICS (REQ_METRIC_ID);                                                       
CREATE UNIQUE INDEX  F_RRDT_MET_PK ON F_REQU_CREATI_REQUI_DT_METRICS (REQDT_METRIC_ID);                                           
CREATE UNIQUE INDEX  F_RCRTD_MET_PK ON F_REQU_CREATI_TPLN_DT_METRICS (REQDT_METRIC_ID);                                           
CREATE UNIQUE INDEX  F_TCCMD_MET_PK ON F_TASK_CLOSE_COMP_DT_METRICS (TASKCLS_METRICS_ID);                                         
CREATE UNIQUE INDEX  F_TASK_COMP_MET_PK ON F_TASK_COMP_METRICS (TASK_METRICS_ID);                                                 
CREATE UNIQUE INDEX  F_TCRCMD_MET_PK ON F_TASK_CREATE_COMP_DT_METRICS (TASKCRD_METRICS_ID);                                       
CREATE UNIQUE INDEX  F_TESTITER_MET_PK ON F_TESTCASE_ITER_METRICS (TSTCASE_METRIC_ID);                                            
CREATE UNIQUE INDEX  F_TPJR_MET_PK ON F_TESTCASE_REQUI_METRICS (TSTCASE_METRIC_ID);                                               
CREATE UNIQUE INDEX  F_TFVD_MET_PK ON F_TEXT_FILE_VERSION_DT_METRICS (SLOC_METRICS_ID);                                           
CREATE UNIQUE INDEX  F_TFVRD_MET_PK ON F_TEXT_FILE_VERSREQ_DT_METRICS (SLOC_METRICS_ID);                                          
CREATE UNIQUE INDEX  F_TXFVR_MET_PK ON F_TEXT_FILE_VER_REQU_METRICS (SLOC_METRICS_ID);                                            
CREATE UNIQUE INDEX F_ACTCMPM_PK ON F_ACTIVITY_COMP_METRICS (ACTIVITY_METRICS_ID);                                                
CREATE UNIQUE INDEX F_C_ACTCMPM_PK ON F_C_ACTIVITY_COMP_METRICS (ACTIVITY_METRICS_ID);                                            
CREATE UNIQUE INDEX F_ACTCOMCRDM_PK ON F_ACT_COM_CREATION_DT_METRICS (ACTIVITYCRD_METRICS_ID);                                    
CREATE UNIQUE INDEX F_TFVBSLN_MET_PK ON F_TEXT_FILE_VER_BSLN_METRICS (SLOC_METRICS_ID);                                           
CREATE UNIQUE INDEX F_CTXFVBSLN_PK ON F_C_TEXT_FILE_VERBSLN_METRICS (SLOC_METRICS_ID);                                            
CREATE UNIQUE INDEX  H_ACT_ITER_MET_PK ON H_ACTIVITY_ITER_METRICS (ACTIVITY_ID,ACTIVITY_METRICS_ID);                              
CREATE UNIQUE INDEX  H_ACT_REQ_MET_PK ON H_ACTIVITY_REQ_METRICS (ACTIVITY_METRICS_ID,ACTIVITY_ID);                                
CREATE UNIQUE INDEX  H_AICRD_MET_PK ON H_ACT_ITER_CREATION_DT_METRICS (ACTIVITYCRD_METRICS_ID,ACTIVITY_ID);                       
CREATE UNIQUE INDEX  H_ARCRD_MET_PK ON H_ACT_REQUI_CREAT_DT_METRICS (ACTIVITYCRD_METRICS_ID,ACTIVITY_ID);                         
CREATE UNIQUE INDEX  H_BRQA_PK ON H_BUILD_REQUI_ATTEMPTS (BUILD_METRIC_ID,BUILD_ID);                                              
CREATE UNIQUE INDEX  H_BRQF_PK ON H_BUILD_REQUI_FAIL (BUILD_METRIC_ID,BUILD_ID);                                                  
CREATE UNIQUE INDEX  H_BRQP_PK ON H_BUILD_REQUI_PASS (BUILD_METRIC_ID,BUILD_ID);                                                  
CREATE UNIQUE INDEX  H_BRQUA_PK ON H_BUILD_REQU_ATTEMPTS (BUILD_METRIC_ID,BUILD_ID);                                              
CREATE UNIQUE INDEX  H_BREDT_MET_PK ON H_BUILD_REQU_EXEC_DT_MET_TOT (BUILD_EXEC_METRIC_ID,BUILD_ID);                              
CREATE UNIQUE INDEX  H_BLD_REQU_FAIL_PK ON H_BUILD_REQU_FAIL (BUILD_METRIC_ID,BUILD_ID);                                          
CREATE UNIQUE INDEX  H_BLD_REQU_PASS_PK ON H_BUILD_REQU_PASS (BUILD_METRIC_ID,BUILD_ID);                                          
CREATE UNIQUE INDEX  H_EXPI_MET_PK ON H_EXECRESPOINTS_ITER_METRICS (EXECRES_METRIC_ID,EXECUTION_RESULT_ID);                       
CREATE UNIQUE INDEX  H_ERI_MET_PK ON H_EXECUTION_RES_ITER_METRICS (EXERES_METRICS_ID,EXECUTION_RESULT_ID);                        
CREATE UNIQUE INDEX  HEWI_MET_PK ON H_EXEC_WORKITEM_ITER_METRICS (EXECWORKITEM_METRIC_ID,EXECWORKITEM_ID);                        
CREATE UNIQUE INDEX  HEWR_MET_PK ON H_EXEC_WORKITEM_REQU_METRICS (EXECWORKITEM_METRIC_ID,EXECWORKITEM_ID);                        
CREATE UNIQUE INDEX  H_RAT_MX_PK ON H_REQUEST_AGING_TPLN_MAX (AGING_METRIC_ID,REQUEST_ID);                                        
CREATE UNIQUE INDEX  H_RAT_MI_PK ON H_REQUEST_AGING_TPLN_MIN (AGING_METRIC_ID,REQUEST_ID);                                        
CREATE UNIQUE INDEX  H_RAT_TO_PK ON H_REQUEST_AGING_TPLN_TOTAL (AGING_METRIC_ID,REQUEST_ID);                                      
CREATE UNIQUE INDEX  H_TCRCMD_MET_PK ON H_TASK_CREATE_COMP_DT_METRICS (TASKCRD_METRICS_ID,TASK_ID);                               
CREATE UNIQUE INDEX  H_RCBL_MET_PK ON H_REQUEST_CUST_METRICS_BLOCK (REQUEST_METRIC_ID,REQUEST_ID);                                
CREATE UNIQUE INDEX  H_RCTO_MET_PK ON H_REQUEST_CUST_METRICS_TOTAL (REQUEST_METRIC_ID,REQUEST_ID);                                
CREATE UNIQUE INDEX  H_RRF_MET_PK ON H_REQUEST_REQUI_FAIL_METRICS (REQFAIL_METRIC_ID,REQUEST_ID);                                 
CREATE UNIQUE INDEX  H_RRIBL_MET_PK ON H_REQUEST_REQUI_METRICS_BLOCK (REQUEST_METRIC_ID,REQUEST_ID);                              
CREATE UNIQUE INDEX  H_RRITO_MET_PK ON H_REQUEST_REQUI_METRICS_TOTAL (REQUEST_METRIC_ID,REQUEST_ID);                              
CREATE UNIQUE INDEX  H_RRRQD_MET_PK ON H_REQUEST_RES_REQUI_DT_METRICS (REQDT_METRIC_ID,REQUEST_ID);                               
CREATE UNIQUE INDEX  H_RRETD_MET_PK ON H_REQUEST_RES_TPLN_DT_METRICS (REQDT_METRIC_ID,REQUEST_ID);                                
CREATE UNIQUE INDEX  H_RTF_MET_PK ON H_REQUEST_TPLN_FAIL_METRICS (REQFAIL_METRIC_ID,REQUEST_ID);                                  
CREATE UNIQUE INDEX  H_RQTPB_MET_PK ON H_REQUEST_TPLN_METRICS_BLOCK (REQUEST_METRIC_ID,REQUEST_ID);                               
CREATE UNIQUE INDEX  H_RQTPT_MET_PK ON H_REQUEST_TPLN_METRICS_TOTAL (REQUEST_METRIC_ID,REQUEST_ID);                               
CREATE UNIQUE INDEX  H_RQTPT_MAX_PK ON H_REQUEST_TPLN_TURNAROUND_MAX (TURNAROUND_METRIC_ID,REQUEST_ID);                           
CREATE UNIQUE INDEX  H_RQTPT_MIN_PK ON H_REQUEST_TPLN_TURNAROUND_MIN (TURNAROUND_METRIC_ID,REQUEST_ID);                           
CREATE UNIQUE INDEX  H_RQTPT_TOT_PK ON H_REQUEST_TPLN_TURNAROUND_TOT (TURNAROUND_METRIC_ID,REQUEST_ID);                           
CREATE UNIQUE INDEX  H_RCRUD_MET_PK ON H_REQUE_CLOSE_REQUI_DT_METRICS (REQCDT_METRIC_ID,REQUEST_ID);                              
CREATE UNIQUE INDEX  H_RCTPD_MET_PK ON H_REQUE_CLOSE_TPLN_DT_METRICS (REQCDT_METRIC_ID,REQUEST_ID);                               
CREATE UNIQUE INDEX  H_RTCCH_MET_PK ON H_REQUI_TCASE_METRICS_CHANGES (REQ_METRIC_ID,REQUIREMENT_ID);                              
CREATE UNIQUE INDEX  H_RTCT_MET_PK ON H_REQUI_TCASE_METRICS_TOTAL (REQ_METRIC_ID,REQUIREMENT_ID);                                 
CREATE UNIQUE INDEX  H_RTPCH_MET_PK ON H_REQUI_TPLN_METRICS_CHANGES (REQ_METRIC_ID,REQUIREMENT_ID);                               
CREATE UNIQUE INDEX  H_RTPTO_MET_PK ON H_REQUI_TPLN_METRICS_TOTAL (REQ_METRIC_ID,REQUIREMENT_ID);                                 
CREATE UNIQUE INDEX  H_RCRD_MET_PK ON H_REQU_CREATI_REQUI_DT_METRICS (REQDT_METRIC_ID,REQUEST_ID);                                
CREATE UNIQUE INDEX  H_RCTTPD_MET_PK ON H_REQU_CREATI_TPLN_DT_METRICS (REQDT_METRIC_ID,REQUEST_ID);                               
CREATE UNIQUE INDEX  H_TCCMD_MET_PK ON H_TASK_CLOSE_COMP_DT_METRICS (TASKCLS_METRICS_ID,TASK_ID);                                 
CREATE UNIQUE INDEX  H_TASK_COMP_MET_PK ON H_TASK_COMP_METRICS (TASK_METRICS_ID,TASK_ID);                                         
CREATE UNIQUE INDEX  H_TCI_MET_PK ON H_TESTCASE_ITER_METRICS (TSTCASE_METRIC_ID,TESTCASE_ID);                                     
CREATE UNIQUE INDEX  H_TPJR_MET_PK ON H_TESTCASE_REQUI_METRICS (TSTCASE_METRIC_ID,TESTCASE_ID);                                   
CREATE UNIQUE INDEX  H_TXFVDCH_MET_PK ON H_TEXT_FILE_VERS_DT_METRICS_CH (SLOC_METRICS_ID,FILE_VERSION_ID);                        
CREATE UNIQUE INDEX  H_TXFVDTO_MET_PK ON H_TEXT_FILE_VERS_DT_METRICS_TO (SLOC_METRICS_ID,FILE_VERSION_ID);                        
CREATE UNIQUE INDEX  H_TXFVRCH_MET_PK ON H_TEXT_FILE_VER_REQ_METRICS_CH (SLOC_METRICS_ID,FILE_VERSION_ID);                        
CREATE UNIQUE INDEX  H_TXFVRTO_MET_PK ON H_TEXT_FILE_VER_REQ_METRICS_TO (SLOC_METRICS_ID,FILE_VERSION_ID);                        
CREATE UNIQUE INDEX  H_TXFVRDC_MET_PK ON H_TXT_FILE_VERSREQ_DT_METR_CH (SLOC_METRICS_ID,FILE_VERSION_ID);                         
CREATE UNIQUE INDEX  H_TXFVRDT_MET_PK ON H_TXT_FILE_VERSREQ_DT_METR_TO (SLOC_METRICS_ID,FILE_VERSION_ID);                         
CREATE UNIQUE INDEX H_ACTCOMPM_PK ON H_ACTIVITY_COMP_METRICS (ACTIVITY_METRICS_ID,ACTIVITY_ID);                                   
CREATE UNIQUE INDEX H_ACTCOMCRDM_PK ON H_ACT_COM_CREATION_DT_METRICS (ACTIVITYCRD_METRICS_ID,ACTIVITY_ID);                        
CREATE UNIQUE INDEX H_TFVBSLNCH_PK ON H_TEXT_FILE_VERBSLN_METRICS_CH (SLOC_METRICS_ID,FILE_VERSION_ID);                           
CREATE UNIQUE INDEX H_TFVBSLNT_PK ON H_TEXT_FILE_VERBSLN_METRICS_TO (SLOC_METRICS_ID,FILE_VERSION_ID);                            
CREATE UNIQUE INDEX F_MISSTIMSH_PK ON F_MISSING_TIMESHEET_METRICS (TIMESHEET_METRICS_ID);                                         
CREATE UNIQUE INDEX H_MISSTIMSH_PK ON H_MISSING_TIMESHEET_METRICS (TIMESHEET_METRICS_ID,ACTIVITY_ID);                             
CREATE UNIQUE INDEX F_TIMESH_PK ON F_TIMESHEET_METRICS (TIMESHEET_METRICS_ID);                                                    
CREATE UNIQUE INDEX H_TIMESH_PK ON H_TIMESHEET_METRICS (TIMESHEET_METRICS_ID,ACTIVITY_ID);                                        
CREATE UNIQUE INDEX F_TIMESHTC_PK ON F_TIMESHEET_TIMECODE_METRICS (TIMESHEET_METRICS_ID);                                         
CREATE UNIQUE INDEX H_TIMESHTC_PK ON H_TIMESHEET_TIMECODE_METRICS (TIMESHEET_METRICS_ID,ACTIVITY_ID);                             
CREATE UNIQUE INDEX F_WPJRESDSMET_PK ON F_WK_PROJ_RESDEMSUPP_METRICS (F_PROJDS_MET_ID);                                           
CREATE UNIQUE INDEX F_MPJRESDSMET_PK ON F_MO_PROJ_RESDEMSUPP_METRICS (F_PROJDS_MET_ID);                                           
CREATE UNIQUE INDEX F_WRESUTILMET_PK ON F_WK_RESOURCE_UTIL_METRICS (F_RESUTIL_MET_ID);                                            
CREATE UNIQUE INDEX F_MRESUTILMET_PK ON F_MO_RESOURCE_UTIL_METRICS (F_RESUTIL_MET_ID);                                            
CREATE UNIQUE INDEX F_RISKMET_PK ON F_RISK_METRICS (F_RISKMET_ID);                                                                
CREATE UNIQUE INDEX F_C_RISKMET_PK ON F_C_RISK_METRICS (F_RISKMET_ID);                                                            
CREATE UNIQUE INDEX H_WPJRESDSMET_PK ON H_WK_PROJ_RESDEMSUPP_METRICS (F_PROJDS_MET_ID,PROJECT_ALLOCATION_ID);                     
CREATE UNIQUE INDEX H_MPJRESDSMET_PK ON H_MO_PROJ_RESDEMSUPP_METRICS (F_PROJDS_MET_ID,PROJECT_ALLOCATION_ID);                     
CREATE UNIQUE INDEX H_WRESUTILMET_PK ON H_WK_RESOURCE_UTIL_METRICS (F_RESUTIL_MET_ID,RESOURCE_ID);                                
CREATE UNIQUE INDEX H_MRESUTILMET_PK ON H_MO_RESOURCE_UTIL_METRICS (F_RESUTIL_MET_ID,RESOURCE_ID);                                
CREATE UNIQUE INDEX H_RISKMET_PK ON H_RISK_METRICS (F_RISKMET_ID,RISK_ID);                                                        
CREATE UNIQUE INDEX D_RISK_PK ON D_RISK (RISK_ID);                                                                                
CREATE UNIQUE INDEX D_RISKSTATE_PK ON D_RISK_STATE (STATE_ID);                                                                    
CREATE UNIQUE INDEX D_PROBRNK_PK ON D_PROBABILITY_RANK (PROBABILITY_RANK_ID);                                                     
CREATE UNIQUE INDEX D_IMPRNK_PK ON D_IMPACT_RANK (IMPACT_RANK_ID);                                                                
CREATE UNIQUE INDEX D_PROBCSTRNK_PK ON D_PROBABILITY_COST_RANK (PROBABILITY_COST_RANK_ID);                                        
CREATE UNIQUE INDEX D_SCORERNK_PK ON D_SCORE_RANK (SCORE_RANK_ID);                                                                
CREATE UNIQUE INDEX FTSKITVARMET_PK ON F_TASK_ITER_VARIANCE_METRICS (F_TASKVAR_MET_ID);                                           
CREATE UNIQUE INDEX FTSKPRJVARMET_PK ON F_TASK_PROJ_VARIANCE_METRICS (F_TASKVAR_MET_ID);                                          
CREATE UNIQUE INDEX FCTSKITVARMET_PK ON F_C_TASK_ITE_VARIANCE_METRICS (F_TASKVAR_MET_ID);                                         
CREATE UNIQUE INDEX FCTSKPRVARMET_PK ON F_C_TASK_PRO_VARIANCE_METRICS (F_TASKVAR_MET_ID);                                         
CREATE UNIQUE INDEX HTSKITVARMET_PK ON H_TASK_ITER_VARIANCE_METRICS (F_TASKVAR_MET_ID,TASK_ID);                                   
CREATE UNIQUE INDEX HTSKPRJVARME_PK ON H_TASK_PROJ_VARIANCE_METRICS (F_TASKVAR_MET_ID,TASK_ID);                                   
CREATE UNIQUE INDEX D_OPTERRITORY_PK ON D_OPERATING_TERRITORY (TERRITORY_ID);                                                     
CREATE UNIQUE INDEX D_COUNTRY_PK ON D_COUNTRY (COUNTRY_ID);                                                                       
CREATE UNIQUE INDEX D_PROVSTATE_PK ON D_PROVINCE_STATE (PROVINCE_STATE_ID);                                                       
CREATE UNIQUE INDEX D_CITY_PK ON D_CITY (CITY_ID);                                                                                
CREATE UNIQUE INDEX D_ORGANIZATION_PK ON D_ORGANIZATION (ORGANIZATION_ID);                                                        
CREATE UNIQUE INDEX F_WSCPRDSMET_PK ON F_WK_SCPROJ_RESDEMSUP_METRICS (F_PROJDS_MET_ID);                                           
CREATE UNIQUE INDEX H_WSCPRDSMET_PK ON H_WK_SCPROJ_RESDEMSUP_METRICS (F_PROJDS_MET_ID,PROJECT_ALLOCATION_ID);                     
CREATE UNIQUE INDEX F_WSKPRDSMET_PK ON F_WK_SKPROJ_RESDEMSUP_METRICS (F_PROJDS_MET_ID);                                           
CREATE UNIQUE INDEX H_WSKPRDSMET_PK ON H_WK_SKPROJ_RESDEMSUP_METRICS (F_PROJDS_MET_ID,PROJECT_ALLOCATION_ID);                     
CREATE UNIQUE INDEX F_WCOPRDSMET_PK ON F_WK_COPROJ_RESDEMSUP_METRICS (F_PROJDS_MET_ID);                                           
CREATE UNIQUE INDEX H_WCOPRDSMET_PK ON H_WK_COPROJ_RESDEMSUP_METRICS (F_PROJDS_MET_ID,PROJECT_ALLOCATION_ID);                     
CREATE UNIQUE INDEX F_MSCPRDSMET_PK ON F_MO_SCPROJ_RESDEMSUP_METRICS (F_PROJDS_MET_ID);                                           
CREATE UNIQUE INDEX H_MSCPRDSMET_PK ON H_MO_SCPROJ_RESDEMSUP_METRICS (F_PROJDS_MET_ID,PROJECT_ALLOCATION_ID);                     
CREATE UNIQUE INDEX F_MSKPRDSMET_PK ON F_MO_SKPROJ_RESDEMSUP_METRICS (F_PROJDS_MET_ID);                                           
CREATE UNIQUE INDEX H_MSKPRDSMET_PK ON H_MO_SKPROJ_RESDEMSUP_METRICS (F_PROJDS_MET_ID,PROJECT_ALLOCATION_ID);                     
CREATE UNIQUE INDEX F_MCOPRDSMET_PK ON F_MO_COPROJ_RESDEMSUP_METRICS (F_PROJDS_MET_ID);                                           
CREATE UNIQUE INDEX H_MCOPRDSMET_PK ON H_MO_COPROJ_RESDEMSUP_METRICS (F_PROJDS_MET_ID,PROJECT_ALLOCATION_ID);                     
CREATE UNIQUE INDEX F_WSCRESUTMET_PK ON F_WK_SCRESOURCE_UTIL_METRICS (F_RESUTIL_MET_ID);                                          
CREATE UNIQUE INDEX H_WSCRESUTMET_PK ON H_WK_SCRESOURCE_UTIL_METRICS (F_RESUTIL_MET_ID,RESOURCE_ID);                              
CREATE UNIQUE INDEX F_WSKRESUTMET_PK ON F_WK_SKRESOURCE_UTIL_METRICS (F_RESUTIL_MET_ID);                                          
CREATE UNIQUE INDEX H_WSKRESUTMET_PK ON H_WK_SKRESOURCE_UTIL_METRICS (F_RESUTIL_MET_ID,RESOURCE_ID);                              
CREATE UNIQUE INDEX F_WCORESUTMET_PK ON F_WK_CORESOURCE_UTIL_METRICS (F_RESUTIL_MET_ID);                                          
CREATE UNIQUE INDEX H_WCORESUTMET_PK ON H_WK_CORESOURCE_UTIL_METRICS (F_RESUTIL_MET_ID,RESOURCE_ID);                              
CREATE UNIQUE INDEX F_MSCRESUTMET_PK ON F_MO_SCRESOURCE_UTIL_METRICS (F_RESUTIL_MET_ID);                                          
CREATE UNIQUE INDEX H_MSCRESUTMET_PK ON H_MO_SCRESOURCE_UTIL_METRICS (F_RESUTIL_MET_ID,RESOURCE_ID);                              
CREATE UNIQUE INDEX F_MSKRESUTMET_PK ON F_MO_SKRESOURCE_UTIL_METRICS (F_RESUTIL_MET_ID);                                          
CREATE UNIQUE INDEX H_MSKRESUTMET_PK ON H_MO_SKRESOURCE_UTIL_METRICS (F_RESUTIL_MET_ID,RESOURCE_ID);                              
CREATE UNIQUE INDEX F_MCORESUTMET_PK ON F_MO_CORESOURCE_UTIL_METRICS (F_RESUTIL_MET_ID);                                          
CREATE UNIQUE INDEX H_MCORESUTMET_PK ON H_MO_CORESOURCE_UTIL_METRICS (F_RESUTIL_MET_ID,RESOURCE_ID);                              
CREATE UNIQUE INDEX F_STORY_METRIC_PK ON F_STORY_METRICS (F_STORY_METRIC_ID);                                                     
CREATE UNIQUE INDEX F_CSTORY_METRIC_PK ON F_C_STORY_METRICS (F_STORY_METRIC_ID);                                                  
CREATE UNIQUE INDEX HSTORYPIONTS_PK ON H_STORY_METRICS (F_STORY_METRIC_ID, REQUEST_ID);                                           
CREATE UNIQUE INDEX F_REQFAIL_DTM_PK ON F_REQUEST_FAILURE_DT_METRICS (REQFAIL_METRIC_ID);                                         
CREATE UNIQUE INDEX H_REQFAIL_DTM_PK ON H_REQUEST_FAILURE_DT_METRICS (REQFAIL_METRIC_ID,REQUEST_ID);                              
CREATE UNIQUE INDEX F_REQTPLN_FDT_PK ON F_REQUEST_TPLN_FAILDT_METRICS (REQFAIL_METRIC_ID);                                        
CREATE UNIQUE INDEX H_REQTPLN_FDT_PK ON H_REQUEST_TPLN_FAILDT_METRICS (REQFAIL_METRIC_ID,REQUEST_ID);                             
CREATE UNIQUE INDEX F_REQREQUI_FDT_PK ON F_REQUEST_REQUI_FAILDT_METRICS (REQFAIL_METRIC_ID);                                      
CREATE UNIQUE INDEX H_REQREQUI_FDT_PK ON H_REQUEST_REQUI_FAILDT_METRICS (REQFAIL_METRIC_ID,REQUEST_ID);                           
CREATE UNIQUE INDEX F_REQMODI_DTM_PK ON F_REQUIR_MODIF_DT_METRICS (REQ_METRIC_ID);                                                
CREATE UNIQUE INDEX H_REQMODI_DTM_PK ON H_REQUIR_MODIF_DT_METRICS (REQ_METRIC_ID,REQUIREMENT_ID);                                 
CREATE UNIQUE INDEX F_PRJFINMET_PK ON F_PROJECT_FINANCIAL_METRICS (F_PROJFIN_METRIC_ID);                                          
CREATE UNIQUE INDEX F_CPRJFINMET_PK ON F_C_PROJECT_FINANCIAL_METRICS (F_PROJFIN_METRIC_ID);                                       
CREATE UNIQUE INDEX H_PRJFINMET_PK ON H_PROJECT_FINANCIAL_METRICS (F_PROJFIN_METRIC_ID,PROJECT_ID);                               
CREATE UNIQUE INDEX F_TPPRJFINMET_PK ON F_TP_PROJECT_FINANCIAL_METRICS (F_TPPROJFIN_METRIC_ID);                                   
CREATE UNIQUE INDEX H_TPPRJFINMET_PK ON H_TP_PROJECT_FINANCIAL_METRICS (F_TPPROJFIN_METRIC_ID,PROJECT_ID);                        
CREATE UNIQUE INDEX D_ASSET_PK ON D_ASSET (ASSET_ID);                                                                             
CREATE UNIQUE INDEX D_ASSETTP_PK ON D_ASSET_TYPE (ASSET_TYPE_ID);                                                                 
CREATE UNIQUE INDEX D_ACTION_TYPE_PK ON D_ACTION_TYPE (ACTION_TYPE_ID);                                                           
CREATE UNIQUE INDEX F_ASTUTDT_PK ON F_ASSET_UTIL_DT_METRICS (F_ASSET_METRIC_ID);                                                  
CREATE UNIQUE INDEX F_LICDTMET_PK ON F_LICENSE_DT_METRICS (F_LICENSE_METRIC_ID);                                                  
CREATE UNIQUE INDEX D_REQPRIORITY_PK ON D_REQUEST_PRIORITY (PRIORITY_ID);                                                         
CREATE UNIQUE INDEX D_REQSEVERITY_PK ON D_REQUEST_SEVERITY (SEVERITY_ID);                                                         
CREATE UNIQUE INDEX D_REQSTATUS_PK ON D_REQUEST_STATUS (STATUS_ID);                                                               
CREATE UNIQUE INDEX D_BALLTAB_PK ON D_BALLOT_TAB (BALLOT_TAB_ID);                                                                 
CREATE UNIQUE INDEX F_BALLTABMET_PK ON F_SC_BALLOT_TAB_RESULT_METRICS (BALLOT_TAB_RESULT_METRICS_ID);                             

ALTER TABLE D_DATE ADD PRIMARY KEY (DATE_ID);
ALTER TABLE D_CURRENCY ADD PRIMARY KEY (CURRENCY_ID);
ALTER TABLE D_BUILD ADD PRIMARY KEY (BUILD_ID);
ALTER TABLE D_REQUEST_STATE ADD PRIMARY KEY (STATE_ID);
ALTER TABLE D_REQUIREMENT_STATE ADD PRIMARY KEY (STATE_ID);
ALTER TABLE D_RESOURCE ADD PRIMARY KEY (RESOURCE_ID);
ALTER TABLE D_PRIORITY ADD PRIMARY KEY (PRIORITY_ID);
ALTER TABLE D_STABILITY ADD PRIMARY KEY (STABILITY_ID);
ALTER TABLE D_DIFFICULTY ADD PRIMARY KEY (DIFFICULTY_ID);
ALTER TABLE D_CUSTOMER_PRIORITY ADD PRIMARY KEY (CUSTOMER_PRIORITY_ID);
ALTER TABLE D_ITERATION ADD PRIMARY KEY (ITERATION_ID);
ALTER TABLE D_TEAM ADD PRIMARY KEY (TEAM_ID);
ALTER TABLE D_RELEASE ADD PRIMARY KEY (RELEASE_ID);
ALTER TABLE D_PLATFORM ADD PRIMARY KEY (PLATFORM_ID);
ALTER TABLE D_SEVERITY ADD PRIMARY KEY (SEVERITY_ID);
ALTER TABLE D_STATUS ADD PRIMARY KEY (STATUS_ID);
ALTER TABLE D_PROGRAM ADD PRIMARY KEY (PROGRAM_ID);
ALTER TABLE D_PROJECT ADD PRIMARY KEY (PROJECT_ID);
ALTER TABLE D_CUSTOMER ADD PRIMARY KEY (CUSTOMER_ID);
ALTER TABLE D_PRODUCT ADD PRIMARY KEY (PRODUCT_ID);
ALTER TABLE D_COMPONENT ADD PRIMARY KEY (COMPONENT_ID);
ALTER TABLE D_REQUEST_CLASSIFICATION ADD PRIMARY KEY (REQUEST_CLASS_ID);
ALTER TABLE D_REQUIREMENT_CLASSIFICATION ADD PRIMARY KEY (REQUIREMENT_CLASS_ID);
ALTER TABLE D_TASK_CLASSIFICATION ADD PRIMARY KEY (TASK_CLASS_ID);
ALTER TABLE D_REQUIREMENT ADD PRIMARY KEY (REQUIREMENT_ID);
ALTER TABLE D_TESTCASE ADD PRIMARY KEY (TESTCASE_ID);
ALTER TABLE D_TESTSUITE ADD PRIMARY KEY (TESTSUITE_ID);
ALTER TABLE D_EXECUTION_WORKITEM ADD PRIMARY KEY (EXECWORKITEM_ID);
ALTER TABLE D_EXECUTION_RESULT ADD PRIMARY KEY (EXECUTION_RESULT_ID);
ALTER TABLE D_TESTSUITELOG ADD PRIMARY KEY (TESTSUITELOG_ID);
ALTER TABLE D_TESTPLAN ADD PRIMARY KEY (TESTPLAN_ID);
ALTER TABLE D_VERDICT ADD PRIMARY KEY (VERDICT_ID);
ALTER TABLE D_REQUEST_SOURCE ADD PRIMARY KEY (REQUEST_SOURCE_ID);
ALTER TABLE D_RESOLUTION ADD PRIMARY KEY (RESOLUTION_ID);
ALTER TABLE D_REQUEST ADD PRIMARY KEY (REQUEST_ID);
ALTER TABLE D_ASSETREGISTRY ADD PRIMARY KEY (ASSETREGISTRY_ID);
ALTER TABLE D_TESTCASE_STATE ADD PRIMARY KEY (STATE_ID);
ALTER TABLE D_ACTIVITY ADD PRIMARY KEY (ACTIVITY_ID);
ALTER TABLE D_FILE ADD PRIMARY KEY (FILE_ID);
ALTER TABLE D_FILE_STREAM ADD PRIMARY KEY (FILE_STREAM_ID);
ALTER TABLE D_FILE_BASELINE ADD PRIMARY KEY (FILE_BASELINE_ID);
ALTER TABLE D_FILE_VERSION ADD PRIMARY KEY (FILE_VERSION_ID);
ALTER TABLE D_EXECUTIONWKITEM_STATE ADD PRIMARY KEY (STATE_ID);
ALTER TABLE D_TESTPLAN_STATE ADD PRIMARY KEY (STATE_ID);
ALTER TABLE D_TESTSUITE_STATE ADD PRIMARY KEY (STATE_ID);
ALTER TABLE D_TASK_STATE ADD PRIMARY KEY (STATE_ID);
ALTER TABLE D_TASK ADD PRIMARY KEY (TASK_ID);
ALTER TABLE D_FACTOR ADD PRIMARY KEY (FACTOR_ID);
ALTER TABLE D_BUILD_TYPE ADD PRIMARY KEY (BUILD_TYPE_ID);
ALTER TABLE D_REQUEST_TYPE ADD PRIMARY KEY (REQUEST_TYPE_ID);
ALTER TABLE D_CONFIGURATION ADD PRIMARY KEY (CONFIGURATION_ID);
ALTER TABLE D_RESOURCE_GROUP ADD PRIMARY KEY (RESOURCE_GROUP_ID);
ALTER TABLE D_LAB_RESOURCE ADD PRIMARY KEY (LAB_RESOURCE_ID);
ALTER TABLE D_OS_TYPE ADD PRIMARY KEY (OS_TYPE_ID);
ALTER TABLE D_REQUEST_CATEGORY ADD PRIMARY KEY (REQUEST_CATEGORY_ID);
ALTER TABLE D_FILE_CLASSIFICATION ADD PRIMARY KEY (FILE_CLASS_ID);
ALTER TABLE D_FILE_STREAM_CLASSIFICATION ADD PRIMARY KEY (FILE_STREAM_CLASS_ID);
ALTER TABLE D_JOB ADD PRIMARY KEY (JOB_ID);
ALTER TABLE D_JOB_RESULT ADD PRIMARY KEY (JOB_RESULT_ID);
ALTER TABLE D_JOB_RESULT_STATE ADD PRIMARY KEY (STATE_ID);	

ALTER TABLE D_TIMESHEET_STATE ADD PRIMARY KEY (STATE_ID);
ALTER TABLE D_PROJECT_ALLOCATION ADD PRIMARY KEY (PROJECT_ALLOCATION_ID);
ALTER TABLE D_SKILL ADD PRIMARY KEY (SKILL_ID);
ALTER TABLE D_COMPETENCY ADD PRIMARY KEY (COMPETENCY_ID);
ALTER TABLE D_POOL ADD PRIMARY KEY (POOL_ID);
ALTER TABLE D_BASELINE ADD PRIMARY KEY	(BASELINE_ID);
ALTER TABLE D_CHARGECODE ADD PRIMARY KEY	(CHARGECODE_ID);
ALTER TABLE D_TIMECODE ADD PRIMARY KEY	(TIMECODE_ID);
ALTER TABLE D_PORTFOLIO ADD PRIMARY KEY	(PORTFOLIO_ID);
ALTER TABLE BD_PORTFOLIO ADD PRIMARY KEY	(PORTFOLIO_ID,PROGRAM_ID,PROJECT_ID);
ALTER TABLE D_REQUIREMENT_TYPE ADD PRIMARY KEY	(REQUIREMENT_TYPE_ID);
ALTER TABLE F_REQUEST_METRICS ADD PRIMARY KEY (REQUEST_METRIC_ID);
ALTER TABLE H_REQUEST_METRICS_TOTAL ADD PRIMARY KEY (REQUEST_METRIC_ID, REQUEST_ID);
ALTER TABLE H_REQUEST_METRICS_BLOCKING ADD PRIMARY KEY (REQUEST_METRIC_ID, REQUEST_ID);
ALTER TABLE F_REQUEST_AGING ADD PRIMARY KEY (AGING_METRIC_ID);
ALTER TABLE H_REQUEST_AGING_TOTAL ADD PRIMARY KEY (AGING_METRIC_ID,REQUEST_ID);
ALTER TABLE H_REQUEST_AGING_MIN ADD PRIMARY KEY (AGING_METRIC_ID,REQUEST_ID);
ALTER TABLE H_REQUEST_AGING_MAX ADD PRIMARY KEY (AGING_METRIC_ID,REQUEST_ID);
ALTER TABLE F_REQUEST_CLOSURE_DATE_METRICS ADD PRIMARY KEY (REQCDT_METRIC_ID);
ALTER TABLE F_EXECUTION_RESULT_METRICS ADD PRIMARY KEY (EXERES_METRICS_ID);
ALTER TABLE F_REQUEST_CREATION_DT_METRICS ADD PRIMARY KEY (REQDT_METRIC_ID);
ALTER TABLE F_REQUEST_FAILURE_METRICS ADD PRIMARY KEY (REQFAIL_METRIC_ID);
ALTER TABLE H_REQUEST_FAILURE_METRICS ADD PRIMARY KEY (REQFAIL_METRIC_ID, REQUEST_ID);
ALTER TABLE F_REQUIREMENT_METRICS ADD PRIMARY KEY (REQ_METRIC_ID);
ALTER TABLE H_REQUIREMENT_METRICS_TOTAL ADD PRIMARY KEY (REQ_METRIC_ID, REQUIREMENT_ID);
ALTER TABLE H_REQUIREMENT_METRICS_CHANGES ADD PRIMARY KEY (REQ_METRIC_ID, REQUIREMENT_ID);
ALTER TABLE F_EXECUTION_WORKITEM_METRICS ADD PRIMARY KEY (EXECWORKITEM_METRIC_ID);
ALTER TABLE H_EXECUTION_WORKITEM_METRICS ADD PRIMARY KEY (EXECWORKITEM_METRIC_ID, EXECWORKITEM_ID);
ALTER TABLE F_TESTCASE_METRICS ADD PRIMARY KEY (TSTCASE_METRIC_ID);
ALTER TABLE F_PROJ_TESTCASE_TPLN_METRICS ADD PRIMARY KEY (TSTCASE_METRIC_ID);
ALTER TABLE F_C_PROJ_TESTCASE_TPLN_METRICS ADD PRIMARY KEY (TSTCASE_METRIC_ID);
ALTER TABLE F_PROJ_TESTCASE_METRICS ADD PRIMARY KEY (TSTCASE_METRIC_ID);
ALTER TABLE F_C_PROJ_TESTCASE_METRICS ADD PRIMARY KEY (TSTCASE_METRIC_ID);
ALTER TABLE H_TESTCASE_METRICS ADD PRIMARY KEY (TSTCASE_METRIC_ID, TESTCASE_ID);
ALTER TABLE H_PROJ_TESTCASE_TPLN_METRICS ADD PRIMARY KEY (TSTCASE_METRIC_ID, TESTCASE_ID);
ALTER TABLE H_PROJ_TESTCASE_METRICS ADD PRIMARY KEY (TSTCASE_METRIC_ID, TESTCASE_ID);
ALTER TABLE F_BUILD_METRICS ADD PRIMARY KEY (BUILD_METRIC_ID);
ALTER TABLE H_BUILD_ATTEMPTS ADD PRIMARY KEY (BUILD_METRIC_ID, BUILD_ID);
ALTER TABLE H_BUILD_PASS ADD PRIMARY KEY (BUILD_METRIC_ID, BUILD_ID);
ALTER TABLE H_BUILD_FAIL ADD PRIMARY KEY (BUILD_METRIC_ID, BUILD_ID);
ALTER TABLE F_TEXT_FILE_VERSION_METRICS ADD PRIMARY KEY (SLOC_METRICS_ID);
ALTER TABLE H_TEXT_FILE_VERSION_METRICS_CH ADD PRIMARY KEY (SLOC_METRICS_ID,FILE_VERSION_ID);
ALTER TABLE H_TEXT_FILE_VERSION_METRICS_TO ADD PRIMARY KEY (SLOC_METRICS_ID,FILE_VERSION_ID);
ALTER TABLE F_CHILDREQUIREMENT_METRICS ADD PRIMARY KEY (CHILDREQ_METRICS_ID);
ALTER TABLE F_PROJECT_PERFORMANCE_METRICS ADD PRIMARY KEY (PERF_METRICS_ID);
ALTER TABLE H_REQUEST_CLOSURE_DATE_METRICS ADD PRIMARY KEY (REQCDT_METRIC_ID, REQUEST_ID);
ALTER TABLE H_REQUEST_CREATION_DT_METRICS ADD PRIMARY KEY (REQDT_METRIC_ID, REQUEST_ID);
ALTER TABLE H_EXECUTION_RESULT_METRICS ADD PRIMARY KEY (EXERES_METRICS_ID, EXECUTION_RESULT_ID);
ALTER TABLE H_CHILDREQUIREMENT_METRICS ADD PRIMARY KEY (CHILDREQ_METRICS_ID, REQUIREMENT_ID);
ALTER TABLE D_ACTIVITY_STATE ADD PRIMARY KEY (STATE_ID);
ALTER TABLE D_ACTIVITY_CLASSIFICATION ADD PRIMARY KEY (ACTIVITY_CLASS_ID);
ALTER TABLE D_COMPONENT_CLASSIFICATION ADD PRIMARY KEY (COMPONENT_CLASS_ID);
ALTER TABLE D_PROJECT_CLASSIFICATION ADD PRIMARY KEY (PROJECT_CLASS_ID);
ALTER TABLE D_TASK_TYPE ADD PRIMARY KEY (TASK_TYPE_ID);
ALTER TABLE D_AGE_RANK ADD PRIMARY KEY (AGE_RANK_ID);
ALTER TABLE F_ACTIVITY_METRICS ADD PRIMARY KEY (ACTIVITY_METRICS_ID);
ALTER TABLE H_ACTIVITY_METRICS ADD PRIMARY KEY (ACTIVITY_METRICS_ID,ACTIVITY_ID);
ALTER TABLE F_ACTIVITY_CREATION_DT_METRICS ADD PRIMARY KEY (ACTIVITYCRD_METRICS_ID);
ALTER TABLE H_ACTIVITY_CREATION_DT_METRICS ADD PRIMARY KEY (ACTIVITYCRD_METRICS_ID,ACTIVITY_ID);
ALTER TABLE F_EXECRESULT_DATE_METRICS ADD PRIMARY KEY (EXECRESDT_METRICS_ID);
ALTER TABLE H_EXECRESULT_DATE_METRICS ADD PRIMARY KEY(EXECRESDT_METRICS_ID,EXECUTION_RESULT_ID);
ALTER TABLE F_EXECRESPOINTS_METRICS ADD PRIMARY KEY (EXECRES_METRIC_ID);
ALTER TABLE H_EXECRESPOINTS_METRICS ADD PRIMARY KEY (EXECRES_METRIC_ID,EXECUTION_RESULT_ID);
ALTER TABLE F_REQUEST_TURNAROUND ADD PRIMARY KEY (TURNAROUND_METRIC_ID);
ALTER TABLE H_REQUEST_TURNAROUND_TOTAL ADD PRIMARY KEY (TURNAROUND_METRIC_ID,REQUEST_ID);
ALTER TABLE H_REQUEST_TURNAROUND_MIN ADD PRIMARY KEY (TURNAROUND_METRIC_ID,REQUEST_ID);	
ALTER TABLE H_REQUEST_TURNAROUND_MAX ADD PRIMARY KEY (TURNAROUND_METRIC_ID,REQUEST_ID);
ALTER TABLE F_TASK_METRICS ADD PRIMARY KEY (TASK_METRICS_ID);
ALTER TABLE H_TASK_METRICS ADD PRIMARY KEY (TASK_METRICS_ID,TASK_ID);
ALTER TABLE F_TASK_CREATION_DT_METRICS ADD PRIMARY KEY (TASKCRD_METRICS_ID);
ALTER TABLE H_TASK_CREATION_DT_METRICS ADD PRIMARY KEY (TASKCRD_METRICS_ID,TASK_ID);
ALTER TABLE F_TASK_CLOSURE_DT_METRICS ADD PRIMARY KEY (TASKCLS_METRICS_ID);
ALTER TABLE H_TASK_CLOSURE_DT_METRICS ADD PRIMARY KEY (TASKCLS_METRICS_ID,TASK_ID);
ALTER TABLE H_BUILD_EXEC_DT_METRICS_TOT ADD PRIMARY KEY (BUILD_EXEC_METRIC_ID,BUILD_ID);
ALTER TABLE F_BUILD_EXECUTION_DT_METRICS ADD PRIMARY KEY (BUILD_EXEC_METRIC_ID);
ALTER TABLE D_TESTCASE_CLASSIFICATION ADD PRIMARY KEY (TESTCASE_CLASS_ID); 

ALTER TABLE D_EXECWORKITEM_CLASSIFICATION ADD PRIMARY KEY (EXECWORKIT_CLASS_ID); 

ALTER TABLE D_EXECRESULT_CLASSIFICATION ADD PRIMARY KEY (EXECRES_CLASS_ID); 

ALTER TABLE D_TESTSUITE_CLASSIFICATION ADD PRIMARY KEY (TESTSUITE_CLASS_ID);
ALTER TABLE F_LAB_RESUTILIZATION_METRICS ADD PRIMARY KEY (LAB_RESUTIL_ID);
ALTER TABLE H_LAB_RESUTILIZATION_METRICS ADD PRIMARY KEY (LAB_RESUTIL_ID,LAB_RESOURCE_ID);
ALTER TABLE F_TEXT_FILE_CHANGE_METRICS ADD PRIMARY KEY (FTEXTCHNG_METRICS_ID);
ALTER TABLE H_TEXT_FILE_CHANGE_METRICS ADD PRIMARY KEY (FTEXTCHNG_METRICS_ID,FILE_ID);
ALTER TABLE F_FILE_STREAM_METRICS ADD PRIMARY KEY (FSTREAM_METRICS_ID);
ALTER TABLE H_FILE_STREAM_METRICS ADD PRIMARY KEY (FSTREAM_METRICS_ID,FILE_STREAM_ID);
ALTER TABLE D_BUILD_CLASSIFICATION ADD PRIMARY KEY (BUILD_CLASS_ID);
ALTER TABLE F_JOB_EXECUTION_DT_METRICS ADD PRIMARY KEY (F_JOBRES_METRIC_ID);
ALTER TABLE H_JOB_EXECUTION_DT_METRICS ADD PRIMARY KEY (F_JOBRES_METRIC_ID,JOB_RESULT_ID);
ALTER TABLE F_REQUEST_RESOLUTIO_DT_METRICS ADD PRIMARY KEY (REQDT_METRIC_ID);
ALTER TABLE H_REQUEST_RESOLUTIO_DT_METRICS ADD PRIMARY KEY (REQDT_METRIC_ID, REQUEST_ID);
ALTER TABLE F_RELEASE_REQUEST_METRICS ADD PRIMARY KEY (F_RELREQ_METRIC_ID);
ALTER TABLE H_RELEASE_REQUEST_METRICS ADD PRIMARY KEY (F_RELREQ_METRIC_ID,REQUEST_ID);
ALTER TABLE F_REL_REQUEST_TURN_METRICS ADD PRIMARY KEY (F_RELREQ_TURN_METRIC_ID);
ALTER TABLE H_REL_REQUEST_TURN_METRICS ADD PRIMARY KEY (F_RELREQ_TURN_METRIC_ID,REQUEST_ID);
ALTER TABLE F_TIME_TO_MARKET_RELEA_METRICS ADD PRIMARY KEY (F_TIME_TO_MRKT_METRIC_ID);
ALTER TABLE H_TIME_TO_MARKET_REL_METRICS ADD PRIMARY KEY (F_TIME_TO_MRKT_METRIC_ID,RELEASE_ID);
ALTER TABLE F_C_REQUEST_METRICS ADD PRIMARY KEY (REQUEST_METRIC_ID);
ALTER TABLE F_C_REQUEST_AGING ADD PRIMARY KEY (AGING_METRIC_ID);
ALTER TABLE F_C_REQUEST_TURNAROUND ADD PRIMARY KEY (TURNAROUND_METRIC_ID);
ALTER TABLE F_C_EXECUTION_RESULT_METRICS ADD PRIMARY KEY (EXERES_METRICS_ID);
ALTER TABLE F_C_REQUEST_FAILURE_METRICS ADD PRIMARY KEY (REQFAIL_METRIC_ID);
ALTER TABLE F_C_REQUIREMENT_METRICS ADD PRIMARY KEY (REQ_METRIC_ID);
ALTER TABLE F_C_EXECUTION_WORKITEM_METRICS ADD PRIMARY KEY (EXECWORKITEM_METRIC_ID);
ALTER TABLE F_C_TESTCASE_METRICS ADD PRIMARY KEY (TSTCASE_METRIC_ID);
ALTER TABLE F_C_BUILD_METRICS ADD PRIMARY KEY (BUILD_METRIC_ID);
ALTER TABLE F_C_PROJECT_PERFORM_METRICS ADD PRIMARY KEY (PERF_METRICS_ID);
ALTER TABLE F_C_CHILDREQUIREMENT_METRICS ADD PRIMARY KEY (CHILDREQ_METRICS_ID);
ALTER TABLE F_C_EXECRESPOINTS_METRICS ADD PRIMARY KEY (EXECRES_METRIC_ID);
ALTER TABLE F_C_ACTIVITY_METRICS ADD PRIMARY KEY (ACTIVITY_METRICS_ID);
ALTER TABLE F_C_TASK_METRICS ADD PRIMARY KEY (TASK_METRICS_ID);
ALTER TABLE F_C_LAB_RESUTILIZATION_METRICS ADD PRIMARY KEY (LAB_RESUTIL_ID);
ALTER TABLE F_C_TEXT_FILE_CHANGE_METRICS ADD PRIMARY KEY (FTEXTCHNG_METRICS_ID);
ALTER TABLE F_C_FILE_STREAM_METRICS ADD PRIMARY KEY (FSTREAM_METRICS_ID);
ALTER TABLE F_C_RELEASE_REQUEST_METRICS ADD PRIMARY KEY (F_RELREQ_METRIC_ID);
ALTER TABLE F_C_REL_REQUEST_TURN_METRICS ADD PRIMARY KEY (F_RELREQ_TURN_METRIC_ID);
ALTER TABLE F_ACTIVITY_ITER_METRICS  ADD PRIMARY KEY (ACTIVITY_METRICS_ID);
ALTER TABLE F_ACTIVITY_REQ_METRICS  ADD PRIMARY KEY (ACTIVITY_METRICS_ID);
ALTER TABLE F_ACT_ITER_CREATION_DT_METRICS  ADD PRIMARY KEY (ACTIVITYCRD_METRICS_ID);
ALTER TABLE F_ACT_REQU_CREATION_DT_METRICS  ADD PRIMARY KEY (ACTIVITYCRD_METRICS_ID);
ALTER TABLE F_BUILD_REQUI_METRICS  ADD PRIMARY KEY (BUILD_METRIC_ID);
ALTER TABLE F_BUILD_REQU_EXEC_DT_METRICS  ADD PRIMARY KEY (BUILD_EXEC_METRIC_ID);
ALTER TABLE F_BUILD_REQU_METRICS  ADD PRIMARY KEY (BUILD_METRIC_ID);
ALTER TABLE F_C_ACTIVITY_ITER_METRICS   ADD PRIMARY KEY (ACTIVITY_METRICS_ID);
ALTER TABLE F_C_ACTIVITY_REQ_METRICS   ADD PRIMARY KEY (ACTIVITY_METRICS_ID);
ALTER TABLE F_C_BUILD_REQUI_METRICS  ADD PRIMARY KEY (BUILD_METRIC_ID);
ALTER TABLE F_C_BUILD_REQU_METRICS  ADD PRIMARY KEY (BUILD_METRIC_ID);
ALTER TABLE F_C_EXECRESPOINTS_ITER_METRICS  ADD PRIMARY KEY (EXECRES_METRIC_ID);
ALTER TABLE F_C_EXEC_RESULT_ITER_METRICS  ADD PRIMARY KEY (EXERES_METRICS_ID);
ALTER TABLE F_C_EXEC_WORKITEM_ITER_METRICS   ADD PRIMARY KEY (EXECWORKITEM_METRIC_ID);
ALTER TABLE F_C_EXEC_WORKITEM_REQU_METRICS  ADD PRIMARY KEY (EXECWORKITEM_METRIC_ID);
ALTER TABLE F_C_REQUEST_CUST_METRICS  ADD PRIMARY KEY (REQUEST_METRIC_ID);
ALTER TABLE F_C_REQUEST_REQUI_FAIL_METRICS  ADD PRIMARY KEY (REQFAIL_METRIC_ID);
ALTER TABLE F_C_REQUEST_REQUI_METRICS  ADD PRIMARY KEY (REQUEST_METRIC_ID);
ALTER TABLE F_C_REQUEST_TPLN_AGING   ADD PRIMARY KEY (AGING_METRIC_ID);
ALTER TABLE F_C_REQUEST_TPLN_FAIL_METRICS  ADD PRIMARY KEY (REQFAIL_METRIC_ID);
ALTER TABLE F_C_REQUEST_TPLN_METRICS  ADD PRIMARY KEY (REQUEST_METRIC_ID);
ALTER TABLE F_C_REQUEST_TPLN_TURNAROUND  ADD PRIMARY KEY (TURNAROUND_METRIC_ID);
ALTER TABLE F_C_REQUIREMENT_TPLN_METRICS   ADD PRIMARY KEY (REQ_METRIC_ID);
ALTER TABLE F_C_REQUI_TCASE_METRICS   ADD PRIMARY KEY (REQ_METRIC_ID);
ALTER TABLE F_C_TASK_COMP_METRICS  ADD PRIMARY KEY (TASK_METRICS_ID);
ALTER TABLE F_C_TESTCASE_ITER_METRICS  ADD PRIMARY KEY (TSTCASE_METRIC_ID);
ALTER TABLE F_C_TESTCASE_REQUI_METRICS  ADD PRIMARY KEY (TSTCASE_METRIC_ID);
ALTER TABLE F_C_TEXT_FILE_VERSION_METRICS  ADD PRIMARY KEY (SLOC_METRICS_ID);
ALTER TABLE F_C_TEXT_FILE_VER_REQU_METRICS  ADD PRIMARY KEY (SLOC_METRICS_ID);
ALTER TABLE F_EXECRESPOINTS_ITER_METRICS   ADD PRIMARY KEY (EXECRES_METRIC_ID);
ALTER TABLE F_EXECUTION_RES_ITER_METRICS  ADD PRIMARY KEY (EXERES_METRICS_ID);
ALTER TABLE F_EXEC_WORKITEM_ITER_METRICS  ADD PRIMARY KEY (EXECWORKITEM_METRIC_ID);
ALTER TABLE F_EXEC_WORKITEM_REQU_METRICS  ADD PRIMARY KEY (EXECWORKITEM_METRIC_ID);
ALTER TABLE F_REQUEST_CUST_METRICS  ADD PRIMARY KEY (REQUEST_METRIC_ID);
ALTER TABLE F_REQUEST_REQUI_FAIL_METRICS  ADD PRIMARY KEY (REQFAIL_METRIC_ID);
ALTER TABLE F_REQUEST_REQUI_METRICS  ADD PRIMARY KEY (REQUEST_METRIC_ID);
ALTER TABLE F_REQUEST_RES_REQUI_DT_METRICS   ADD PRIMARY KEY (REQDT_METRIC_ID);
ALTER TABLE F_REQUEST_RES_TPLN_DT_METRICS   ADD PRIMARY KEY (REQDT_METRIC_ID);
ALTER TABLE F_REQUEST_TPLN_AGING   ADD PRIMARY KEY (AGING_METRIC_ID);
ALTER TABLE F_REQUEST_TPLN_FAIL_METRICS  ADD PRIMARY KEY (REQFAIL_METRIC_ID);
ALTER TABLE F_REQUEST_TPLN_METRICS  ADD PRIMARY KEY (REQUEST_METRIC_ID);
ALTER TABLE F_REQUEST_TPLN_TURNAROUND  ADD PRIMARY KEY (TURNAROUND_METRIC_ID);
ALTER TABLE F_REQUE_CLOSE_REQUI_DT_METRICS   ADD PRIMARY KEY (REQCDT_METRIC_ID);
ALTER TABLE F_REQUE_CLOSE_TPLN_DT_METRICS   ADD PRIMARY KEY (REQCDT_METRIC_ID);
ALTER TABLE F_REQUIREMENT_TPLN_METRICS   ADD PRIMARY KEY (REQ_METRIC_ID);
ALTER TABLE F_REQUI_TCASE_METRICS   ADD PRIMARY KEY (REQ_METRIC_ID);
ALTER TABLE F_REQU_CREATI_REQUI_DT_METRICS   ADD PRIMARY KEY (REQDT_METRIC_ID);
ALTER TABLE F_REQU_CREATI_TPLN_DT_METRICS   ADD PRIMARY KEY (REQDT_METRIC_ID);
ALTER TABLE F_TASK_CLOSE_COMP_DT_METRICS  ADD PRIMARY KEY (TASKCLS_METRICS_ID);
ALTER TABLE F_TASK_COMP_METRICS  ADD PRIMARY KEY (TASK_METRICS_ID);
ALTER TABLE F_TASK_CREATE_COMP_DT_METRICS  ADD PRIMARY KEY (TASKCRD_METRICS_ID);
ALTER TABLE F_TESTCASE_ITER_METRICS  ADD PRIMARY KEY (TSTCASE_METRIC_ID);
ALTER TABLE F_TESTCASE_REQUI_METRICS  ADD PRIMARY KEY (TSTCASE_METRIC_ID);
ALTER TABLE F_TEXT_FILE_VERSION_DT_METRICS  ADD PRIMARY KEY (SLOC_METRICS_ID);
ALTER TABLE F_TEXT_FILE_VERSREQ_DT_METRICS  ADD PRIMARY KEY (SLOC_METRICS_ID);
ALTER TABLE F_TEXT_FILE_VER_REQU_METRICS  ADD PRIMARY KEY (SLOC_METRICS_ID);
ALTER TABLE F_ACTIVITY_COMP_METRICS ADD PRIMARY KEY (ACTIVITY_METRICS_ID);
ALTER TABLE F_C_ACTIVITY_COMP_METRICS ADD PRIMARY KEY (ACTIVITY_METRICS_ID);
ALTER TABLE F_ACT_COM_CREATION_DT_METRICS ADD PRIMARY KEY (ACTIVITYCRD_METRICS_ID);
ALTER TABLE F_TEXT_FILE_VER_BSLN_METRICS ADD PRIMARY KEY (SLOC_METRICS_ID);
ALTER TABLE F_C_TEXT_FILE_VERBSLN_METRICS ADD PRIMARY KEY (SLOC_METRICS_ID);
ALTER TABLE H_ACTIVITY_ITER_METRICS  ADD PRIMARY KEY (ACTIVITY_ID,ACTIVITY_METRICS_ID);
ALTER TABLE H_ACTIVITY_REQ_METRICS  ADD PRIMARY KEY (ACTIVITY_METRICS_ID,ACTIVITY_ID);
ALTER TABLE H_ACT_ITER_CREATION_DT_METRICS  ADD PRIMARY KEY (ACTIVITYCRD_METRICS_ID,ACTIVITY_ID);
ALTER TABLE H_ACT_REQUI_CREAT_DT_METRICS  ADD PRIMARY KEY (ACTIVITYCRD_METRICS_ID,ACTIVITY_ID); 
ALTER TABLE H_BUILD_REQUI_ATTEMPTS  ADD PRIMARY KEY (BUILD_METRIC_ID,BUILD_ID);
ALTER TABLE H_BUILD_REQUI_FAIL  ADD PRIMARY KEY (BUILD_METRIC_ID,BUILD_ID);
ALTER TABLE H_BUILD_REQUI_PASS  ADD PRIMARY KEY (BUILD_METRIC_ID,BUILD_ID);
ALTER TABLE H_BUILD_REQU_ATTEMPTS  ADD PRIMARY KEY (BUILD_METRIC_ID,BUILD_ID);  
ALTER TABLE H_BUILD_REQU_EXEC_DT_MET_TOT  ADD PRIMARY KEY (BUILD_EXEC_METRIC_ID,BUILD_ID);
ALTER TABLE H_BUILD_REQU_FAIL  ADD PRIMARY KEY (BUILD_METRIC_ID,BUILD_ID);
ALTER TABLE H_BUILD_REQU_PASS  ADD PRIMARY KEY (BUILD_METRIC_ID,BUILD_ID);
ALTER TABLE H_EXECRESPOINTS_ITER_METRICS  ADD PRIMARY KEY (EXECRES_METRIC_ID,EXECUTION_RESULT_ID);
ALTER TABLE H_EXECUTION_RES_ITER_METRICS  ADD PRIMARY KEY (EXERES_METRICS_ID,EXECUTION_RESULT_ID);
ALTER TABLE H_EXEC_WORKITEM_ITER_METRICS  ADD PRIMARY KEY (EXECWORKITEM_METRIC_ID,EXECWORKITEM_ID); 
ALTER TABLE H_EXEC_WORKITEM_REQU_METRICS  ADD PRIMARY KEY (EXECWORKITEM_METRIC_ID,EXECWORKITEM_ID); 
ALTER TABLE H_REQUEST_AGING_TPLN_MAX  ADD PRIMARY KEY (AGING_METRIC_ID,REQUEST_ID);
ALTER TABLE H_REQUEST_AGING_TPLN_MIN  ADD PRIMARY KEY (AGING_METRIC_ID,REQUEST_ID) ; 
ALTER TABLE H_REQUEST_AGING_TPLN_TOTAL  ADD PRIMARY KEY (AGING_METRIC_ID,REQUEST_ID);
ALTER TABLE H_TASK_CREATE_COMP_DT_METRICS  ADD PRIMARY KEY (TASKCRD_METRICS_ID,TASK_ID);
ALTER TABLE H_REQUEST_CUST_METRICS_BLOCK  ADD PRIMARY KEY (REQUEST_METRIC_ID,REQUEST_ID);  
ALTER TABLE H_REQUEST_CUST_METRICS_TOTAL  ADD PRIMARY KEY (REQUEST_METRIC_ID,REQUEST_ID);  
ALTER TABLE H_REQUEST_REQUI_FAIL_METRICS  ADD PRIMARY KEY (REQFAIL_METRIC_ID,REQUEST_ID);
ALTER TABLE H_REQUEST_REQUI_METRICS_BLOCK  ADD PRIMARY KEY (REQUEST_METRIC_ID,REQUEST_ID);  
ALTER TABLE H_REQUEST_REQUI_METRICS_TOTAL  ADD PRIMARY KEY (REQUEST_METRIC_ID,REQUEST_ID);  
ALTER TABLE H_REQUEST_RES_REQUI_DT_METRICS  ADD PRIMARY KEY (REQDT_METRIC_ID,REQUEST_ID);
ALTER TABLE H_REQUEST_RES_TPLN_DT_METRICS  ADD PRIMARY KEY (REQDT_METRIC_ID,REQUEST_ID);
ALTER TABLE H_REQUEST_TPLN_FAIL_METRICS  ADD PRIMARY KEY (REQFAIL_METRIC_ID,REQUEST_ID);
ALTER TABLE H_REQUEST_TPLN_METRICS_BLOCK  ADD PRIMARY KEY (REQUEST_METRIC_ID,REQUEST_ID);  
ALTER TABLE H_REQUEST_TPLN_METRICS_TOTAL  ADD PRIMARY KEY (REQUEST_METRIC_ID,REQUEST_ID);  
ALTER TABLE H_REQUEST_TPLN_TURNAROUND_MAX  ADD PRIMARY KEY (TURNAROUND_METRIC_ID,REQUEST_ID);
ALTER TABLE H_REQUEST_TPLN_TURNAROUND_MIN  ADD PRIMARY KEY (TURNAROUND_METRIC_ID,REQUEST_ID); 
ALTER TABLE H_REQUEST_TPLN_TURNAROUND_TOT  ADD PRIMARY KEY (TURNAROUND_METRIC_ID,REQUEST_ID); 
ALTER TABLE H_REQUE_CLOSE_REQUI_DT_METRICS  ADD PRIMARY KEY (REQCDT_METRIC_ID,REQUEST_ID);
ALTER TABLE H_REQUE_CLOSE_TPLN_DT_METRICS  ADD PRIMARY KEY (REQCDT_METRIC_ID,REQUEST_ID);
ALTER TABLE H_REQUI_TCASE_METRICS_CHANGES  ADD PRIMARY KEY (REQ_METRIC_ID,REQUIREMENT_ID);  
ALTER TABLE H_REQUI_TCASE_METRICS_TOTAL  ADD PRIMARY KEY (REQ_METRIC_ID,REQUIREMENT_ID);  
ALTER TABLE H_REQUI_TPLN_METRICS_CHANGES  ADD PRIMARY KEY (REQ_METRIC_ID,REQUIREMENT_ID);
ALTER TABLE H_REQUI_TPLN_METRICS_TOTAL  ADD PRIMARY KEY (REQ_METRIC_ID,REQUIREMENT_ID);  
ALTER TABLE H_REQU_CREATI_REQUI_DT_METRICS  ADD PRIMARY KEY (REQDT_METRIC_ID,REQUEST_ID);
ALTER TABLE H_REQU_CREATI_TPLN_DT_METRICS  ADD PRIMARY KEY (REQDT_METRIC_ID,REQUEST_ID);
ALTER TABLE H_TASK_CLOSE_COMP_DT_METRICS  ADD PRIMARY KEY (TASKCLS_METRICS_ID,TASK_ID);
ALTER TABLE H_TASK_COMP_METRICS  ADD PRIMARY KEY (TASK_METRICS_ID,TASK_ID); 
ALTER TABLE H_TESTCASE_ITER_METRICS  ADD PRIMARY KEY (TSTCASE_METRIC_ID,TESTCASE_ID);
ALTER TABLE H_TESTCASE_REQUI_METRICS  ADD PRIMARY KEY (TSTCASE_METRIC_ID,TESTCASE_ID);
ALTER TABLE H_TEXT_FILE_VERS_DT_METRICS_CH  ADD PRIMARY KEY (SLOC_METRICS_ID,FILE_VERSION_ID); 
ALTER TABLE H_TEXT_FILE_VERS_DT_METRICS_TO  ADD PRIMARY KEY (SLOC_METRICS_ID,FILE_VERSION_ID);  
ALTER TABLE H_TEXT_FILE_VER_REQ_METRICS_CH  ADD PRIMARY KEY (SLOC_METRICS_ID,FILE_VERSION_ID);  
ALTER TABLE H_TEXT_FILE_VER_REQ_METRICS_TO  ADD PRIMARY KEY (SLOC_METRICS_ID,FILE_VERSION_ID);  
ALTER TABLE H_TXT_FILE_VERSREQ_DT_METR_CH   ADD PRIMARY KEY (SLOC_METRICS_ID,FILE_VERSION_ID);
ALTER TABLE H_TXT_FILE_VERSREQ_DT_METR_TO  ADD PRIMARY KEY (SLOC_METRICS_ID,FILE_VERSION_ID);    
ALTER TABLE H_ACTIVITY_COMP_METRICS ADD PRIMARY KEY (ACTIVITY_METRICS_ID,ACTIVITY_ID);
ALTER TABLE H_ACT_COM_CREATION_DT_METRICS ADD PRIMARY KEY (ACTIVITYCRD_METRICS_ID,ACTIVITY_ID);
ALTER TABLE H_TEXT_FILE_VERBSLN_METRICS_CH ADD PRIMARY KEY (SLOC_METRICS_ID,FILE_VERSION_ID);
ALTER TABLE H_TEXT_FILE_VERBSLN_METRICS_TO ADD PRIMARY KEY (SLOC_METRICS_ID,FILE_VERSION_ID);
ALTER TABLE F_MISSING_TIMESHEET_METRICS ADD PRIMARY KEY (TIMESHEET_METRICS_ID);
ALTER TABLE H_MISSING_TIMESHEET_METRICS ADD PRIMARY KEY (TIMESHEET_METRICS_ID,ACTIVITY_ID);
ALTER TABLE F_TIMESHEET_METRICS ADD PRIMARY KEY (TIMESHEET_METRICS_ID);
ALTER TABLE H_TIMESHEET_METRICS ADD PRIMARY KEY (TIMESHEET_METRICS_ID,ACTIVITY_ID);
ALTER TABLE F_TIMESHEET_TIMECODE_METRICS ADD PRIMARY KEY (TIMESHEET_METRICS_ID);
ALTER TABLE H_TIMESHEET_TIMECODE_METRICS ADD PRIMARY KEY (TIMESHEET_METRICS_ID,ACTIVITY_ID);
ALTER TABLE F_WK_PROJ_RESDEMSUPP_METRICS ADD PRIMARY KEY (F_PROJDS_MET_ID);
ALTER TABLE F_MO_PROJ_RESDEMSUPP_METRICS ADD PRIMARY KEY (F_PROJDS_MET_ID);
ALTER TABLE F_WK_RESOURCE_UTIL_METRICS ADD PRIMARY KEY (F_RESUTIL_MET_ID);
ALTER TABLE F_MO_RESOURCE_UTIL_METRICS ADD PRIMARY KEY (F_RESUTIL_MET_ID);
ALTER TABLE F_RISK_METRICS ADD PRIMARY KEY (F_RISKMET_ID);
ALTER TABLE F_C_RISK_METRICS ADD PRIMARY KEY (F_RISKMET_ID);
ALTER TABLE H_WK_PROJ_RESDEMSUPP_METRICS ADD PRIMARY KEY (F_PROJDS_MET_ID,PROJECT_ALLOCATION_ID);
ALTER TABLE H_MO_PROJ_RESDEMSUPP_METRICS ADD PRIMARY KEY (F_PROJDS_MET_ID,PROJECT_ALLOCATION_ID);
ALTER TABLE H_WK_RESOURCE_UTIL_METRICS ADD PRIMARY KEY (F_RESUTIL_MET_ID,RESOURCE_ID);
ALTER TABLE H_MO_RESOURCE_UTIL_METRICS ADD PRIMARY KEY (F_RESUTIL_MET_ID,RESOURCE_ID);
ALTER TABLE H_RISK_METRICS ADD PRIMARY KEY (F_RISKMET_ID,RISK_ID);
ALTER TABLE D_RISK ADD PRIMARY KEY (RISK_ID);
ALTER TABLE D_RISK_STATE ADD PRIMARY KEY (STATE_ID);
ALTER TABLE D_PROBABILITY_RANK ADD PRIMARY KEY (PROBABILITY_RANK_ID);
ALTER TABLE D_IMPACT_RANK ADD PRIMARY KEY (IMPACT_RANK_ID);
ALTER TABLE D_PROBABILITY_COST_RANK ADD PRIMARY KEY (PROBABILITY_COST_RANK_ID);
ALTER TABLE D_SCORE_RANK ADD PRIMARY KEY (SCORE_RANK_ID);
ALTER TABLE F_TASK_ITER_VARIANCE_METRICS ADD PRIMARY KEY (F_TASKVAR_MET_ID);
ALTER TABLE F_TASK_PROJ_VARIANCE_METRICS ADD PRIMARY KEY (F_TASKVAR_MET_ID);
ALTER TABLE F_C_TASK_ITE_VARIANCE_METRICS ADD PRIMARY KEY (F_TASKVAR_MET_ID);
ALTER TABLE F_C_TASK_PRO_VARIANCE_METRICS ADD PRIMARY KEY (F_TASKVAR_MET_ID);
ALTER TABLE H_TASK_ITER_VARIANCE_METRICS ADD PRIMARY KEY (F_TASKVAR_MET_ID,TASK_ID);
ALTER TABLE H_TASK_PROJ_VARIANCE_METRICS ADD PRIMARY KEY (F_TASKVAR_MET_ID,TASK_ID);
ALTER TABLE D_OPERATING_TERRITORY ADD PRIMARY KEY (TERRITORY_ID);
ALTER TABLE D_COUNTRY ADD PRIMARY KEY (COUNTRY_ID);
ALTER TABLE D_PROVINCE_STATE ADD PRIMARY KEY (PROVINCE_STATE_ID);
ALTER TABLE D_CITY ADD PRIMARY KEY (CITY_ID);
ALTER TABLE D_ORGANIZATION ADD PRIMARY KEY (ORGANIZATION_ID);
ALTER TABLE F_WK_SCPROJ_RESDEMSUP_METRICS ADD PRIMARY KEY (F_PROJDS_MET_ID);
ALTER TABLE H_WK_SCPROJ_RESDEMSUP_METRICS ADD PRIMARY KEY (F_PROJDS_MET_ID,PROJECT_ALLOCATION_ID);
ALTER TABLE F_WK_SKPROJ_RESDEMSUP_METRICS ADD PRIMARY KEY (F_PROJDS_MET_ID);
ALTER TABLE H_WK_SKPROJ_RESDEMSUP_METRICS ADD PRIMARY KEY (F_PROJDS_MET_ID,PROJECT_ALLOCATION_ID);
ALTER TABLE F_WK_COPROJ_RESDEMSUP_METRICS ADD PRIMARY KEY (F_PROJDS_MET_ID);
ALTER TABLE H_WK_COPROJ_RESDEMSUP_METRICS ADD PRIMARY KEY (F_PROJDS_MET_ID,PROJECT_ALLOCATION_ID);
ALTER TABLE F_MO_SCPROJ_RESDEMSUP_METRICS ADD PRIMARY KEY (F_PROJDS_MET_ID);
ALTER TABLE H_MO_SCPROJ_RESDEMSUP_METRICS ADD PRIMARY KEY (F_PROJDS_MET_ID,PROJECT_ALLOCATION_ID);
ALTER TABLE F_MO_SKPROJ_RESDEMSUP_METRICS ADD PRIMARY KEY (F_PROJDS_MET_ID);
ALTER TABLE H_MO_SKPROJ_RESDEMSUP_METRICS ADD PRIMARY KEY (F_PROJDS_MET_ID,PROJECT_ALLOCATION_ID);
ALTER TABLE F_MO_COPROJ_RESDEMSUP_METRICS ADD PRIMARY KEY (F_PROJDS_MET_ID);
ALTER TABLE H_MO_COPROJ_RESDEMSUP_METRICS ADD PRIMARY KEY (F_PROJDS_MET_ID,PROJECT_ALLOCATION_ID);
ALTER TABLE F_WK_SCRESOURCE_UTIL_METRICS ADD PRIMARY KEY (F_RESUTIL_MET_ID);
ALTER TABLE H_WK_SCRESOURCE_UTIL_METRICS ADD PRIMARY KEY (F_RESUTIL_MET_ID,RESOURCE_ID);
ALTER TABLE F_WK_SKRESOURCE_UTIL_METRICS ADD PRIMARY KEY (F_RESUTIL_MET_ID);
ALTER TABLE H_WK_SKRESOURCE_UTIL_METRICS ADD PRIMARY KEY (F_RESUTIL_MET_ID,RESOURCE_ID);
ALTER TABLE F_WK_CORESOURCE_UTIL_METRICS ADD PRIMARY KEY (F_RESUTIL_MET_ID);
ALTER TABLE H_WK_CORESOURCE_UTIL_METRICS ADD PRIMARY KEY (F_RESUTIL_MET_ID,RESOURCE_ID);
ALTER TABLE F_MO_SCRESOURCE_UTIL_METRICS ADD PRIMARY KEY (F_RESUTIL_MET_ID);
ALTER TABLE H_MO_SCRESOURCE_UTIL_METRICS ADD PRIMARY KEY (F_RESUTIL_MET_ID,RESOURCE_ID);
ALTER TABLE F_MO_SKRESOURCE_UTIL_METRICS ADD PRIMARY KEY (F_RESUTIL_MET_ID);
ALTER TABLE H_MO_SKRESOURCE_UTIL_METRICS ADD PRIMARY KEY (F_RESUTIL_MET_ID,RESOURCE_ID);
ALTER TABLE F_MO_CORESOURCE_UTIL_METRICS ADD PRIMARY KEY (F_RESUTIL_MET_ID);
ALTER TABLE H_MO_CORESOURCE_UTIL_METRICS ADD PRIMARY KEY (F_RESUTIL_MET_ID,RESOURCE_ID);
ALTER TABLE F_STORY_METRICS ADD PRIMARY KEY (F_STORY_METRIC_ID);
ALTER TABLE F_C_STORY_METRICS ADD PRIMARY KEY (F_STORY_METRIC_ID);
ALTER TABLE H_STORY_METRICS ADD PRIMARY KEY (F_STORY_METRIC_ID, REQUEST_ID);
ALTER TABLE F_REQUEST_FAILURE_DT_METRICS ADD PRIMARY KEY (REQFAIL_METRIC_ID);
ALTER TABLE H_REQUEST_FAILURE_DT_METRICS ADD PRIMARY KEY (REQFAIL_METRIC_ID,REQUEST_ID);
ALTER TABLE F_REQUEST_TPLN_FAILDT_METRICS ADD PRIMARY KEY (REQFAIL_METRIC_ID);
ALTER TABLE H_REQUEST_TPLN_FAILDT_METRICS ADD PRIMARY KEY (REQFAIL_METRIC_ID,REQUEST_ID);
ALTER TABLE F_REQUEST_REQUI_FAILDT_METRICS ADD PRIMARY KEY (REQFAIL_METRIC_ID);
ALTER TABLE H_REQUEST_REQUI_FAILDT_METRICS ADD PRIMARY KEY (REQFAIL_METRIC_ID,REQUEST_ID);
ALTER TABLE F_REQUIR_MODIF_DT_METRICS ADD PRIMARY KEY (REQ_METRIC_ID);
ALTER TABLE H_REQUIR_MODIF_DT_METRICS ADD PRIMARY KEY (REQ_METRIC_ID,REQUIREMENT_ID);
ALTER TABLE F_PROJECT_FINANCIAL_METRICS ADD PRIMARY KEY (F_PROJFIN_METRIC_ID);
ALTER TABLE F_C_PROJECT_FINANCIAL_METRICS ADD PRIMARY KEY (F_PROJFIN_METRIC_ID);
ALTER TABLE H_PROJECT_FINANCIAL_METRICS ADD PRIMARY KEY (F_PROJFIN_METRIC_ID,PROJECT_ID);
ALTER TABLE F_TP_PROJECT_FINANCIAL_METRICS ADD PRIMARY KEY (F_TPPROJFIN_METRIC_ID);
ALTER TABLE H_TP_PROJECT_FINANCIAL_METRICS ADD PRIMARY KEY (F_TPPROJFIN_METRIC_ID,PROJECT_ID);
ALTER TABLE D_ASSET ADD PRIMARY KEY (ASSET_ID);
ALTER TABLE D_ASSET_TYPE ADD PRIMARY KEY (ASSET_TYPE_ID);
ALTER TABLE D_ACTION_TYPE ADD PRIMARY KEY (ACTION_TYPE_ID);
ALTER TABLE F_ASSET_UTIL_DT_METRICS ADD PRIMARY KEY (F_ASSET_METRIC_ID);
ALTER TABLE F_LICENSE_DT_METRICS ADD PRIMARY KEY (F_LICENSE_METRIC_ID);
ALTER TABLE D_REQUEST_PRIORITY ADD PRIMARY KEY (PRIORITY_ID);
ALTER TABLE D_REQUEST_SEVERITY ADD PRIMARY KEY (SEVERITY_ID);
ALTER TABLE D_REQUEST_STATUS ADD PRIMARY KEY (STATUS_ID);
ALTER TABLE D_BALLOT_TAB ADD PRIMARY KEY (BALLOT_TAB_ID);
ALTER TABLE F_SC_BALLOT_TAB_RESULT_METRICS ADD PRIMARY KEY (BALLOT_TAB_RESULT_METRICS_ID);

ALTER TABLE F_REQUEST_METRICS ADD CONSTRAINT F_REQUEST_FK1 FOREIGN KEY (PROJECT_ID)
	REFERENCES D_PROJECT (PROJECT_ID);
	
ALTER TABLE F_REQUEST_METRICS ADD CONSTRAINT F_REQUEST_FK13 FOREIGN KEY (RELEASE_ID)
	REFERENCES D_RELEASE (RELEASE_ID);

ALTER TABLE F_REQUEST_METRICS ADD CONSTRAINT F_REQUEST_FK14 FOREIGN KEY (FIXEDINRELEASE_ID)
	REFERENCES D_RELEASE (RELEASE_ID);

ALTER TABLE F_REQUEST_METRICS ADD CONSTRAINT F_REQUEST_FK15 FOREIGN KEY (DATE_ID)
	REFERENCES D_DATE (DATE_ID);

ALTER TABLE F_REQUEST_METRICS ADD CONSTRAINT F_REQUEST_FK16 FOREIGN KEY (REQUEST_CLASS_ID)
	REFERENCES D_REQUEST_CLASSIFICATION (REQUEST_CLASS_ID);

ALTER TABLE F_REQUEST_METRICS ADD CONSTRAINT F_REQUEST_FK17 FOREIGN KEY (RESOURCE_ID)
	REFERENCES D_RESOURCE (RESOURCE_ID);
	
ALTER TABLE F_REQUEST_METRICS ADD CONSTRAINT F_REQUEST_FK19 FOREIGN KEY (STATUS_ID)
	REFERENCES D_REQUEST_STATUS (STATUS_ID);	

ALTER TABLE F_REQUEST_METRICS ADD CONSTRAINT F_REQUEST_FK2 FOREIGN KEY (STATE_ID)
	REFERENCES D_REQUEST_STATE (STATE_ID);

ALTER TABLE F_REQUEST_METRICS ADD CONSTRAINT F_REQUEST_FK21 FOREIGN KEY (REQUEST_CATEGORY_ID)
	REFERENCES D_REQUEST_CATEGORY (REQUEST_CATEGORY_ID);
	
ALTER TABLE F_REQUEST_METRICS ADD CONSTRAINT F_REQUEST_FK3 FOREIGN KEY (PRIORITY_ID)
	REFERENCES D_REQUEST_PRIORITY (PRIORITY_ID);

ALTER TABLE F_REQUEST_METRICS ADD CONSTRAINT F_REQUEST_FK4 FOREIGN KEY (SEVERITY_ID)
	REFERENCES D_REQUEST_SEVERITY (SEVERITY_ID);

ALTER TABLE F_REQUEST_METRICS ADD CONSTRAINT F_REQUEST_FK5 FOREIGN KEY (TEAM_ID)
	REFERENCES D_TEAM (TEAM_ID);

ALTER TABLE F_REQUEST_METRICS ADD CONSTRAINT F_REQUEST_FK6 FOREIGN KEY (PLATFORM_ID)
	REFERENCES D_PLATFORM (PLATFORM_ID);

ALTER TABLE F_REQUEST_METRICS ADD CONSTRAINT F_REQUEST_FK8 FOREIGN KEY (ITERATION_ID)
	REFERENCES D_ITERATION (ITERATION_ID);

ALTER TABLE F_REQUEST_METRICS ADD CONSTRAINT F_REQUEST_FK9 FOREIGN KEY (COMPONENT_ID)
	REFERENCES D_COMPONENT (COMPONENT_ID);

ALTER TABLE F_REQUEST_METRICS ADD CONSTRAINT F_REQUEST_FK10 FOREIGN KEY (REQUEST_TYPE_ID)
	REFERENCES D_REQUEST_TYPE (REQUEST_TYPE_ID);
	
ALTER TABLE H_REQUEST_METRICS_TOTAL ADD CONSTRAINT HREQMETRIC_FK1 FOREIGN KEY (REQUEST_METRIC_ID)
	REFERENCES F_REQUEST_METRICS (REQUEST_METRIC_ID) ON DELETE CASCADE;

ALTER TABLE H_REQUEST_METRICS_TOTAL ADD CONSTRAINT HREQMETRIC_FK2 FOREIGN KEY (REQUEST_ID)
	REFERENCES D_REQUEST (REQUEST_ID) ON DELETE CASCADE;
	
ALTER TABLE H_REQUEST_METRICS_BLOCKING ADD CONSTRAINT HREQMETRICB_FK1 FOREIGN KEY (REQUEST_METRIC_ID)
	REFERENCES F_REQUEST_METRICS (REQUEST_METRIC_ID) ON DELETE CASCADE;

ALTER TABLE H_REQUEST_METRICS_BLOCKING ADD CONSTRAINT HREQMETRICB_FK2 FOREIGN KEY (REQUEST_ID)
	REFERENCES D_REQUEST (REQUEST_ID) ON DELETE CASCADE;

ALTER TABLE F_REQUEST_AGING ADD CONSTRAINT F_REQ_AGD_FK1 FOREIGN KEY (STATE_ID)
	REFERENCES D_REQUEST_STATE (STATE_ID);

ALTER TABLE F_REQUEST_AGING ADD CONSTRAINT F_REQ_AGD_FK2 FOREIGN KEY (DATE_ID)
	REFERENCES D_DATE (DATE_ID);

ALTER TABLE F_REQUEST_AGING ADD CONSTRAINT F_REQ_AGD_FK3 FOREIGN KEY (PROJECT_ID)
	REFERENCES D_PROJECT (PROJECT_ID);

ALTER TABLE F_REQUEST_AGING ADD CONSTRAINT F_REQ_AGD_FK4 FOREIGN KEY (COMPONENT_ID)
	REFERENCES D_COMPONENT (COMPONENT_ID);

ALTER TABLE F_REQUEST_AGING ADD CONSTRAINT F_REQ_AGD_FK5 FOREIGN KEY (RESOURCE_ID)
	REFERENCES D_RESOURCE (RESOURCE_ID);

ALTER TABLE F_REQUEST_AGING ADD CONSTRAINT F_REQ_AGD_FK6 FOREIGN KEY (SEVERITY_ID)
	REFERENCES D_REQUEST_SEVERITY (SEVERITY_ID);

ALTER TABLE F_REQUEST_AGING ADD CONSTRAINT F_REQ_AGD_FK7 FOREIGN KEY (PRIORITY_ID)
	REFERENCES D_REQUEST_PRIORITY (PRIORITY_ID);

ALTER TABLE F_REQUEST_AGING ADD CONSTRAINT F_REQ_AGD_FK8 FOREIGN KEY (ITERATION_ID)
	REFERENCES D_ITERATION (ITERATION_ID);
			
ALTER TABLE F_REQUEST_AGING ADD CONSTRAINT F_REQ_AGD_FK9 FOREIGN KEY (REQUEST_CLASS_ID)
	REFERENCES D_REQUEST_CLASSIFICATION (REQUEST_CLASS_ID);		

ALTER TABLE F_REQUEST_AGING ADD CONSTRAINT F_REQ_AGD_FK10 FOREIGN KEY (REQUEST_TYPE_ID)
	REFERENCES D_REQUEST_TYPE (REQUEST_TYPE_ID);	
	
ALTER TABLE H_REQUEST_AGING_MIN ADD CONSTRAINT HREQAGM_FK1 FOREIGN KEY (AGING_METRIC_ID)
	REFERENCES F_REQUEST_AGING (AGING_METRIC_ID) ON DELETE CASCADE;
	
ALTER TABLE H_REQUEST_AGING_MIN ADD CONSTRAINT HREQAGM_FK2 FOREIGN KEY (REQUEST_ID)
	REFERENCES D_REQUEST (REQUEST_ID)  ON DELETE CASCADE;
	
ALTER TABLE H_REQUEST_AGING_MAX ADD CONSTRAINT HREQAGX_FK1 FOREIGN KEY (AGING_METRIC_ID)
	REFERENCES F_REQUEST_AGING (AGING_METRIC_ID) ON DELETE CASCADE;
	
ALTER TABLE H_REQUEST_AGING_MAX ADD CONSTRAINT HREQAGX_FK2 FOREIGN KEY (REQUEST_ID)
	REFERENCES D_REQUEST (REQUEST_ID)  ON DELETE CASCADE;
		
ALTER TABLE H_REQUEST_AGING_TOTAL ADD CONSTRAINT HREQAG_FK1 FOREIGN KEY (AGING_METRIC_ID)
	REFERENCES F_REQUEST_AGING (AGING_METRIC_ID) ON DELETE CASCADE;
	
ALTER TABLE H_REQUEST_AGING_TOTAL ADD CONSTRAINT HREQAG_FK2 FOREIGN KEY (REQUEST_ID)
	REFERENCES D_REQUEST (REQUEST_ID)  ON DELETE CASCADE;	
	
ALTER TABLE F_REQUEST_CLOSURE_DATE_METRICS ADD CONSTRAINT F_REQCDT_FK1 FOREIGN KEY (RELEASE_ID)
	REFERENCES D_RELEASE (RELEASE_ID);

ALTER TABLE F_REQUEST_CLOSURE_DATE_METRICS ADD CONSTRAINT F_REQCDT_FK2 FOREIGN KEY (COMPONENT_ID)
	REFERENCES D_COMPONENT (COMPONENT_ID);

ALTER TABLE F_REQUEST_CLOSURE_DATE_METRICS ADD CONSTRAINT F_REQCDT_FK3 FOREIGN KEY (PROJECT_ID)
	REFERENCES D_PROJECT (PROJECT_ID);

ALTER TABLE F_REQUEST_CLOSURE_DATE_METRICS ADD CONSTRAINT F_REQCDT_FK5 FOREIGN KEY (REQUEST_CLASS_ID)
	REFERENCES D_REQUEST_CLASSIFICATION (REQUEST_CLASS_ID);

ALTER TABLE F_REQUEST_CLOSURE_DATE_METRICS ADD CONSTRAINT F_REQCDT_FK7 FOREIGN KEY (STATUS_ID)
	REFERENCES D_REQUEST_STATUS (STATUS_ID);

ALTER TABLE F_REQUEST_CLOSURE_DATE_METRICS ADD CONSTRAINT F_REQCDT_FK8 FOREIGN KEY (CUSTOMER_PRIORITY_ID)
	REFERENCES D_CUSTOMER_PRIORITY (CUSTOMER_PRIORITY_ID);

ALTER TABLE F_REQUEST_CLOSURE_DATE_METRICS ADD CONSTRAINT F_REQCDT_FK9 FOREIGN KEY (CLOSED_DATE_ID)
	REFERENCES D_DATE (DATE_ID);	

ALTER TABLE F_REQUEST_CLOSURE_DATE_METRICS ADD CONSTRAINT F_REQCDT_FK10 FOREIGN KEY (SEVERITY_ID)
	REFERENCES D_REQUEST_SEVERITY (SEVERITY_ID);
	
ALTER TABLE F_REQUEST_CLOSURE_DATE_METRICS ADD CONSTRAINT F_REQCDT_FK11 FOREIGN KEY (REQUEST_TYPE_ID)
	REFERENCES D_REQUEST_TYPE (REQUEST_TYPE_ID);
		
ALTER TABLE F_TEXT_FILE_VERSION_METRICS ADD CONSTRAINT F_TFV_FK1 FOREIGN KEY (FILE_ID)
	REFERENCES D_FILE (FILE_ID);
	
ALTER TABLE F_TEXT_FILE_VERSION_METRICS ADD CONSTRAINT F_TFV_FK2 FOREIGN KEY (RESOURCE_ID)
	REFERENCES D_RESOURCE (RESOURCE_ID);	
	
ALTER TABLE F_TEXT_FILE_VERSION_METRICS ADD CONSTRAINT F_TFV_FK3 FOREIGN KEY (FILE_STREAM_ID)
	REFERENCES D_FILE_STREAM (FILE_STREAM_ID);	
	
ALTER TABLE F_TEXT_FILE_VERSION_METRICS ADD CONSTRAINT F_TFV_FK4 FOREIGN KEY (PROJECT_ID)
	REFERENCES D_PROJECT (PROJECT_ID);	
	
ALTER TABLE F_TEXT_FILE_VERSION_METRICS ADD CONSTRAINT F_TFV_FK6 FOREIGN KEY (COMPONENT_ID)
	REFERENCES D_COMPONENT (COMPONENT_ID);	
	
ALTER TABLE F_TEXT_FILE_VERSION_METRICS ADD CONSTRAINT F_TFV_FK7 FOREIGN KEY (DATE_ID)
	REFERENCES D_DATE (DATE_ID);			

ALTER TABLE F_TEXT_FILE_VERSION_METRICS ADD CONSTRAINT F_TFV_FK10 FOREIGN KEY (FILE_CLASS_ID)
	REFERENCES D_FILE_CLASSIFICATION (FILE_CLASS_ID);								

ALTER TABLE H_TEXT_FILE_VERSION_METRICS_CH ADD CONSTRAINT H_TFVCH_FK1 FOREIGN KEY (SLOC_METRICS_ID)
	REFERENCES F_TEXT_FILE_VERSION_METRICS (SLOC_METRICS_ID) ON DELETE CASCADE;
	
ALTER TABLE H_TEXT_FILE_VERSION_METRICS_CH ADD CONSTRAINT H_TFVCH_FK2 FOREIGN KEY (FILE_VERSION_ID)
	REFERENCES D_FILE_VERSION (FILE_VERSION_ID) ON DELETE CASCADE;	
		
ALTER TABLE H_TEXT_FILE_VERSION_METRICS_TO ADD CONSTRAINT H_TFVT_FK1 FOREIGN KEY (SLOC_METRICS_ID)
	REFERENCES F_TEXT_FILE_VERSION_METRICS (SLOC_METRICS_ID) ON DELETE CASCADE;
	
ALTER TABLE H_TEXT_FILE_VERSION_METRICS_TO ADD CONSTRAINT H_TFVT_FK2 FOREIGN KEY (FILE_VERSION_ID)
	REFERENCES D_FILE_VERSION (FILE_VERSION_ID) ON DELETE CASCADE;	
	
ALTER TABLE F_EXECUTION_RESULT_METRICS ADD CONSTRAINT F_EXERES_FK2 FOREIGN KEY (ASSETREGISTRY_ID)
	REFERENCES D_ASSETREGISTRY (ASSETREGISTRY_ID);

ALTER TABLE F_EXECUTION_RESULT_METRICS ADD CONSTRAINT F_EXERES_FK3 FOREIGN KEY (TESTCASE_ID)
	REFERENCES D_TESTCASE (TESTCASE_ID);

ALTER TABLE F_EXECUTION_RESULT_METRICS ADD CONSTRAINT F_EXERES_FK4 FOREIGN KEY (VERDICT_ID)
	REFERENCES D_VERDICT (VERDICT_ID);

ALTER TABLE F_EXECUTION_RESULT_METRICS ADD CONSTRAINT F_EXERES_FK5 FOREIGN KEY (DATE_ID)
	REFERENCES D_DATE (DATE_ID);

ALTER TABLE F_EXECUTION_RESULT_METRICS ADD CONSTRAINT F_EXERES_FK6 FOREIGN KEY (EXECRES_CLASS_ID)
	REFERENCES D_EXECRESULT_CLASSIFICATION (EXECRES_CLASS_ID);
	
ALTER TABLE F_EXECUTION_RESULT_METRICS ADD CONSTRAINT F_EXERES_FK7 FOREIGN KEY (TESTPLAN_ID)
	REFERENCES D_TESTPLAN (TESTPLAN_ID);	
	
ALTER TABLE F_EXECUTION_RESULT_METRICS ADD CONSTRAINT F_EXERES_FK8 FOREIGN KEY (PROJECT_ID)
	REFERENCES D_PROJECT (PROJECT_ID);	

ALTER TABLE H_EXECRESULT_DATE_METRICS ADD CONSTRAINT H_EXECRESDTK_FK1 FOREIGN KEY (EXECRESDT_METRICS_ID)
	REFERENCES F_EXECRESULT_DATE_METRICS (EXECRESDT_METRICS_ID) ON DELETE CASCADE;
	
ALTER TABLE H_EXECRESULT_DATE_METRICS ADD CONSTRAINT H_EXECRESDTK_FK2 FOREIGN KEY (EXECUTION_RESULT_ID)
	REFERENCES D_EXECUTION_RESULT (EXECUTION_RESULT_ID) ON DELETE CASCADE;	

ALTER TABLE F_REQUEST_CREATION_DT_METRICS ADD CONSTRAINT F_REQDT_FK1 FOREIGN KEY (RELEASE_ID)
	REFERENCES D_RELEASE (RELEASE_ID);

ALTER TABLE F_REQUEST_CREATION_DT_METRICS ADD CONSTRAINT F_REQDT_FK2 FOREIGN KEY (COMPONENT_ID)
	REFERENCES D_COMPONENT (COMPONENT_ID);

ALTER TABLE F_REQUEST_CREATION_DT_METRICS ADD CONSTRAINT F_REQDT_FK3 FOREIGN KEY (PROJECT_ID)
	REFERENCES D_PROJECT (PROJECT_ID);

ALTER TABLE F_REQUEST_CREATION_DT_METRICS ADD CONSTRAINT F_REQDT_FK5 FOREIGN KEY (REQUEST_CLASS_ID)
	REFERENCES D_REQUEST_CLASSIFICATION (REQUEST_CLASS_ID);

ALTER TABLE F_REQUEST_CREATION_DT_METRICS ADD CONSTRAINT F_REQDT_FK7 FOREIGN KEY (STATUS_ID)
	REFERENCES D_REQUEST_STATUS (STATUS_ID);

ALTER TABLE F_REQUEST_CREATION_DT_METRICS ADD CONSTRAINT F_REQDT_FK8 FOREIGN KEY (CUSTOMER_PRIORITY_ID)
	REFERENCES D_CUSTOMER_PRIORITY (CUSTOMER_PRIORITY_ID);

ALTER TABLE F_REQUEST_CREATION_DT_METRICS ADD CONSTRAINT F_REQDT_FK9 FOREIGN KEY (CREATION_DATE_ID)
	REFERENCES D_DATE (DATE_ID);	
	
ALTER TABLE F_REQUEST_CREATION_DT_METRICS ADD CONSTRAINT F_REQDT_FK10 FOREIGN KEY (SEVERITY_ID)
	REFERENCES D_REQUEST_SEVERITY (SEVERITY_ID);	
	
ALTER TABLE F_REQUEST_CREATION_DT_METRICS ADD CONSTRAINT F_REQDT_FK11 FOREIGN KEY (REQUEST_TYPE_ID)
	REFERENCES D_REQUEST_TYPE (REQUEST_TYPE_ID);	
	
ALTER TABLE F_REQUEST_CREATION_DT_METRICS ADD CONSTRAINT F_REQDT_FK12 FOREIGN KEY (TEAM_ID)
	REFERENCES D_TEAM (TEAM_ID);
	
ALTER TABLE F_REQUEST_CREATION_DT_METRICS ADD CONSTRAINT F_REQDT_FK13 FOREIGN KEY (REQUEST_CATEGORY_ID)
	REFERENCES D_REQUEST_CATEGORY (REQUEST_CATEGORY_ID);
	
ALTER TABLE F_REQUEST_CREATION_DT_METRICS ADD CONSTRAINT F_REQDT_FK14 FOREIGN KEY (STATE_ID)
	REFERENCES D_REQUEST_STATE (STATE_ID);	
	
ALTER TABLE F_REQUEST_CREATION_DT_METRICS ADD CONSTRAINT F_REQDT_FK15 FOREIGN KEY (PRIORITY_ID)
	REFERENCES D_REQUEST_PRIORITY (PRIORITY_ID);	

ALTER TABLE F_REQUEST_CREATION_DT_METRICS ADD CONSTRAINT F_REQDT_FK16 FOREIGN KEY (ITERATION_ID)
	REFERENCES D_ITERATION (ITERATION_ID);							

ALTER TABLE F_REQUEST_FAILURE_METRICS ADD CONSTRAINT F_REQFL_FK1 FOREIGN KEY (RELEASE_ID)
	REFERENCES D_RELEASE (RELEASE_ID);

ALTER TABLE F_REQUEST_FAILURE_METRICS ADD CONSTRAINT F_REQFL_FK2 FOREIGN KEY (COMPONENT_ID)
	REFERENCES D_COMPONENT (COMPONENT_ID);

ALTER TABLE F_REQUEST_FAILURE_METRICS ADD CONSTRAINT F_REQFL_FK3 FOREIGN KEY (PROJECT_ID)
	REFERENCES D_PROJECT (PROJECT_ID);

ALTER TABLE F_REQUEST_FAILURE_METRICS ADD CONSTRAINT F_REQFL_FK4 FOREIGN KEY (ITERATION_ID)
	REFERENCES D_ITERATION (ITERATION_ID);

ALTER TABLE F_REQUEST_FAILURE_METRICS ADD CONSTRAINT F_REQFL_FK5 FOREIGN KEY (DATE_ID)
	REFERENCES D_DATE (DATE_ID);			

ALTER TABLE H_REQUEST_FAILURE_METRICS ADD CONSTRAINT HREQFMETRIC_FK1 FOREIGN KEY (REQFAIL_METRIC_ID)
	REFERENCES F_REQUEST_FAILURE_METRICS (REQFAIL_METRIC_ID) ON DELETE CASCADE;

ALTER TABLE H_REQUEST_FAILURE_METRICS ADD CONSTRAINT HREQFMETRIC_FK2 FOREIGN KEY (REQUEST_ID)
	REFERENCES D_REQUEST (REQUEST_ID) ON DELETE CASCADE;

ALTER TABLE F_REQUIREMENT_METRICS ADD CONSTRAINT F_REQMET_FK1 FOREIGN KEY (DATE_ID)
	REFERENCES D_DATE (DATE_ID);

ALTER TABLE F_REQUIREMENT_METRICS ADD CONSTRAINT F_REQMET_FK2 FOREIGN KEY (PROJECT_ID)
	REFERENCES D_PROJECT (PROJECT_ID);

ALTER TABLE F_REQUIREMENT_METRICS ADD CONSTRAINT F_REQMET_FK3 FOREIGN KEY (ITERATION_ID)
	REFERENCES D_ITERATION (ITERATION_ID);

ALTER TABLE F_REQUIREMENT_METRICS ADD CONSTRAINT F_REQMET_FK4 FOREIGN KEY (STATE_ID)
	REFERENCES D_REQUIREMENT_STATE (STATE_ID);

ALTER TABLE F_REQUIREMENT_METRICS ADD CONSTRAINT F_REQMET_FK5 FOREIGN KEY (REQUIREMENT_CLASS_ID)
	REFERENCES D_REQUIREMENT_CLASSIFICATION (REQUIREMENT_CLASS_ID);

ALTER TABLE F_REQUIREMENT_METRICS ADD CONSTRAINT F_REQMET_FK6 FOREIGN KEY (STATUS_ID)
	REFERENCES D_STATUS (STATUS_ID);

ALTER TABLE F_REQUIREMENT_METRICS ADD CONSTRAINT F_REQMET_FK7 FOREIGN KEY (STABILITY_ID)
	REFERENCES D_STABILITY (STABILITY_ID);

ALTER TABLE F_REQUIREMENT_METRICS ADD CONSTRAINT F_REQMET_FK8 FOREIGN KEY (DIFFICULTY_ID)
	REFERENCES D_DIFFICULTY (DIFFICULTY_ID);
	
ALTER TABLE F_REQUIREMENT_METRICS ADD CONSTRAINT F_REQMET_FK11 FOREIGN KEY (COMPONENT_ID)
	REFERENCES D_COMPONENT (COMPONENT_ID);	

ALTER TABLE F_REQUIREMENT_METRICS ADD CONSTRAINT F_REQMET_FK12 FOREIGN KEY (RESOURCE_ID)
	REFERENCES D_RESOURCE (RESOURCE_ID);	
	
ALTER TABLE F_REQUIREMENT_METRICS ADD CONSTRAINT F_REQMET_FK13 FOREIGN KEY (PRIORITY_ID)
	REFERENCES D_PRIORITY (PRIORITY_ID);	
	
ALTER TABLE F_REQUIREMENT_METRICS ADD CONSTRAINT F_REQMET_FK14 FOREIGN KEY (REQUIREMENT_TYPE_ID)
	REFERENCES D_REQUIREMENT_TYPE (REQUIREMENT_TYPE_ID);	
			
ALTER TABLE H_REQUIREMENT_METRICS_TOTAL ADD CONSTRAINT HREQUIMETTOT_FK1 FOREIGN KEY (REQ_METRIC_ID)
	REFERENCES F_REQUIREMENT_METRICS (REQ_METRIC_ID) ON DELETE CASCADE;

ALTER TABLE H_REQUIREMENT_METRICS_TOTAL ADD CONSTRAINT HREQUIMETTOT_FK2 FOREIGN KEY (REQUIREMENT_ID)
	REFERENCES D_REQUIREMENT (REQUIREMENT_ID) ON DELETE CASCADE;
	
ALTER TABLE H_REQUIREMENT_METRICS_CHANGES ADD CONSTRAINT HREQUIMETCH_FK1 FOREIGN KEY (REQ_METRIC_ID)
	REFERENCES F_REQUIREMENT_METRICS (REQ_METRIC_ID) ON DELETE CASCADE;

ALTER TABLE H_REQUIREMENT_METRICS_CHANGES ADD CONSTRAINT HREQUIMETCH_FK2 FOREIGN KEY (REQUIREMENT_ID)
	REFERENCES D_REQUIREMENT (REQUIREMENT_ID) ON DELETE CASCADE;	

ALTER TABLE F_EXECUTION_WORKITEM_METRICS ADD CONSTRAINT F_CFGTST_FK1 FOREIGN KEY (DATE_ID)
	REFERENCES D_DATE (DATE_ID);

ALTER TABLE F_EXECUTION_WORKITEM_METRICS ADD CONSTRAINT F_CFGTST_FK2 FOREIGN KEY (PROJECT_ID)
	REFERENCES D_PROJECT (PROJECT_ID);

ALTER TABLE F_EXECUTION_WORKITEM_METRICS ADD CONSTRAINT F_CFGTST_FK4 FOREIGN KEY (TESTPLAN_ID)
	REFERENCES D_TESTPLAN (TESTPLAN_ID);

ALTER TABLE F_EXECUTION_WORKITEM_METRICS ADD CONSTRAINT F_CFGTST_FK5 FOREIGN KEY (VERDICT_ID)
	REFERENCES D_VERDICT (VERDICT_ID);

ALTER TABLE F_EXECUTION_WORKITEM_METRICS ADD CONSTRAINT F_CFGTST_FK6 FOREIGN KEY (EXECWORKIT_CLASS_ID)
	REFERENCES D_EXECWORKITEM_CLASSIFICATION (EXECWORKIT_CLASS_ID);
	
ALTER TABLE F_EXECUTION_WORKITEM_METRICS ADD CONSTRAINT F_CFGTST_FK7 FOREIGN KEY (CONFIGURATION_ID)
	REFERENCES D_CONFIGURATION (CONFIGURATION_ID);	

ALTER TABLE H_EXECUTION_WORKITEM_METRICS ADD CONSTRAINT HEXECWKMETRIC_FK1 FOREIGN KEY (EXECWORKITEM_METRIC_ID)
	REFERENCES F_EXECUTION_WORKITEM_METRICS (EXECWORKITEM_METRIC_ID) ON DELETE CASCADE;

ALTER TABLE H_EXECUTION_WORKITEM_METRICS ADD CONSTRAINT HEXECWKMETRIC_FK2 FOREIGN KEY (EXECWORKITEM_ID)
	REFERENCES D_EXECUTION_WORKITEM (EXECWORKITEM_ID) ON DELETE CASCADE;	

ALTER TABLE F_TESTCASE_METRICS ADD CONSTRAINT F_TSTCASE_FK1 FOREIGN KEY (DATE_ID)
	REFERENCES D_DATE (DATE_ID);

ALTER TABLE F_TESTCASE_METRICS ADD CONSTRAINT F_TSTCASE_FK5 FOREIGN KEY (TESTPLAN_ID)
	REFERENCES D_TESTPLAN (TESTPLAN_ID);

ALTER TABLE F_TESTCASE_METRICS ADD CONSTRAINT F_TSTCASE_FK7 FOREIGN KEY (TESTCASE_CLASS_ID)
	REFERENCES D_TESTCASE_CLASSIFICATION (TESTCASE_CLASS_ID);		
	
ALTER TABLE F_TESTCASE_METRICS ADD CONSTRAINT F_TSTCASE_FK8 FOREIGN KEY (STATE_ID)
	REFERENCES D_TESTCASE_STATE (STATE_ID);	
	
ALTER TABLE F_TESTCASE_METRICS ADD CONSTRAINT F_TSTCASE_FK9 FOREIGN KEY (PROJECT_ID)
	REFERENCES D_PROJECT (PROJECT_ID);	
	
ALTER TABLE F_PROJ_TESTCASE_TPLN_METRICS ADD CONSTRAINT F_PTSTCASEPLN_FK1 FOREIGN KEY (DATE_ID)
	REFERENCES D_DATE (DATE_ID);

ALTER TABLE F_PROJ_TESTCASE_TPLN_METRICS ADD CONSTRAINT F_PTSTCASEPLN_FK2 FOREIGN KEY (TESTPLAN_ID)
	REFERENCES D_TESTPLAN (TESTPLAN_ID);

ALTER TABLE F_PROJ_TESTCASE_TPLN_METRICS ADD CONSTRAINT F_PTSTCASEPLN_FK3 FOREIGN KEY (TESTCASE_CLASS_ID)
	REFERENCES D_TESTCASE_CLASSIFICATION (TESTCASE_CLASS_ID);		
	
ALTER TABLE F_PROJ_TESTCASE_TPLN_METRICS ADD CONSTRAINT F_PTSTCASEPLN_FK4 FOREIGN KEY (STATE_ID)
	REFERENCES D_TESTCASE_STATE (STATE_ID);	
	
ALTER TABLE F_PROJ_TESTCASE_TPLN_METRICS ADD CONSTRAINT F_PTSTCASEPLN_FK5 FOREIGN KEY (PROJECT_ID)
	REFERENCES D_PROJECT (PROJECT_ID);	

ALTER TABLE F_C_PROJ_TESTCASE_TPLN_METRICS ADD CONSTRAINT F_CPTSTCASEPL_FK1 FOREIGN KEY (DATE_ID)
	REFERENCES D_DATE (DATE_ID);

ALTER TABLE F_C_PROJ_TESTCASE_TPLN_METRICS ADD CONSTRAINT F_CPTSTCASEPL_FK2 FOREIGN KEY (TESTPLAN_ID)
	REFERENCES D_TESTPLAN (TESTPLAN_ID);

ALTER TABLE F_C_PROJ_TESTCASE_TPLN_METRICS ADD CONSTRAINT F_CPTSTCASEPL_FK3 FOREIGN KEY (TESTCASE_CLASS_ID)
	REFERENCES D_TESTCASE_CLASSIFICATION (TESTCASE_CLASS_ID);		
	
ALTER TABLE F_C_PROJ_TESTCASE_TPLN_METRICS ADD CONSTRAINT F_CPTSTCASEPL_FK4 FOREIGN KEY (STATE_ID)
	REFERENCES D_TESTCASE_STATE (STATE_ID);	
	
ALTER TABLE F_C_PROJ_TESTCASE_TPLN_METRICS ADD CONSTRAINT F_CPTSTCASEPL_FK5 FOREIGN KEY (PROJECT_ID)
	REFERENCES D_PROJECT (PROJECT_ID);

ALTER TABLE F_PROJ_TESTCASE_METRICS ADD CONSTRAINT F_PTSTCASE_FK1 FOREIGN KEY (DATE_ID)
	REFERENCES D_DATE (DATE_ID);

ALTER TABLE F_PROJ_TESTCASE_METRICS ADD CONSTRAINT F_PTSTCASE_FK2 FOREIGN KEY (TESTCASE_CLASS_ID)
	REFERENCES D_TESTCASE_CLASSIFICATION (TESTCASE_CLASS_ID);		
	
ALTER TABLE F_PROJ_TESTCASE_METRICS ADD CONSTRAINT F_PTSTCASE_FK3 FOREIGN KEY (STATE_ID)
	REFERENCES D_TESTCASE_STATE (STATE_ID);	
	
ALTER TABLE F_PROJ_TESTCASE_METRICS ADD CONSTRAINT F_PTSTCASE_FK4 FOREIGN KEY (PROJECT_ID)
	REFERENCES D_PROJECT (PROJECT_ID);	
	
ALTER TABLE F_C_PROJ_TESTCASE_METRICS ADD CONSTRAINT F_CPTSTCASE_FK1 FOREIGN KEY (DATE_ID)
	REFERENCES D_DATE (DATE_ID);

ALTER TABLE F_C_PROJ_TESTCASE_METRICS ADD CONSTRAINT F_CPTSTCASE_FK2 FOREIGN KEY (TESTCASE_CLASS_ID)
	REFERENCES D_TESTCASE_CLASSIFICATION (TESTCASE_CLASS_ID);		
	
ALTER TABLE F_C_PROJ_TESTCASE_METRICS ADD CONSTRAINT F_CPTSTCASE_FK3 FOREIGN KEY (STATE_ID)
	REFERENCES D_TESTCASE_STATE (STATE_ID);	
	
ALTER TABLE F_C_PROJ_TESTCASE_METRICS ADD CONSTRAINT F_CPTSTCASE_FK4 FOREIGN KEY (PROJECT_ID)
	REFERENCES D_PROJECT (PROJECT_ID);	
			
ALTER TABLE H_TESTCASE_METRICS ADD CONSTRAINT HTSTCMETRIC_FK1 FOREIGN KEY (TSTCASE_METRIC_ID)
	REFERENCES F_TESTCASE_METRICS (TSTCASE_METRIC_ID) ON DELETE CASCADE;

ALTER TABLE H_TESTCASE_METRICS ADD CONSTRAINT HTSTCMETRIC_FK2 FOREIGN KEY (TESTCASE_ID)
	REFERENCES D_TESTCASE (TESTCASE_ID) ON DELETE CASCADE;

ALTER TABLE H_PROJ_TESTCASE_TPLN_METRICS ADD CONSTRAINT HPTSTCASEPLN_FK1 FOREIGN KEY (TSTCASE_METRIC_ID)
	REFERENCES F_PROJ_TESTCASE_TPLN_METRICS (TSTCASE_METRIC_ID) ON DELETE CASCADE;

ALTER TABLE H_PROJ_TESTCASE_TPLN_METRICS ADD CONSTRAINT HPTSTCASEPLN_FK2 FOREIGN KEY (TESTCASE_ID)
	REFERENCES D_TESTCASE (TESTCASE_ID) ON DELETE CASCADE;		

ALTER TABLE H_PROJ_TESTCASE_METRICS ADD CONSTRAINT HPTSTCASE_FK1 FOREIGN KEY (TSTCASE_METRIC_ID)
	REFERENCES F_PROJ_TESTCASE_METRICS (TSTCASE_METRIC_ID) ON DELETE CASCADE;

ALTER TABLE H_PROJ_TESTCASE_METRICS ADD CONSTRAINT HPTSTCASE_FK2 FOREIGN KEY (TESTCASE_ID)
	REFERENCES D_TESTCASE (TESTCASE_ID) ON DELETE CASCADE;
	
ALTER TABLE H_BUILD_ATTEMPTS ADD CONSTRAINT HBLDATTE_FK1 FOREIGN KEY (BUILD_METRIC_ID)
	REFERENCES F_BUILD_METRICS (BUILD_METRIC_ID) ON DELETE CASCADE;

ALTER TABLE H_BUILD_ATTEMPTS ADD CONSTRAINT HBLDATTE_FK2 FOREIGN KEY (BUILD_ID)
	REFERENCES D_BUILD (BUILD_ID) ON DELETE CASCADE;
	
ALTER TABLE H_BUILD_PASS ADD CONSTRAINT HBLDPAS_FK1 FOREIGN KEY (BUILD_METRIC_ID)
	REFERENCES F_BUILD_METRICS (BUILD_METRIC_ID) ON DELETE CASCADE;

ALTER TABLE H_BUILD_PASS ADD CONSTRAINT HBLDPAS_FK2 FOREIGN KEY (BUILD_ID)
	REFERENCES D_BUILD (BUILD_ID) ON DELETE CASCADE;	
	
ALTER TABLE H_BUILD_FAIL ADD CONSTRAINT HBLDFAIL_FK1 FOREIGN KEY (BUILD_METRIC_ID)
	REFERENCES F_BUILD_METRICS (BUILD_METRIC_ID) ON DELETE CASCADE;

ALTER TABLE H_BUILD_FAIL ADD CONSTRAINT HBLDFAIL_FK2 FOREIGN KEY (BUILD_ID)
	REFERENCES D_BUILD (BUILD_ID) ON DELETE CASCADE;	

ALTER TABLE F_CHILDREQUIREMENT_METRICS ADD CONSTRAINT F_CHREQM_FK1 FOREIGN KEY (DATE_ID)
	REFERENCES D_DATE (DATE_ID);

ALTER TABLE F_CHILDREQUIREMENT_METRICS ADD CONSTRAINT F_CHREQM_FK2 FOREIGN KEY (PROJECT_ID)
	REFERENCES D_PROJECT (PROJECT_ID);

ALTER TABLE F_CHILDREQUIREMENT_METRICS ADD CONSTRAINT F_CHREQM_FK3 FOREIGN KEY (ITERATION_ID)
	REFERENCES D_ITERATION (ITERATION_ID);

ALTER TABLE F_CHILDREQUIREMENT_METRICS ADD CONSTRAINT F_CHREQM_FK4 FOREIGN KEY (RELEASE_ID)
	REFERENCES D_RELEASE (RELEASE_ID);

ALTER TABLE F_CHILDREQUIREMENT_METRICS ADD CONSTRAINT F_CHREQM_FK5 FOREIGN KEY (PARENT_REQUIREMENT_ID)
	REFERENCES D_REQUIREMENT (REQUIREMENT_ID);
	
ALTER TABLE F_CHILDREQUIREMENT_METRICS ADD CONSTRAINT F_CHREQM_FK6 FOREIGN KEY (COMPONENT_ID)
	REFERENCES D_COMPONENT (COMPONENT_ID);	
	
ALTER TABLE F_CHILDREQUIREMENT_METRICS ADD CONSTRAINT F_CHREQM_FK7 FOREIGN KEY (REQUIREMENT_CLASS_ID)
	REFERENCES D_REQUIREMENT_CLASSIFICATION (REQUIREMENT_CLASS_ID);	

ALTER TABLE F_CHILDREQUIREMENT_METRICS ADD CONSTRAINT F_CHREQM_FK8 FOREIGN KEY (REQUIREMENT_TYPE_ID)  
  REFERENCES D_REQUIREMENT_TYPE (REQUIREMENT_TYPE_ID);
		
ALTER TABLE F_PROJECT_PERFORMANCE_METRICS ADD CONSTRAINT F_PPM_FK1 FOREIGN KEY (DATE_ID)
	REFERENCES D_DATE (DATE_ID);
	
ALTER TABLE F_PROJECT_PERFORMANCE_METRICS ADD CONSTRAINT F_PPM_FK2 FOREIGN KEY (PROJECT_ID)
	REFERENCES D_PROJECT (PROJECT_ID);

ALTER TABLE F_BUILD_METRICS ADD CONSTRAINT F_BUILD_FK1 FOREIGN KEY (DATE_ID)
	REFERENCES D_DATE (DATE_ID);

ALTER TABLE F_BUILD_METRICS ADD CONSTRAINT F_BUILD_FK2 FOREIGN KEY (PROJECT_ID)
	REFERENCES D_PROJECT (PROJECT_ID);

ALTER TABLE F_BUILD_METRICS ADD CONSTRAINT F_BUILD_FK5 FOREIGN KEY (COMPONENT_ID)
	REFERENCES D_COMPONENT (COMPONENT_ID);

ALTER TABLE F_BUILD_METRICS ADD CONSTRAINT F_BUILD_FK7 FOREIGN KEY (BUILD_TYPE_ID)
	REFERENCES D_BUILD_TYPE (BUILD_TYPE_ID);
	
ALTER TABLE F_BUILD_METRICS ADD CONSTRAINT F_BUILD_FK8 FOREIGN KEY (BUILD_CLASS_ID)
	REFERENCES D_BUILD_CLASSIFICATION (BUILD_CLASS_ID);
		
ALTER TABLE H_REQUEST_CLOSURE_DATE_METRICS ADD CONSTRAINT H_REQCLD_FK1 FOREIGN KEY (REQCDT_METRIC_ID)
	REFERENCES F_REQUEST_CLOSURE_DATE_METRICS (REQCDT_METRIC_ID) ON DELETE CASCADE;

ALTER TABLE H_REQUEST_CLOSURE_DATE_METRICS ADD CONSTRAINT H_REQCLD_FK2 FOREIGN KEY (REQUEST_ID)
	REFERENCES D_REQUEST (REQUEST_ID) ON DELETE CASCADE;

ALTER TABLE H_REQUEST_CREATION_DT_METRICS ADD CONSTRAINT H_REQDT_FK1 FOREIGN KEY (REQDT_METRIC_ID)
	REFERENCES F_REQUEST_CREATION_DT_METRICS (REQDT_METRIC_ID) ON DELETE CASCADE;

ALTER TABLE H_REQUEST_CREATION_DT_METRICS ADD CONSTRAINT H_REQDT_FK2 FOREIGN KEY (REQUEST_ID)
	REFERENCES D_REQUEST (REQUEST_ID) ON DELETE CASCADE;

ALTER TABLE H_EXECUTION_RESULT_METRICS ADD CONSTRAINT H_EXERES_FK1 FOREIGN KEY (EXERES_METRICS_ID)
	REFERENCES F_EXECUTION_RESULT_METRICS (EXERES_METRICS_ID) ON DELETE CASCADE;

ALTER TABLE H_EXECUTION_RESULT_METRICS ADD CONSTRAINT H_EXERES_FK2 FOREIGN KEY (EXECUTION_RESULT_ID)
	REFERENCES D_EXECUTION_RESULT(EXECUTION_RESULT_ID) ON DELETE CASCADE;

ALTER TABLE H_CHILDREQUIREMENT_METRICS ADD CONSTRAINT H_CHREQ_FK1 FOREIGN KEY (CHILDREQ_METRICS_ID)
	REFERENCES F_CHILDREQUIREMENT_METRICS  (CHILDREQ_METRICS_ID) ON DELETE CASCADE;

ALTER TABLE H_CHILDREQUIREMENT_METRICS ADD CONSTRAINT H_CHREQ_FK2 FOREIGN KEY (REQUIREMENT_ID)
	REFERENCES D_REQUIREMENT(REQUIREMENT_ID) ON DELETE CASCADE;
	
ALTER TABLE F_EXECRESULT_DATE_METRICS ADD CONSTRAINT F_EXECRESDT_FK1 FOREIGN KEY (TESTCASE_ID)
	REFERENCES D_TESTCASE (TESTCASE_ID);
	
ALTER TABLE F_EXECRESULT_DATE_METRICS ADD CONSTRAINT F_EXECRESDT_FK2 FOREIGN KEY (COMPONENT_ID)
	REFERENCES D_COMPONENT (COMPONENT_ID);	
	
ALTER TABLE F_EXECRESULT_DATE_METRICS ADD CONSTRAINT F_EXECRESDT_FK4 FOREIGN KEY (DAY_OF_ID)
	REFERENCES D_DATE (DATE_ID);	

ALTER TABLE F_EXECRESULT_DATE_METRICS ADD CONSTRAINT F_EXECRESDT_FK5 FOREIGN KEY (EXECRES_CLASS_ID)
	REFERENCES D_EXECRESULT_CLASSIFICATION (EXECRES_CLASS_ID);	
	
ALTER TABLE F_EXECRESULT_DATE_METRICS ADD CONSTRAINT F_EXECRESDT_FK6 FOREIGN KEY (TESTPLAN_ID)
	REFERENCES D_TESTPLAN (TESTPLAN_ID);		
	
ALTER TABLE F_EXECRESULT_DATE_METRICS ADD CONSTRAINT F_EXECRESDT_FK7 FOREIGN KEY (PROJECT_ID)
	REFERENCES D_PROJECT (PROJECT_ID);			
		
ALTER TABLE F_ACTIVITY_METRICS ADD CONSTRAINT F_ACTM_FK1 FOREIGN KEY (ACTIVITY_CLASS_ID)
	REFERENCES D_ACTIVITY_CLASSIFICATION (ACTIVITY_CLASS_ID);
	
ALTER TABLE F_ACTIVITY_METRICS ADD CONSTRAINT F_ACTM_FK2 FOREIGN KEY (DATE_ID)
	REFERENCES D_DATE (DATE_ID);	
	
ALTER TABLE F_ACTIVITY_METRICS ADD CONSTRAINT F_ACTM_FK4 FOREIGN KEY (RESOURCE_ID)
	REFERENCES D_RESOURCE (RESOURCE_ID);	

ALTER TABLE F_ACTIVITY_METRICS ADD CONSTRAINT F_ACTM_FK5 FOREIGN KEY (PROJECT_ID)
	REFERENCES D_PROJECT (PROJECT_ID);			

ALTER TABLE F_ACTIVITY_METRICS ADD CONSTRAINT F_ACTM_FK7 FOREIGN KEY (STATE_ID)
	REFERENCES D_ACTIVITY_STATE (STATE_ID);			
		 
ALTER TABLE F_ACTIVITY_METRICS ADD CONSTRAINT F_ACTM_FK8 FOREIGN KEY (PRIORITY_ID)
	REFERENCES D_PRIORITY (PRIORITY_ID);	 
		
ALTER TABLE  H_ACTIVITY_METRICS ADD CONSTRAINT H_ACTM_STATE_FK1 FOREIGN KEY (ACTIVITY_METRICS_ID)
		REFERENCES F_ACTIVITY_METRICS (ACTIVITY_METRICS_ID) ON DELETE CASCADE;
		
ALTER TABLE  H_ACTIVITY_METRICS ADD CONSTRAINT H_ACTM_STATE_FK2 FOREIGN KEY (ACTIVITY_ID)
		REFERENCES D_ACTIVITY (ACTIVITY_ID) ON DELETE CASCADE;	
		
ALTER TABLE F_ACTIVITY_CREATION_DT_METRICS ADD CONSTRAINT	F_ACTCRDM_FK1 FOREIGN KEY (ACTIVITY_CLASS_ID)
		REFERENCES D_ACTIVITY_CLASSIFICATION (ACTIVITY_CLASS_ID);	
		
ALTER TABLE F_ACTIVITY_CREATION_DT_METRICS ADD CONSTRAINT	F_ACTCRDM_FK2 FOREIGN KEY (STATE_ID)
		REFERENCES D_ACTIVITY_STATE (STATE_ID);	
		
ALTER TABLE F_ACTIVITY_CREATION_DT_METRICS ADD CONSTRAINT	F_ACTCRDM_FK3 FOREIGN KEY (PROJECT_ID)
		REFERENCES D_PROJECT (PROJECT_ID);	
		
ALTER TABLE F_ACTIVITY_CREATION_DT_METRICS ADD CONSTRAINT	F_ACTCRDM_FK5 FOREIGN KEY (RESOURCE_ID)
		REFERENCES D_RESOURCE (RESOURCE_ID);	
		
ALTER TABLE F_ACTIVITY_CREATION_DT_METRICS ADD CONSTRAINT	F_ACTCRDM_FK6 FOREIGN KEY (PRIORITY_ID)
		REFERENCES D_PRIORITY (PRIORITY_ID);					

ALTER TABLE H_ACTIVITY_CREATION_DT_METRICS ADD CONSTRAINT	H_ACTCRDM_FK1 FOREIGN KEY (ACTIVITYCRD_METRICS_ID)
		REFERENCES F_ACTIVITY_CREATION_DT_METRICS (ACTIVITYCRD_METRICS_ID)  ON DELETE CASCADE;	
		
ALTER TABLE H_ACTIVITY_CREATION_DT_METRICS ADD CONSTRAINT	H_ACTCRDM_FK2 FOREIGN KEY (ACTIVITY_ID)
		REFERENCES D_ACTIVITY (ACTIVITY_ID) ON DELETE CASCADE;	

ALTER TABLE F_EXECRESPOINTS_METRICS ADD CONSTRAINT F_EXECPTS_FK2 FOREIGN KEY (DATE_ID)
	REFERENCES D_DATE (DATE_ID);
	
ALTER TABLE F_EXECRESPOINTS_METRICS ADD CONSTRAINT F_EXECPTS_FK3 FOREIGN KEY (TESTPLAN_ID)
	REFERENCES D_TESTPLAN (TESTPLAN_ID);	

ALTER TABLE F_EXECRESPOINTS_METRICS ADD CONSTRAINT F_EXECPTS_FK4 FOREIGN KEY (TESTCASE_ID)
	REFERENCES D_TESTCASE (TESTCASE_ID);	
	
ALTER TABLE F_EXECRESPOINTS_METRICS ADD CONSTRAINT F_EXECPTS_FK5 FOREIGN KEY (EXECRES_CLASS_ID)
	REFERENCES D_EXECRESULT_CLASSIFICATION (EXECRES_CLASS_ID);	

ALTER TABLE F_EXECRESPOINTS_METRICS ADD CONSTRAINT F_EXECPTS_FK6 FOREIGN KEY (VERDICT_ID)
	REFERENCES D_VERDICT (VERDICT_ID);	
	
ALTER TABLE F_EXECRESPOINTS_METRICS ADD CONSTRAINT F_EXECPTS_FK7 FOREIGN KEY (PROJECT_ID)
	REFERENCES D_PROJECT (PROJECT_ID);		

ALTER TABLE H_EXECRESPOINTS_METRICS ADD CONSTRAINT H_EXECPTS_FK1 FOREIGN KEY (EXECRES_METRIC_ID)
	REFERENCES F_EXECRESPOINTS_METRICS (EXECRES_METRIC_ID) ON DELETE CASCADE;

ALTER TABLE H_EXECRESPOINTS_METRICS ADD CONSTRAINT H_EXECPTS_FK2 FOREIGN KEY (EXECUTION_RESULT_ID)
	REFERENCES D_EXECUTION_RESULT (EXECUTION_RESULT_ID) ON DELETE CASCADE;												

ALTER TABLE F_REQUEST_TURNAROUND ADD CONSTRAINT F_REQTURN_FK1 FOREIGN KEY (REQUEST_CLASS_ID)
		REFERENCES D_REQUEST_CLASSIFICATION (REQUEST_CLASS_ID);        
		        
ALTER TABLE F_REQUEST_TURNAROUND ADD CONSTRAINT F_REQTURN_FK2 FOREIGN KEY (PROJECT_ID)      
		REFERENCES D_PROJECT (PROJECT_ID);         
		                
ALTER TABLE F_REQUEST_TURNAROUND ADD CONSTRAINT F_REQTURN_FK4 FOREIGN KEY (COMPONENT_ID)    
		REFERENCES D_COMPONENT (COMPONENT_ID); 
		                
ALTER TABLE F_REQUEST_TURNAROUND ADD CONSTRAINT F_REQTURN_FK5 FOREIGN KEY (RESOURCE_ID)     
		REFERENCES D_RESOURCE(RESOURCE_ID); 
		                
ALTER TABLE F_REQUEST_TURNAROUND ADD CONSTRAINT F_REQTURN_FK6 FOREIGN KEY (SEVERITY_ID)    
		REFERENCES D_REQUEST_SEVERITY (SEVERITY_ID); 
		                
ALTER TABLE F_REQUEST_TURNAROUND ADD CONSTRAINT F_REQTURN_FK7 FOREIGN KEY (PRIORITY_ID)     
		REFERENCES D_REQUEST_PRIORITY (PRIORITY_ID); 
		                
ALTER TABLE F_REQUEST_TURNAROUND ADD CONSTRAINT F_REQTURN_FK8 FOREIGN KEY (ITERATION_ID)    
		REFERENCES D_ITERATION (ITERATION_ID); 
		                
ALTER TABLE F_REQUEST_TURNAROUND ADD CONSTRAINT F_REQTURN_FK9 FOREIGN KEY (DATE_ID)         
		REFERENCES D_DATE (DATE_ID); 

ALTER TABLE F_REQUEST_TURNAROUND ADD CONSTRAINT F_REQTURN_FK10 FOREIGN KEY (REQUEST_TYPE_ID)         
		REFERENCES D_REQUEST_TYPE (REQUEST_TYPE_ID); 
		
ALTER TABLE H_REQUEST_TURNAROUND_TOTAL ADD CONSTRAINT H_REQTURNTOT_FK1 FOREIGN KEY (TURNAROUND_METRIC_ID)
		REFERENCES F_REQUEST_TURNAROUND (TURNAROUND_METRIC_ID) ON DELETE CASCADE;

ALTER TABLE H_REQUEST_TURNAROUND_TOTAL ADD CONSTRAINT H_REQTURNTOT_FK2 FOREIGN KEY (REQUEST_ID)
		REFERENCES D_REQUEST (REQUEST_ID) ON DELETE CASCADE;
		
ALTER TABLE H_REQUEST_TURNAROUND_MIN ADD CONSTRAINT H_REQTURNMIN_FK1 FOREIGN KEY (TURNAROUND_METRIC_ID)
		REFERENCES F_REQUEST_TURNAROUND (TURNAROUND_METRIC_ID) ON DELETE CASCADE;

ALTER TABLE H_REQUEST_TURNAROUND_MIN ADD CONSTRAINT H_REQTURNMIN_FK2 FOREIGN KEY (REQUEST_ID)
		REFERENCES D_REQUEST (REQUEST_ID)  ON DELETE CASCADE;

ALTER TABLE H_REQUEST_TURNAROUND_MAX ADD CONSTRAINT H_REQTURNMAX_FK1 FOREIGN KEY (TURNAROUND_METRIC_ID)
		REFERENCES F_REQUEST_TURNAROUND (TURNAROUND_METRIC_ID)  ON DELETE CASCADE;

ALTER TABLE H_REQUEST_TURNAROUND_MAX ADD CONSTRAINT H_REQTURNMAX_FK2 FOREIGN KEY (REQUEST_ID)
		REFERENCES D_REQUEST (REQUEST_ID) ON DELETE CASCADE;
		
ALTER TABLE F_TASK_METRICS ADD CONSTRAINT F_TSKMET_FK1 FOREIGN KEY (TASK_CLASS_ID)
		REFERENCES D_TASK_CLASSIFICATION (TASK_CLASS_ID);
		
ALTER TABLE F_TASK_METRICS ADD CONSTRAINT F_TSKMET_FK2 FOREIGN KEY (DATE_ID)
		REFERENCES D_DATE (DATE_ID);		
		
ALTER TABLE F_TASK_METRICS ADD CONSTRAINT F_TSKMET_FK3 FOREIGN KEY (RESOURCE_ID)
		REFERENCES D_RESOURCE (RESOURCE_ID);			

ALTER TABLE F_TASK_METRICS ADD CONSTRAINT F_TSKMET_FK4 FOREIGN KEY (PROJECT_ID)
		REFERENCES D_PROJECT (PROJECT_ID);		
		
ALTER TABLE F_TASK_METRICS ADD CONSTRAINT F_TSKMET_FK6 FOREIGN KEY (STATE_ID)
		REFERENCES D_TASK_STATE (STATE_ID);			
		
ALTER TABLE F_TASK_METRICS ADD CONSTRAINT F_TSKMET_FK7 FOREIGN KEY (PRIORITY_ID)
		REFERENCES D_PRIORITY (PRIORITY_ID);							
	
ALTER TABLE F_TASK_METRICS ADD CONSTRAINT F_TSKMET_FK8 FOREIGN KEY (ITERATION_ID)
		REFERENCES D_ITERATION (ITERATION_ID);	
		
ALTER TABLE F_TASK_METRICS ADD CONSTRAINT F_TSKMET_FK9 FOREIGN KEY (TASK_TYPE_ID)
		REFERENCES D_TASK_TYPE (TASK_TYPE_ID);			
		
ALTER TABLE H_TASK_METRICS ADD CONSTRAINT H_TSKMET_FK1 FOREIGN KEY (TASK_METRICS_ID)
		REFERENCES F_TASK_METRICS (TASK_METRICS_ID) ON DELETE CASCADE;

ALTER TABLE H_TASK_METRICS ADD CONSTRAINT H_TSKMET_FK2 FOREIGN KEY (TASK_ID)
		REFERENCES D_TASK (TASK_ID) ON DELETE CASCADE;

ALTER TABLE F_TASK_CREATION_DT_METRICS ADD CONSTRAINT F_TSKCRDTMET_FK1 FOREIGN KEY (TASK_CLASS_ID)
		REFERENCES D_TASK_CLASSIFICATION (TASK_CLASS_ID);
		
ALTER TABLE F_TASK_CREATION_DT_METRICS ADD CONSTRAINT F_TSKCRDTMET_FK2 FOREIGN KEY (CREATION_DATE_ID)
		REFERENCES D_DATE (DATE_ID);		
		
ALTER TABLE F_TASK_CREATION_DT_METRICS ADD CONSTRAINT F_TSKCRDTMET_FK3 FOREIGN KEY (RESOURCE_ID)
		REFERENCES D_RESOURCE (RESOURCE_ID);			

ALTER TABLE F_TASK_CREATION_DT_METRICS ADD CONSTRAINT F_TSKCRDTMET_FK4 FOREIGN KEY (PROJECT_ID)
		REFERENCES D_PROJECT (PROJECT_ID);				
		
ALTER TABLE F_TASK_CREATION_DT_METRICS ADD CONSTRAINT F_TSKCRDTMET_FK6 FOREIGN KEY (STATE_ID)
		REFERENCES D_TASK_STATE (STATE_ID);			
		
ALTER TABLE F_TASK_CREATION_DT_METRICS ADD CONSTRAINT F_TSKCRDTMET_FK7 FOREIGN KEY (PRIORITY_ID)
		REFERENCES D_PRIORITY (PRIORITY_ID);							
	
ALTER TABLE F_TASK_CREATION_DT_METRICS ADD CONSTRAINT F_TSKCRDTMET_FK8 FOREIGN KEY (ITERATION_ID)
		REFERENCES D_ITERATION (ITERATION_ID);	
		
ALTER TABLE F_TASK_CREATION_DT_METRICS ADD CONSTRAINT F_TSKCRDTMET_FK9 FOREIGN KEY (TASK_TYPE_ID)
		REFERENCES D_TASK_TYPE (TASK_TYPE_ID);			

ALTER TABLE H_TASK_CREATION_DT_METRICS ADD CONSTRAINT H_TSKCRDTMET_FK1 FOREIGN KEY (TASKCRD_METRICS_ID)
		REFERENCES F_TASK_CREATION_DT_METRICS (TASKCRD_METRICS_ID) ON DELETE CASCADE;

ALTER TABLE H_TASK_CREATION_DT_METRICS ADD CONSTRAINT H_TSKCRDTMET_FK2 FOREIGN KEY (TASK_ID)
		REFERENCES D_TASK (TASK_ID) ON DELETE CASCADE;	

ALTER TABLE F_TASK_CLOSURE_DT_METRICS ADD CONSTRAINT F_TSKCLDTMET_FK1 FOREIGN KEY (TASK_CLASS_ID)
		REFERENCES D_TASK_CLASSIFICATION (TASK_CLASS_ID);
		
ALTER TABLE F_TASK_CLOSURE_DT_METRICS ADD CONSTRAINT F_TSKCLDTMET_FK2 FOREIGN KEY (CLOSURE_DATE_ID)
		REFERENCES D_DATE (DATE_ID);		
		
ALTER TABLE F_TASK_CLOSURE_DT_METRICS ADD CONSTRAINT F_TSKCLDTMET_FK3 FOREIGN KEY (RESOURCE_ID)
		REFERENCES D_RESOURCE (RESOURCE_ID);			

ALTER TABLE F_TASK_CLOSURE_DT_METRICS ADD CONSTRAINT F_TSKCLDTMET_FK4 FOREIGN KEY (PROJECT_ID)
		REFERENCES D_PROJECT (PROJECT_ID);			
		
ALTER TABLE F_TASK_CLOSURE_DT_METRICS ADD CONSTRAINT F_TSKCLDTMET_FK6 FOREIGN KEY (STATE_ID)
		REFERENCES D_TASK_STATE (STATE_ID);			
		
ALTER TABLE F_TASK_CLOSURE_DT_METRICS ADD CONSTRAINT F_TSKCLDTMET_FK7 FOREIGN KEY (PRIORITY_ID)
		REFERENCES D_PRIORITY (PRIORITY_ID);							
	
ALTER TABLE F_TASK_CLOSURE_DT_METRICS ADD CONSTRAINT F_TSKCLDTMET_FK8 FOREIGN KEY (ITERATION_ID)
		REFERENCES D_ITERATION (ITERATION_ID);	
		
ALTER TABLE F_TASK_CLOSURE_DT_METRICS ADD CONSTRAINT F_TSKCLDTMET_FK9 FOREIGN KEY (TASK_TYPE_ID)
		REFERENCES D_TASK_TYPE (TASK_TYPE_ID);			
		
ALTER TABLE H_TASK_CLOSURE_DT_METRICS ADD CONSTRAINT H_TSKCLDTMET_FK1 FOREIGN KEY (TASKCLS_METRICS_ID)
		REFERENCES F_TASK_CLOSURE_DT_METRICS (TASKCLS_METRICS_ID) ON DELETE CASCADE;

ALTER TABLE H_TASK_CLOSURE_DT_METRICS ADD CONSTRAINT H_TSKCLDTMET_FK2 FOREIGN KEY (TASK_ID)
		REFERENCES D_TASK (TASK_ID) ON DELETE CASCADE;						

ALTER TABLE H_BUILD_EXEC_DT_METRICS_TOT ADD CONSTRAINT H_BLDEXDTMET_FK1 FOREIGN KEY (BUILD_EXEC_METRIC_ID)
		REFERENCES F_BUILD_EXECUTION_DT_METRICS (BUILD_EXEC_METRIC_ID) ON DELETE CASCADE;

ALTER TABLE H_BUILD_EXEC_DT_METRICS_TOT ADD CONSTRAINT H_BLDEXDTMET_FK2 FOREIGN KEY (BUILD_ID)
		REFERENCES D_BUILD (BUILD_ID)  ON DELETE CASCADE;	

ALTER TABLE F_BUILD_EXECUTION_DT_METRICS ADD CONSTRAINT F_BLDEXDTMET_FK1 FOREIGN KEY (END_DATE_ID)
	REFERENCES D_DATE (DATE_ID);

ALTER TABLE F_BUILD_EXECUTION_DT_METRICS ADD CONSTRAINT F_BLDEXDTMET_FK2 FOREIGN KEY (PROJECT_ID)
	REFERENCES D_PROJECT (PROJECT_ID);
	
ALTER TABLE F_BUILD_EXECUTION_DT_METRICS ADD CONSTRAINT F_BLDEXDTMET_FK7 FOREIGN KEY (BUILD_TYPE_ID)
	REFERENCES D_BUILD_TYPE (BUILD_TYPE_ID);		

ALTER TABLE F_BUILD_EXECUTION_DT_METRICS ADD CONSTRAINT F_BLDEXDTMET_FK8 FOREIGN KEY (STATUS_ID)
	REFERENCES D_STATUS (STATUS_ID);	

ALTER TABLE F_BUILD_EXECUTION_DT_METRICS ADD CONSTRAINT F_BLDEXDTMET_FK9 FOREIGN KEY (BUILD_CLASS_ID)
	REFERENCES D_BUILD_CLASSIFICATION (BUILD_CLASS_ID);		
	
ALTER TABLE F_LAB_RESUTILIZATION_METRICS ADD CONSTRAINT F_LABRESUTL_FK1 FOREIGN KEY (RESOURCE_GROUP_ID)
		REFERENCES D_RESOURCE_GROUP (RESOURCE_GROUP_ID);
		
ALTER TABLE F_LAB_RESUTILIZATION_METRICS ADD CONSTRAINT F_LABRESUTL_FK2 FOREIGN KEY (OWNER_ID)
		REFERENCES D_RESOURCE (RESOURCE_ID);		

ALTER TABLE F_LAB_RESUTILIZATION_METRICS ADD CONSTRAINT F_LABRESUTL_FK3 FOREIGN KEY (OS_TYPE_ID)
		REFERENCES D_OS_TYPE (OS_TYPE_ID);		
		
ALTER TABLE F_LAB_RESUTILIZATION_METRICS ADD CONSTRAINT F_LABRESUTL_FK4 FOREIGN KEY (RESERVATION_DATE_ID)
		REFERENCES D_DATE (DATE_ID);		
		
ALTER TABLE F_LAB_RESUTILIZATION_METRICS ADD CONSTRAINT F_LABRESUTL_FK5 FOREIGN KEY (PROJECT_ID)
		REFERENCES D_PROJECT (PROJECT_ID);			
		
ALTER TABLE H_LAB_RESUTILIZATION_METRICS ADD CONSTRAINT H_LABRESUTL_FK1 FOREIGN KEY (LAB_RESUTIL_ID)
		REFERENCES F_LAB_RESUTILIZATION_METRICS (LAB_RESUTIL_ID) ON DELETE CASCADE;		
		
ALTER TABLE H_LAB_RESUTILIZATION_METRICS ADD CONSTRAINT H_LABRESUTL_FK2 FOREIGN KEY (LAB_RESOURCE_ID)
		REFERENCES D_LAB_RESOURCE (LAB_RESOURCE_ID) ON DELETE CASCADE;			

ALTER TABLE F_TEXT_FILE_CHANGE_METRICS ADD CONSTRAINT FFTXTCHNGM_FK1 FOREIGN KEY (FILE_CLASS_ID)
		REFERENCES D_FILE_CLASSIFICATION (FILE_CLASS_ID);
		
ALTER TABLE F_TEXT_FILE_CHANGE_METRICS ADD CONSTRAINT FFTXTCHNGM_FK2 FOREIGN KEY (DATE_ID)
		REFERENCES D_DATE (DATE_ID);	
		
ALTER TABLE F_TEXT_FILE_CHANGE_METRICS ADD CONSTRAINT FFTXTCHNGM_FK3 FOREIGN KEY (PROJECT_ID)
		REFERENCES D_PROJECT (PROJECT_ID);			
		
ALTER TABLE F_TEXT_FILE_CHANGE_METRICS ADD CONSTRAINT FFTXTCHNGM_FK4 FOREIGN KEY (TEAM_ID)
		REFERENCES D_TEAM (TEAM_ID);		
		
ALTER TABLE F_TEXT_FILE_CHANGE_METRICS ADD CONSTRAINT FFTXTCHNGM_FK5 FOREIGN KEY (FILE_STREAM_ID)
		REFERENCES D_FILE_STREAM (FILE_STREAM_ID);			
		
ALTER TABLE F_TEXT_FILE_CHANGE_METRICS ADD CONSTRAINT FFTXTCHNGM_FK6 FOREIGN KEY (COMPONENT_ID)
		REFERENCES D_COMPONENT (COMPONENT_ID);			
		
ALTER TABLE H_TEXT_FILE_CHANGE_METRICS ADD CONSTRAINT HFTXTCHNGM_FK1 FOREIGN KEY (FTEXTCHNG_METRICS_ID)
		REFERENCES F_TEXT_FILE_CHANGE_METRICS (FTEXTCHNG_METRICS_ID) ON DELETE CASCADE;

ALTER TABLE H_TEXT_FILE_CHANGE_METRICS ADD CONSTRAINT HFTXTCHNGM_FK2 FOREIGN KEY (FILE_ID)
		REFERENCES D_FILE (FILE_ID) ON DELETE CASCADE;	
		
ALTER TABLE F_FILE_STREAM_METRICS	ADD CONSTRAINT 	FFILESTRMET_FK1 FOREIGN KEY (DATE_ID)
		REFERENCES D_DATE (DATE_ID);

ALTER TABLE F_FILE_STREAM_METRICS	ADD CONSTRAINT 	FFILESTRMET_FK2 FOREIGN KEY (FILE_STREAM_CLASS_ID)
		REFERENCES D_FILE_STREAM_CLASSIFICATION (FILE_STREAM_CLASS_ID);

ALTER TABLE F_FILE_STREAM_METRICS	ADD CONSTRAINT 	FFILESTRMET_FK3 FOREIGN KEY (PROJECT_ID)
		REFERENCES D_PROJECT (PROJECT_ID);

ALTER TABLE F_FILE_STREAM_METRICS	ADD CONSTRAINT 	FFILESTRMET_FK4 FOREIGN KEY (TEAM_ID)
		REFERENCES D_TEAM (TEAM_ID);

ALTER TABLE F_FILE_STREAM_METRICS	ADD CONSTRAINT 	FFILESTRMET_FK5 FOREIGN KEY (FILE_STREAM_ID)
		REFERENCES D_FILE_STREAM (FILE_STREAM_ID);

ALTER TABLE H_FILE_STREAM_METRICS ADD CONSTRAINT HFILESTRMET_FK1 FOREIGN KEY (FSTREAM_METRICS_ID)		
		REFERENCES F_FILE_STREAM_METRICS (FSTREAM_METRICS_ID) ON DELETE CASCADE;

ALTER TABLE H_FILE_STREAM_METRICS ADD CONSTRAINT HFILESTRMET_FK2 FOREIGN KEY (FILE_STREAM_ID)	
		REFERENCES D_FILE_STREAM (FILE_STREAM_ID) ON DELETE CASCADE;

ALTER TABLE F_JOB_EXECUTION_DT_METRICS ADD CONSTRAINT F_JOBEXECRES_FK1 FOREIGN KEY (OWNER_ID)
	REFERENCES D_RESOURCE(RESOURCE_ID);
	
ALTER TABLE F_JOB_EXECUTION_DT_METRICS ADD CONSTRAINT F_JOBEXECRES_FK2 FOREIGN KEY (JOB_ID)
	REFERENCES D_JOB (JOB_ID);	
	
ALTER TABLE F_JOB_EXECUTION_DT_METRICS ADD CONSTRAINT F_JOBEXECRES_FK3 FOREIGN KEY (LAB_RESOURCE_ID)
	REFERENCES D_LAB_RESOURCE (LAB_RESOURCE_ID);		

ALTER TABLE F_JOB_EXECUTION_DT_METRICS ADD CONSTRAINT F_JOBEXECRES_FK4 FOREIGN KEY (DATE_ID)
	REFERENCES D_DATE (DATE_ID);
	
ALTER TABLE F_JOB_EXECUTION_DT_METRICS ADD CONSTRAINT F_JOBEXECRES_FK5 FOREIGN KEY (VERDICT_ID)
	REFERENCES D_VERDICT (VERDICT_ID);	
	
ALTER TABLE F_JOB_EXECUTION_DT_METRICS ADD CONSTRAINT F_JOBEXECRES_FK6 FOREIGN KEY (STATE_ID)
	REFERENCES D_JOB_RESULT_STATE (STATE_ID);	
	
ALTER TABLE F_JOB_EXECUTION_DT_METRICS ADD CONSTRAINT F_JOBEXECRES_FK7 FOREIGN KEY (PROJECT_ID)
	REFERENCES D_PROJECT (PROJECT_ID);	

ALTER TABLE H_JOB_EXECUTION_DT_METRICS ADD CONSTRAINT H_JOBEXECRES_FK1 FOREIGN KEY (F_JOBRES_METRIC_ID)
	REFERENCES F_JOB_EXECUTION_DT_METRICS (F_JOBRES_METRIC_ID) ON DELETE CASCADE;
	
ALTER TABLE H_JOB_EXECUTION_DT_METRICS ADD CONSTRAINT H_JOBEXECRES_FK2 FOREIGN KEY (JOB_RESULT_ID)
	REFERENCES D_JOB_RESULT (JOB_RESULT_ID) ON DELETE CASCADE;	
	
ALTER TABLE F_REQUEST_RESOLUTIO_DT_METRICS ADD CONSTRAINT F_REQRESDT_FK1 FOREIGN KEY (RELEASE_ID)
	REFERENCES D_RELEASE (RELEASE_ID);

ALTER TABLE F_REQUEST_RESOLUTIO_DT_METRICS ADD CONSTRAINT F_REQRESDT_FK2 FOREIGN KEY (COMPONENT_ID)
	REFERENCES D_COMPONENT (COMPONENT_ID);

ALTER TABLE F_REQUEST_RESOLUTIO_DT_METRICS ADD CONSTRAINT F_REQRESDT_FK3 FOREIGN KEY (PROJECT_ID)
	REFERENCES D_PROJECT (PROJECT_ID);
	
ALTER TABLE F_REQUEST_RESOLUTIO_DT_METRICS ADD CONSTRAINT F_REQRESDT_FK5 FOREIGN KEY (REQUEST_CLASS_ID)
	REFERENCES D_REQUEST_CLASSIFICATION (REQUEST_CLASS_ID);

ALTER TABLE F_REQUEST_RESOLUTIO_DT_METRICS ADD CONSTRAINT F_REQRESDT_FK7 FOREIGN KEY (STATUS_ID)
	REFERENCES D_REQUEST_STATUS (STATUS_ID);

ALTER TABLE F_REQUEST_RESOLUTIO_DT_METRICS ADD CONSTRAINT F_REQRESDT_FK8 FOREIGN KEY (CUSTOMER_PRIORITY_ID)
	REFERENCES D_CUSTOMER_PRIORITY (CUSTOMER_PRIORITY_ID);

ALTER TABLE F_REQUEST_RESOLUTIO_DT_METRICS ADD CONSTRAINT F_REQRESDT_FK9 FOREIGN KEY (RESOLUTION_DATE_ID)
	REFERENCES D_DATE (DATE_ID);	
	
ALTER TABLE F_REQUEST_RESOLUTIO_DT_METRICS ADD CONSTRAINT F_REQRESDT_FK10 FOREIGN KEY (SEVERITY_ID)
	REFERENCES D_REQUEST_SEVERITY (SEVERITY_ID);	
	
ALTER TABLE F_REQUEST_RESOLUTIO_DT_METRICS ADD CONSTRAINT F_REQRESDT_FK11 FOREIGN KEY (REQUEST_TYPE_ID)
	REFERENCES D_REQUEST_TYPE (REQUEST_TYPE_ID);	
	
ALTER TABLE F_REQUEST_RESOLUTIO_DT_METRICS ADD CONSTRAINT F_REQRESDT_FK12 FOREIGN KEY (TEAM_ID)
	REFERENCES D_TEAM (TEAM_ID);
	
ALTER TABLE F_REQUEST_RESOLUTIO_DT_METRICS ADD CONSTRAINT F_REQRESDT_FK13 FOREIGN KEY (REQUEST_CATEGORY_ID)
	REFERENCES D_REQUEST_CATEGORY (REQUEST_CATEGORY_ID);
	
ALTER TABLE F_REQUEST_RESOLUTIO_DT_METRICS ADD CONSTRAINT F_REQRESDT_FK14 FOREIGN KEY (STATE_ID)
	REFERENCES D_REQUEST_STATE (STATE_ID);	
	
ALTER TABLE F_REQUEST_RESOLUTIO_DT_METRICS ADD CONSTRAINT F_REQRESDT_FK15 FOREIGN KEY (PRIORITY_ID)
	REFERENCES D_REQUEST_PRIORITY (PRIORITY_ID);	

ALTER TABLE F_REQUEST_RESOLUTIO_DT_METRICS ADD CONSTRAINT F_REQRESDT_FK16 FOREIGN KEY (ITERATION_ID)
	REFERENCES D_ITERATION (ITERATION_ID);							

ALTER TABLE H_REQUEST_RESOLUTIO_DT_METRICS ADD CONSTRAINT H_REQRESDT_FK1 FOREIGN KEY (REQDT_METRIC_ID)
	REFERENCES F_REQUEST_RESOLUTIO_DT_METRICS (REQDT_METRIC_ID) ON DELETE CASCADE;

ALTER TABLE H_REQUEST_RESOLUTIO_DT_METRICS ADD CONSTRAINT H_REQRESDT_FK2 FOREIGN KEY (REQUEST_ID)
	REFERENCES D_REQUEST (REQUEST_ID) ON DELETE CASCADE;

ALTER TABLE F_RELEASE_REQUEST_METRICS ADD CONSTRAINT F_RELREQ_FK1 FOREIGN KEY (DATE_ID)
		REFERENCES D_DATE (DATE_ID);
		
ALTER TABLE F_RELEASE_REQUEST_METRICS ADD CONSTRAINT F_RELREQ_FK2 FOREIGN KEY (REQUEST_CLASS_ID)
		REFERENCES D_REQUEST_CLASSIFICATION (REQUEST_CLASS_ID);

ALTER TABLE F_RELEASE_REQUEST_METRICS ADD CONSTRAINT F_RELREQ_FK3 FOREIGN KEY (RELEASE_ID)
		REFERENCES D_RELEASE (RELEASE_ID);	
		
ALTER TABLE F_RELEASE_REQUEST_METRICS ADD CONSTRAINT F_RELREQ_FK4 FOREIGN KEY (PRODUCT_ID)
		REFERENCES D_PRODUCT (PRODUCT_ID);	
		
ALTER TABLE F_RELEASE_REQUEST_METRICS ADD CONSTRAINT F_RELREQ_FK5 FOREIGN KEY (STATE_ID)
		REFERENCES D_REQUEST_STATE (STATE_ID);			
		
ALTER TABLE F_RELEASE_REQUEST_METRICS ADD CONSTRAINT F_RELREQ_FK6 FOREIGN KEY (SEVERITY_ID)
		REFERENCES D_REQUEST_SEVERITY (SEVERITY_ID);	
		
ALTER TABLE F_RELEASE_REQUEST_METRICS ADD CONSTRAINT F_RELREQ_FK7 FOREIGN KEY (REQUEST_TYPE_ID)
		REFERENCES D_REQUEST_TYPE (REQUEST_TYPE_ID);	
		
ALTER TABLE F_RELEASE_REQUEST_METRICS ADD CONSTRAINT F_RELREQ_FK8 FOREIGN KEY (PROJECT_ID)
		REFERENCES D_PROJECT (PROJECT_ID);			
		
ALTER TABLE H_RELEASE_REQUEST_METRICS ADD CONSTRAINT H_RELREQ_FK1 FOREIGN KEY (F_RELREQ_METRIC_ID)
		REFERENCES F_RELEASE_REQUEST_METRICS (F_RELREQ_METRIC_ID) ON DELETE CASCADE;			
		
ALTER TABLE H_RELEASE_REQUEST_METRICS ADD CONSTRAINT H_RELREQ_FK2 FOREIGN KEY (REQUEST_ID)
		REFERENCES D_REQUEST (REQUEST_ID) ON DELETE CASCADE;										

ALTER TABLE F_REL_REQUEST_TURN_METRICS ADD CONSTRAINT F_RELREQTU_FK1 FOREIGN KEY (DATE_ID)
		REFERENCES D_DATE (DATE_ID);
		
ALTER TABLE F_REL_REQUEST_TURN_METRICS ADD CONSTRAINT F_RELREQTU_FK2 FOREIGN KEY (REQUEST_CLASS_ID)
		REFERENCES D_REQUEST_CLASSIFICATION (REQUEST_CLASS_ID);

ALTER TABLE F_REL_REQUEST_TURN_METRICS ADD CONSTRAINT F_RELREQTU_FK3 FOREIGN KEY (RELEASE_ID)
		REFERENCES D_RELEASE (RELEASE_ID);	
		
ALTER TABLE F_REL_REQUEST_TURN_METRICS ADD CONSTRAINT F_RELREQTU_FK4 FOREIGN KEY (PRODUCT_ID)
		REFERENCES D_PRODUCT (PRODUCT_ID);	
		
ALTER TABLE F_REL_REQUEST_TURN_METRICS ADD CONSTRAINT F_RELREQTU_FK5 FOREIGN KEY (STATE_ID)
		REFERENCES D_REQUEST_STATE (STATE_ID);			
		
ALTER TABLE F_REL_REQUEST_TURN_METRICS ADD CONSTRAINT F_RELREQTU_FK6 FOREIGN KEY (SEVERITY_ID)
		REFERENCES D_REQUEST_SEVERITY (SEVERITY_ID);	
		
ALTER TABLE F_REL_REQUEST_TURN_METRICS ADD CONSTRAINT F_RELREQTU_FK7 FOREIGN KEY (REQUEST_TYPE_ID)
		REFERENCES D_REQUEST_TYPE (REQUEST_TYPE_ID);								

ALTER TABLE F_REL_REQUEST_TURN_METRICS ADD CONSTRAINT F_RELREQTU_FK8 FOREIGN KEY (PROJECT_ID)
		REFERENCES D_PROJECT (PROJECT_ID);		

ALTER TABLE H_REL_REQUEST_TURN_METRICS ADD CONSTRAINT H_RELREQTU_FK1 FOREIGN KEY (F_RELREQ_TURN_METRIC_ID)
		REFERENCES F_REL_REQUEST_TURN_METRICS (F_RELREQ_TURN_METRIC_ID) ON DELETE CASCADE;										

ALTER TABLE H_REL_REQUEST_TURN_METRICS ADD CONSTRAINT H_RELREQTU_FK2 FOREIGN KEY (REQUEST_ID)
		REFERENCES D_REQUEST (REQUEST_ID) ON DELETE CASCADE;										
	
ALTER TABLE F_TIME_TO_MARKET_RELEA_METRICS ADD CONSTRAINT F_TTMKTREL_FK1 FOREIGN KEY (RELEASE_DATE_ID)
		REFERENCES D_DATE (DATE_ID);
		
ALTER TABLE F_TIME_TO_MARKET_RELEA_METRICS ADD CONSTRAINT F_TTMKTREL_FK2 FOREIGN KEY (PROJECT_ID)
		REFERENCES D_PROJECT (PROJECT_ID);			
		
ALTER TABLE F_TIME_TO_MARKET_RELEA_METRICS ADD CONSTRAINT F_TTMKTREL_FK3 FOREIGN KEY (PRODUCT_ID)
		REFERENCES D_PRODUCT (PRODUCT_ID);			
		
ALTER TABLE H_TIME_TO_MARKET_REL_METRICS ADD CONSTRAINT H_TTMKTREL_FK1 FOREIGN KEY (F_TIME_TO_MRKT_METRIC_ID)
		REFERENCES F_TIME_TO_MARKET_RELEA_METRICS (F_TIME_TO_MRKT_METRIC_ID) ON DELETE CASCADE;										

ALTER TABLE H_TIME_TO_MARKET_REL_METRICS ADD CONSTRAINT H_TTMKTREL_FK2 FOREIGN KEY (RELEASE_ID)
		REFERENCES D_RELEASE (RELEASE_ID) ON DELETE CASCADE;			

ALTER TABLE F_C_REQUEST_METRICS ADD CONSTRAINT F_C_REQUEST_FK1 FOREIGN KEY (PROJECT_ID)
	REFERENCES D_PROJECT (PROJECT_ID);

ALTER TABLE F_C_REQUEST_METRICS ADD CONSTRAINT F_C_REQUEST_FK13 FOREIGN KEY (RELEASE_ID)
	REFERENCES D_RELEASE (RELEASE_ID);

ALTER TABLE F_C_REQUEST_METRICS ADD CONSTRAINT F_C_REQUEST_FK14 FOREIGN KEY (FIXEDINRELEASE_ID)
	REFERENCES D_RELEASE (RELEASE_ID);

ALTER TABLE F_C_REQUEST_METRICS ADD CONSTRAINT F_C_REQUEST_FK15 FOREIGN KEY (DATE_ID)
	REFERENCES D_DATE (DATE_ID);

ALTER TABLE F_C_REQUEST_METRICS ADD CONSTRAINT F_C_REQUEST_FK16 FOREIGN KEY (REQUEST_CLASS_ID)
	REFERENCES D_REQUEST_CLASSIFICATION (REQUEST_CLASS_ID);

ALTER TABLE F_C_REQUEST_METRICS ADD CONSTRAINT F_C_REQUEST_FK17 FOREIGN KEY (RESOURCE_ID)
	REFERENCES D_RESOURCE (RESOURCE_ID);
	
ALTER TABLE F_C_REQUEST_METRICS ADD CONSTRAINT F_C_REQUEST_FK19 FOREIGN KEY (STATUS_ID)
	REFERENCES D_REQUEST_STATUS (STATUS_ID);	

ALTER TABLE F_C_REQUEST_METRICS ADD CONSTRAINT F_C_REQUEST_FK2 FOREIGN KEY (STATE_ID)
	REFERENCES D_REQUEST_STATE (STATE_ID);

ALTER TABLE F_C_REQUEST_METRICS ADD CONSTRAINT F_C_REQUEST_FK21 FOREIGN KEY (REQUEST_CATEGORY_ID)
	REFERENCES D_REQUEST_CATEGORY (REQUEST_CATEGORY_ID);
	
ALTER TABLE F_C_REQUEST_METRICS ADD CONSTRAINT F_C_REQUEST_FK3 FOREIGN KEY (PRIORITY_ID)
	REFERENCES D_REQUEST_PRIORITY (PRIORITY_ID);

ALTER TABLE F_C_REQUEST_METRICS ADD CONSTRAINT F_C_REQUEST_FK4 FOREIGN KEY (SEVERITY_ID)
	REFERENCES D_REQUEST_SEVERITY (SEVERITY_ID);

ALTER TABLE F_C_REQUEST_METRICS ADD CONSTRAINT F_C_REQUEST_FK5 FOREIGN KEY (TEAM_ID)
	REFERENCES D_TEAM (TEAM_ID);

ALTER TABLE F_C_REQUEST_METRICS ADD CONSTRAINT F_C_REQUEST_FK6 FOREIGN KEY (PLATFORM_ID)
	REFERENCES D_PLATFORM (PLATFORM_ID);

ALTER TABLE F_C_REQUEST_METRICS ADD CONSTRAINT F_C_REQUEST_FK8 FOREIGN KEY (ITERATION_ID)
	REFERENCES D_ITERATION (ITERATION_ID);

ALTER TABLE F_C_REQUEST_METRICS ADD CONSTRAINT F_C_REQUEST_FK9 FOREIGN KEY (COMPONENT_ID)
	REFERENCES D_COMPONENT (COMPONENT_ID);

ALTER TABLE F_C_REQUEST_METRICS ADD CONSTRAINT F_C_REQUEST_FK10 FOREIGN KEY (REQUEST_TYPE_ID)
	REFERENCES D_REQUEST_TYPE (REQUEST_TYPE_ID);

ALTER TABLE F_C_REQUEST_AGING ADD CONSTRAINT F_C_REQ_AGD_FK1 FOREIGN KEY (STATE_ID)
	REFERENCES D_REQUEST_STATE (STATE_ID);

ALTER TABLE F_C_REQUEST_AGING ADD CONSTRAINT F_C_REQ_AGD_FK2 FOREIGN KEY (DATE_ID)
	REFERENCES D_DATE (DATE_ID);

ALTER TABLE F_C_REQUEST_AGING ADD CONSTRAINT F_C_REQ_AGD_FK3 FOREIGN KEY (PROJECT_ID)
	REFERENCES D_PROJECT (PROJECT_ID);

ALTER TABLE F_C_REQUEST_AGING ADD CONSTRAINT F_C_REQ_AGD_FK4 FOREIGN KEY (COMPONENT_ID)
	REFERENCES D_COMPONENT (COMPONENT_ID);

ALTER TABLE F_C_REQUEST_AGING ADD CONSTRAINT F_C_REQ_AGD_FK5 FOREIGN KEY (RESOURCE_ID)
	REFERENCES D_RESOURCE (RESOURCE_ID);

ALTER TABLE F_C_REQUEST_AGING ADD CONSTRAINT F_C_REQ_AGD_FK6 FOREIGN KEY (SEVERITY_ID)
	REFERENCES D_REQUEST_SEVERITY (SEVERITY_ID);

ALTER TABLE F_C_REQUEST_AGING ADD CONSTRAINT F_C_REQ_AGD_FK7 FOREIGN KEY (PRIORITY_ID)
	REFERENCES D_REQUEST_PRIORITY (PRIORITY_ID);

ALTER TABLE F_C_REQUEST_AGING ADD CONSTRAINT F_C_REQ_AGD_FK8 FOREIGN KEY (ITERATION_ID)
	REFERENCES D_ITERATION (ITERATION_ID);
			
ALTER TABLE F_C_REQUEST_AGING ADD CONSTRAINT F_C_REQ_AGD_FK9 FOREIGN KEY (REQUEST_CLASS_ID)
	REFERENCES D_REQUEST_CLASSIFICATION (REQUEST_CLASS_ID);		

ALTER TABLE F_C_REQUEST_AGING ADD CONSTRAINT F_C_REQ_AGD_FK10 FOREIGN KEY (REQUEST_TYPE_ID)
	REFERENCES D_REQUEST_TYPE (REQUEST_TYPE_ID);		

ALTER TABLE F_C_REQUEST_TURNAROUND ADD CONSTRAINT F_C_REQTURN_FK1 FOREIGN KEY (REQUEST_CLASS_ID)
		REFERENCES D_REQUEST_CLASSIFICATION (REQUEST_CLASS_ID);        
		        
ALTER TABLE F_C_REQUEST_TURNAROUND ADD CONSTRAINT F_C_REQTURN_FK2 FOREIGN KEY (PROJECT_ID)      
		REFERENCES D_PROJECT (PROJECT_ID);         
		                
ALTER TABLE F_C_REQUEST_TURNAROUND ADD CONSTRAINT F_C_REQTURN_FK4 FOREIGN KEY (COMPONENT_ID)    
		REFERENCES D_COMPONENT (COMPONENT_ID); 
		                
ALTER TABLE F_C_REQUEST_TURNAROUND ADD CONSTRAINT F_C_REQTURN_FK5 FOREIGN KEY (RESOURCE_ID)     
		REFERENCES D_RESOURCE(RESOURCE_ID); 
		                
ALTER TABLE F_C_REQUEST_TURNAROUND ADD CONSTRAINT F_C_REQTURN_FK6 FOREIGN KEY (SEVERITY_ID)    
		REFERENCES D_REQUEST_SEVERITY (SEVERITY_ID); 
		                
ALTER TABLE F_C_REQUEST_TURNAROUND ADD CONSTRAINT F_C_REQTURN_FK7 FOREIGN KEY (PRIORITY_ID)     
		REFERENCES D_REQUEST_PRIORITY (PRIORITY_ID); 
		                
ALTER TABLE F_C_REQUEST_TURNAROUND ADD CONSTRAINT F_C_REQTURN_FK8 FOREIGN KEY (ITERATION_ID)    
		REFERENCES D_ITERATION (ITERATION_ID); 
		                
ALTER TABLE F_C_REQUEST_TURNAROUND ADD CONSTRAINT F_C_REQTURN_FK9 FOREIGN KEY (DATE_ID)         
		REFERENCES D_DATE (DATE_ID); 

ALTER TABLE F_C_REQUEST_TURNAROUND ADD CONSTRAINT F_C_REQTURN_FK10 FOREIGN KEY (REQUEST_TYPE_ID)         
		REFERENCES D_REQUEST_TYPE (REQUEST_TYPE_ID); 		

ALTER TABLE F_C_EXECUTION_RESULT_METRICS ADD CONSTRAINT F_C_EXERES_FK1 FOREIGN KEY (ASSETREGISTRY_ID)
	REFERENCES D_ASSETREGISTRY (ASSETREGISTRY_ID);

ALTER TABLE F_C_EXECUTION_RESULT_METRICS ADD CONSTRAINT F_C_EXERES_FK2 FOREIGN KEY (TESTCASE_ID)
	REFERENCES D_TESTCASE (TESTCASE_ID);

ALTER TABLE F_C_EXECUTION_RESULT_METRICS ADD CONSTRAINT F_C_EXERES_FK3 FOREIGN KEY (VERDICT_ID)
	REFERENCES D_VERDICT (VERDICT_ID);

ALTER TABLE F_C_EXECUTION_RESULT_METRICS ADD CONSTRAINT F_C_EXERES_FK4 FOREIGN KEY (DATE_ID)
	REFERENCES D_DATE (DATE_ID);

ALTER TABLE F_C_EXECUTION_RESULT_METRICS ADD CONSTRAINT F_C_EXERES_FK5 FOREIGN KEY (EXECRES_CLASS_ID)
	REFERENCES D_EXECRESULT_CLASSIFICATION (EXECRES_CLASS_ID);
	
ALTER TABLE F_C_EXECUTION_RESULT_METRICS ADD CONSTRAINT F_C_EXERES_FK6 FOREIGN KEY (TESTPLAN_ID)
	REFERENCES D_TESTPLAN (TESTPLAN_ID);	
	
ALTER TABLE F_C_EXECUTION_RESULT_METRICS ADD CONSTRAINT F_C_EXERES_FK7 FOREIGN KEY (PROJECT_ID)
	REFERENCES D_PROJECT (PROJECT_ID);		

ALTER TABLE F_C_REQUEST_FAILURE_METRICS ADD CONSTRAINT F_C_REQFL_FK1 FOREIGN KEY (RELEASE_ID)
	REFERENCES D_RELEASE (RELEASE_ID);

ALTER TABLE F_C_REQUEST_FAILURE_METRICS ADD CONSTRAINT F_C_REQFL_FK2 FOREIGN KEY (COMPONENT_ID)
	REFERENCES D_COMPONENT (COMPONENT_ID);

ALTER TABLE F_C_REQUEST_FAILURE_METRICS ADD CONSTRAINT F_C_REQFL_FK3 FOREIGN KEY (PROJECT_ID)
	REFERENCES D_PROJECT (PROJECT_ID);

ALTER TABLE F_C_REQUEST_FAILURE_METRICS ADD CONSTRAINT F_C_REQFL_FK5 FOREIGN KEY (ITERATION_ID)
	REFERENCES D_ITERATION (ITERATION_ID);

ALTER TABLE F_C_REQUEST_FAILURE_METRICS ADD CONSTRAINT F_C_REQFL_FK6 FOREIGN KEY (DATE_ID)
	REFERENCES D_DATE (DATE_ID);	

ALTER TABLE F_C_REQUIREMENT_METRICS ADD CONSTRAINT F_C_REQMET_FK1 FOREIGN KEY (DATE_ID)
	REFERENCES D_DATE (DATE_ID);

ALTER TABLE F_C_REQUIREMENT_METRICS ADD CONSTRAINT F_C_REQMET_FK2 FOREIGN KEY (PROJECT_ID)
	REFERENCES D_PROJECT (PROJECT_ID);

ALTER TABLE F_C_REQUIREMENT_METRICS ADD CONSTRAINT F_C_REQMET_FK3 FOREIGN KEY (ITERATION_ID)
	REFERENCES D_ITERATION (ITERATION_ID);

ALTER TABLE F_C_REQUIREMENT_METRICS ADD CONSTRAINT F_C_REQMET_FK4 FOREIGN KEY (STATE_ID)
	REFERENCES D_REQUIREMENT_STATE (STATE_ID);

ALTER TABLE F_C_REQUIREMENT_METRICS ADD CONSTRAINT F_C_REQMET_FK5 FOREIGN KEY (REQUIREMENT_CLASS_ID)
	REFERENCES D_REQUIREMENT_CLASSIFICATION (REQUIREMENT_CLASS_ID);

ALTER TABLE F_C_REQUIREMENT_METRICS ADD CONSTRAINT F_C_REQMET_FK6 FOREIGN KEY (STATUS_ID)
	REFERENCES D_STATUS (STATUS_ID);

ALTER TABLE F_C_REQUIREMENT_METRICS ADD CONSTRAINT F_C_REQMET_FK7 FOREIGN KEY (STABILITY_ID)
	REFERENCES D_STABILITY (STABILITY_ID);

ALTER TABLE F_C_REQUIREMENT_METRICS ADD CONSTRAINT F_C_REQMET_FK8 FOREIGN KEY (DIFFICULTY_ID)
	REFERENCES D_DIFFICULTY (DIFFICULTY_ID);
	
ALTER TABLE F_C_REQUIREMENT_METRICS ADD CONSTRAINT F_C_REQMET_FK11 FOREIGN KEY (COMPONENT_ID)
	REFERENCES D_COMPONENT (COMPONENT_ID);	

ALTER TABLE F_C_REQUIREMENT_METRICS ADD CONSTRAINT F_C_REQMET_FK12 FOREIGN KEY (RESOURCE_ID)
	REFERENCES D_RESOURCE (RESOURCE_ID);	
	
ALTER TABLE F_C_REQUIREMENT_METRICS ADD CONSTRAINT F_C_REQMET_FK13 FOREIGN KEY (PRIORITY_ID)
	REFERENCES D_PRIORITY (PRIORITY_ID);		
	
ALTER TABLE F_C_REQUIREMENT_METRICS ADD CONSTRAINT F_C_REQMET_FK14 FOREIGN KEY (REQUIREMENT_TYPE_ID)
	REFERENCES D_REQUIREMENT_TYPE (REQUIREMENT_TYPE_ID);
		
ALTER TABLE F_C_EXECUTION_WORKITEM_METRICS ADD CONSTRAINT F_C_CFGTST_FK1 FOREIGN KEY (DATE_ID)
	REFERENCES D_DATE (DATE_ID);

ALTER TABLE F_C_EXECUTION_WORKITEM_METRICS ADD CONSTRAINT F_C_CFGTST_FK2 FOREIGN KEY (PROJECT_ID)
	REFERENCES D_PROJECT (PROJECT_ID);

ALTER TABLE F_C_EXECUTION_WORKITEM_METRICS ADD CONSTRAINT F_C_CFGTST_FK3 FOREIGN KEY (TESTPLAN_ID)
	REFERENCES D_TESTPLAN (TESTPLAN_ID);

ALTER TABLE F_C_EXECUTION_WORKITEM_METRICS ADD CONSTRAINT F_C_CFGTST_FK4 FOREIGN KEY (VERDICT_ID)
	REFERENCES D_VERDICT (VERDICT_ID);

ALTER TABLE F_C_EXECUTION_WORKITEM_METRICS ADD CONSTRAINT F_C_CFGTST_FK5 FOREIGN KEY (EXECWORKIT_CLASS_ID)
	REFERENCES D_EXECWORKITEM_CLASSIFICATION (EXECWORKIT_CLASS_ID);
	
ALTER TABLE F_C_EXECUTION_WORKITEM_METRICS ADD CONSTRAINT F_C_CFGTST_FK6 FOREIGN KEY (CONFIGURATION_ID)
	REFERENCES D_CONFIGURATION (CONFIGURATION_ID);	

ALTER TABLE F_C_TESTCASE_METRICS ADD CONSTRAINT F_C_TSTCASE_FK1 FOREIGN KEY (DATE_ID)
	REFERENCES D_DATE (DATE_ID);

ALTER TABLE F_C_TESTCASE_METRICS ADD CONSTRAINT F_C_TSTCASE_FK5 FOREIGN KEY (TESTPLAN_ID)
	REFERENCES D_TESTPLAN (TESTPLAN_ID);

ALTER TABLE F_C_TESTCASE_METRICS ADD CONSTRAINT F_C_TSTCASE_FK7 FOREIGN KEY (TESTCASE_CLASS_ID)
	REFERENCES D_TESTCASE_CLASSIFICATION (TESTCASE_CLASS_ID);		
	
ALTER TABLE F_C_TESTCASE_METRICS ADD CONSTRAINT F_C_TSTCASE_FK8 FOREIGN KEY (STATE_ID)
	REFERENCES D_TESTCASE_STATE (STATE_ID);	
	
ALTER TABLE F_C_TESTCASE_METRICS ADD CONSTRAINT F_C_TSTCASE_FK9 FOREIGN KEY (PROJECT_ID)
	REFERENCES D_PROJECT (PROJECT_ID);		

ALTER TABLE F_C_BUILD_METRICS ADD CONSTRAINT F_C_BUILD_FK1 FOREIGN KEY (DATE_ID)
	REFERENCES D_DATE (DATE_ID);

ALTER TABLE F_C_BUILD_METRICS ADD CONSTRAINT F_C_BUILD_FK2 FOREIGN KEY (PROJECT_ID)
	REFERENCES D_PROJECT (PROJECT_ID);

ALTER TABLE F_C_BUILD_METRICS ADD CONSTRAINT F_C_BUILD_FK5 FOREIGN KEY (COMPONENT_ID)
	REFERENCES D_COMPONENT (COMPONENT_ID);

ALTER TABLE F_C_BUILD_METRICS ADD CONSTRAINT F_C_BUILD_FK7 FOREIGN KEY (BUILD_TYPE_ID)
	REFERENCES D_BUILD_TYPE (BUILD_TYPE_ID);
	
ALTER TABLE F_C_BUILD_METRICS ADD CONSTRAINT F_C_BUILD_FK8 FOREIGN KEY (BUILD_CLASS_ID)
	REFERENCES D_BUILD_CLASSIFICATION (BUILD_CLASS_ID);
	
ALTER TABLE F_C_PROJECT_PERFORM_METRICS ADD CONSTRAINT F_CPPM_FK1 FOREIGN KEY (DATE_ID)
	REFERENCES D_DATE (DATE_ID);
	
ALTER TABLE F_C_PROJECT_PERFORM_METRICS ADD CONSTRAINT F_CPPM_FK2 FOREIGN KEY (PROJECT_ID)
	REFERENCES D_PROJECT (PROJECT_ID);
	
ALTER TABLE F_C_CHILDREQUIREMENT_METRICS ADD CONSTRAINT F_C_CHREQM_FK1 FOREIGN KEY (DATE_ID)
	REFERENCES D_DATE (DATE_ID);

ALTER TABLE F_C_CHILDREQUIREMENT_METRICS ADD CONSTRAINT F_C_CHREQM_FK2 FOREIGN KEY (PROJECT_ID)
	REFERENCES D_PROJECT (PROJECT_ID);

ALTER TABLE F_C_CHILDREQUIREMENT_METRICS ADD CONSTRAINT F_C_CHREQM_FK3 FOREIGN KEY (ITERATION_ID)
	REFERENCES D_ITERATION (ITERATION_ID);

ALTER TABLE F_C_CHILDREQUIREMENT_METRICS ADD CONSTRAINT F_C_CHREQM_FK4 FOREIGN KEY (RELEASE_ID)
	REFERENCES D_RELEASE (RELEASE_ID);

ALTER TABLE F_C_CHILDREQUIREMENT_METRICS ADD CONSTRAINT F_C_CHREQM_FK5 FOREIGN KEY (PARENT_REQUIREMENT_ID)
	REFERENCES D_REQUIREMENT (REQUIREMENT_ID);
	
ALTER TABLE F_C_CHILDREQUIREMENT_METRICS ADD CONSTRAINT F_C_CHREQM_FK6 FOREIGN KEY (COMPONENT_ID)
	REFERENCES D_COMPONENT (COMPONENT_ID);	
	
ALTER TABLE F_C_CHILDREQUIREMENT_METRICS ADD CONSTRAINT F_C_CHREQM_FK7 FOREIGN KEY (REQUIREMENT_CLASS_ID)
	REFERENCES D_REQUIREMENT_CLASSIFICATION (REQUIREMENT_CLASS_ID);	

ALTER TABLE F_C_CHILDREQUIREMENT_METRICS ADD CONSTRAINT F_C_CHREQM_FK8 FOREIGN KEY (REQUIREMENT_TYPE_ID)  
  REFERENCES D_REQUIREMENT_TYPE (REQUIREMENT_TYPE_ID);

ALTER TABLE F_C_EXECRESPOINTS_METRICS ADD CONSTRAINT F_C_EXECPTS_FK2 FOREIGN KEY (DATE_ID)
	REFERENCES D_DATE (DATE_ID);
	
ALTER TABLE F_C_EXECRESPOINTS_METRICS ADD CONSTRAINT F_C_EXECPTS_FK3 FOREIGN KEY (TESTPLAN_ID)
	REFERENCES D_TESTPLAN (TESTPLAN_ID);	

ALTER TABLE F_C_EXECRESPOINTS_METRICS ADD CONSTRAINT F_C_EXECPTS_FK4 FOREIGN KEY (TESTCASE_ID)
	REFERENCES D_TESTCASE (TESTCASE_ID);	
	
ALTER TABLE F_C_EXECRESPOINTS_METRICS ADD CONSTRAINT F_C_EXECPTS_FK5 FOREIGN KEY (EXECRES_CLASS_ID)
	REFERENCES D_EXECRESULT_CLASSIFICATION (EXECRES_CLASS_ID);	

ALTER TABLE F_C_EXECRESPOINTS_METRICS ADD CONSTRAINT F_C_EXECPTS_FK6 FOREIGN KEY (VERDICT_ID)
	REFERENCES D_VERDICT (VERDICT_ID);
	
ALTER TABLE F_C_EXECRESPOINTS_METRICS ADD CONSTRAINT F_C_EXECPTS_FK7 FOREIGN KEY (PROJECT_ID)
	REFERENCES D_PROJECT (PROJECT_ID);	
	
ALTER TABLE F_C_ACTIVITY_METRICS ADD CONSTRAINT F_C_ACTM_FK1 FOREIGN KEY (ACTIVITY_CLASS_ID)
	REFERENCES D_ACTIVITY_CLASSIFICATION (ACTIVITY_CLASS_ID);
	
ALTER TABLE F_C_ACTIVITY_METRICS ADD CONSTRAINT F_C_ACTM_FK2 FOREIGN KEY (DATE_ID)
	REFERENCES D_DATE (DATE_ID);	
	
ALTER TABLE F_C_ACTIVITY_METRICS ADD CONSTRAINT F_C_ACTM_FK4 FOREIGN KEY (RESOURCE_ID)
	REFERENCES D_RESOURCE (RESOURCE_ID);	

ALTER TABLE F_C_ACTIVITY_METRICS ADD CONSTRAINT F_C_ACTM_FK5 FOREIGN KEY (PROJECT_ID)
	REFERENCES D_PROJECT (PROJECT_ID);				

ALTER TABLE F_C_ACTIVITY_METRICS ADD CONSTRAINT F_C_ACTM_FK7 FOREIGN KEY (STATE_ID)
	REFERENCES D_ACTIVITY_STATE (STATE_ID);			
		 
ALTER TABLE F_C_ACTIVITY_METRICS ADD CONSTRAINT F_C_ACTM_FK8 FOREIGN KEY (PRIORITY_ID)
	REFERENCES D_PRIORITY (PRIORITY_ID);	
	
ALTER TABLE F_C_TASK_METRICS ADD CONSTRAINT F_C_TSKMET_FK1 FOREIGN KEY (TASK_CLASS_ID)
		REFERENCES D_TASK_CLASSIFICATION (TASK_CLASS_ID);
		
ALTER TABLE F_C_TASK_METRICS ADD CONSTRAINT F_C_TSKMET_FK2 FOREIGN KEY (DATE_ID)
		REFERENCES D_DATE (DATE_ID);		
		
ALTER TABLE F_C_TASK_METRICS ADD CONSTRAINT F_C_TSKMET_FK3 FOREIGN KEY (RESOURCE_ID)
		REFERENCES D_RESOURCE (RESOURCE_ID);			

ALTER TABLE F_C_TASK_METRICS ADD CONSTRAINT F_C_TSKMET_FK4 FOREIGN KEY (PROJECT_ID)
		REFERENCES D_PROJECT (PROJECT_ID);				
		
ALTER TABLE F_C_TASK_METRICS ADD CONSTRAINT F_C_TSKMET_FK6 FOREIGN KEY (STATE_ID)
		REFERENCES D_TASK_STATE (STATE_ID);			
		
ALTER TABLE F_C_TASK_METRICS ADD CONSTRAINT F_C_TSKMET_FK7 FOREIGN KEY (PRIORITY_ID)
		REFERENCES D_PRIORITY (PRIORITY_ID);							
	
ALTER TABLE F_C_TASK_METRICS ADD CONSTRAINT F_C_TSKMET_FK8 FOREIGN KEY (ITERATION_ID)
		REFERENCES D_ITERATION (ITERATION_ID);	
		
ALTER TABLE F_C_TASK_METRICS ADD CONSTRAINT F_C_TSKMET_FK9 FOREIGN KEY (TASK_TYPE_ID)
		REFERENCES D_TASK_TYPE (TASK_TYPE_ID);	

ALTER TABLE F_C_LAB_RESUTILIZATION_METRICS ADD CONSTRAINT F_C_LABRESUTL_FK1 FOREIGN KEY (RESOURCE_GROUP_ID)
		REFERENCES D_RESOURCE_GROUP (RESOURCE_GROUP_ID);
		
ALTER TABLE F_C_LAB_RESUTILIZATION_METRICS ADD CONSTRAINT F_C_LABRESUTL_FK2 FOREIGN KEY (OWNER_ID)
		REFERENCES D_RESOURCE (RESOURCE_ID);		

ALTER TABLE F_C_LAB_RESUTILIZATION_METRICS ADD CONSTRAINT F_C_LABRESUTL_FK3 FOREIGN KEY (OS_TYPE_ID)
		REFERENCES D_OS_TYPE (OS_TYPE_ID);		
		
ALTER TABLE F_C_LAB_RESUTILIZATION_METRICS ADD CONSTRAINT F_C_LABRESUTL_FK4 FOREIGN KEY (RESERVATION_DATE_ID)
		REFERENCES D_DATE (DATE_ID);	
		
ALTER TABLE F_C_LAB_RESUTILIZATION_METRICS ADD CONSTRAINT F_C_LABRESUTL_FK5 FOREIGN KEY (PROJECT_ID)
		REFERENCES D_PROJECT (PROJECT_ID);			

ALTER TABLE F_C_TEXT_FILE_CHANGE_METRICS ADD CONSTRAINT FCFTXTCHNGM_FK1 FOREIGN KEY (FILE_CLASS_ID)
		REFERENCES D_FILE_CLASSIFICATION (FILE_CLASS_ID);
		
ALTER TABLE F_C_TEXT_FILE_CHANGE_METRICS ADD CONSTRAINT FCFTXTCHNGM_FK2 FOREIGN KEY (DATE_ID)
		REFERENCES D_DATE (DATE_ID);	
		
ALTER TABLE F_C_TEXT_FILE_CHANGE_METRICS ADD CONSTRAINT FCFTXTCHNGM_FK3 FOREIGN KEY (PROJECT_ID)
		REFERENCES D_PROJECT (PROJECT_ID);			
		
ALTER TABLE F_C_TEXT_FILE_CHANGE_METRICS ADD CONSTRAINT FCFTXTCHNGM_FK4 FOREIGN KEY (TEAM_ID)
		REFERENCES D_TEAM (TEAM_ID);		
		
ALTER TABLE F_C_TEXT_FILE_CHANGE_METRICS ADD CONSTRAINT FCFTXTCHNGM_FK5 FOREIGN KEY (FILE_STREAM_ID)
		REFERENCES D_FILE_STREAM (FILE_STREAM_ID);			
		
ALTER TABLE F_C_TEXT_FILE_CHANGE_METRICS ADD CONSTRAINT FCFTXTCHNGM_FK6 FOREIGN KEY (COMPONENT_ID)
		REFERENCES D_COMPONENT (COMPONENT_ID);			

ALTER TABLE F_C_FILE_STREAM_METRICS	ADD CONSTRAINT 	FCFILESTRMET_FK1 FOREIGN KEY (DATE_ID)
		REFERENCES D_DATE (DATE_ID);

ALTER TABLE F_C_FILE_STREAM_METRICS	ADD CONSTRAINT 	FCFILESTRMET_FK2 FOREIGN KEY (FILE_STREAM_CLASS_ID)
		REFERENCES D_FILE_STREAM_CLASSIFICATION (FILE_STREAM_CLASS_ID);

ALTER TABLE F_C_FILE_STREAM_METRICS	ADD CONSTRAINT 	FCFILESTRMET_FK3 FOREIGN KEY (PROJECT_ID)
		REFERENCES D_PROJECT (PROJECT_ID);

ALTER TABLE F_C_FILE_STREAM_METRICS	ADD CONSTRAINT 	FCFILESTRMET_FK4 FOREIGN KEY (TEAM_ID)
		REFERENCES D_TEAM (TEAM_ID);

ALTER TABLE F_C_FILE_STREAM_METRICS	ADD CONSTRAINT 	FCFILESTRMET_FK5 FOREIGN KEY (FILE_STREAM_ID)
		REFERENCES D_FILE_STREAM (FILE_STREAM_ID);

ALTER TABLE F_C_RELEASE_REQUEST_METRICS ADD CONSTRAINT F_C_RELREQ_FK1 FOREIGN KEY (DATE_ID)
		REFERENCES D_DATE (DATE_ID);
		
ALTER TABLE F_C_RELEASE_REQUEST_METRICS ADD CONSTRAINT F_C_RELREQ_FK2 FOREIGN KEY (REQUEST_CLASS_ID)
		REFERENCES D_REQUEST_CLASSIFICATION (REQUEST_CLASS_ID);

ALTER TABLE F_C_RELEASE_REQUEST_METRICS ADD CONSTRAINT F_C_RELREQ_FK3 FOREIGN KEY (RELEASE_ID)
		REFERENCES D_RELEASE (RELEASE_ID);	
		
ALTER TABLE F_C_RELEASE_REQUEST_METRICS ADD CONSTRAINT F_C_RELREQ_FK4 FOREIGN KEY (PRODUCT_ID)
		REFERENCES D_PRODUCT (PRODUCT_ID);	
		
ALTER TABLE F_C_RELEASE_REQUEST_METRICS ADD CONSTRAINT F_C_RELREQ_FK5 FOREIGN KEY (STATE_ID)
		REFERENCES D_REQUEST_STATE (STATE_ID);			
		
ALTER TABLE F_C_RELEASE_REQUEST_METRICS ADD CONSTRAINT F_C_RELREQ_FK6 FOREIGN KEY (SEVERITY_ID)
		REFERENCES D_REQUEST_SEVERITY (SEVERITY_ID);	
		
ALTER TABLE F_C_RELEASE_REQUEST_METRICS ADD CONSTRAINT F_C_RELREQ_FK7 FOREIGN KEY (REQUEST_TYPE_ID)
		REFERENCES D_REQUEST_TYPE (REQUEST_TYPE_ID);	
		
ALTER TABLE F_C_RELEASE_REQUEST_METRICS ADD CONSTRAINT F_C_RELREQ_FK8 FOREIGN KEY (PROJECT_ID)
		REFERENCES D_PROJECT (PROJECT_ID);			

ALTER TABLE F_C_REL_REQUEST_TURN_METRICS ADD CONSTRAINT F_C_RELREQTU_FK1 FOREIGN KEY (DATE_ID)
		REFERENCES D_DATE (DATE_ID);
		
ALTER TABLE F_C_REL_REQUEST_TURN_METRICS ADD CONSTRAINT F_C_RELREQTU_FK2 FOREIGN KEY (REQUEST_CLASS_ID)
		REFERENCES D_REQUEST_CLASSIFICATION (REQUEST_CLASS_ID);

ALTER TABLE F_C_REL_REQUEST_TURN_METRICS ADD CONSTRAINT F_C_RELREQTU_FK3 FOREIGN KEY (RELEASE_ID)
		REFERENCES D_RELEASE (RELEASE_ID);	
		
ALTER TABLE F_C_REL_REQUEST_TURN_METRICS ADD CONSTRAINT F_C_RELREQTU_FK4 FOREIGN KEY (PRODUCT_ID)
		REFERENCES D_PRODUCT (PRODUCT_ID);	
		
ALTER TABLE F_C_REL_REQUEST_TURN_METRICS ADD CONSTRAINT F_C_RELREQTU_FK5 FOREIGN KEY (STATE_ID)
		REFERENCES D_REQUEST_STATE (STATE_ID);			
		
ALTER TABLE F_C_REL_REQUEST_TURN_METRICS ADD CONSTRAINT F_C_RELREQTU_FK6 FOREIGN KEY (SEVERITY_ID)
		REFERENCES D_REQUEST_SEVERITY (SEVERITY_ID);	
		
ALTER TABLE F_C_REL_REQUEST_TURN_METRICS ADD CONSTRAINT F_C_RELREQTU_FK7 FOREIGN KEY (REQUEST_TYPE_ID)
		REFERENCES D_REQUEST_TYPE (REQUEST_TYPE_ID);								

ALTER TABLE F_C_REL_REQUEST_TURN_METRICS ADD CONSTRAINT F_C_RELREQTU_FK8 FOREIGN KEY (PROJECT_ID)
		REFERENCES D_PROJECT (PROJECT_ID);		

ALTER TABLE D_PROJECT ADD CONSTRAINT PROJECT_FK1 FOREIGN KEY (PROGRAM_ID)
  REFERENCES D_PROGRAM (PROGRAM_ID);
  
ALTER TABLE D_COMPONENT  ADD CONSTRAINT  D_COMPONENT_FK1  FOREIGN KEY (PRODUCT_ID)
  REFERENCES D_PRODUCT(PRODUCT_ID);
  
ALTER TABLE F_ACTIVITY_ITER_METRICS  ADD CONSTRAINT  F_ACTITER_MET_FK1  FOREIGN KEY (ACTIVITY_CLASS_ID)
  REFERENCES D_ACTIVITY_CLASSIFICATION(ACTIVITY_CLASS_ID);
  
ALTER TABLE F_ACTIVITY_ITER_METRICS  ADD CONSTRAINT  F_ACTITER_MET_FK4  FOREIGN KEY (DATE_ID)
  REFERENCES D_DATE(DATE_ID);
 
ALTER TABLE F_ACTIVITY_ITER_METRICS  ADD CONSTRAINT  F_ACTITER_MET_FK5  FOREIGN KEY (ITERATION_ID)
  REFERENCES D_ITERATION(ITERATION_ID);
  
ALTER TABLE F_ACTIVITY_ITER_METRICS  ADD CONSTRAINT  F_ACTITER_MET_FK6  FOREIGN KEY (PRIORITY_ID)
  REFERENCES D_PRIORITY(PRIORITY_ID);
 
ALTER TABLE F_ACTIVITY_ITER_METRICS  ADD CONSTRAINT  F_ACTITER_MET_FK7  FOREIGN KEY (PROJECT_ID)
  REFERENCES D_PROJECT(PROJECT_ID);
  
ALTER TABLE F_ACTIVITY_ITER_METRICS  ADD CONSTRAINT  F_ACTITER_MET_FK8  FOREIGN KEY (RESOURCE_ID)
  REFERENCES D_RESOURCE(RESOURCE_ID);
 
ALTER TABLE F_ACTIVITY_ITER_METRICS  ADD CONSTRAINT  F_ACTITER_MET_FK9  FOREIGN KEY (STATE_ID)
  REFERENCES D_ACTIVITY_STATE(STATE_ID);
  
ALTER TABLE F_ACTIVITY_REQ_METRICS  ADD CONSTRAINT  F_ACTREQ_MET_FK1  FOREIGN KEY (ACTIVITY_CLASS_ID)
  REFERENCES D_ACTIVITY_CLASSIFICATION(ACTIVITY_CLASS_ID);
  
ALTER TABLE F_ACTIVITY_REQ_METRICS  ADD CONSTRAINT  F_ACTREQ_MET_FK4  FOREIGN KEY (DATE_ID)
  REFERENCES D_DATE(DATE_ID);
 
ALTER TABLE F_ACTIVITY_REQ_METRICS  ADD CONSTRAINT  F_ACTREQ_MET_FK5  FOREIGN KEY (ITERATION_ID)
  REFERENCES D_ITERATION(ITERATION_ID);
  
ALTER TABLE F_ACTIVITY_REQ_METRICS  ADD CONSTRAINT  F_ACTREQ_MET_FK6  FOREIGN KEY (PRIORITY_ID)
  REFERENCES D_PRIORITY(PRIORITY_ID);
 
ALTER TABLE F_ACTIVITY_REQ_METRICS  ADD CONSTRAINT  F_ACTREQ_MET_FK7  FOREIGN KEY (PROJECT_ID)
  REFERENCES D_PROJECT(PROJECT_ID);
  
ALTER TABLE F_ACTIVITY_REQ_METRICS  ADD CONSTRAINT  F_ACTREQ_MET_FK8  FOREIGN KEY (REQUIREMENT_ID)
  REFERENCES D_REQUIREMENT(REQUIREMENT_ID);
  
ALTER TABLE F_ACTIVITY_REQ_METRICS  ADD CONSTRAINT  F_ACTREQ_MET_FK9  FOREIGN KEY (RESOURCE_ID)
  REFERENCES D_RESOURCE(RESOURCE_ID);
 
ALTER TABLE F_ACTIVITY_REQ_METRICS  ADD CONSTRAINT  F_ACTREQ_MET_FK10 FOREIGN KEY (STATE_ID)
  REFERENCES D_ACTIVITY_STATE(STATE_ID);
 
ALTER TABLE F_ACT_ITER_CREATION_DT_METRICS  ADD CONSTRAINT  F_AICRDT_MET_FK2  FOREIGN KEY (ACTIVITY_CLASS_ID)
  REFERENCES D_ACTIVITY_CLASSIFICATION(ACTIVITY_CLASS_ID);
  
ALTER TABLE F_ACT_ITER_CREATION_DT_METRICS  ADD CONSTRAINT  F_AICRDT_MET_FK4  FOREIGN KEY (ITERATION_ID)
  REFERENCES D_ITERATION(ITERATION_ID);
  
ALTER TABLE F_ACT_ITER_CREATION_DT_METRICS  ADD CONSTRAINT  F_AICRDT_MET_FK5  FOREIGN KEY (PRIORITY_ID)
  REFERENCES D_PRIORITY(PRIORITY_ID);
 
ALTER TABLE F_ACT_ITER_CREATION_DT_METRICS  ADD CONSTRAINT  F_AICRDT_MET_FK6  FOREIGN KEY (PROJECT_ID)
  REFERENCES D_PROJECT(PROJECT_ID);
  
ALTER TABLE F_ACT_ITER_CREATION_DT_METRICS  ADD CONSTRAINT  F_AICRDT_MET_FK7  FOREIGN KEY (RESOURCE_ID)
  REFERENCES D_RESOURCE(RESOURCE_ID);
 
ALTER TABLE F_ACT_ITER_CREATION_DT_METRICS  ADD CONSTRAINT  F_AICRDT_MET_FK8  FOREIGN KEY (STATE_ID)
  REFERENCES D_ACTIVITY_STATE(STATE_ID);
 
ALTER TABLE F_ACT_REQU_CREATION_DT_METRICS  ADD CONSTRAINT  F_ARCRDT_MET_FK2  FOREIGN KEY (ACTIVITY_CLASS_ID)
  REFERENCES D_ACTIVITY_CLASSIFICATION(ACTIVITY_CLASS_ID);
  
ALTER TABLE F_ACT_REQU_CREATION_DT_METRICS  ADD CONSTRAINT  F_ARCRDT_MET_FK4  FOREIGN KEY (PRIORITY_ID)
  REFERENCES D_PRIORITY(PRIORITY_ID);
 
ALTER TABLE F_ACT_REQU_CREATION_DT_METRICS  ADD CONSTRAINT  F_ARCRDT_MET_FK5  FOREIGN KEY (PROJECT_ID)
  REFERENCES D_PROJECT(PROJECT_ID);
  
ALTER TABLE F_ACT_REQU_CREATION_DT_METRICS  ADD CONSTRAINT  F_ARCRDT_MET_FK6  FOREIGN KEY (REQUIREMENT_ID)
  REFERENCES D_REQUIREMENT(REQUIREMENT_ID);
  
ALTER TABLE F_ACT_REQU_CREATION_DT_METRICS  ADD CONSTRAINT  F_ARCRDT_MET_FK7  FOREIGN KEY (RESOURCE_ID)
  REFERENCES D_RESOURCE(RESOURCE_ID);
 
ALTER TABLE F_ACT_REQU_CREATION_DT_METRICS  ADD CONSTRAINT  F_ARCRDT_MET_FK8  FOREIGN KEY (STATE_ID)
  REFERENCES D_ACTIVITY_STATE(STATE_ID);
  
ALTER TABLE F_BUILD_REQUI_METRICS  ADD CONSTRAINT  F_BLDREQUI_MET_FK1 FOREIGN KEY (BUILD_CLASS_ID)
  REFERENCES D_BUILD_CLASSIFICATION(BUILD_CLASS_ID);
  
ALTER TABLE F_BUILD_REQUI_METRICS  ADD CONSTRAINT  F_BLDREQUI_MET_FK3 FOREIGN KEY (BUILD_TYPE_ID)
  REFERENCES D_BUILD_TYPE(BUILD_TYPE_ID);
 
ALTER TABLE F_BUILD_REQUI_METRICS  ADD CONSTRAINT  F_BLDREQUI_MET_FK4 FOREIGN KEY (COMPONENT_ID)
  REFERENCES D_COMPONENT(COMPONENT_ID);
  
ALTER TABLE F_BUILD_REQUI_METRICS  ADD CONSTRAINT  F_BLDREQUI_MET_FK5 FOREIGN KEY (DATE_ID)
  REFERENCES D_DATE(DATE_ID);
 
ALTER TABLE F_BUILD_REQUI_METRICS  ADD CONSTRAINT  F_BLDREQUI_MET_FK6 FOREIGN KEY (ITERATION_ID)
  REFERENCES D_ITERATION(ITERATION_ID);
  
ALTER TABLE F_BUILD_REQUI_METRICS  ADD CONSTRAINT  F_BLDREQUI_MET_FK7 FOREIGN KEY (PROJECT_ID)
  REFERENCES D_PROJECT(PROJECT_ID);
  
ALTER TABLE F_BUILD_REQUI_METRICS  ADD CONSTRAINT  F_BLDREQUI_MET_FK8 FOREIGN KEY (RELEASE_ID)
  REFERENCES D_RELEASE(RELEASE_ID);
  
ALTER TABLE F_BUILD_REQUI_METRICS  ADD CONSTRAINT  F_BLDREQUI_MET_FK9 FOREIGN KEY (REQUIREMENT_ID)
  REFERENCES D_REQUIREMENT(REQUIREMENT_ID);
  
ALTER TABLE F_BUILD_REQU_EXEC_DT_METRICS  ADD CONSTRAINT  F_BREDT_MET_FK1 FOREIGN KEY (BUILD_CLASS_ID)
  REFERENCES D_BUILD_CLASSIFICATION(BUILD_CLASS_ID); 
 
ALTER TABLE F_BUILD_REQU_EXEC_DT_METRICS  ADD CONSTRAINT  F_BREDT_MET_FK3 FOREIGN KEY (BUILD_TYPE_ID)
  REFERENCES D_BUILD_TYPE(BUILD_TYPE_ID);
 
ALTER TABLE F_BUILD_REQU_EXEC_DT_METRICS  ADD CONSTRAINT  F_BREDT_MET_FK4 FOREIGN KEY (COMPONENT_ID)
  REFERENCES D_COMPONENT(COMPONENT_ID);
  
ALTER TABLE F_BUILD_REQU_EXEC_DT_METRICS  ADD CONSTRAINT  F_BREDT_MET_FK5 FOREIGN KEY (ITERATION_ID)
  REFERENCES D_ITERATION(ITERATION_ID);
  
ALTER TABLE F_BUILD_REQU_EXEC_DT_METRICS  ADD CONSTRAINT  F_BREDT_MET_FK6 FOREIGN KEY (PROJECT_ID)
  REFERENCES D_PROJECT(PROJECT_ID);
  
ALTER TABLE F_BUILD_REQU_EXEC_DT_METRICS  ADD CONSTRAINT  F_BREDT_MET_FK7 FOREIGN KEY (RELEASE_ID)
  REFERENCES D_RELEASE(RELEASE_ID);
  
ALTER TABLE F_BUILD_REQU_EXEC_DT_METRICS  ADD CONSTRAINT  F_BREDT_MET_FK8 FOREIGN KEY (STATUS_ID)
  REFERENCES D_STATUS(STATUS_ID);
 
ALTER TABLE F_BUILD_REQU_METRICS  ADD CONSTRAINT  F_BLDREQU_MET_FK1 FOREIGN KEY (BUILD_CLASS_ID)
  REFERENCES D_BUILD_CLASSIFICATION(BUILD_CLASS_ID); 
  
ALTER TABLE F_BUILD_REQU_METRICS  ADD CONSTRAINT  F_BLDREQU_MET_FK3 FOREIGN KEY (BUILD_TYPE_ID)
  REFERENCES D_BUILD_TYPE(BUILD_TYPE_ID);
 
ALTER TABLE F_BUILD_REQU_METRICS  ADD CONSTRAINT  F_BLDREQU_MET_FK4 FOREIGN KEY (COMPONENT_ID)
  REFERENCES D_COMPONENT(COMPONENT_ID);
  
ALTER TABLE F_BUILD_REQU_METRICS  ADD CONSTRAINT  F_BLDREQU_MET_FK5 FOREIGN KEY (DATE_ID)
  REFERENCES D_DATE(DATE_ID);
 
ALTER TABLE F_BUILD_REQU_METRICS  ADD CONSTRAINT  F_BLDREQU_MET_FK6 FOREIGN KEY (ITERATION_ID)
  REFERENCES D_ITERATION(ITERATION_ID);
  
ALTER TABLE F_BUILD_REQU_METRICS  ADD CONSTRAINT  F_BLDREQU_MET_FK7 FOREIGN KEY (PROJECT_ID)
  REFERENCES D_PROJECT(PROJECT_ID);
  
ALTER TABLE F_BUILD_REQU_METRICS  ADD CONSTRAINT  F_BLDREQU_MET_FK8 FOREIGN KEY (RELEASE_ID)
  REFERENCES D_RELEASE(RELEASE_ID);
  
ALTER TABLE F_C_ACTIVITY_ITER_METRICS  ADD CONSTRAINT  F_CACTITER_MET_FK1  FOREIGN KEY (ACTIVITY_CLASS_ID)
  REFERENCES D_ACTIVITY_CLASSIFICATION(ACTIVITY_CLASS_ID);  
  
ALTER TABLE F_C_ACTIVITY_ITER_METRICS  ADD CONSTRAINT  F_CACTITER_MET_FK4  FOREIGN KEY (DATE_ID)
  REFERENCES D_DATE(DATE_ID);
 
ALTER TABLE F_C_ACTIVITY_ITER_METRICS  ADD CONSTRAINT  F_CACTITER_MET_FK5  FOREIGN KEY (ITERATION_ID)
  REFERENCES D_ITERATION(ITERATION_ID);
  
ALTER TABLE F_C_ACTIVITY_ITER_METRICS  ADD CONSTRAINT  F_CACTITER_MET_FK6  FOREIGN KEY (PRIORITY_ID)
  REFERENCES D_PRIORITY(PRIORITY_ID);
 
ALTER TABLE F_C_ACTIVITY_ITER_METRICS  ADD CONSTRAINT  F_CACTITER_MET_FK7  FOREIGN KEY (PROJECT_ID)
  REFERENCES D_PROJECT(PROJECT_ID);
  
ALTER TABLE F_C_ACTIVITY_ITER_METRICS  ADD CONSTRAINT  F_CACTITER_MET_FK8  FOREIGN KEY (RESOURCE_ID)
  REFERENCES D_RESOURCE(RESOURCE_ID);
 
ALTER TABLE F_C_ACTIVITY_ITER_METRICS  ADD CONSTRAINT  F_CACTITER_MET_FK9  FOREIGN KEY (STATE_ID)
  REFERENCES D_ACTIVITY_STATE(STATE_ID);
 
ALTER TABLE F_C_ACTIVITY_REQ_METRICS  ADD CONSTRAINT  F_C_ACTREQ_MET_FK1  FOREIGN KEY (ACTIVITY_CLASS_ID)
  REFERENCES D_ACTIVITY_CLASSIFICATION(ACTIVITY_CLASS_ID);
  
ALTER TABLE F_C_ACTIVITY_REQ_METRICS  ADD CONSTRAINT  F_C_ACTREQ_MET_FK4  FOREIGN KEY (DATE_ID)
  REFERENCES D_DATE(DATE_ID);
 
ALTER TABLE F_C_ACTIVITY_REQ_METRICS  ADD CONSTRAINT  F_C_ACTREQ_MET_FK5  FOREIGN KEY (ITERATION_ID)
  REFERENCES D_ITERATION(ITERATION_ID);
  
ALTER TABLE F_C_ACTIVITY_REQ_METRICS  ADD CONSTRAINT  F_C_ACTREQ_MET_FK6  FOREIGN KEY (PRIORITY_ID)
  REFERENCES D_PRIORITY(PRIORITY_ID);
 
ALTER TABLE F_C_ACTIVITY_REQ_METRICS  ADD CONSTRAINT  F_C_ACTREQ_MET_FK7  FOREIGN KEY (PROJECT_ID)
  REFERENCES D_PROJECT(PROJECT_ID);
  
ALTER TABLE F_C_ACTIVITY_REQ_METRICS  ADD CONSTRAINT  F_C_ACTREQ_MET_FK8  FOREIGN KEY (REQUIREMENT_ID)
  REFERENCES D_REQUIREMENT(REQUIREMENT_ID);
  
ALTER TABLE F_C_ACTIVITY_REQ_METRICS  ADD CONSTRAINT  F_C_ACTREQ_MET_FK9  FOREIGN KEY (RESOURCE_ID)
  REFERENCES D_RESOURCE(RESOURCE_ID);
 
ALTER TABLE F_C_ACTIVITY_REQ_METRICS  ADD CONSTRAINT  F_CACTREQ_MET_FK10 FOREIGN KEY (STATE_ID)
  REFERENCES D_ACTIVITY_STATE(STATE_ID);
 
ALTER TABLE F_C_BUILD_REQUI_METRICS  ADD CONSTRAINT  F_CBLDREQ_MET_FK1 FOREIGN KEY (BUILD_CLASS_ID)
  REFERENCES D_BUILD_CLASSIFICATION(BUILD_CLASS_ID);
  
ALTER TABLE F_C_BUILD_REQUI_METRICS  ADD CONSTRAINT  F_CBLDREQ_MET_FK3 FOREIGN KEY (BUILD_TYPE_ID)
  REFERENCES D_BUILD_TYPE(BUILD_TYPE_ID);
 
ALTER TABLE F_C_BUILD_REQUI_METRICS  ADD CONSTRAINT  F_CBLDREQ_MET_FK4 FOREIGN KEY (COMPONENT_ID)
  REFERENCES D_COMPONENT(COMPONENT_ID);
  
ALTER TABLE F_C_BUILD_REQUI_METRICS  ADD CONSTRAINT  F_CBLDREQ_MET_FK5 FOREIGN KEY (DATE_ID)
  REFERENCES D_DATE(DATE_ID);
 
ALTER TABLE F_C_BUILD_REQUI_METRICS  ADD CONSTRAINT  F_CBLDREQ_MET_FK6 FOREIGN KEY (ITERATION_ID)
  REFERENCES D_ITERATION(ITERATION_ID);
  
ALTER TABLE F_C_BUILD_REQUI_METRICS  ADD CONSTRAINT  F_CBLDREQ_MET_FK7 FOREIGN KEY (PROJECT_ID)
  REFERENCES D_PROJECT(PROJECT_ID);
  
ALTER TABLE F_C_BUILD_REQUI_METRICS  ADD CONSTRAINT  F_CBLDREQ_MET_FK8 FOREIGN KEY (RELEASE_ID)
  REFERENCES D_RELEASE(RELEASE_ID);
  
ALTER TABLE F_C_BUILD_REQUI_METRICS  ADD CONSTRAINT  F_CBLDREQ_MET_FK9 FOREIGN KEY (REQUIREMENT_ID)
  REFERENCES D_REQUIREMENT(REQUIREMENT_ID);
  
ALTER TABLE F_C_BUILD_REQU_METRICS  ADD CONSTRAINT  F_CBLDREQU_MET_FK1 FOREIGN KEY (BUILD_CLASS_ID)
  REFERENCES D_BUILD_CLASSIFICATION(BUILD_CLASS_ID);
   
ALTER TABLE F_C_BUILD_REQU_METRICS  ADD CONSTRAINT  F_CBLDREQU_MET_FK3 FOREIGN KEY (BUILD_TYPE_ID)
  REFERENCES D_BUILD_TYPE(BUILD_TYPE_ID);
 
ALTER TABLE F_C_BUILD_REQU_METRICS  ADD CONSTRAINT  F_CBLDREQU_MET_FK4 FOREIGN KEY (COMPONENT_ID)
  REFERENCES D_COMPONENT(COMPONENT_ID);
  
ALTER TABLE F_C_BUILD_REQU_METRICS  ADD CONSTRAINT  F_CBLDREQU_MET_FK5 FOREIGN KEY (DATE_ID)
  REFERENCES D_DATE(DATE_ID);
 
ALTER TABLE F_C_BUILD_REQU_METRICS  ADD CONSTRAINT  F_CBLDREQU_MET_FK6 FOREIGN KEY (ITERATION_ID)
  REFERENCES D_ITERATION(ITERATION_ID);
  
ALTER TABLE F_C_BUILD_REQU_METRICS  ADD CONSTRAINT  F_CBLDREQU_MET_FK7 FOREIGN KEY (PROJECT_ID)
  REFERENCES D_PROJECT(PROJECT_ID);
  
ALTER TABLE F_C_BUILD_REQU_METRICS  ADD CONSTRAINT  F_CBLDREQU_MET_FK8 FOREIGN KEY (RELEASE_ID)
  REFERENCES D_RELEASE(RELEASE_ID);
  
ALTER TABLE F_C_EXECRESPOINTS_ITER_METRICS  ADD CONSTRAINT  F_CEPTI_MET_FK1 FOREIGN KEY (DATE_ID)
  REFERENCES D_DATE(DATE_ID);
 
ALTER TABLE F_C_EXECRESPOINTS_ITER_METRICS  ADD CONSTRAINT  F_CEPTI_MET_FK2 FOREIGN KEY (EXECRES_CLASS_ID)
  REFERENCES D_EXECRESULT_CLASSIFICATION(EXECRES_CLASS_ID); 
  
ALTER TABLE F_C_EXECRESPOINTS_ITER_METRICS  ADD CONSTRAINT  F_CEPTI_MET_FK4 FOREIGN KEY (ITERATION_ID)
  REFERENCES D_ITERATION(ITERATION_ID);
  
ALTER TABLE F_C_EXECRESPOINTS_ITER_METRICS  ADD CONSTRAINT  F_CEPTI_MET_FK5 FOREIGN KEY (TESTCASE_ID)
  REFERENCES D_TESTCASE(TESTCASE_ID);
 
ALTER TABLE F_C_EXECRESPOINTS_ITER_METRICS  ADD CONSTRAINT  F_CEPTI_MET_FK6 FOREIGN KEY (TESTPLAN_ID)
  REFERENCES D_TESTPLAN(TESTPLAN_ID);
 
ALTER TABLE F_C_EXECRESPOINTS_ITER_METRICS  ADD CONSTRAINT  F_CEPTI_MET_FK7 FOREIGN KEY (VERDICT_ID)
  REFERENCES D_VERDICT(VERDICT_ID);
  
ALTER TABLE F_C_EXECRESPOINTS_ITER_METRICS  ADD CONSTRAINT  F_CEPTI_MET_FK8 FOREIGN KEY (PROJECT_ID)
  REFERENCES D_PROJECT (PROJECT_ID);  
  
ALTER TABLE F_C_EXEC_RESULT_ITER_METRICS  ADD CONSTRAINT  F_CEREI_MET_FK1 FOREIGN KEY (ASSETREGISTRY_ID)
  REFERENCES D_ASSETREGISTRY(ASSETREGISTRY_ID);
  
ALTER TABLE F_C_EXEC_RESULT_ITER_METRICS  ADD CONSTRAINT  F_CEREI_MET_FK2 FOREIGN KEY (DATE_ID)
  REFERENCES D_DATE(DATE_ID);
 
ALTER TABLE F_C_EXEC_RESULT_ITER_METRICS  ADD CONSTRAINT  F_CEREI_MET_FK3 FOREIGN KEY (EXECRES_CLASS_ID)
  REFERENCES D_EXECRESULT_CLASSIFICATION(EXECRES_CLASS_ID);
   
ALTER TABLE F_C_EXEC_RESULT_ITER_METRICS  ADD CONSTRAINT  F_CEREI_MET_FK4 FOREIGN KEY (ITERATION_ID)
  REFERENCES D_ITERATION(ITERATION_ID);
  
ALTER TABLE F_C_EXEC_RESULT_ITER_METRICS  ADD CONSTRAINT  F_CEREI_MET_FK5 FOREIGN KEY (TESTCASE_ID)
  REFERENCES D_TESTCASE(TESTCASE_ID);
 
ALTER TABLE F_C_EXEC_RESULT_ITER_METRICS  ADD CONSTRAINT  F_CEREI_MET_FK6 FOREIGN KEY (TESTPLAN_ID)
  REFERENCES D_TESTPLAN(TESTPLAN_ID);
 
ALTER TABLE F_C_EXEC_RESULT_ITER_METRICS  ADD CONSTRAINT  F_CEREI_MET_FK7 FOREIGN KEY (VERDICT_ID)
  REFERENCES D_VERDICT(VERDICT_ID);
  
ALTER TABLE F_C_EXEC_RESULT_ITER_METRICS  ADD CONSTRAINT  F_CEREI_MET_FK8 FOREIGN KEY (PROJECT_ID)
  REFERENCES D_PROJECT (PROJECT_ID);   
  
ALTER TABLE F_C_EXEC_WORKITEM_ITER_METRICS  ADD CONSTRAINT  F_CEWI_MET_FK1  FOREIGN KEY (CONFIGURATION_ID)
  REFERENCES D_CONFIGURATION(CONFIGURATION_ID);
  
ALTER TABLE F_C_EXEC_WORKITEM_ITER_METRICS  ADD CONSTRAINT  F_CEWI_MET_FK2  FOREIGN KEY (DATE_ID)
  REFERENCES D_DATE(DATE_ID);
 
ALTER TABLE F_C_EXEC_WORKITEM_ITER_METRICS  ADD CONSTRAINT  F_CEWI_MET_FK4  FOREIGN KEY (EXECWORKIT_CLASS_ID)
  REFERENCES D_EXECWORKITEM_CLASSIFICATION(EXECWORKIT_CLASS_ID);
  
ALTER TABLE F_C_EXEC_WORKITEM_ITER_METRICS  ADD CONSTRAINT  F_CEWI_MET_FK5  FOREIGN KEY (ITERATION_ID)
  REFERENCES D_ITERATION(ITERATION_ID);
  
ALTER TABLE F_C_EXEC_WORKITEM_ITER_METRICS  ADD CONSTRAINT  F_CEWI_MET_FK6  FOREIGN KEY (PROJECT_ID)
  REFERENCES D_PROJECT(PROJECT_ID);
  
ALTER TABLE F_C_EXEC_WORKITEM_ITER_METRICS  ADD CONSTRAINT  F_CEWI_MET_FK7  FOREIGN KEY (TESTPLAN_ID)
  REFERENCES D_TESTPLAN(TESTPLAN_ID);
 
ALTER TABLE F_C_EXEC_WORKITEM_ITER_METRICS  ADD CONSTRAINT  F_CEWI_MET_FK8  FOREIGN KEY (VERDICT_ID)
  REFERENCES D_VERDICT(VERDICT_ID);
  
ALTER TABLE F_C_EXEC_WORKITEM_REQU_METRICS  ADD CONSTRAINT  F_CEWIR_MET_FK1 FOREIGN KEY (CONFIGURATION_ID)
  REFERENCES D_CONFIGURATION(CONFIGURATION_ID);
  
ALTER TABLE F_C_EXEC_WORKITEM_REQU_METRICS  ADD CONSTRAINT  F_CEWIR_MET_FK2 FOREIGN KEY (DATE_ID)
  REFERENCES D_DATE(DATE_ID); 
 
ALTER TABLE F_C_EXEC_WORKITEM_REQU_METRICS  ADD CONSTRAINT  F_CEWIR_MET_FK3 FOREIGN KEY (EXECWORKIT_CLASS_ID)
  REFERENCES D_EXECWORKITEM_CLASSIFICATION(EXECWORKIT_CLASS_ID);
  
ALTER TABLE F_C_EXEC_WORKITEM_REQU_METRICS  ADD CONSTRAINT  F_CEWIR_MET_FK4 FOREIGN KEY (PROJECT_ID)
  REFERENCES D_PROJECT(PROJECT_ID);
  
ALTER TABLE F_C_EXEC_WORKITEM_REQU_METRICS  ADD CONSTRAINT  F_CEWIR_MET_FK5 FOREIGN KEY (RELEASE_ID)
  REFERENCES D_RELEASE(RELEASE_ID);
  
ALTER TABLE F_C_EXEC_WORKITEM_REQU_METRICS  ADD CONSTRAINT  F_CEWIR_MET_FK6 FOREIGN KEY (REQUIREMENT_ID)
  REFERENCES D_REQUIREMENT(REQUIREMENT_ID);
  
ALTER TABLE F_C_EXEC_WORKITEM_REQU_METRICS  ADD CONSTRAINT  F_CEWIR_MET_FK7 FOREIGN KEY (TESTPLAN_ID)
  REFERENCES D_TESTPLAN(TESTPLAN_ID);
 
ALTER TABLE F_C_EXEC_WORKITEM_REQU_METRICS  ADD CONSTRAINT  F_CEWIR_MET_FK8 FOREIGN KEY (VERDICT_ID)
  REFERENCES D_VERDICT(VERDICT_ID);
  
ALTER TABLE F_C_FILE_STREAM_METRICS  ADD CONSTRAINT  F_C_FILESTRMET_FK1 FOREIGN KEY (COMPONENT_ID)
  REFERENCES D_COMPONENT(COMPONENT_ID);
  
ALTER TABLE F_C_REQUEST_CUST_METRICS  ADD CONSTRAINT  F_CREQCU_MET_FK1  FOREIGN KEY (COMPONENT_ID)
  REFERENCES D_COMPONENT(COMPONENT_ID);
  
ALTER TABLE F_C_REQUEST_CUST_METRICS  ADD CONSTRAINT  F_CREQCU_MET_FK2  FOREIGN KEY (DATE_ID)
  REFERENCES D_DATE(DATE_ID);
 
ALTER TABLE F_C_REQUEST_CUST_METRICS  ADD CONSTRAINT  F_CREQCU_MET_FK3  FOREIGN KEY (ITERATION_ID)
  REFERENCES D_ITERATION(ITERATION_ID);
  
ALTER TABLE F_C_REQUEST_CUST_METRICS  ADD CONSTRAINT  F_CREQCU_MET_FK4  FOREIGN KEY (PLATFORM_ID)
  REFERENCES D_PLATFORM(PLATFORM_ID);
 
ALTER TABLE F_C_REQUEST_CUST_METRICS  ADD CONSTRAINT  F_CREQCU_MET_FK5  FOREIGN KEY (PRIORITY_ID)
  REFERENCES D_REQUEST_PRIORITY(PRIORITY_ID);
 
ALTER TABLE F_C_REQUEST_CUST_METRICS  ADD CONSTRAINT  F_CREQCU_MET_FK6  FOREIGN KEY (PROJECT_ID)
  REFERENCES D_PROJECT(PROJECT_ID);
  
ALTER TABLE F_C_REQUEST_CUST_METRICS  ADD CONSTRAINT  F_CREQCU_MET_FK7  FOREIGN KEY (RELEASE_ID)
  REFERENCES D_RELEASE(RELEASE_ID);
  
ALTER TABLE F_C_REQUEST_CUST_METRICS  ADD CONSTRAINT  F_CREQCU_MET_FK8  FOREIGN KEY (REQUEST_CATEGORY_ID)
  REFERENCES D_REQUEST_CATEGORY(REQUEST_CATEGORY_ID);
 
ALTER TABLE F_C_REQUEST_CUST_METRICS  ADD CONSTRAINT  F_CREQCU_MET_FK9  FOREIGN KEY (REQUEST_CLASS_ID)
  REFERENCES D_REQUEST_CLASSIFICATION(REQUEST_CLASS_ID);
   
ALTER TABLE F_C_REQUEST_CUST_METRICS  ADD CONSTRAINT  F_CREQCU_MET_FK11 FOREIGN KEY (REQUEST_TYPE_ID)
  REFERENCES D_REQUEST_TYPE(REQUEST_TYPE_ID);
 
ALTER TABLE F_C_REQUEST_CUST_METRICS  ADD CONSTRAINT  F_CREQCU_MET_FK12 FOREIGN KEY (RESOURCE_ID)
  REFERENCES D_RESOURCE(RESOURCE_ID);
 
ALTER TABLE F_C_REQUEST_CUST_METRICS  ADD CONSTRAINT  F_CREQCU_MET_FK13 FOREIGN KEY (SEVERITY_ID)
  REFERENCES D_REQUEST_SEVERITY(SEVERITY_ID);
 
ALTER TABLE F_C_REQUEST_CUST_METRICS  ADD CONSTRAINT  F_CREQCU_MET_FK14 FOREIGN KEY (STATE_ID)
  REFERENCES D_REQUEST_STATE(STATE_ID);
  
ALTER TABLE F_C_REQUEST_CUST_METRICS  ADD CONSTRAINT  F_CREQCU_MET_FK20 FOREIGN KEY (STATUS_ID)
  REFERENCES D_REQUEST_STATUS(STATUS_ID);
 
ALTER TABLE F_C_REQUEST_CUST_METRICS  ADD CONSTRAINT  F_CREQCU_MET_FK21 FOREIGN KEY (TEAM_ID)
  REFERENCES D_TEAM(TEAM_ID);
 
ALTER TABLE F_C_REQUEST_REQUI_FAIL_METRICS  ADD CONSTRAINT  F_CREQRQF_MET_FK1 FOREIGN KEY (COMPONENT_ID)
  REFERENCES D_COMPONENT(COMPONENT_ID);
  
ALTER TABLE F_C_REQUEST_REQUI_FAIL_METRICS  ADD CONSTRAINT  F_CREQRQF_MET_FK2 FOREIGN KEY (DATE_ID)
  REFERENCES D_DATE(DATE_ID);
 
ALTER TABLE F_C_REQUEST_REQUI_FAIL_METRICS  ADD CONSTRAINT  F_CREQRQF_MET_FK3 FOREIGN KEY (ITERATION_ID)
  REFERENCES D_ITERATION(ITERATION_ID);
  
ALTER TABLE F_C_REQUEST_REQUI_FAIL_METRICS  ADD CONSTRAINT  F_CREQRQF_MET_FK4 FOREIGN KEY (PROJECT_ID)
  REFERENCES D_PROJECT(PROJECT_ID);
  
ALTER TABLE F_C_REQUEST_REQUI_FAIL_METRICS  ADD CONSTRAINT  F_CREQRQF_MET_FK5 FOREIGN KEY (RELEASE_ID)
  REFERENCES D_RELEASE(RELEASE_ID);
    
ALTER TABLE F_C_REQUEST_REQUI_FAIL_METRICS  ADD CONSTRAINT  F_CREQRQF_MET_FK7 FOREIGN KEY (REQUIREMENT_ID)
  REFERENCES D_REQUIREMENT(REQUIREMENT_ID);
  
ALTER TABLE F_C_REQUEST_REQUI_METRICS  ADD CONSTRAINT  F_CREQRQU_MET_FK1  FOREIGN KEY (COMPONENT_ID)
  REFERENCES D_COMPONENT(COMPONENT_ID);
  
ALTER TABLE F_C_REQUEST_REQUI_METRICS  ADD CONSTRAINT  F_CREQRQU_MET_FK2  FOREIGN KEY (DATE_ID)
  REFERENCES D_DATE(DATE_ID);
 
ALTER TABLE F_C_REQUEST_REQUI_METRICS  ADD CONSTRAINT  F_CREQRQU_MET_FK3  FOREIGN KEY (ITERATION_ID)
  REFERENCES D_ITERATION(ITERATION_ID);
  
ALTER TABLE F_C_REQUEST_REQUI_METRICS  ADD CONSTRAINT  F_CREQRQU_MET_FK4  FOREIGN KEY (PLATFORM_ID)
  REFERENCES D_PLATFORM(PLATFORM_ID);
 
ALTER TABLE F_C_REQUEST_REQUI_METRICS  ADD CONSTRAINT  F_CREQRQU_MET_FK5  FOREIGN KEY (PRIORITY_ID)
  REFERENCES D_REQUEST_PRIORITY(PRIORITY_ID);
 
ALTER TABLE F_C_REQUEST_REQUI_METRICS  ADD CONSTRAINT  F_CREQRQU_MET_FK6  FOREIGN KEY (PROJECT_ID)
  REFERENCES D_PROJECT(PROJECT_ID);
  
ALTER TABLE F_C_REQUEST_REQUI_METRICS  ADD CONSTRAINT  F_CREQRQU_MET_FK7  FOREIGN KEY (RELEASE_ID)
  REFERENCES D_RELEASE(RELEASE_ID);
  
ALTER TABLE F_C_REQUEST_REQUI_METRICS  ADD CONSTRAINT  F_CREQRQU_MET_FK8  FOREIGN KEY (REQUEST_CATEGORY_ID)
  REFERENCES D_REQUEST_CATEGORY(REQUEST_CATEGORY_ID);
 
ALTER TABLE F_C_REQUEST_REQUI_METRICS  ADD CONSTRAINT  F_CREQRQU_MET_FK9  FOREIGN KEY (REQUEST_CLASS_ID)
  REFERENCES D_REQUEST_CLASSIFICATION(REQUEST_CLASS_ID);
   
ALTER TABLE F_C_REQUEST_REQUI_METRICS  ADD CONSTRAINT  F_CREQRQU_MET_FK11 FOREIGN KEY (REQUEST_TYPE_ID)
  REFERENCES D_REQUEST_TYPE(REQUEST_TYPE_ID);
 
ALTER TABLE F_C_REQUEST_REQUI_METRICS  ADD CONSTRAINT  F_CREQRQU_MET_FK12 FOREIGN KEY (REQUIREMENT_ID)
  REFERENCES D_REQUIREMENT(REQUIREMENT_ID);
  
ALTER TABLE F_C_REQUEST_REQUI_METRICS  ADD CONSTRAINT  F_CREQRQU_MET_FK13 FOREIGN KEY (RESOURCE_ID)
  REFERENCES D_RESOURCE(RESOURCE_ID);
 
ALTER TABLE F_C_REQUEST_REQUI_METRICS  ADD CONSTRAINT  F_CREQRQU_MET_FK14 FOREIGN KEY (SEVERITY_ID)
  REFERENCES D_REQUEST_SEVERITY(SEVERITY_ID);
 
ALTER TABLE F_C_REQUEST_REQUI_METRICS  ADD CONSTRAINT  F_CREQRQU_MET_FK15 FOREIGN KEY (STATE_ID)
  REFERENCES D_REQUEST_STATE(STATE_ID);
 
ALTER TABLE F_C_REQUEST_REQUI_METRICS  ADD CONSTRAINT  F_CREQRQU_MET_FK21 FOREIGN KEY (STATUS_ID)
  REFERENCES D_REQUEST_STATUS(STATUS_ID);
 
ALTER TABLE F_C_REQUEST_REQUI_METRICS  ADD CONSTRAINT  F_CREQRQU_MET_FK22 FOREIGN KEY (TEAM_ID)
  REFERENCES D_TEAM(TEAM_ID);
  
ALTER TABLE F_C_REQUEST_TPLN_AGING  ADD CONSTRAINT  F_C_REQTPLN_AG_FK2  FOREIGN KEY (COMPONENT_ID)
  REFERENCES D_COMPONENT(COMPONENT_ID);
  
ALTER TABLE F_C_REQUEST_TPLN_AGING  ADD CONSTRAINT  F_C_REQTPLN_AG_FK3  FOREIGN KEY (DATE_ID)
  REFERENCES D_DATE(DATE_ID);
 
ALTER TABLE F_C_REQUEST_TPLN_AGING  ADD CONSTRAINT  F_C_REQTPLN_AG_FK4  FOREIGN KEY (ITERATION_ID)
  REFERENCES D_ITERATION(ITERATION_ID);
  
ALTER TABLE F_C_REQUEST_TPLN_AGING  ADD CONSTRAINT  F_C_REQTPLN_AG_FK5  FOREIGN KEY (PRIORITY_ID)
  REFERENCES D_REQUEST_PRIORITY(PRIORITY_ID);
 
ALTER TABLE F_C_REQUEST_TPLN_AGING  ADD CONSTRAINT  F_C_REQTPLN_AG_FK6  FOREIGN KEY (PROJECT_ID)
  REFERENCES D_PROJECT(PROJECT_ID);
  
ALTER TABLE F_C_REQUEST_TPLN_AGING  ADD CONSTRAINT  F_C_REQTPLN_AG_FK7  FOREIGN KEY (REQUEST_CLASS_ID)
  REFERENCES D_REQUEST_CLASSIFICATION(REQUEST_CLASS_ID);
 
ALTER TABLE F_C_REQUEST_TPLN_AGING  ADD CONSTRAINT  F_C_REQTPLN_AG_FK8  FOREIGN KEY (REQUEST_TYPE_ID)
  REFERENCES D_REQUEST_TYPE(REQUEST_TYPE_ID);
 
ALTER TABLE F_C_REQUEST_TPLN_AGING  ADD CONSTRAINT  F_C_REQTPLN_AG_FK9  FOREIGN KEY (RESOURCE_ID)
  REFERENCES D_RESOURCE(RESOURCE_ID);
 
ALTER TABLE F_C_REQUEST_TPLN_AGING  ADD CONSTRAINT  F_CREQTPLN_AG_FK10 FOREIGN KEY (SEVERITY_ID)
  REFERENCES D_REQUEST_SEVERITY(SEVERITY_ID);
 
ALTER TABLE F_C_REQUEST_TPLN_AGING  ADD CONSTRAINT  F_CREQTPLN_AG_FK11 FOREIGN KEY (STATE_ID)
  REFERENCES D_REQUEST_STATE(STATE_ID);
 
ALTER TABLE F_C_REQUEST_TPLN_AGING  ADD CONSTRAINT  F_CREQTPLN_AG_FK17 FOREIGN KEY (TESTPLAN_ID)
  REFERENCES D_TESTPLAN(TESTPLAN_ID);
 
ALTER TABLE F_C_REQUEST_TPLN_FAIL_METRICS  ADD CONSTRAINT  F_CREQTPF_MET_FK1 FOREIGN KEY (COMPONENT_ID)
  REFERENCES D_COMPONENT(COMPONENT_ID);
  
ALTER TABLE F_C_REQUEST_TPLN_FAIL_METRICS  ADD CONSTRAINT  F_CREQTPF_MET_FK2 FOREIGN KEY (DATE_ID)
  REFERENCES D_DATE(DATE_ID);
 
ALTER TABLE F_C_REQUEST_TPLN_FAIL_METRICS  ADD CONSTRAINT  F_CREQTPF_MET_FK3 FOREIGN KEY (ITERATION_ID)
  REFERENCES D_ITERATION(ITERATION_ID);
  
ALTER TABLE F_C_REQUEST_TPLN_FAIL_METRICS  ADD CONSTRAINT  F_CREQTPF_MET_FK4 FOREIGN KEY (PROJECT_ID)
  REFERENCES D_PROJECT(PROJECT_ID);
  
ALTER TABLE F_C_REQUEST_TPLN_FAIL_METRICS  ADD CONSTRAINT  F_CREQTPF_MET_FK5 FOREIGN KEY (RELEASE_ID)
  REFERENCES D_RELEASE(RELEASE_ID);  
  
ALTER TABLE F_C_REQUEST_TPLN_FAIL_METRICS  ADD CONSTRAINT  F_CREQTPF_MET_FK7 FOREIGN KEY (TESTPLAN_ID)
  REFERENCES D_TESTPLAN(TESTPLAN_ID);
 
ALTER TABLE F_C_REQUEST_TPLN_METRICS  ADD CONSTRAINT  F_CREQTP_MET_FK1  FOREIGN KEY (COMPONENT_ID)
  REFERENCES D_COMPONENT(COMPONENT_ID);
  
ALTER TABLE F_C_REQUEST_TPLN_METRICS  ADD CONSTRAINT  F_CREQTP_MET_FK2  FOREIGN KEY (DATE_ID)
  REFERENCES D_DATE(DATE_ID);
 
ALTER TABLE F_C_REQUEST_TPLN_METRICS  ADD CONSTRAINT  F_CREQTP_MET_FK3  FOREIGN KEY (ITERATION_ID)
  REFERENCES D_ITERATION(ITERATION_ID);
  
ALTER TABLE F_C_REQUEST_TPLN_METRICS  ADD CONSTRAINT  F_CREQTP_MET_FK4  FOREIGN KEY (PLATFORM_ID)
  REFERENCES D_PLATFORM(PLATFORM_ID);
 
ALTER TABLE F_C_REQUEST_TPLN_METRICS  ADD CONSTRAINT  F_CREQTP_MET_FK5  FOREIGN KEY (PRIORITY_ID)
  REFERENCES D_REQUEST_PRIORITY(PRIORITY_ID);
 
ALTER TABLE F_C_REQUEST_TPLN_METRICS  ADD CONSTRAINT  F_CREQTP_MET_FK6  FOREIGN KEY (PROJECT_ID)
  REFERENCES D_PROJECT(PROJECT_ID);
  
ALTER TABLE F_C_REQUEST_TPLN_METRICS  ADD CONSTRAINT  F_CREQTP_MET_FK7  FOREIGN KEY (RELEASE_ID)
  REFERENCES D_RELEASE(RELEASE_ID);
  
ALTER TABLE F_C_REQUEST_TPLN_METRICS  ADD CONSTRAINT  F_CREQTP_MET_FK8  FOREIGN KEY (REQUEST_CATEGORY_ID)
  REFERENCES D_REQUEST_CATEGORY(REQUEST_CATEGORY_ID);
 
ALTER TABLE F_C_REQUEST_TPLN_METRICS  ADD CONSTRAINT  F_CREQTP_MET_FK9  FOREIGN KEY (REQUEST_CLASS_ID)
  REFERENCES D_REQUEST_CLASSIFICATION(REQUEST_CLASS_ID);
  
ALTER TABLE F_C_REQUEST_TPLN_METRICS  ADD CONSTRAINT  F_CREQTP_MET_FK11 FOREIGN KEY (REQUEST_TYPE_ID)
  REFERENCES D_REQUEST_TYPE(REQUEST_TYPE_ID);
  
ALTER TABLE F_C_REQUEST_TPLN_METRICS  ADD CONSTRAINT  F_CREQTP_MET_FK13 FOREIGN KEY (RESOURCE_ID)
  REFERENCES D_RESOURCE(RESOURCE_ID);
 
ALTER TABLE F_C_REQUEST_TPLN_METRICS  ADD CONSTRAINT  F_CREQTP_MET_FK14 FOREIGN KEY (SEVERITY_ID)
  REFERENCES D_REQUEST_SEVERITY(SEVERITY_ID);
 
ALTER TABLE F_C_REQUEST_TPLN_METRICS  ADD CONSTRAINT  F_CREQTP_MET_FK15 FOREIGN KEY (STATE_ID)
  REFERENCES D_REQUEST_STATE(STATE_ID);
  
ALTER TABLE F_C_REQUEST_TPLN_METRICS  ADD CONSTRAINT  F_CREQTP_MET_FK21 FOREIGN KEY (STATUS_ID)
  REFERENCES D_REQUEST_STATUS(STATUS_ID);
 
ALTER TABLE F_C_REQUEST_TPLN_METRICS  ADD CONSTRAINT  F_CREQTP_MET_FK22 FOREIGN KEY (TEAM_ID)
  REFERENCES D_TEAM(TEAM_ID);

ALTER TABLE F_C_REQUEST_TPLN_METRICS  ADD CONSTRAINT  F_CREQTP_MET_FK23 FOREIGN KEY (TESTPLAN_ID)
  REFERENCES D_TESTPLAN(TESTPLAN_ID);
 
ALTER TABLE F_C_REQUEST_TPLN_TURNAROUND  ADD CONSTRAINT  F_CREQTPT_MET_FK1  FOREIGN KEY (COMPONENT_ID)
  REFERENCES D_COMPONENT(COMPONENT_ID);
  
ALTER TABLE F_C_REQUEST_TPLN_TURNAROUND  ADD CONSTRAINT  F_CREQTPT_MET_FK2  FOREIGN KEY (DATE_ID)
  REFERENCES D_DATE(DATE_ID);
 
ALTER TABLE F_C_REQUEST_TPLN_TURNAROUND  ADD CONSTRAINT  F_CREQTPT_MET_FK3  FOREIGN KEY (ITERATION_ID)
  REFERENCES D_ITERATION(ITERATION_ID);
  
ALTER TABLE F_C_REQUEST_TPLN_TURNAROUND  ADD CONSTRAINT  F_CREQTPT_MET_FK4  FOREIGN KEY (PRIORITY_ID)
  REFERENCES D_REQUEST_PRIORITY(PRIORITY_ID);
 
ALTER TABLE F_C_REQUEST_TPLN_TURNAROUND  ADD CONSTRAINT  F_CREQTPT_MET_FK5  FOREIGN KEY (PROJECT_ID)
  REFERENCES D_PROJECT(PROJECT_ID);
  
ALTER TABLE F_C_REQUEST_TPLN_TURNAROUND  ADD CONSTRAINT  F_CREQTPT_MET_FK6  FOREIGN KEY (REQUEST_CLASS_ID)
  REFERENCES D_REQUEST_CLASSIFICATION(REQUEST_CLASS_ID);
 
ALTER TABLE F_C_REQUEST_TPLN_TURNAROUND  ADD CONSTRAINT  F_CREQTPT_MET_FK7  FOREIGN KEY (REQUEST_TYPE_ID)
  REFERENCES D_REQUEST_TYPE(REQUEST_TYPE_ID);
 
ALTER TABLE F_C_REQUEST_TPLN_TURNAROUND  ADD CONSTRAINT  F_CREQTPT_MET_FK8  FOREIGN KEY (RESOURCE_ID)
  REFERENCES D_RESOURCE(RESOURCE_ID);
 
ALTER TABLE F_C_REQUEST_TPLN_TURNAROUND  ADD CONSTRAINT  F_CREQTPT_MET_FK9  FOREIGN KEY (SEVERITY_ID)
  REFERENCES D_REQUEST_SEVERITY(SEVERITY_ID);
 
 ALTER TABLE F_C_REQUEST_TPLN_TURNAROUND ADD CONSTRAINT F_CREQTPT_MET_FK10 FOREIGN KEY (TESTPLAN_ID)         
  REFERENCES D_TESTPLAN (TESTPLAN_ID);
		
ALTER TABLE F_C_REQUIREMENT_METRICS  ADD CONSTRAINT  F_C_REQU_MET_FK1 FOREIGN KEY (RELEASE_ID)
  REFERENCES D_RELEASE(RELEASE_ID);
  
ALTER TABLE F_C_REQUIREMENT_TPLN_METRICS  ADD CONSTRAINT  F_CREQUTP_MET_FK1  FOREIGN KEY (COMPONENT_ID)
  REFERENCES D_COMPONENT(COMPONENT_ID);
  
ALTER TABLE F_C_REQUIREMENT_TPLN_METRICS  ADD CONSTRAINT  F_CREQUTP_MET_FK2  FOREIGN KEY (DATE_ID)
  REFERENCES D_DATE(DATE_ID);
 
ALTER TABLE F_C_REQUIREMENT_TPLN_METRICS  ADD CONSTRAINT  F_CREQUTP_MET_FK3  FOREIGN KEY (DIFFICULTY_ID)
  REFERENCES D_DIFFICULTY(DIFFICULTY_ID);
 
ALTER TABLE F_C_REQUIREMENT_TPLN_METRICS  ADD CONSTRAINT  F_CREQUTP_MET_FK4  FOREIGN KEY (ITERATION_ID)
  REFERENCES D_ITERATION(ITERATION_ID);
  
ALTER TABLE F_C_REQUIREMENT_TPLN_METRICS  ADD CONSTRAINT  F_CREQUTP_MET_FK5  FOREIGN KEY (PRIORITY_ID)
  REFERENCES D_PRIORITY(PRIORITY_ID);
 
ALTER TABLE F_C_REQUIREMENT_TPLN_METRICS  ADD CONSTRAINT  F_CREQUTP_MET_FK6  FOREIGN KEY (PROJECT_ID)
  REFERENCES D_PROJECT(PROJECT_ID);
  
ALTER TABLE F_C_REQUIREMENT_TPLN_METRICS  ADD CONSTRAINT  F_CREQUTP_MET_FK7  FOREIGN KEY (RELEASE_ID)
  REFERENCES D_RELEASE(RELEASE_ID);
  
ALTER TABLE F_C_REQUIREMENT_TPLN_METRICS  ADD CONSTRAINT  F_CREQUTP_MET_FK8  FOREIGN KEY (REQUIREMENT_CLASS_ID)
  REFERENCES D_REQUIREMENT_CLASSIFICATION(REQUIREMENT_CLASS_ID);
 
ALTER TABLE F_C_REQUIREMENT_TPLN_METRICS  ADD CONSTRAINT  F_CREQUTP_MET_FK10 FOREIGN KEY (RESOURCE_ID)
  REFERENCES D_RESOURCE(RESOURCE_ID);
 
ALTER TABLE F_C_REQUIREMENT_TPLN_METRICS  ADD CONSTRAINT  F_CREQUTP_MET_FK11 FOREIGN KEY (STABILITY_ID)
  REFERENCES D_STABILITY(STABILITY_ID);
  
ALTER TABLE F_C_REQUIREMENT_TPLN_METRICS  ADD CONSTRAINT  F_CREQUTP_MET_FK12 FOREIGN KEY (STATE_ID)
  REFERENCES D_REQUIREMENT_STATE(STATE_ID);
 
ALTER TABLE F_C_REQUIREMENT_TPLN_METRICS  ADD CONSTRAINT  F_CREQUTP_MET_FK18 FOREIGN KEY (STATUS_ID)
  REFERENCES D_STATUS(STATUS_ID);
 
ALTER TABLE F_C_REQUIREMENT_TPLN_METRICS  ADD CONSTRAINT  F_CREQUTP_MET_FK19 FOREIGN KEY (TESTPLAN_ID)
  REFERENCES D_TESTPLAN(TESTPLAN_ID);
 
 ALTER TABLE F_C_REQUIREMENT_TPLN_METRICS  ADD CONSTRAINT  F_CREQUTP_MET_FK20 FOREIGN KEY (REQUIREMENT_TYPE_ID)  
  REFERENCES D_REQUIREMENT_TYPE (REQUIREMENT_TYPE_ID); 
  
ALTER TABLE F_C_REQUI_TCASE_METRICS  ADD CONSTRAINT  F_CREQTC_MET_FK1  FOREIGN KEY (COMPONENT_ID)
  REFERENCES D_COMPONENT(COMPONENT_ID);
  
ALTER TABLE F_C_REQUI_TCASE_METRICS  ADD CONSTRAINT  F_CREQTC_MET_FK2  FOREIGN KEY (DATE_ID)
  REFERENCES D_DATE(DATE_ID);
 
ALTER TABLE F_C_REQUI_TCASE_METRICS  ADD CONSTRAINT  F_CREQTC_MET_FK3  FOREIGN KEY (DIFFICULTY_ID)
  REFERENCES D_DIFFICULTY(DIFFICULTY_ID);
 
ALTER TABLE F_C_REQUI_TCASE_METRICS  ADD CONSTRAINT  F_CREQTC_MET_FK4  FOREIGN KEY (ITERATION_ID)
  REFERENCES D_ITERATION(ITERATION_ID);
  
ALTER TABLE F_C_REQUI_TCASE_METRICS  ADD CONSTRAINT  F_CREQTC_MET_FK5  FOREIGN KEY (PRIORITY_ID)
  REFERENCES D_PRIORITY(PRIORITY_ID);
 
ALTER TABLE F_C_REQUI_TCASE_METRICS  ADD CONSTRAINT  F_CREQTC_MET_FK6  FOREIGN KEY (PROJECT_ID)
  REFERENCES D_PROJECT(PROJECT_ID);
  
ALTER TABLE F_C_REQUI_TCASE_METRICS  ADD CONSTRAINT  F_CREQTC_MET_FK7  FOREIGN KEY (RELEASE_ID)
  REFERENCES D_RELEASE(RELEASE_ID);
  
ALTER TABLE F_C_REQUI_TCASE_METRICS  ADD CONSTRAINT  F_CREQTC_MET_FK8  FOREIGN KEY (REQUIREMENT_CLASS_ID)
  REFERENCES D_REQUIREMENT_CLASSIFICATION(REQUIREMENT_CLASS_ID);
   
ALTER TABLE F_C_REQUI_TCASE_METRICS  ADD CONSTRAINT  F_CREQTC_MET_FK10 FOREIGN KEY (RESOURCE_ID)
  REFERENCES D_RESOURCE(RESOURCE_ID);
 
ALTER TABLE F_C_REQUI_TCASE_METRICS  ADD CONSTRAINT  F_CREQTC_MET_FK11 FOREIGN KEY (STABILITY_ID)
  REFERENCES D_STABILITY(STABILITY_ID);
  
ALTER TABLE F_C_REQUI_TCASE_METRICS  ADD CONSTRAINT  F_CREQTC_MET_FK12 FOREIGN KEY (STATE_ID)
  REFERENCES D_REQUIREMENT_STATE(STATE_ID);
  
ALTER TABLE F_C_REQUI_TCASE_METRICS  ADD CONSTRAINT  F_CREQTC_MET_FK18 FOREIGN KEY (STATUS_ID)
  REFERENCES D_STATUS(STATUS_ID);
 
ALTER TABLE F_C_REQUI_TCASE_METRICS  ADD CONSTRAINT  F_CREQTC_MET_FK19 FOREIGN KEY (TESTCASE_ID)
  REFERENCES D_TESTCASE(TESTCASE_ID);
  
ALTER TABLE F_C_REQUI_TCASE_METRICS  ADD CONSTRAINT  F_CREQTC_MET_FK20 FOREIGN KEY (REQUIREMENT_TYPE_ID)
  REFERENCES D_REQUIREMENT_TYPE (REQUIREMENT_TYPE_ID);   
 
ALTER TABLE F_C_TASK_COMP_METRICS  ADD CONSTRAINT  F_CTKCM_MET_FK1  FOREIGN KEY (COMPONENT_ID)
  REFERENCES D_COMPONENT(COMPONENT_ID);
  
ALTER TABLE F_C_TASK_COMP_METRICS  ADD CONSTRAINT  F_CTKCM_MET_FK2  FOREIGN KEY (DATE_ID)
  REFERENCES D_DATE(DATE_ID);
 
ALTER TABLE F_C_TASK_COMP_METRICS  ADD CONSTRAINT  F_CTKCM_MET_FK3  FOREIGN KEY (ITERATION_ID)
  REFERENCES D_ITERATION(ITERATION_ID);
  
ALTER TABLE F_C_TASK_COMP_METRICS  ADD CONSTRAINT  F_CTKCM_MET_FK4  FOREIGN KEY (PRIORITY_ID)
  REFERENCES D_PRIORITY(PRIORITY_ID);
 
ALTER TABLE F_C_TASK_COMP_METRICS  ADD CONSTRAINT  F_CTKCM_MET_FK5  FOREIGN KEY (PROJECT_ID)
  REFERENCES D_PROJECT(PROJECT_ID);
  
ALTER TABLE F_C_TASK_COMP_METRICS  ADD CONSTRAINT  F_CTKCM_MET_FK6  FOREIGN KEY (RESOURCE_ID)
  REFERENCES D_RESOURCE(RESOURCE_ID);
 
ALTER TABLE F_C_TASK_COMP_METRICS  ADD CONSTRAINT  F_CTKCM_MET_FK7  FOREIGN KEY (STATE_ID)
  REFERENCES D_TASK_STATE(STATE_ID);
 
ALTER TABLE F_C_TASK_COMP_METRICS  ADD CONSTRAINT  F_CTKCM_MET_FK13 FOREIGN KEY (TASK_CLASS_ID)
  REFERENCES D_TASK_CLASSIFICATION(TASK_CLASS_ID);
   
ALTER TABLE F_C_TASK_COMP_METRICS  ADD CONSTRAINT  F_CTKCM_MET_FK15 FOREIGN KEY (TASK_TYPE_ID)
  REFERENCES D_TASK_TYPE(TASK_TYPE_ID);
  
ALTER TABLE F_C_TESTCASE_ITER_METRICS  ADD CONSTRAINT  F_CTSI_MET_FK1  FOREIGN KEY (DATE_ID)
  REFERENCES D_DATE(DATE_ID);
 
ALTER TABLE F_C_TESTCASE_ITER_METRICS  ADD CONSTRAINT  F_CTSI_MET_FK2  FOREIGN KEY (ITERATION_ID)
  REFERENCES D_ITERATION(ITERATION_ID);
  
ALTER TABLE F_C_TESTCASE_ITER_METRICS  ADD CONSTRAINT  F_CTSI_MET_FK3  FOREIGN KEY (STATE_ID)
  REFERENCES D_TESTCASE_STATE(STATE_ID);
 
ALTER TABLE F_C_TESTCASE_ITER_METRICS  ADD CONSTRAINT  F_CTSI_MET_FK9  FOREIGN KEY (TESTCASE_CLASS_ID)
  REFERENCES D_TESTCASE_CLASSIFICATION(TESTCASE_CLASS_ID);
  
ALTER TABLE F_C_TESTCASE_ITER_METRICS  ADD CONSTRAINT  F_CTSI_MET_FK10 FOREIGN KEY (TESTPLAN_ID)
  REFERENCES D_TESTPLAN(TESTPLAN_ID);
  
ALTER TABLE F_C_TESTCASE_ITER_METRICS  ADD CONSTRAINT  F_CTSI_MET_FK11 FOREIGN KEY (PROJECT_ID)
  REFERENCES D_PROJECT (PROJECT_ID);  
 
ALTER TABLE F_C_TESTCASE_REQUI_METRICS  ADD CONSTRAINT  F_CTPJR_MET_FK1  FOREIGN KEY (DATE_ID)
  REFERENCES D_DATE(DATE_ID);
 
ALTER TABLE F_C_TESTCASE_REQUI_METRICS  ADD CONSTRAINT  F_CTPJR_MET_FK2  FOREIGN KEY (PROJECT_ID)
  REFERENCES D_PROJECT(PROJECT_ID);
  
ALTER TABLE F_C_TESTCASE_REQUI_METRICS  ADD CONSTRAINT  F_CTPJR_MET_FK3  FOREIGN KEY (REQUIREMENT_ID)
  REFERENCES D_REQUIREMENT(REQUIREMENT_ID);
  
ALTER TABLE F_C_TESTCASE_REQUI_METRICS  ADD CONSTRAINT  F_CTPJR_MET_FK4  FOREIGN KEY (STATE_ID)
  REFERENCES D_TESTCASE_STATE(STATE_ID);
 
ALTER TABLE F_C_TESTCASE_REQUI_METRICS  ADD CONSTRAINT  F_CTPJR_MET_FK10 FOREIGN KEY (TESTCASE_CLASS_ID)
  REFERENCES D_TESTCASE_CLASSIFICATION(TESTCASE_CLASS_ID);
  
ALTER TABLE F_C_TESTCASE_REQUI_METRICS  ADD CONSTRAINT  F_CTPJR_MET_FK11 FOREIGN KEY (TESTPLAN_ID)
  REFERENCES D_TESTPLAN(TESTPLAN_ID);
 
ALTER TABLE F_C_TEXT_FILE_VERSION_METRICS  ADD CONSTRAINT  F_CTXFV_MET_FK1  FOREIGN KEY (ACTIVITY_ID)
  REFERENCES D_ACTIVITY(ACTIVITY_ID);
 
ALTER TABLE F_C_TEXT_FILE_VERSION_METRICS  ADD CONSTRAINT  F_CTXFV_MET_FK2  FOREIGN KEY (COMPONENT_ID)
  REFERENCES D_COMPONENT(COMPONENT_ID);
  
ALTER TABLE F_C_TEXT_FILE_VERSION_METRICS  ADD CONSTRAINT  F_CTXFV_MET_FK3  FOREIGN KEY (DATE_ID)
  REFERENCES D_DATE(DATE_ID);
  
ALTER TABLE F_C_TEXT_FILE_VERSION_METRICS  ADD CONSTRAINT  F_CTXFV_MET_FK5  FOREIGN KEY (FILE_CLASS_ID)
  REFERENCES D_FILE_CLASSIFICATION(FILE_CLASS_ID);
  
ALTER TABLE F_C_TEXT_FILE_VERSION_METRICS  ADD CONSTRAINT  F_CTXFV_MET_FK6  FOREIGN KEY (FILE_ID)
  REFERENCES D_FILE(FILE_ID);
 
ALTER TABLE F_C_TEXT_FILE_VERSION_METRICS  ADD CONSTRAINT  F_CTXFV_MET_FK7  FOREIGN KEY (FILE_STREAM_ID)
  REFERENCES D_FILE_STREAM(FILE_STREAM_ID);
  
ALTER TABLE F_C_TEXT_FILE_VERSION_METRICS  ADD CONSTRAINT  F_CTXFV_MET_FK8  FOREIGN KEY (PROJECT_ID)
  REFERENCES D_PROJECT(PROJECT_ID);
  
ALTER TABLE F_C_TEXT_FILE_VERSION_METRICS  ADD CONSTRAINT  F_CTXFV_MET_FK9  FOREIGN KEY (RESOURCE_ID)
  REFERENCES D_RESOURCE(RESOURCE_ID);
  
ALTER TABLE F_C_TEXT_FILE_VER_REQU_METRICS  ADD CONSTRAINT  F_CTXFVR_MET_FK1  FOREIGN KEY (ACTIVITY_ID)
  REFERENCES D_ACTIVITY(ACTIVITY_ID);
 
ALTER TABLE F_C_TEXT_FILE_VER_REQU_METRICS  ADD CONSTRAINT  F_CTXFVR_MET_FK2  FOREIGN KEY (COMPONENT_ID)
  REFERENCES D_COMPONENT(COMPONENT_ID);
  
ALTER TABLE F_C_TEXT_FILE_VER_REQU_METRICS  ADD CONSTRAINT  F_CTXFVR_MET_FK3  FOREIGN KEY (DATE_ID)
  REFERENCES D_DATE(DATE_ID);
  
ALTER TABLE F_C_TEXT_FILE_VER_REQU_METRICS  ADD CONSTRAINT  F_CTXFVR_MET_FK5  FOREIGN KEY (FILE_CLASS_ID)
  REFERENCES D_FILE_CLASSIFICATION(FILE_CLASS_ID);
  
ALTER TABLE F_C_TEXT_FILE_VER_REQU_METRICS  ADD CONSTRAINT  F_CTXFVR_MET_FK6  FOREIGN KEY (FILE_ID)
  REFERENCES D_FILE(FILE_ID);
 
ALTER TABLE F_C_TEXT_FILE_VER_REQU_METRICS  ADD CONSTRAINT  F_CTXFVR_MET_FK7  FOREIGN KEY (FILE_STREAM_ID)
  REFERENCES D_FILE_STREAM(FILE_STREAM_ID);
  
ALTER TABLE F_C_TEXT_FILE_VER_REQU_METRICS  ADD CONSTRAINT  F_CTXFVR_MET_FK8  FOREIGN KEY (PROJECT_ID)
  REFERENCES D_PROJECT(PROJECT_ID);
  
ALTER TABLE F_C_TEXT_FILE_VER_REQU_METRICS  ADD CONSTRAINT  F_CTXFVR_MET_FK9  FOREIGN KEY (REQUEST_ID)
  REFERENCES D_REQUEST(REQUEST_ID);
  
ALTER TABLE F_C_TEXT_FILE_VER_REQU_METRICS  ADD CONSTRAINT  F_CTXFVR_MET_FK10 FOREIGN KEY (RESOURCE_ID)
  REFERENCES D_RESOURCE(RESOURCE_ID);
 
 ALTER TABLE F_EXECRESPOINTS_ITER_METRICS  ADD CONSTRAINT  F_EXPI_MET_FK1  FOREIGN KEY (DATE_ID)
  REFERENCES D_DATE(DATE_ID);
 
ALTER TABLE F_EXECRESPOINTS_ITER_METRICS  ADD CONSTRAINT  F_EXPI_MET_FK2  FOREIGN KEY (EXECRES_CLASS_ID)
  REFERENCES D_EXECRESULT_CLASSIFICATION(EXECRES_CLASS_ID);
   
ALTER TABLE F_EXECRESPOINTS_ITER_METRICS  ADD CONSTRAINT  F_EXPI_MET_FK4  FOREIGN KEY (ITERATION_ID)
  REFERENCES D_ITERATION(ITERATION_ID);
  
ALTER TABLE F_EXECRESPOINTS_ITER_METRICS  ADD CONSTRAINT  F_EXPI_MET_FK5  FOREIGN KEY (TESTCASE_ID)
  REFERENCES D_TESTCASE(TESTCASE_ID);
 
ALTER TABLE F_EXECRESPOINTS_ITER_METRICS  ADD CONSTRAINT  F_EXPI_MET_FK6  FOREIGN KEY (TESTPLAN_ID)
  REFERENCES D_TESTPLAN(TESTPLAN_ID);
 
ALTER TABLE F_EXECRESPOINTS_ITER_METRICS  ADD CONSTRAINT  F_EXPI_MET_FK7  FOREIGN KEY (VERDICT_ID)
  REFERENCES D_VERDICT(VERDICT_ID);
  
ALTER TABLE F_EXECRESPOINTS_ITER_METRICS  ADD CONSTRAINT  F_EXPI_MET_FK8  FOREIGN KEY (PROJECT_ID)
  REFERENCES D_PROJECT (PROJECT_ID);  
  
ALTER TABLE F_EXECUTION_RES_ITER_METRICS  ADD CONSTRAINT  F_ERI_MET_FK1  FOREIGN KEY (ASSETREGISTRY_ID)
  REFERENCES D_ASSETREGISTRY(ASSETREGISTRY_ID);
  
ALTER TABLE F_EXECUTION_RES_ITER_METRICS  ADD CONSTRAINT  F_ERI_MET_FK2  FOREIGN KEY (DATE_ID)
  REFERENCES D_DATE(DATE_ID);
 
ALTER TABLE F_EXECUTION_RES_ITER_METRICS  ADD CONSTRAINT  F_ERI_MET_FK3 FOREIGN KEY (EXECRES_CLASS_ID)
  REFERENCES D_EXECRESULT_CLASSIFICATION(EXECRES_CLASS_ID);
  
ALTER TABLE F_EXECUTION_RES_ITER_METRICS  ADD CONSTRAINT  F_ERI_MET_FK4 FOREIGN KEY (ITERATION_ID)
  REFERENCES D_ITERATION(ITERATION_ID);
  
ALTER TABLE F_EXECUTION_RES_ITER_METRICS  ADD CONSTRAINT  F_ERI_MET_FK5 FOREIGN KEY (TESTCASE_ID)
  REFERENCES D_TESTCASE(TESTCASE_ID);
 
ALTER TABLE F_EXECUTION_RES_ITER_METRICS  ADD CONSTRAINT  F_ERI_MET_FK6 FOREIGN KEY (TESTPLAN_ID)
  REFERENCES D_TESTPLAN(TESTPLAN_ID);
 
ALTER TABLE F_EXECUTION_RES_ITER_METRICS  ADD CONSTRAINT  F_ERI_MET_FK7 FOREIGN KEY (VERDICT_ID)
  REFERENCES D_VERDICT(VERDICT_ID);
  
ALTER TABLE F_EXECUTION_RES_ITER_METRICS  ADD CONSTRAINT  F_ERI_MET_FK8 FOREIGN KEY (PROJECT_ID)
  REFERENCES D_PROJECT (PROJECT_ID);  
  
ALTER TABLE F_EXEC_WORKITEM_ITER_METRICS  ADD CONSTRAINT  F_EWI_MET_FK1 FOREIGN KEY (CONFIGURATION_ID)
  REFERENCES D_CONFIGURATION(CONFIGURATION_ID);
  
ALTER TABLE F_EXEC_WORKITEM_ITER_METRICS  ADD CONSTRAINT  F_EWI_MET_FK2 FOREIGN KEY (DATE_ID)
  REFERENCES D_DATE(DATE_ID); 
 
ALTER TABLE F_EXEC_WORKITEM_ITER_METRICS  ADD CONSTRAINT  F_EWI_MET_FK3 FOREIGN KEY (EXECWORKIT_CLASS_ID)
  REFERENCES D_EXECWORKITEM_CLASSIFICATION(EXECWORKIT_CLASS_ID);
  
ALTER TABLE F_EXEC_WORKITEM_ITER_METRICS  ADD CONSTRAINT  F_EWI_MET_FK4 FOREIGN KEY (ITERATION_ID)
  REFERENCES D_ITERATION(ITERATION_ID);
  
ALTER TABLE F_EXEC_WORKITEM_ITER_METRICS  ADD CONSTRAINT  F_EWI_MET_FK5 FOREIGN KEY (PROJECT_ID)
  REFERENCES D_PROJECT(PROJECT_ID);
  
ALTER TABLE F_EXEC_WORKITEM_ITER_METRICS  ADD CONSTRAINT  F_EWI_MET_FK6 FOREIGN KEY (TESTPLAN_ID)
  REFERENCES D_TESTPLAN(TESTPLAN_ID);
 
ALTER TABLE F_EXEC_WORKITEM_ITER_METRICS  ADD CONSTRAINT  F_EWI_MET_FK7 FOREIGN KEY (VERDICT_ID)
  REFERENCES D_VERDICT(VERDICT_ID);
  
ALTER TABLE F_EXEC_WORKITEM_REQU_METRICS  ADD CONSTRAINT  F_EWR_MET_FK1 FOREIGN KEY (CONFIGURATION_ID)
  REFERENCES D_CONFIGURATION(CONFIGURATION_ID);
  
ALTER TABLE F_EXEC_WORKITEM_REQU_METRICS  ADD CONSTRAINT  F_EWR_MET_FK2 FOREIGN KEY (DATE_ID)
  REFERENCES D_DATE(DATE_ID);
  
ALTER TABLE F_EXEC_WORKITEM_REQU_METRICS  ADD CONSTRAINT  F_EWR_MET_FK3 FOREIGN KEY (EXECWORKIT_CLASS_ID)
  REFERENCES D_EXECWORKITEM_CLASSIFICATION(EXECWORKIT_CLASS_ID);
  
ALTER TABLE F_EXEC_WORKITEM_REQU_METRICS  ADD CONSTRAINT  F_EWR_MET_FK4 FOREIGN KEY (PROJECT_ID)
  REFERENCES D_PROJECT(PROJECT_ID);
  
ALTER TABLE F_EXEC_WORKITEM_REQU_METRICS  ADD CONSTRAINT  F_EWR_MET_FK5 FOREIGN KEY (RELEASE_ID)
  REFERENCES D_RELEASE(RELEASE_ID);
  
ALTER TABLE F_EXEC_WORKITEM_REQU_METRICS  ADD CONSTRAINT  F_EWR_MET_FK6 FOREIGN KEY (REQUIREMENT_ID)
  REFERENCES D_REQUIREMENT(REQUIREMENT_ID);
  
ALTER TABLE F_EXEC_WORKITEM_REQU_METRICS  ADD CONSTRAINT  F_EWR_MET_FK7 FOREIGN KEY (TESTPLAN_ID)
  REFERENCES D_TESTPLAN(TESTPLAN_ID);
 
ALTER TABLE F_EXEC_WORKITEM_REQU_METRICS  ADD CONSTRAINT  F_EWR_MET_FK8 FOREIGN KEY (VERDICT_ID)
  REFERENCES D_VERDICT(VERDICT_ID);
  
ALTER TABLE F_FILE_STREAM_METRICS  ADD CONSTRAINT  F_FSTR_MET_FK1  FOREIGN KEY (COMPONENT_ID)
  REFERENCES D_COMPONENT(COMPONENT_ID);
  
ALTER TABLE F_REQUEST_CLOSURE_DATE_METRICS  ADD CONSTRAINT  F_RCLDT_MET_FK1 FOREIGN KEY (ITERATION_ID)
  REFERENCES D_ITERATION(ITERATION_ID);
  
ALTER TABLE F_REQUEST_CUST_METRICS  ADD CONSTRAINT  F_REQCUST_MET_FK1  FOREIGN KEY (COMPONENT_ID)
  REFERENCES D_COMPONENT(COMPONENT_ID);
  
ALTER TABLE F_REQUEST_CUST_METRICS  ADD CONSTRAINT  F_REQCUST_MET_FK2  FOREIGN KEY (DATE_ID)
  REFERENCES D_DATE(DATE_ID);
 
ALTER TABLE F_REQUEST_CUST_METRICS  ADD CONSTRAINT  F_REQCUST_MET_FK3  FOREIGN KEY (ITERATION_ID)
  REFERENCES D_ITERATION(ITERATION_ID);
  
ALTER TABLE F_REQUEST_CUST_METRICS  ADD CONSTRAINT  F_REQCUST_MET_FK4  FOREIGN KEY (PLATFORM_ID)
  REFERENCES D_PLATFORM(PLATFORM_ID);
 
ALTER TABLE F_REQUEST_CUST_METRICS  ADD CONSTRAINT  F_REQCUST_MET_FK5  FOREIGN KEY (PRIORITY_ID)
  REFERENCES D_REQUEST_PRIORITY(PRIORITY_ID);
 
ALTER TABLE F_REQUEST_CUST_METRICS  ADD CONSTRAINT  F_REQCUST_MET_FK6  FOREIGN KEY (PROJECT_ID)
  REFERENCES D_PROJECT(PROJECT_ID);
  
ALTER TABLE F_REQUEST_CUST_METRICS  ADD CONSTRAINT  F_REQCUST_MET_FK7  FOREIGN KEY (RELEASE_ID)
  REFERENCES D_RELEASE(RELEASE_ID);
  
ALTER TABLE F_REQUEST_CUST_METRICS  ADD CONSTRAINT  F_REQCUST_MET_FK8  FOREIGN KEY (REQUEST_CATEGORY_ID)
  REFERENCES D_REQUEST_CATEGORY(REQUEST_CATEGORY_ID);
 
ALTER TABLE F_REQUEST_CUST_METRICS  ADD CONSTRAINT  F_REQCUST_MET_FK9  FOREIGN KEY (REQUEST_CLASS_ID)
  REFERENCES D_REQUEST_CLASSIFICATION(REQUEST_CLASS_ID);
   
ALTER TABLE F_REQUEST_CUST_METRICS  ADD CONSTRAINT  F_REQCUST_MET_FK11 FOREIGN KEY (REQUEST_TYPE_ID)
  REFERENCES D_REQUEST_TYPE(REQUEST_TYPE_ID);
 
ALTER TABLE F_REQUEST_CUST_METRICS  ADD CONSTRAINT  F_REQCUST_MET_FK12 FOREIGN KEY (RESOURCE_ID)
  REFERENCES D_RESOURCE(RESOURCE_ID);
 
ALTER TABLE F_REQUEST_CUST_METRICS  ADD CONSTRAINT  F_REQCUST_MET_FK13 FOREIGN KEY (SEVERITY_ID)
  REFERENCES D_REQUEST_SEVERITY(SEVERITY_ID);
 
ALTER TABLE F_REQUEST_CUST_METRICS  ADD CONSTRAINT  F_REQCUST_MET_FK14 FOREIGN KEY (STATE_ID)
  REFERENCES D_REQUEST_STATE(STATE_ID);
 
ALTER TABLE F_REQUEST_CUST_METRICS  ADD CONSTRAINT  F_REQCUST_MET_FK20 FOREIGN KEY (STATUS_ID)
  REFERENCES D_REQUEST_STATUS(STATUS_ID);
 
ALTER TABLE F_REQUEST_CUST_METRICS  ADD CONSTRAINT  F_REQCUST_MET_FK21 FOREIGN KEY (TEAM_ID)
  REFERENCES D_TEAM(TEAM_ID);
 
ALTER TABLE F_REQUEST_REQUI_FAIL_METRICS  ADD CONSTRAINT  F_RQRUF_MET_FK1 FOREIGN KEY (COMPONENT_ID)
  REFERENCES D_COMPONENT(COMPONENT_ID);
  
ALTER TABLE F_REQUEST_REQUI_FAIL_METRICS  ADD CONSTRAINT  F_RQRUF_MET_FK2 FOREIGN KEY (DATE_ID)
  REFERENCES D_DATE(DATE_ID);
 
ALTER TABLE F_REQUEST_REQUI_FAIL_METRICS  ADD CONSTRAINT  F_RQRUF_MET_FK3 FOREIGN KEY (ITERATION_ID)
  REFERENCES D_ITERATION(ITERATION_ID);
  
ALTER TABLE F_REQUEST_REQUI_FAIL_METRICS  ADD CONSTRAINT  F_RQRUF_MET_FK4 FOREIGN KEY (PROJECT_ID)
  REFERENCES D_PROJECT(PROJECT_ID);
  
ALTER TABLE F_REQUEST_REQUI_FAIL_METRICS  ADD CONSTRAINT  F_RQRUF_MET_FK5 FOREIGN KEY (RELEASE_ID)
  REFERENCES D_RELEASE(RELEASE_ID);
  
ALTER TABLE F_REQUEST_REQUI_FAIL_METRICS  ADD CONSTRAINT  F_RQRUF_MET_FK7 FOREIGN KEY (REQUIREMENT_ID)
  REFERENCES D_REQUIREMENT(REQUIREMENT_ID);
  
ALTER TABLE F_REQUEST_REQUI_METRICS  ADD CONSTRAINT  F_REQREQUI_MET_FK1  FOREIGN KEY (COMPONENT_ID)
  REFERENCES D_COMPONENT(COMPONENT_ID);
  
ALTER TABLE F_REQUEST_REQUI_METRICS  ADD CONSTRAINT  F_REQREQUI_MET_FK2  FOREIGN KEY (DATE_ID)
  REFERENCES D_DATE(DATE_ID);
 
ALTER TABLE F_REQUEST_REQUI_METRICS  ADD CONSTRAINT  F_REQREQUI_MET_FK3  FOREIGN KEY (ITERATION_ID)
  REFERENCES D_ITERATION(ITERATION_ID);
  
ALTER TABLE F_REQUEST_REQUI_METRICS  ADD CONSTRAINT  F_REQREQUI_MET_FK4  FOREIGN KEY (PLATFORM_ID)
  REFERENCES D_PLATFORM(PLATFORM_ID);
 
ALTER TABLE F_REQUEST_REQUI_METRICS  ADD CONSTRAINT  F_REQREQUI_MET_FK5  FOREIGN KEY (PRIORITY_ID)
  REFERENCES D_REQUEST_PRIORITY(PRIORITY_ID);
 
ALTER TABLE F_REQUEST_REQUI_METRICS  ADD CONSTRAINT  F_REQREQUI_MET_FK6  FOREIGN KEY (PROJECT_ID)
  REFERENCES D_PROJECT(PROJECT_ID);
  
ALTER TABLE F_REQUEST_REQUI_METRICS  ADD CONSTRAINT  F_REQREQUI_MET_FK7  FOREIGN KEY (RELEASE_ID)
  REFERENCES D_RELEASE(RELEASE_ID);
  
ALTER TABLE F_REQUEST_REQUI_METRICS  ADD CONSTRAINT  F_REQREQUI_MET_FK8  FOREIGN KEY (REQUEST_CATEGORY_ID)
  REFERENCES D_REQUEST_CATEGORY(REQUEST_CATEGORY_ID);
 
ALTER TABLE F_REQUEST_REQUI_METRICS  ADD CONSTRAINT  F_REQREQUI_MET_FK9  FOREIGN KEY (REQUEST_CLASS_ID)
  REFERENCES D_REQUEST_CLASSIFICATION(REQUEST_CLASS_ID);
  
ALTER TABLE F_REQUEST_REQUI_METRICS  ADD CONSTRAINT  F_RRUI_MET_FK11 FOREIGN KEY (REQUEST_TYPE_ID)
  REFERENCES D_REQUEST_TYPE(REQUEST_TYPE_ID);
 
ALTER TABLE F_REQUEST_REQUI_METRICS  ADD CONSTRAINT  F_RRUI_MET_FK12 FOREIGN KEY (REQUIREMENT_ID)
  REFERENCES D_REQUIREMENT(REQUIREMENT_ID);
  
ALTER TABLE F_REQUEST_REQUI_METRICS  ADD CONSTRAINT  F_RRUI_MET_FK13 FOREIGN KEY (RESOURCE_ID)
  REFERENCES D_RESOURCE(RESOURCE_ID);
 
ALTER TABLE F_REQUEST_REQUI_METRICS  ADD CONSTRAINT  F_RRUI_MET_FK14 FOREIGN KEY (SEVERITY_ID)
  REFERENCES D_REQUEST_SEVERITY(SEVERITY_ID);
 
ALTER TABLE F_REQUEST_REQUI_METRICS  ADD CONSTRAINT  F_RRUI_MET_FK15 FOREIGN KEY (STATE_ID)
  REFERENCES D_REQUEST_STATE(STATE_ID);
 
ALTER TABLE F_REQUEST_REQUI_METRICS  ADD CONSTRAINT  F_RRUI_MET_FK21 FOREIGN KEY (STATUS_ID)
  REFERENCES D_REQUEST_STATUS(STATUS_ID);
 
ALTER TABLE F_REQUEST_REQUI_METRICS  ADD CONSTRAINT  F_RRUI_MET_FK22 FOREIGN KEY (TEAM_ID)
  REFERENCES D_TEAM(TEAM_ID);
 
ALTER TABLE F_REQUEST_RES_REQUI_DT_METRICS  ADD CONSTRAINT  F_RRERD_MET_FK1  FOREIGN KEY (COMPONENT_ID)
  REFERENCES D_COMPONENT(COMPONENT_ID);
  
ALTER TABLE F_REQUEST_RES_REQUI_DT_METRICS  ADD CONSTRAINT  F_RRERD_MET_FK2  FOREIGN KEY (CUSTOMER_PRIORITY_ID)
  REFERENCES D_CUSTOMER_PRIORITY(CUSTOMER_PRIORITY_ID);
  
ALTER TABLE F_REQUEST_RES_REQUI_DT_METRICS  ADD CONSTRAINT  F_RRERD_MET_FK3  FOREIGN KEY (ITERATION_ID)
  REFERENCES D_ITERATION(ITERATION_ID);
  
ALTER TABLE F_REQUEST_RES_REQUI_DT_METRICS  ADD CONSTRAINT  F_RRERD_MET_FK4  FOREIGN KEY (PRIORITY_ID)
  REFERENCES D_REQUEST_PRIORITY(PRIORITY_ID);
 
ALTER TABLE F_REQUEST_RES_REQUI_DT_METRICS  ADD CONSTRAINT  F_RRERD_MET_FK5  FOREIGN KEY (PROJECT_ID)
  REFERENCES D_PROJECT(PROJECT_ID);
  
ALTER TABLE F_REQUEST_RES_REQUI_DT_METRICS  ADD CONSTRAINT  F_RRERD_MET_FK6  FOREIGN KEY (RELEASE_ID)
  REFERENCES D_RELEASE(RELEASE_ID);
   
ALTER TABLE F_REQUEST_RES_REQUI_DT_METRICS  ADD CONSTRAINT  F_RRERD_MET_FK8  FOREIGN KEY (REQUEST_CATEGORY_ID)
  REFERENCES D_REQUEST_CATEGORY(REQUEST_CATEGORY_ID);
 
ALTER TABLE F_REQUEST_RES_REQUI_DT_METRICS  ADD CONSTRAINT  F_RRERD_MET_FK9  FOREIGN KEY (REQUEST_CLASS_ID)
  REFERENCES D_REQUEST_CLASSIFICATION(REQUEST_CLASS_ID);
 
ALTER TABLE F_REQUEST_RES_REQUI_DT_METRICS  ADD CONSTRAINT  F_RRERD_MET_FK10 FOREIGN KEY (REQUEST_TYPE_ID)
  REFERENCES D_REQUEST_TYPE(REQUEST_TYPE_ID);
 
ALTER TABLE F_REQUEST_RES_REQUI_DT_METRICS  ADD CONSTRAINT  F_RRERD_MET_FK11 FOREIGN KEY (REQUIREMENT_ID)
  REFERENCES D_REQUIREMENT(REQUIREMENT_ID);
  
ALTER TABLE F_REQUEST_RES_REQUI_DT_METRICS  ADD CONSTRAINT  F_RRERD_MET_FK12 FOREIGN KEY (SEVERITY_ID)
  REFERENCES D_REQUEST_SEVERITY(SEVERITY_ID);
 
ALTER TABLE F_REQUEST_RES_REQUI_DT_METRICS  ADD CONSTRAINT  F_RRERD_MET_FK13 FOREIGN KEY (STATE_ID)
  REFERENCES D_REQUEST_STATE(STATE_ID);
 
ALTER TABLE F_REQUEST_RES_REQUI_DT_METRICS  ADD CONSTRAINT  F_RRERD_MET_FK19 FOREIGN KEY (STATUS_ID)
  REFERENCES D_REQUEST_STATUS(STATUS_ID);
 
ALTER TABLE F_REQUEST_RES_REQUI_DT_METRICS  ADD CONSTRAINT  F_RRERD_MET_FK20 FOREIGN KEY (TEAM_ID)
  REFERENCES D_TEAM(TEAM_ID);
 
ALTER TABLE F_REQUEST_RES_TPLN_DT_METRICS  ADD CONSTRAINT  F_RRETD_MET_FK1  FOREIGN KEY (COMPONENT_ID)
  REFERENCES D_COMPONENT(COMPONENT_ID);
  
ALTER TABLE F_REQUEST_RES_TPLN_DT_METRICS  ADD CONSTRAINT  F_RRETD_MET_FK2  FOREIGN KEY (CUSTOMER_PRIORITY_ID)
  REFERENCES D_CUSTOMER_PRIORITY(CUSTOMER_PRIORITY_ID);
  
ALTER TABLE F_REQUEST_RES_TPLN_DT_METRICS  ADD CONSTRAINT  F_RRETD_MET_FK3  FOREIGN KEY (ITERATION_ID)
  REFERENCES D_ITERATION(ITERATION_ID);
  
ALTER TABLE F_REQUEST_RES_TPLN_DT_METRICS  ADD CONSTRAINT  F_RRETD_MET_FK4  FOREIGN KEY (PRIORITY_ID)
  REFERENCES D_REQUEST_PRIORITY(PRIORITY_ID);
 
ALTER TABLE F_REQUEST_RES_TPLN_DT_METRICS  ADD CONSTRAINT  F_RRETD_MET_FK5  FOREIGN KEY (PROJECT_ID)
  REFERENCES D_PROJECT(PROJECT_ID);
  
ALTER TABLE F_REQUEST_RES_TPLN_DT_METRICS  ADD CONSTRAINT  F_RRETD_MET_FK6  FOREIGN KEY (RELEASE_ID)
  REFERENCES D_RELEASE(RELEASE_ID);
    
ALTER TABLE F_REQUEST_RES_TPLN_DT_METRICS  ADD CONSTRAINT  F_RRETD_MET_FK8  FOREIGN KEY (REQUEST_CATEGORY_ID)
  REFERENCES D_REQUEST_CATEGORY(REQUEST_CATEGORY_ID);
 
ALTER TABLE F_REQUEST_RES_TPLN_DT_METRICS  ADD CONSTRAINT  F_RRETD_MET_FK9  FOREIGN KEY (REQUEST_CLASS_ID)
  REFERENCES D_REQUEST_CLASSIFICATION(REQUEST_CLASS_ID);
 
ALTER TABLE F_REQUEST_RES_TPLN_DT_METRICS  ADD CONSTRAINT  F_RRETD_MET_FK10 FOREIGN KEY (REQUEST_TYPE_ID)
  REFERENCES D_REQUEST_TYPE(REQUEST_TYPE_ID);
 
ALTER TABLE F_REQUEST_RES_TPLN_DT_METRICS  ADD CONSTRAINT  F_RRETD_MET_FK11 FOREIGN KEY (SEVERITY_ID)
  REFERENCES D_REQUEST_SEVERITY(SEVERITY_ID);
 
ALTER TABLE F_REQUEST_RES_TPLN_DT_METRICS  ADD CONSTRAINT  F_RRETD_MET_FK12 FOREIGN KEY (STATE_ID)
  REFERENCES D_REQUEST_STATE(STATE_ID);
 
ALTER TABLE F_REQUEST_RES_TPLN_DT_METRICS  ADD CONSTRAINT  F_RRETD_MET_FK18 FOREIGN KEY (STATUS_ID)
  REFERENCES D_REQUEST_STATUS(STATUS_ID);
 
ALTER TABLE F_REQUEST_RES_TPLN_DT_METRICS  ADD CONSTRAINT  F_RRETD_MET_FK19 FOREIGN KEY (TEAM_ID)
  REFERENCES D_TEAM(TEAM_ID);
 
ALTER TABLE F_REQUEST_RES_TPLN_DT_METRICS  ADD CONSTRAINT  F_RRETD_MET_FK20 FOREIGN KEY (TESTPLAN_ID)
  REFERENCES D_TESTPLAN(TESTPLAN_ID);
 
ALTER TABLE F_REQUEST_TPLN_AGING  ADD CONSTRAINT  F_REQTPLN_AG_FK2  FOREIGN KEY (COMPONENT_ID)
  REFERENCES D_COMPONENT(COMPONENT_ID);
  
ALTER TABLE F_REQUEST_TPLN_AGING  ADD CONSTRAINT  F_REQTPLN_AG_FK3  FOREIGN KEY (DATE_ID)
  REFERENCES D_DATE(DATE_ID);
 
ALTER TABLE F_REQUEST_TPLN_AGING  ADD CONSTRAINT  F_REQTPLN_AG_FK4  FOREIGN KEY (ITERATION_ID)
  REFERENCES D_ITERATION(ITERATION_ID);
  
ALTER TABLE F_REQUEST_TPLN_AGING  ADD CONSTRAINT  F_REQTPLN_AG_FK5  FOREIGN KEY (PRIORITY_ID)
  REFERENCES D_REQUEST_PRIORITY(PRIORITY_ID);
 
ALTER TABLE F_REQUEST_TPLN_AGING  ADD CONSTRAINT  F_REQTPLN_AG_FK6  FOREIGN KEY (PROJECT_ID)
  REFERENCES D_PROJECT(PROJECT_ID);
  
ALTER TABLE F_REQUEST_TPLN_AGING  ADD CONSTRAINT  F_REQTPLN_AG_FK7  FOREIGN KEY (REQUEST_CLASS_ID)
  REFERENCES D_REQUEST_CLASSIFICATION(REQUEST_CLASS_ID);
 
ALTER TABLE F_REQUEST_TPLN_AGING  ADD CONSTRAINT  F_REQTPLN_AG_FK8  FOREIGN KEY (REQUEST_TYPE_ID)
  REFERENCES D_REQUEST_TYPE(REQUEST_TYPE_ID);
 
ALTER TABLE F_REQUEST_TPLN_AGING  ADD CONSTRAINT  F_REQTPLN_AG_FK9  FOREIGN KEY (RESOURCE_ID)
  REFERENCES D_RESOURCE(RESOURCE_ID);
 
ALTER TABLE F_REQUEST_TPLN_AGING  ADD CONSTRAINT  F_REQTPLN_AG_FK10 FOREIGN KEY (SEVERITY_ID)
  REFERENCES D_REQUEST_SEVERITY(SEVERITY_ID);
 
ALTER TABLE F_REQUEST_TPLN_AGING  ADD CONSTRAINT  F_REQTPLN_AG_FK11 FOREIGN KEY (STATE_ID)
  REFERENCES D_REQUEST_STATE(STATE_ID);
  
ALTER TABLE F_REQUEST_TPLN_AGING  ADD CONSTRAINT  F_REQTPLN_AG_FK17 FOREIGN KEY (TESTPLAN_ID)
  REFERENCES D_TESTPLAN(TESTPLAN_ID);
 
ALTER TABLE F_REQUEST_TPLN_FAIL_METRICS  ADD CONSTRAINT  F_RPLF_MET_FK1 FOREIGN KEY (COMPONENT_ID)
  REFERENCES D_COMPONENT(COMPONENT_ID);
  
ALTER TABLE F_REQUEST_TPLN_FAIL_METRICS  ADD CONSTRAINT  F_RPLF_MET_FK2 FOREIGN KEY (DATE_ID)
  REFERENCES D_DATE(DATE_ID);
 
ALTER TABLE F_REQUEST_TPLN_FAIL_METRICS  ADD CONSTRAINT  F_RPLF_MET_FK3 FOREIGN KEY (ITERATION_ID)
  REFERENCES D_ITERATION(ITERATION_ID);
  
ALTER TABLE F_REQUEST_TPLN_FAIL_METRICS  ADD CONSTRAINT  F_RPLF_MET_FK4 FOREIGN KEY (PROJECT_ID)
  REFERENCES D_PROJECT(PROJECT_ID);
  
ALTER TABLE F_REQUEST_TPLN_FAIL_METRICS  ADD CONSTRAINT  F_RPLF_MET_FK5 FOREIGN KEY (RELEASE_ID)
  REFERENCES D_RELEASE(RELEASE_ID);
    
ALTER TABLE F_REQUEST_TPLN_FAIL_METRICS  ADD CONSTRAINT  F_RPLF_MET_FK7 FOREIGN KEY (TESTPLAN_ID)
  REFERENCES D_TESTPLAN(TESTPLAN_ID);
 
ALTER TABLE F_REQUEST_TPLN_METRICS  ADD CONSTRAINT  F_REQTPLN_MET_FK1  FOREIGN KEY (COMPONENT_ID)
  REFERENCES D_COMPONENT(COMPONENT_ID);
  
ALTER TABLE F_REQUEST_TPLN_METRICS  ADD CONSTRAINT  F_REQTPLN_MET_FK2  FOREIGN KEY (DATE_ID)
  REFERENCES D_DATE(DATE_ID);
 
ALTER TABLE F_REQUEST_TPLN_METRICS  ADD CONSTRAINT  F_REQTPLN_MET_FK3  FOREIGN KEY (ITERATION_ID)
  REFERENCES D_ITERATION(ITERATION_ID);
  
ALTER TABLE F_REQUEST_TPLN_METRICS  ADD CONSTRAINT  F_REQTPLN_MET_FK4  FOREIGN KEY (PLATFORM_ID)
  REFERENCES D_PLATFORM(PLATFORM_ID);
 
ALTER TABLE F_REQUEST_TPLN_METRICS  ADD CONSTRAINT  F_REQTPLN_MET_FK5  FOREIGN KEY (PRIORITY_ID)
  REFERENCES D_REQUEST_PRIORITY(PRIORITY_ID);
 
ALTER TABLE F_REQUEST_TPLN_METRICS  ADD CONSTRAINT  F_REQTPLN_MET_FK6  FOREIGN KEY (PROJECT_ID)
  REFERENCES D_PROJECT(PROJECT_ID);
  
ALTER TABLE F_REQUEST_TPLN_METRICS  ADD CONSTRAINT  F_REQTPLN_MET_FK7  FOREIGN KEY (RELEASE_ID)
  REFERENCES D_RELEASE(RELEASE_ID);
  
ALTER TABLE F_REQUEST_TPLN_METRICS  ADD CONSTRAINT  F_REQTPLN_MET_FK8  FOREIGN KEY (REQUEST_CATEGORY_ID)
  REFERENCES D_REQUEST_CATEGORY(REQUEST_CATEGORY_ID);
 
ALTER TABLE F_REQUEST_TPLN_METRICS  ADD CONSTRAINT  F_REQTPLN_MET_FK9  FOREIGN KEY (REQUEST_CLASS_ID)
  REFERENCES D_REQUEST_CLASSIFICATION(REQUEST_CLASS_ID);
  
ALTER TABLE F_REQUEST_TPLN_METRICS  ADD CONSTRAINT  F_REQTPLN_MET_FK11 FOREIGN KEY (REQUEST_TYPE_ID)
  REFERENCES D_REQUEST_TYPE(REQUEST_TYPE_ID);
 
ALTER TABLE F_REQUEST_TPLN_METRICS  ADD CONSTRAINT  F_REQTPLN_MET_FK12 FOREIGN KEY (RESOURCE_ID)
  REFERENCES D_RESOURCE(RESOURCE_ID);
 
ALTER TABLE F_REQUEST_TPLN_METRICS  ADD CONSTRAINT  F_REQTPLN_MET_FK13 FOREIGN KEY (SEVERITY_ID)
  REFERENCES D_REQUEST_SEVERITY(SEVERITY_ID);
 
ALTER TABLE F_REQUEST_TPLN_METRICS  ADD CONSTRAINT  F_REQTPLN_MET_FK14 FOREIGN KEY (STATE_ID)
  REFERENCES D_REQUEST_STATE(STATE_ID);
 
ALTER TABLE F_REQUEST_TPLN_METRICS  ADD CONSTRAINT  F_REQTPLN_MET_FK20 FOREIGN KEY (STATUS_ID)
  REFERENCES D_REQUEST_STATUS(STATUS_ID);
 
ALTER TABLE F_REQUEST_TPLN_METRICS  ADD CONSTRAINT  F_REQTPLN_MET_FK21 FOREIGN KEY (TEAM_ID)
  REFERENCES D_TEAM(TEAM_ID);
 
ALTER TABLE F_REQUEST_TPLN_METRICS  ADD CONSTRAINT  F_REQTPLN_MET_FK22 FOREIGN KEY (TESTPLAN_ID)
  REFERENCES D_TESTPLAN(TESTPLAN_ID);
 
ALTER TABLE F_REQUEST_TPLN_TURNAROUND  ADD CONSTRAINT  F_RQTPT_FK1  FOREIGN KEY (COMPONENT_ID)
  REFERENCES D_COMPONENT(COMPONENT_ID);
  
ALTER TABLE F_REQUEST_TPLN_TURNAROUND  ADD CONSTRAINT  F_RQTPT_FK2  FOREIGN KEY (DATE_ID)
  REFERENCES D_DATE(DATE_ID);
 
ALTER TABLE F_REQUEST_TPLN_TURNAROUND  ADD CONSTRAINT  F_RQTPT_FK3  FOREIGN KEY (ITERATION_ID)
  REFERENCES D_ITERATION(ITERATION_ID);
  
ALTER TABLE F_REQUEST_TPLN_TURNAROUND  ADD CONSTRAINT  F_RQTPT_FK4  FOREIGN KEY (PRIORITY_ID)
  REFERENCES D_REQUEST_PRIORITY(PRIORITY_ID);
 
ALTER TABLE F_REQUEST_TPLN_TURNAROUND  ADD CONSTRAINT  F_RQTPT_FK5  FOREIGN KEY (PROJECT_ID)
  REFERENCES D_PROJECT(PROJECT_ID);
  
ALTER TABLE F_REQUEST_TPLN_TURNAROUND  ADD CONSTRAINT  F_RQTPT_FK6  FOREIGN KEY (REQUEST_CLASS_ID)
  REFERENCES D_REQUEST_CLASSIFICATION(REQUEST_CLASS_ID);
 
ALTER TABLE F_REQUEST_TPLN_TURNAROUND  ADD CONSTRAINT  F_RQTPT_FK7  FOREIGN KEY (REQUEST_TYPE_ID)
  REFERENCES D_REQUEST_TYPE(REQUEST_TYPE_ID);
 
ALTER TABLE F_REQUEST_TPLN_TURNAROUND  ADD CONSTRAINT  F_RQTPT_FK8  FOREIGN KEY (RESOURCE_ID)
  REFERENCES D_RESOURCE(RESOURCE_ID);
 
ALTER TABLE F_REQUEST_TPLN_TURNAROUND  ADD CONSTRAINT  F_RQTPT_FK9  FOREIGN KEY (SEVERITY_ID)
  REFERENCES D_REQUEST_SEVERITY(SEVERITY_ID);
  
ALTER TABLE F_REQUEST_TPLN_TURNAROUND  ADD CONSTRAINT  F_REQTU_FK1 FOREIGN KEY (TESTPLAN_ID)
  REFERENCES D_TESTPLAN(TESTPLAN_ID);
 
ALTER TABLE F_REQUE_CLOSE_REQUI_DT_METRICS  ADD CONSTRAINT  F_RCRDT_MET_FK1  FOREIGN KEY (COMPONENT_ID)
  REFERENCES D_COMPONENT(COMPONENT_ID);
  
ALTER TABLE F_REQUE_CLOSE_REQUI_DT_METRICS  ADD CONSTRAINT  F_RCRDT_MET_FK2  FOREIGN KEY (CUSTOMER_PRIORITY_ID)
  REFERENCES D_CUSTOMER_PRIORITY(CUSTOMER_PRIORITY_ID);
  
ALTER TABLE F_REQUE_CLOSE_REQUI_DT_METRICS  ADD CONSTRAINT  F_RCRDT_MET_FK3  FOREIGN KEY (ITERATION_ID)
  REFERENCES D_ITERATION(ITERATION_ID);
  
ALTER TABLE F_REQUE_CLOSE_REQUI_DT_METRICS  ADD CONSTRAINT  F_RCRDT_MET_FK4  FOREIGN KEY (PROJECT_ID)
  REFERENCES D_PROJECT(PROJECT_ID);
  
ALTER TABLE F_REQUE_CLOSE_REQUI_DT_METRICS  ADD CONSTRAINT  F_RCRDT_MET_FK5  FOREIGN KEY (RELEASE_ID)
  REFERENCES D_RELEASE(RELEASE_ID);
  
ALTER TABLE F_REQUE_CLOSE_REQUI_DT_METRICS  ADD CONSTRAINT  F_RCRDT_MET_FK7  FOREIGN KEY (REQUEST_CLASS_ID)
  REFERENCES D_REQUEST_CLASSIFICATION(REQUEST_CLASS_ID);
 
ALTER TABLE F_REQUE_CLOSE_REQUI_DT_METRICS  ADD CONSTRAINT  F_RCRDT_MET_FK8  FOREIGN KEY (REQUEST_TYPE_ID)
  REFERENCES D_REQUEST_TYPE(REQUEST_TYPE_ID);
 
ALTER TABLE F_REQUE_CLOSE_REQUI_DT_METRICS  ADD CONSTRAINT  F_RCRDT_MET_FK9  FOREIGN KEY (REQUIREMENT_ID)
  REFERENCES D_REQUIREMENT(REQUIREMENT_ID);
  
ALTER TABLE F_REQUE_CLOSE_REQUI_DT_METRICS  ADD CONSTRAINT  F_RCRDT_MET_FK10 FOREIGN KEY (SEVERITY_ID)
  REFERENCES D_REQUEST_SEVERITY(SEVERITY_ID);
 
ALTER TABLE F_REQUE_CLOSE_REQUI_DT_METRICS  ADD CONSTRAINT  F_RCRDT_MET_FK11 FOREIGN KEY (STATUS_ID)
  REFERENCES D_REQUEST_STATUS(STATUS_ID);
 
ALTER TABLE F_REQUE_CLOSE_TPLN_DT_METRICS  ADD CONSTRAINT  F_RCTD_MET_FK1  FOREIGN KEY (COMPONENT_ID)
  REFERENCES D_COMPONENT(COMPONENT_ID);
  
ALTER TABLE F_REQUE_CLOSE_TPLN_DT_METRICS  ADD CONSTRAINT  F_RCTD_MET_FK2  FOREIGN KEY (CUSTOMER_PRIORITY_ID)
  REFERENCES D_CUSTOMER_PRIORITY(CUSTOMER_PRIORITY_ID);
  
ALTER TABLE F_REQUE_CLOSE_TPLN_DT_METRICS  ADD CONSTRAINT  F_RCTD_MET_FK3  FOREIGN KEY (ITERATION_ID)
  REFERENCES D_ITERATION(ITERATION_ID);
  
ALTER TABLE F_REQUE_CLOSE_TPLN_DT_METRICS  ADD CONSTRAINT  F_RCTD_MET_FK4  FOREIGN KEY (PROJECT_ID)
  REFERENCES D_PROJECT(PROJECT_ID);
  
ALTER TABLE F_REQUE_CLOSE_TPLN_DT_METRICS  ADD CONSTRAINT  F_RCTD_MET_FK5  FOREIGN KEY (RELEASE_ID)
  REFERENCES D_RELEASE(RELEASE_ID);  
 
ALTER TABLE F_REQUE_CLOSE_TPLN_DT_METRICS  ADD CONSTRAINT  F_RCTD_MET_FK7  FOREIGN KEY (REQUEST_CLASS_ID)
  REFERENCES D_REQUEST_CLASSIFICATION(REQUEST_CLASS_ID);
 
ALTER TABLE F_REQUE_CLOSE_TPLN_DT_METRICS  ADD CONSTRAINT  F_RCTD_MET_FK8  FOREIGN KEY (REQUEST_TYPE_ID)
  REFERENCES D_REQUEST_TYPE(REQUEST_TYPE_ID);
 
ALTER TABLE F_REQUE_CLOSE_TPLN_DT_METRICS  ADD CONSTRAINT  F_RCTD_MET_FK9  FOREIGN KEY (SEVERITY_ID)
  REFERENCES D_REQUEST_SEVERITY(SEVERITY_ID);
 
ALTER TABLE F_REQUE_CLOSE_TPLN_DT_METRICS  ADD CONSTRAINT  F_RCTD_MET_FK10 FOREIGN KEY (STATUS_ID)
  REFERENCES D_REQUEST_STATUS(STATUS_ID);
 
ALTER TABLE F_REQUE_CLOSE_TPLN_DT_METRICS  ADD CONSTRAINT  F_RCTD_MET_FK11 FOREIGN KEY (TESTPLAN_ID)
  REFERENCES D_TESTPLAN(TESTPLAN_ID);
 
ALTER TABLE F_REQUIREMENT_METRICS  ADD CONSTRAINT  F_REQ_MET_FK1 FOREIGN KEY (RELEASE_ID)
  REFERENCES D_RELEASE(RELEASE_ID);
  
ALTER TABLE F_REQUIREMENT_TPLN_METRICS  ADD CONSTRAINT  F_RTPLN_MET_FK1  FOREIGN KEY (COMPONENT_ID)
  REFERENCES D_COMPONENT(COMPONENT_ID);
  
ALTER TABLE F_REQUIREMENT_TPLN_METRICS  ADD CONSTRAINT  F_RQTP_MET_FK2  FOREIGN KEY (DATE_ID)
  REFERENCES D_DATE(DATE_ID);
 
ALTER TABLE F_REQUIREMENT_TPLN_METRICS  ADD CONSTRAINT  F_RQTP_MET_FK3  FOREIGN KEY (DIFFICULTY_ID)
  REFERENCES D_DIFFICULTY(DIFFICULTY_ID);
 
ALTER TABLE F_REQUIREMENT_TPLN_METRICS  ADD CONSTRAINT  F_RQTP_MET_FK4  FOREIGN KEY (ITERATION_ID)
  REFERENCES D_ITERATION(ITERATION_ID);
  
ALTER TABLE F_REQUIREMENT_TPLN_METRICS  ADD CONSTRAINT  F_RQTP_MET_FK5  FOREIGN KEY (PRIORITY_ID)
  REFERENCES D_PRIORITY(PRIORITY_ID);
 
ALTER TABLE F_REQUIREMENT_TPLN_METRICS  ADD CONSTRAINT  F_RQTP_MET_FK6  FOREIGN KEY (PROJECT_ID)
  REFERENCES D_PROJECT(PROJECT_ID);
  
ALTER TABLE F_REQUIREMENT_TPLN_METRICS  ADD CONSTRAINT  F_RQTP_MET_FK7  FOREIGN KEY (RELEASE_ID)
  REFERENCES D_RELEASE(RELEASE_ID);
  
ALTER TABLE F_REQUIREMENT_TPLN_METRICS  ADD CONSTRAINT  F_RQTP_MET_FK8  FOREIGN KEY (REQUIREMENT_CLASS_ID)
  REFERENCES D_REQUIREMENT_CLASSIFICATION(REQUIREMENT_CLASS_ID);
 
ALTER TABLE F_REQUIREMENT_TPLN_METRICS  ADD CONSTRAINT  F_RTPLN_MET_FK10 FOREIGN KEY (RESOURCE_ID)
  REFERENCES D_RESOURCE(RESOURCE_ID);
 
ALTER TABLE F_REQUIREMENT_TPLN_METRICS  ADD CONSTRAINT  F_RTPLN_MET_FK11 FOREIGN KEY (STABILITY_ID)
  REFERENCES D_STABILITY(STABILITY_ID);
  
ALTER TABLE F_REQUIREMENT_TPLN_METRICS  ADD CONSTRAINT  F_RTPLN_MET_FK12 FOREIGN KEY (STATE_ID)
  REFERENCES D_REQUIREMENT_STATE(STATE_ID);
 
ALTER TABLE F_REQUIREMENT_TPLN_METRICS  ADD CONSTRAINT  F_RTPLN_MET_FK18 FOREIGN KEY (STATUS_ID)
  REFERENCES D_STATUS(STATUS_ID);
 
ALTER TABLE F_REQUIREMENT_TPLN_METRICS  ADD CONSTRAINT  F_RTPLN_MET_FK19 FOREIGN KEY (TESTPLAN_ID)
  REFERENCES D_TESTPLAN(TESTPLAN_ID);

ALTER TABLE F_REQUIREMENT_TPLN_METRICS  ADD CONSTRAINT  F_RTPLN_MET_FK20 FOREIGN KEY (REQUIREMENT_TYPE_ID)  
  REFERENCES D_REQUIREMENT_TYPE (REQUIREMENT_TYPE_ID);    
 
ALTER TABLE F_REQUI_TCASE_METRICS  ADD CONSTRAINT  F_RTC_MET_FK1  FOREIGN KEY (COMPONENT_ID)
  REFERENCES D_COMPONENT(COMPONENT_ID);
  
ALTER TABLE F_REQUI_TCASE_METRICS  ADD CONSTRAINT  F_RTC_MET_FK2  FOREIGN KEY (DATE_ID)
  REFERENCES D_DATE(DATE_ID);
 
ALTER TABLE F_REQUI_TCASE_METRICS  ADD CONSTRAINT  F_RTC_MET_FK3  FOREIGN KEY (DIFFICULTY_ID)
  REFERENCES D_DIFFICULTY(DIFFICULTY_ID);
 
ALTER TABLE F_REQUI_TCASE_METRICS  ADD CONSTRAINT  F_RTC_MET_FK4  FOREIGN KEY (ITERATION_ID)
  REFERENCES D_ITERATION(ITERATION_ID);
  
ALTER TABLE F_REQUI_TCASE_METRICS  ADD CONSTRAINT  F_RTC_MET_FK5  FOREIGN KEY (PRIORITY_ID)
  REFERENCES D_PRIORITY(PRIORITY_ID);
 
ALTER TABLE F_REQUI_TCASE_METRICS  ADD CONSTRAINT  F_RTC_MET_FK6  FOREIGN KEY (PROJECT_ID)
  REFERENCES D_PROJECT(PROJECT_ID);
  
ALTER TABLE F_REQUI_TCASE_METRICS  ADD CONSTRAINT  F_RTC_MET_FK7  FOREIGN KEY (RELEASE_ID)
  REFERENCES D_RELEASE(RELEASE_ID);
  
ALTER TABLE F_REQUI_TCASE_METRICS  ADD CONSTRAINT  F_RTC_MET_FK8  FOREIGN KEY (REQUIREMENT_CLASS_ID)
  REFERENCES D_REQUIREMENT_CLASSIFICATION(REQUIREMENT_CLASS_ID);
  
ALTER TABLE F_REQUI_TCASE_METRICS  ADD CONSTRAINT  F_RTC_MET_FK10 FOREIGN KEY (RESOURCE_ID)
  REFERENCES D_RESOURCE(RESOURCE_ID);
 
ALTER TABLE F_REQUI_TCASE_METRICS  ADD CONSTRAINT  F_RTC_MET_FK11 FOREIGN KEY (STABILITY_ID)
  REFERENCES D_STABILITY(STABILITY_ID);
  
ALTER TABLE F_REQUI_TCASE_METRICS  ADD CONSTRAINT  F_RTC_MET_FK12 FOREIGN KEY (STATE_ID)
  REFERENCES D_REQUIREMENT_STATE(STATE_ID);
 
ALTER TABLE F_REQUI_TCASE_METRICS  ADD CONSTRAINT  F_RTC_MET_FK18 FOREIGN KEY (STATUS_ID)
  REFERENCES D_STATUS(STATUS_ID);
 
ALTER TABLE F_REQUI_TCASE_METRICS  ADD CONSTRAINT  F_RTC_MET_FK19 FOREIGN KEY (TESTCASE_ID)
  REFERENCES D_TESTCASE(TESTCASE_ID);
  
ALTER TABLE F_REQUI_TCASE_METRICS  ADD CONSTRAINT  F_RTC_MET_FK20 FOREIGN KEY (REQUIREMENT_TYPE_ID)
  REFERENCES D_REQUIREMENT_TYPE (REQUIREMENT_TYPE_ID);  
 
ALTER TABLE F_REQU_CREATI_REQUI_DT_METRICS  ADD CONSTRAINT  F_RRDT_MET_FK1  FOREIGN KEY (COMPONENT_ID)
  REFERENCES D_COMPONENT(COMPONENT_ID);
  
ALTER TABLE F_REQU_CREATI_REQUI_DT_METRICS  ADD CONSTRAINT  F_RRDT_MET_FK2  FOREIGN KEY (CUSTOMER_PRIORITY_ID)
  REFERENCES D_CUSTOMER_PRIORITY(CUSTOMER_PRIORITY_ID);
  
ALTER TABLE F_REQU_CREATI_REQUI_DT_METRICS  ADD CONSTRAINT  F_RRDT_MET_FK3  FOREIGN KEY (PRIORITY_ID)
  REFERENCES D_REQUEST_PRIORITY(PRIORITY_ID);
 
ALTER TABLE F_REQU_CREATI_REQUI_DT_METRICS  ADD CONSTRAINT  F_RRDT_MET_FK4  FOREIGN KEY (PROJECT_ID)
  REFERENCES D_PROJECT(PROJECT_ID);
  
ALTER TABLE F_REQU_CREATI_REQUI_DT_METRICS  ADD CONSTRAINT  F_RRDT_MET_FK5  FOREIGN KEY (RELEASE_ID)
  REFERENCES D_RELEASE(RELEASE_ID);  
  
ALTER TABLE F_REQU_CREATI_REQUI_DT_METRICS  ADD CONSTRAINT  F_RRDT_MET_FK7  FOREIGN KEY (REQUEST_CATEGORY_ID)
  REFERENCES D_REQUEST_CATEGORY(REQUEST_CATEGORY_ID);
 
ALTER TABLE F_REQU_CREATI_REQUI_DT_METRICS  ADD CONSTRAINT  F_RRDT_MET_FK8  FOREIGN KEY (REQUEST_CLASS_ID)
  REFERENCES D_REQUEST_CLASSIFICATION(REQUEST_CLASS_ID);
 
ALTER TABLE F_REQU_CREATI_REQUI_DT_METRICS  ADD CONSTRAINT  F_RRDT_MET_FK9  FOREIGN KEY (REQUEST_TYPE_ID)
  REFERENCES D_REQUEST_TYPE(REQUEST_TYPE_ID);
 
ALTER TABLE F_REQU_CREATI_REQUI_DT_METRICS  ADD CONSTRAINT  F_RRDT_MET_FK10 FOREIGN KEY (REQUIREMENT_ID)
  REFERENCES D_REQUIREMENT(REQUIREMENT_ID);
  
ALTER TABLE F_REQU_CREATI_REQUI_DT_METRICS  ADD CONSTRAINT  F_RRDT_MET_FK11 FOREIGN KEY (SEVERITY_ID)
  REFERENCES D_REQUEST_SEVERITY(SEVERITY_ID);
 
ALTER TABLE F_REQU_CREATI_REQUI_DT_METRICS  ADD CONSTRAINT  F_RRDT_MET_FK12 FOREIGN KEY (STATE_ID)
  REFERENCES D_REQUEST_STATE(STATE_ID);
 
ALTER TABLE F_REQU_CREATI_REQUI_DT_METRICS  ADD CONSTRAINT  F_RRDT_MET_FK18 FOREIGN KEY (STATUS_ID)
  REFERENCES D_REQUEST_STATUS(STATUS_ID);
 
ALTER TABLE F_REQU_CREATI_REQUI_DT_METRICS  ADD CONSTRAINT  F_RRDT_MET_FK19 FOREIGN KEY (TEAM_ID)
  REFERENCES D_TEAM(TEAM_ID);
  
ALTER TABLE F_REQU_CREATI_REQUI_DT_METRICS  ADD CONSTRAINT  F_RRDT_MET_FK20 FOREIGN KEY (ITERATION_ID)
  REFERENCES D_ITERATION(ITERATION_ID);  
   
ALTER TABLE F_REQU_CREATI_TPLN_DT_METRICS  ADD CONSTRAINT  F_RCRTD_MET_FK1  FOREIGN KEY (COMPONENT_ID)
  REFERENCES D_COMPONENT(COMPONENT_ID);
  
ALTER TABLE F_REQU_CREATI_TPLN_DT_METRICS  ADD CONSTRAINT  F_RCRTD_MET_FK2  FOREIGN KEY (CUSTOMER_PRIORITY_ID)
  REFERENCES D_CUSTOMER_PRIORITY(CUSTOMER_PRIORITY_ID);
  
ALTER TABLE F_REQU_CREATI_TPLN_DT_METRICS  ADD CONSTRAINT  F_RCRTD_MET_FK3  FOREIGN KEY (ITERATION_ID)
  REFERENCES D_ITERATION(ITERATION_ID);
  
ALTER TABLE F_REQU_CREATI_TPLN_DT_METRICS  ADD CONSTRAINT  F_RCRTD_MET_FK4  FOREIGN KEY (PRIORITY_ID)
  REFERENCES D_REQUEST_PRIORITY(PRIORITY_ID);
 
ALTER TABLE F_REQU_CREATI_TPLN_DT_METRICS  ADD CONSTRAINT  F_RCRTD_MET_FK5  FOREIGN KEY (PROJECT_ID)
  REFERENCES D_PROJECT(PROJECT_ID);
  
ALTER TABLE F_REQU_CREATI_TPLN_DT_METRICS  ADD CONSTRAINT  F_RCRTD_MET_FK6  FOREIGN KEY (RELEASE_ID)
  REFERENCES D_RELEASE(RELEASE_ID);  
  
ALTER TABLE F_REQU_CREATI_TPLN_DT_METRICS  ADD CONSTRAINT  F_RCRTD_MET_FK8  FOREIGN KEY (REQUEST_CATEGORY_ID)
  REFERENCES D_REQUEST_CATEGORY(REQUEST_CATEGORY_ID);
 
ALTER TABLE F_REQU_CREATI_TPLN_DT_METRICS  ADD CONSTRAINT  F_RCRTD_MET_FK9  FOREIGN KEY (REQUEST_CLASS_ID)
  REFERENCES D_REQUEST_CLASSIFICATION(REQUEST_CLASS_ID);
 
ALTER TABLE F_REQU_CREATI_TPLN_DT_METRICS  ADD CONSTRAINT  F_RCRTD_MET_FK10 FOREIGN KEY (REQUEST_TYPE_ID)
  REFERENCES D_REQUEST_TYPE(REQUEST_TYPE_ID);
 
ALTER TABLE F_REQU_CREATI_TPLN_DT_METRICS  ADD CONSTRAINT  F_RCRTD_MET_FK11 FOREIGN KEY (SEVERITY_ID)
  REFERENCES D_REQUEST_SEVERITY(SEVERITY_ID);
 
ALTER TABLE F_REQU_CREATI_TPLN_DT_METRICS  ADD CONSTRAINT  F_RCRTD_MET_FK12 FOREIGN KEY (STATE_ID)
  REFERENCES D_REQUEST_STATE(STATE_ID);
 
ALTER TABLE F_REQU_CREATI_TPLN_DT_METRICS  ADD CONSTRAINT  F_RCRTD_MET_FK18 FOREIGN KEY (STATUS_ID)
  REFERENCES D_REQUEST_STATUS(STATUS_ID);
 
ALTER TABLE F_REQU_CREATI_TPLN_DT_METRICS  ADD CONSTRAINT  F_RCRTD_MET_FK19 FOREIGN KEY (TEAM_ID)
  REFERENCES D_TEAM(TEAM_ID);
 
ALTER TABLE F_REQU_CREATI_TPLN_DT_METRICS  ADD CONSTRAINT  F_RCRTD_MET_FK20 FOREIGN KEY (TESTPLAN_ID)
  REFERENCES D_TESTPLAN(TESTPLAN_ID);
 
ALTER TABLE F_TASK_CLOSE_COMP_DT_METRICS  ADD CONSTRAINT  F_TCCMD_MET_FK1  FOREIGN KEY (COMPONENT_ID)
  REFERENCES D_COMPONENT(COMPONENT_ID);
  
ALTER TABLE F_TASK_CLOSE_COMP_DT_METRICS  ADD CONSTRAINT  F_TCCMD_MET_FK2  FOREIGN KEY (ITERATION_ID)
  REFERENCES D_ITERATION(ITERATION_ID);
  
ALTER TABLE F_TASK_CLOSE_COMP_DT_METRICS  ADD CONSTRAINT  F_TCCMD_MET_FK3  FOREIGN KEY (PRIORITY_ID)
  REFERENCES D_PRIORITY(PRIORITY_ID);
 
ALTER TABLE F_TASK_CLOSE_COMP_DT_METRICS  ADD CONSTRAINT  F_TCCMD_MET_FK4  FOREIGN KEY (PROJECT_ID)
  REFERENCES D_PROJECT(PROJECT_ID);
  
ALTER TABLE F_TASK_CLOSE_COMP_DT_METRICS  ADD CONSTRAINT  F_TCCMD_MET_FK5  FOREIGN KEY (RESOURCE_ID)
  REFERENCES D_RESOURCE(RESOURCE_ID);
 
ALTER TABLE F_TASK_CLOSE_COMP_DT_METRICS  ADD CONSTRAINT  F_TCCMD_MET_FK6  FOREIGN KEY (STATE_ID)
  REFERENCES D_TASK_STATE(STATE_ID); 
  
ALTER TABLE F_TASK_CLOSE_COMP_DT_METRICS  ADD CONSTRAINT  F_TCCMD_MET_FK13 FOREIGN KEY (TASK_CLASS_ID)
  REFERENCES D_TASK_CLASSIFICATION(TASK_CLASS_ID);
  
ALTER TABLE F_TASK_CLOSE_COMP_DT_METRICS  ADD CONSTRAINT  F_TCCMD_MET_FK14 FOREIGN KEY (TASK_TYPE_ID)
  REFERENCES D_TASK_TYPE(TASK_TYPE_ID);
  
ALTER TABLE F_TASK_COMP_METRICS  ADD CONSTRAINT  F_TKC_MET_FK1  FOREIGN KEY (COMPONENT_ID)
  REFERENCES D_COMPONENT(COMPONENT_ID);
  
ALTER TABLE F_TASK_COMP_METRICS  ADD CONSTRAINT  F_TKC_MET_FK2  FOREIGN KEY (DATE_ID)
  REFERENCES D_DATE(DATE_ID);
 
ALTER TABLE F_TASK_COMP_METRICS  ADD CONSTRAINT  F_TKC_MET_FK3  FOREIGN KEY (ITERATION_ID)
  REFERENCES D_ITERATION(ITERATION_ID);
  
ALTER TABLE F_TASK_COMP_METRICS  ADD CONSTRAINT  F_TKC_MET_FK4  FOREIGN KEY (PRIORITY_ID)
  REFERENCES D_PRIORITY(PRIORITY_ID);
 
ALTER TABLE F_TASK_COMP_METRICS  ADD CONSTRAINT  F_TKC_MET_FK5  FOREIGN KEY (PROJECT_ID)
  REFERENCES D_PROJECT(PROJECT_ID);
  
ALTER TABLE F_TASK_COMP_METRICS  ADD CONSTRAINT  F_TKC_MET_FK6  FOREIGN KEY (RESOURCE_ID)
  REFERENCES D_RESOURCE(RESOURCE_ID);
 
ALTER TABLE F_TASK_COMP_METRICS  ADD CONSTRAINT  F_TKC_MET_FK7  FOREIGN KEY (STATE_ID)
  REFERENCES D_TASK_STATE(STATE_ID);
 
ALTER TABLE F_TASK_COMP_METRICS  ADD CONSTRAINT  F_TKC_MET_FK13 FOREIGN KEY (TASK_CLASS_ID)
  REFERENCES D_TASK_CLASSIFICATION(TASK_CLASS_ID); 
 
ALTER TABLE F_TASK_COMP_METRICS  ADD CONSTRAINT  F_TKC_MET_FK15 FOREIGN KEY (TASK_TYPE_ID)
  REFERENCES D_TASK_TYPE(TASK_TYPE_ID);
  
ALTER TABLE F_TASK_CREATE_COMP_DT_METRICS  ADD CONSTRAINT  F_TCRCMD_MET_FK1  FOREIGN KEY (COMPONENT_ID)
  REFERENCES D_COMPONENT(COMPONENT_ID);
  
ALTER TABLE F_TASK_CREATE_COMP_DT_METRICS  ADD CONSTRAINT  F_TCRCMD_MET_FK2  FOREIGN KEY (ITERATION_ID)
  REFERENCES D_ITERATION(ITERATION_ID);
  
ALTER TABLE F_TASK_CREATE_COMP_DT_METRICS  ADD CONSTRAINT  F_TCRCMD_MET_FK3  FOREIGN KEY (PRIORITY_ID)
  REFERENCES D_PRIORITY(PRIORITY_ID);
 
ALTER TABLE F_TASK_CREATE_COMP_DT_METRICS  ADD CONSTRAINT  F_TCRCMD_MET_FK4  FOREIGN KEY (PROJECT_ID)
  REFERENCES D_PROJECT(PROJECT_ID);
  
ALTER TABLE F_TASK_CREATE_COMP_DT_METRICS  ADD CONSTRAINT  F_TCRCMD_MET_FK5  FOREIGN KEY (RESOURCE_ID)
  REFERENCES D_RESOURCE(RESOURCE_ID);
 
ALTER TABLE F_TASK_CREATE_COMP_DT_METRICS  ADD CONSTRAINT  F_TCRCMD_MET_FK6  FOREIGN KEY (STATE_ID)
  REFERENCES D_TASK_STATE(STATE_ID);
 
ALTER TABLE F_TASK_CREATE_COMP_DT_METRICS  ADD CONSTRAINT  F_TCRCMD_MET_FK13 FOREIGN KEY (TASK_CLASS_ID)
  REFERENCES D_TASK_CLASSIFICATION(TASK_CLASS_ID);
  
ALTER TABLE F_TASK_CREATE_COMP_DT_METRICS  ADD CONSTRAINT  F_TCRCMD_MET_FK14 FOREIGN KEY (TASK_TYPE_ID)
  REFERENCES D_TASK_TYPE(TASK_TYPE_ID);
  
ALTER TABLE F_TESTCASE_ITER_METRICS  ADD CONSTRAINT  F_TESTITER_MET_FK1  FOREIGN KEY (DATE_ID)
  REFERENCES D_DATE(DATE_ID);
 
ALTER TABLE F_TESTCASE_ITER_METRICS  ADD CONSTRAINT  F_TESTITER_MET_FK2  FOREIGN KEY (ITERATION_ID)
  REFERENCES D_ITERATION(ITERATION_ID);
  
ALTER TABLE F_TESTCASE_ITER_METRICS  ADD CONSTRAINT  F_TESTITER_MET_FK3  FOREIGN KEY (STATE_ID)
  REFERENCES D_TESTCASE_STATE(STATE_ID);
 
ALTER TABLE F_TESTCASE_ITER_METRICS  ADD CONSTRAINT  F_TESTITER_MET_FK9  FOREIGN KEY (TESTCASE_CLASS_ID)
  REFERENCES D_TESTCASE_CLASSIFICATION(TESTCASE_CLASS_ID);
  
ALTER TABLE F_TESTCASE_ITER_METRICS  ADD CONSTRAINT  F_TSIT_MET_FK10 FOREIGN KEY (TESTPLAN_ID)
  REFERENCES D_TESTPLAN(TESTPLAN_ID);
  
ALTER TABLE F_TESTCASE_ITER_METRICS  ADD CONSTRAINT  F_TSIT_MET_FK11 FOREIGN KEY (PROJECT_ID)
  REFERENCES D_PROJECT (PROJECT_ID);  
  
ALTER TABLE F_TESTCASE_REQUI_METRICS  ADD CONSTRAINT  F_TPJR_MET_FK1  FOREIGN KEY (DATE_ID)
  REFERENCES D_DATE(DATE_ID);
 
ALTER TABLE F_TESTCASE_REQUI_METRICS  ADD CONSTRAINT  F_TPJR_MET_FK2  FOREIGN KEY (PROJECT_ID)
  REFERENCES D_PROJECT(PROJECT_ID);
  
ALTER TABLE F_TESTCASE_REQUI_METRICS  ADD CONSTRAINT  F_TPJR_MET_FK3  FOREIGN KEY (REQUIREMENT_ID)
  REFERENCES D_REQUIREMENT(REQUIREMENT_ID);
  
ALTER TABLE F_TESTCASE_REQUI_METRICS  ADD CONSTRAINT  F_TPJR_MET_FK4  FOREIGN KEY (STATE_ID)
  REFERENCES D_TESTCASE_STATE(STATE_ID);
 
ALTER TABLE F_TESTCASE_REQUI_METRICS  ADD CONSTRAINT  F_TPJR_MET_FK10 FOREIGN KEY (TESTCASE_CLASS_ID)
  REFERENCES D_TESTCASE_CLASSIFICATION(TESTCASE_CLASS_ID);
  
ALTER TABLE F_TESTCASE_REQUI_METRICS  ADD CONSTRAINT  F_TPJR_MET_FK11 FOREIGN KEY (TESTPLAN_ID)
  REFERENCES D_TESTPLAN(TESTPLAN_ID);
  
ALTER TABLE F_TEXT_FILE_VERSION_DT_METRICS  ADD CONSTRAINT  F_TFVD_MET_FK1  FOREIGN KEY (ACTIVITY_ID)
  REFERENCES D_ACTIVITY(ACTIVITY_ID);
 
ALTER TABLE F_TEXT_FILE_VERSION_DT_METRICS  ADD CONSTRAINT  F_TFVD_MET_FK2  FOREIGN KEY (COMPONENT_ID)
  REFERENCES D_COMPONENT(COMPONENT_ID);
  
ALTER TABLE F_TEXT_FILE_VERSION_DT_METRICS  ADD CONSTRAINT  F_TFVD_MET_FK3  FOREIGN KEY (DATE_ID)
  REFERENCES D_DATE(DATE_ID);
  
ALTER TABLE F_TEXT_FILE_VERSION_DT_METRICS  ADD CONSTRAINT  F_TFVD_MET_FK5  FOREIGN KEY (FILE_CLASS_ID)
  REFERENCES D_FILE_CLASSIFICATION(FILE_CLASS_ID);
  
ALTER TABLE F_TEXT_FILE_VERSION_DT_METRICS  ADD CONSTRAINT  F_TFVD_MET_FK6  FOREIGN KEY (FILE_ID)
  REFERENCES D_FILE(FILE_ID);
 
ALTER TABLE F_TEXT_FILE_VERSION_DT_METRICS  ADD CONSTRAINT  F_TFVD_MET_FK7  FOREIGN KEY (FILE_STREAM_ID)
  REFERENCES D_FILE_STREAM(FILE_STREAM_ID);
  
ALTER TABLE F_TEXT_FILE_VERSION_DT_METRICS  ADD CONSTRAINT  F_TFVD_MET_FK8  FOREIGN KEY (PROJECT_ID)
  REFERENCES D_PROJECT(PROJECT_ID);
  
ALTER TABLE F_TEXT_FILE_VERSION_DT_METRICS  ADD CONSTRAINT  F_TFVD_MET_FK9  FOREIGN KEY (RESOURCE_ID)
  REFERENCES D_RESOURCE(RESOURCE_ID);
   
ALTER TABLE F_TEXT_FILE_VERSION_METRICS  ADD CONSTRAINT  F_TFV_MET_FK1 FOREIGN KEY (ACTIVITY_ID)
  REFERENCES D_ACTIVITY(ACTIVITY_ID);
 
ALTER TABLE F_TEXT_FILE_VERSREQ_DT_METRICS  ADD CONSTRAINT  F_TFVRD_MET_FK1  FOREIGN KEY (ACTIVITY_ID)
  REFERENCES D_ACTIVITY(ACTIVITY_ID);
 
ALTER TABLE F_TEXT_FILE_VERSREQ_DT_METRICS  ADD CONSTRAINT  F_TFVRD_MET_FK2  FOREIGN KEY (COMPONENT_ID)
  REFERENCES D_COMPONENT(COMPONENT_ID);
  
ALTER TABLE F_TEXT_FILE_VERSREQ_DT_METRICS  ADD CONSTRAINT  F_TFVRD_MET_FK3  FOREIGN KEY (DATE_ID)
  REFERENCES D_DATE(DATE_ID);
  
ALTER TABLE F_TEXT_FILE_VERSREQ_DT_METRICS  ADD CONSTRAINT  F_TFVRD_MET_FK5  FOREIGN KEY (FILE_CLASS_ID)
  REFERENCES D_FILE_CLASSIFICATION(FILE_CLASS_ID);
  
ALTER TABLE F_TEXT_FILE_VERSREQ_DT_METRICS  ADD CONSTRAINT  F_TFVRD_MET_FK6  FOREIGN KEY (FILE_ID)
  REFERENCES D_FILE(FILE_ID);
 
ALTER TABLE F_TEXT_FILE_VERSREQ_DT_METRICS  ADD CONSTRAINT  F_TFVRD_MET_FK7  FOREIGN KEY (FILE_STREAM_ID)
  REFERENCES D_FILE_STREAM(FILE_STREAM_ID);
  
ALTER TABLE F_TEXT_FILE_VERSREQ_DT_METRICS  ADD CONSTRAINT  F_TFVRD_MET_FK8  FOREIGN KEY (PROJECT_ID)
  REFERENCES D_PROJECT(PROJECT_ID);
  
ALTER TABLE F_TEXT_FILE_VERSREQ_DT_METRICS  ADD CONSTRAINT  F_TFVRD_MET_FK9  FOREIGN KEY (REQUEST_ID)
  REFERENCES D_REQUEST(REQUEST_ID);
  
ALTER TABLE F_TEXT_FILE_VERSREQ_DT_METRICS  ADD CONSTRAINT  F_TFVRD_MET_FK10 FOREIGN KEY (RESOURCE_ID)
  REFERENCES D_RESOURCE(RESOURCE_ID);
   
ALTER TABLE F_TEXT_FILE_VER_REQU_METRICS  ADD CONSTRAINT  F_TXFVR_MET_FK1  FOREIGN KEY (ACTIVITY_ID)
  REFERENCES D_ACTIVITY(ACTIVITY_ID);
 
ALTER TABLE F_TEXT_FILE_VER_REQU_METRICS  ADD CONSTRAINT  F_TXFVR_MET_FK2  FOREIGN KEY (COMPONENT_ID)
  REFERENCES D_COMPONENT(COMPONENT_ID);
  
ALTER TABLE F_TEXT_FILE_VER_REQU_METRICS  ADD CONSTRAINT  F_TXFVR_MET_FK3  FOREIGN KEY (DATE_ID)
  REFERENCES D_DATE(DATE_ID);
  
ALTER TABLE F_TEXT_FILE_VER_REQU_METRICS  ADD CONSTRAINT  F_TXFVR_MET_FK5  FOREIGN KEY (FILE_CLASS_ID)
  REFERENCES D_FILE_CLASSIFICATION(FILE_CLASS_ID);
  
ALTER TABLE F_TEXT_FILE_VER_REQU_METRICS  ADD CONSTRAINT  F_TXFVR_MET_FK6  FOREIGN KEY (FILE_ID)
  REFERENCES D_FILE(FILE_ID);
 
ALTER TABLE F_TEXT_FILE_VER_REQU_METRICS  ADD CONSTRAINT  F_TXFVR_MET_FK7  FOREIGN KEY (FILE_STREAM_ID)
  REFERENCES D_FILE_STREAM(FILE_STREAM_ID);
  
ALTER TABLE F_TEXT_FILE_VER_REQU_METRICS  ADD CONSTRAINT  F_TXFVR_MET_FK8  FOREIGN KEY (PROJECT_ID)
  REFERENCES D_PROJECT(PROJECT_ID);
  
ALTER TABLE F_TEXT_FILE_VER_REQU_METRICS  ADD CONSTRAINT  F_TXFVR_MET_FK9  FOREIGN KEY (REQUEST_ID)
  REFERENCES D_REQUEST(REQUEST_ID);
  
ALTER TABLE F_TEXT_FILE_VER_REQU_METRICS  ADD CONSTRAINT  F_TXFVR_MET_FK10 FOREIGN KEY (RESOURCE_ID)
  REFERENCES D_RESOURCE(RESOURCE_ID);
  
ALTER TABLE F_ACTIVITY_COMP_METRICS ADD CONSTRAINT F_ACTCMPM_FK1 FOREIGN KEY (ACTIVITY_CLASS_ID)
	REFERENCES D_ACTIVITY_CLASSIFICATION (ACTIVITY_CLASS_ID);
	
ALTER TABLE F_ACTIVITY_COMP_METRICS ADD CONSTRAINT F_ACTCMPM_FK2 FOREIGN KEY (DATE_ID)
	REFERENCES D_DATE (DATE_ID);	
	
ALTER TABLE F_ACTIVITY_COMP_METRICS ADD CONSTRAINT F_ACTCMPM_FK4 FOREIGN KEY (RESOURCE_ID)
	REFERENCES D_RESOURCE (RESOURCE_ID);	

ALTER TABLE F_ACTIVITY_COMP_METRICS ADD CONSTRAINT F_ACTCMPM_FK5 FOREIGN KEY (PROJECT_ID)
	REFERENCES D_PROJECT (PROJECT_ID);			

ALTER TABLE F_ACTIVITY_COMP_METRICS ADD CONSTRAINT F_ACTCMPM_FK7 FOREIGN KEY (STATE_ID)
	REFERENCES D_ACTIVITY_STATE (STATE_ID);			
		 
ALTER TABLE F_ACTIVITY_COMP_METRICS ADD CONSTRAINT F_ACTCMPM_FK8 FOREIGN KEY (PRIORITY_ID)
	REFERENCES D_PRIORITY (PRIORITY_ID);	 
	
ALTER TABLE F_ACTIVITY_COMP_METRICS ADD CONSTRAINT F_ACTCMPM_FK9 FOREIGN KEY (COMPONENT_ID)
	REFERENCES D_COMPONENT (COMPONENT_ID);	

ALTER TABLE F_C_ACTIVITY_COMP_METRICS ADD CONSTRAINT F_C_ACTCMPM_FK1 FOREIGN KEY (ACTIVITY_CLASS_ID)
	REFERENCES D_ACTIVITY_CLASSIFICATION (ACTIVITY_CLASS_ID);
	
ALTER TABLE F_C_ACTIVITY_COMP_METRICS ADD CONSTRAINT F_C_ACTCMPM_FK2 FOREIGN KEY (DATE_ID)
	REFERENCES D_DATE (DATE_ID);	
	
ALTER TABLE F_C_ACTIVITY_COMP_METRICS ADD CONSTRAINT F_C_ACTCMPM_FK4 FOREIGN KEY (RESOURCE_ID)
	REFERENCES D_RESOURCE (RESOURCE_ID);	

ALTER TABLE F_C_ACTIVITY_COMP_METRICS ADD CONSTRAINT F_C_ACTCMPM_FK5 FOREIGN KEY (PROJECT_ID)
	REFERENCES D_PROJECT (PROJECT_ID);			

ALTER TABLE F_C_ACTIVITY_COMP_METRICS ADD CONSTRAINT F_C_ACTCMPM_FK7 FOREIGN KEY (STATE_ID)
	REFERENCES D_ACTIVITY_STATE (STATE_ID);			
		 
ALTER TABLE F_C_ACTIVITY_COMP_METRICS ADD CONSTRAINT F_C_ACTCMPM_FK8 FOREIGN KEY (PRIORITY_ID)
	REFERENCES D_PRIORITY (PRIORITY_ID);	 
	
ALTER TABLE F_C_ACTIVITY_COMP_METRICS ADD CONSTRAINT F_C_ACTCMPM_FK9 FOREIGN KEY (COMPONENT_ID)
	REFERENCES D_COMPONENT (COMPONENT_ID);	

ALTER TABLE F_ACT_COM_CREATION_DT_METRICS ADD CONSTRAINT	F_ACTCOMCRDM_FK1 FOREIGN KEY (ACTIVITY_CLASS_ID)
		REFERENCES D_ACTIVITY_CLASSIFICATION (ACTIVITY_CLASS_ID);	
		
ALTER TABLE F_ACT_COM_CREATION_DT_METRICS ADD CONSTRAINT	F_ACTCOMCRDM_FK2 FOREIGN KEY (STATE_ID)
		REFERENCES D_ACTIVITY_STATE (STATE_ID);	
		
ALTER TABLE F_ACT_COM_CREATION_DT_METRICS ADD CONSTRAINT	F_ACTCOMCRDM_FK3 FOREIGN KEY (PROJECT_ID)
		REFERENCES D_PROJECT (PROJECT_ID);	
		
ALTER TABLE F_ACT_COM_CREATION_DT_METRICS ADD CONSTRAINT	F_ACTCOMCRDM_FK5 FOREIGN KEY (RESOURCE_ID)
		REFERENCES D_RESOURCE (RESOURCE_ID);	
		
ALTER TABLE F_ACT_COM_CREATION_DT_METRICS ADD CONSTRAINT	F_ACTCOMCRDM_FK6 FOREIGN KEY (PRIORITY_ID)
		REFERENCES D_PRIORITY (PRIORITY_ID);		
		
ALTER TABLE F_ACT_COM_CREATION_DT_METRICS ADD CONSTRAINT	F_ACTCOMCRDM_FK7 FOREIGN KEY (COMPONENT_ID)
		REFERENCES D_COMPONENT (COMPONENT_ID);						
		  
 ALTER TABLE H_ACTIVITY_ITER_METRICS  ADD CONSTRAINT  H_ACT_ITER_MET_FK1 FOREIGN KEY (ACTIVITY_ID)
  REFERENCES D_ACTIVITY(ACTIVITY_ID) ON DELETE CASCADE; 
 
ALTER TABLE H_ACTIVITY_ITER_METRICS  ADD CONSTRAINT  H_ACT_ITER_MET_FK2 FOREIGN KEY (ACTIVITY_METRICS_ID)
  REFERENCES F_ACTIVITY_ITER_METRICS(ACTIVITY_METRICS_ID) ON DELETE CASCADE;
 
ALTER TABLE H_ACTIVITY_REQ_METRICS  ADD CONSTRAINT  H_ACT_REQ_MET_FK1 FOREIGN KEY (ACTIVITY_ID)
  REFERENCES D_ACTIVITY(ACTIVITY_ID) ON DELETE CASCADE;
 
ALTER TABLE H_ACTIVITY_REQ_METRICS  ADD CONSTRAINT  H_ACT_REQ_MET_FK2 FOREIGN KEY (ACTIVITY_METRICS_ID)
  REFERENCES F_ACTIVITY_REQ_METRICS(ACTIVITY_METRICS_ID) ON DELETE CASCADE;
 
ALTER TABLE H_ACT_ITER_CREATION_DT_METRICS  ADD CONSTRAINT  H_AICRD_MET_FK1 FOREIGN KEY (ACTIVITYCRD_METRICS_ID)
  REFERENCES F_ACT_ITER_CREATION_DT_METRICS(ACTIVITYCRD_METRICS_ID) ON DELETE CASCADE;
 
ALTER TABLE H_ACT_ITER_CREATION_DT_METRICS  ADD CONSTRAINT  H_AICRD_MET_FK2 FOREIGN KEY (ACTIVITY_ID)
  REFERENCES D_ACTIVITY(ACTIVITY_ID) ON DELETE CASCADE;
 
ALTER TABLE H_ACT_REQUI_CREAT_DT_METRICS  ADD CONSTRAINT  H_ARCRD_MET_FK1 FOREIGN KEY (ACTIVITYCRD_METRICS_ID)
  REFERENCES F_ACT_REQU_CREATION_DT_METRICS(ACTIVITYCRD_METRICS_ID) ON DELETE CASCADE;
 
ALTER TABLE H_ACT_REQUI_CREAT_DT_METRICS  ADD CONSTRAINT  H_ARCRD_MET_FK2 FOREIGN KEY (ACTIVITY_ID)
  REFERENCES D_ACTIVITY(ACTIVITY_ID) ON DELETE CASCADE;
   
ALTER TABLE H_BUILD_REQUI_ATTEMPTS  ADD CONSTRAINT  H_BRRQA_FK2 FOREIGN KEY (BUILD_METRIC_ID)
  REFERENCES F_BUILD_REQUI_METRICS (BUILD_METRIC_ID) ON DELETE CASCADE;  

ALTER TABLE H_BUILD_REQUI_ATTEMPTS  ADD CONSTRAINT  H_BRQA_FK1 FOREIGN KEY (BUILD_ID)
  REFERENCES D_BUILD(BUILD_ID) ON DELETE CASCADE;
  
ALTER TABLE H_BUILD_REQUI_FAIL  ADD CONSTRAINT  H_BRQF_FK1 FOREIGN KEY (BUILD_ID)
  REFERENCES D_BUILD(BUILD_ID) ON DELETE CASCADE;
  
ALTER TABLE H_BUILD_REQUI_FAIL  ADD CONSTRAINT  H_BRQF_FK2 FOREIGN KEY (BUILD_METRIC_ID)
  REFERENCES F_BUILD_REQUI_METRICS(BUILD_METRIC_ID) ON DELETE CASCADE;
  
ALTER TABLE H_BUILD_REQUI_PASS  ADD CONSTRAINT  H_BRQP_FK1 FOREIGN KEY (BUILD_ID)
  REFERENCES D_BUILD(BUILD_ID) ON DELETE CASCADE;
  
ALTER TABLE H_BUILD_REQUI_PASS  ADD CONSTRAINT  H_BRQP_FK2 FOREIGN KEY (BUILD_METRIC_ID)
  REFERENCES F_BUILD_REQUI_METRICS(BUILD_METRIC_ID) ON DELETE CASCADE;  
  
ALTER TABLE H_BUILD_REQU_ATTEMPTS  ADD CONSTRAINT  H_BRQUA_FK1 FOREIGN KEY (BUILD_ID)
  REFERENCES D_BUILD(BUILD_ID) ON DELETE CASCADE;
  
ALTER TABLE H_BUILD_REQU_ATTEMPTS  ADD CONSTRAINT  H_BRQUA_FK2 FOREIGN KEY (BUILD_METRIC_ID)
  REFERENCES F_BUILD_REQU_METRICS(BUILD_METRIC_ID) ON DELETE CASCADE;
  
ALTER TABLE H_BUILD_REQU_EXEC_DT_MET_TOT  ADD CONSTRAINT  H_BREDT_MET_FK1 FOREIGN KEY (BUILD_EXEC_METRIC_ID)
  REFERENCES F_BUILD_REQU_EXEC_DT_METRICS(BUILD_EXEC_METRIC_ID) ON DELETE CASCADE;
 
ALTER TABLE H_BUILD_REQU_EXEC_DT_MET_TOT  ADD CONSTRAINT  H_BREDT_MET_FK2 FOREIGN KEY (BUILD_ID)
  REFERENCES D_BUILD(BUILD_ID) ON DELETE CASCADE;
    
ALTER TABLE H_EXECRESPOINTS_ITER_METRICS  ADD CONSTRAINT  H_EXPI_MET_FK1 FOREIGN KEY (EXECRES_METRIC_ID)
  REFERENCES F_EXECRESPOINTS_ITER_METRICS(EXECRES_METRIC_ID) ON DELETE CASCADE;
  
ALTER TABLE H_EXECRESPOINTS_ITER_METRICS  ADD CONSTRAINT  H_EXPI_MET_FK2 FOREIGN KEY (EXECUTION_RESULT_ID)
  REFERENCES D_EXECUTION_RESULT(EXECUTION_RESULT_ID) ON DELETE CASCADE;
 
ALTER TABLE H_EXECUTION_RES_ITER_METRICS  ADD CONSTRAINT  H_ERI_MET_FK1 FOREIGN KEY (EXECUTION_RESULT_ID)
  REFERENCES D_EXECUTION_RESULT(EXECUTION_RESULT_ID) ON DELETE CASCADE;
 
ALTER TABLE H_EXECUTION_RES_ITER_METRICS  ADD CONSTRAINT  H_ERI_MET_FK2 FOREIGN KEY (EXERES_METRICS_ID)
  REFERENCES F_EXECUTION_RES_ITER_METRICS(EXERES_METRICS_ID) ON DELETE CASCADE; 
 
ALTER TABLE H_EXEC_WORKITEM_ITER_METRICS  ADD CONSTRAINT  HEWI_MET_FK1 FOREIGN KEY (EXECWORKITEM_ID)
  REFERENCES D_EXECUTION_WORKITEM(EXECWORKITEM_ID) ON DELETE CASCADE;
 
ALTER TABLE H_EXEC_WORKITEM_ITER_METRICS  ADD CONSTRAINT  HEWI_MET_FK2 FOREIGN KEY (EXECWORKITEM_METRIC_ID)
  REFERENCES F_EXEC_WORKITEM_ITER_METRICS(EXECWORKITEM_METRIC_ID) ON DELETE CASCADE;
  
ALTER TABLE H_EXEC_WORKITEM_REQU_METRICS  ADD CONSTRAINT  HEWR_MET_FK1 FOREIGN KEY (EXECWORKITEM_ID)
  REFERENCES D_EXECUTION_WORKITEM(EXECWORKITEM_ID) ON DELETE CASCADE;
 
ALTER TABLE H_EXEC_WORKITEM_REQU_METRICS  ADD CONSTRAINT  HEWR_MET_FK2 FOREIGN KEY (EXECWORKITEM_METRIC_ID)
  REFERENCES F_EXEC_WORKITEM_REQU_METRICS(EXECWORKITEM_METRIC_ID) ON DELETE CASCADE;
 
ALTER TABLE H_REQUEST_AGING_TPLN_MAX  ADD CONSTRAINT  H_RAT_MX_FK1 FOREIGN KEY (AGING_METRIC_ID)
  REFERENCES F_REQUEST_TPLN_AGING(AGING_METRIC_ID) ON DELETE CASCADE;
  
ALTER TABLE H_REQUEST_AGING_TPLN_MAX  ADD CONSTRAINT  H_RAT_MX_FK2 FOREIGN KEY (REQUEST_ID)
  REFERENCES D_REQUEST(REQUEST_ID) ON DELETE CASCADE;
    
ALTER TABLE H_REQUEST_AGING_TPLN_MIN  ADD CONSTRAINT  H_RAT_MI_FK1 FOREIGN KEY (AGING_METRIC_ID)
  REFERENCES F_REQUEST_TPLN_AGING(AGING_METRIC_ID) ON DELETE CASCADE;
  
ALTER TABLE H_REQUEST_AGING_TPLN_MIN  ADD CONSTRAINT  H_RAT_MI_FK2 FOREIGN KEY (REQUEST_ID)
  REFERENCES D_REQUEST(REQUEST_ID) ON DELETE CASCADE;
  
ALTER TABLE H_REQUEST_AGING_TPLN_TOTAL  ADD CONSTRAINT  H_RAT_TO_FK1 FOREIGN KEY (AGING_METRIC_ID)
  REFERENCES F_REQUEST_TPLN_AGING(AGING_METRIC_ID) ON DELETE CASCADE;
  
ALTER TABLE H_REQUEST_AGING_TPLN_TOTAL  ADD CONSTRAINT  H_RAT_TO_FK2 FOREIGN KEY (REQUEST_ID)
  REFERENCES D_REQUEST(REQUEST_ID) ON DELETE CASCADE; 
  
ALTER TABLE H_REQUEST_CUST_METRICS_BLOCK  ADD CONSTRAINT  H_RCMBL_FK1 FOREIGN KEY (REQUEST_ID)
  REFERENCES D_REQUEST(REQUEST_ID) ON DELETE CASCADE;
  
ALTER TABLE H_REQUEST_CUST_METRICS_BLOCK  ADD CONSTRAINT  H_RCBL_MET_FK2 FOREIGN KEY (REQUEST_METRIC_ID)
  REFERENCES F_REQUEST_CUST_METRICS(REQUEST_METRIC_ID) ON DELETE CASCADE;
  
ALTER TABLE H_REQUEST_CUST_METRICS_TOTAL  ADD CONSTRAINT  H_RCTO_MET_FK1 FOREIGN KEY (REQUEST_ID)
  REFERENCES D_REQUEST(REQUEST_ID) ON DELETE CASCADE;
  
ALTER TABLE H_REQUEST_CUST_METRICS_TOTAL  ADD CONSTRAINT  H_RCTO_MET_FK2 FOREIGN KEY (REQUEST_METRIC_ID)
  REFERENCES F_REQUEST_CUST_METRICS(REQUEST_METRIC_ID) ON DELETE CASCADE;
  
ALTER TABLE H_REQUEST_REQUI_FAIL_METRICS  ADD CONSTRAINT  H_RRF_MET_FK1 FOREIGN KEY (REQFAIL_METRIC_ID)
  REFERENCES F_REQUEST_REQUI_FAIL_METRICS(REQFAIL_METRIC_ID) ON DELETE CASCADE;
  
ALTER TABLE H_REQUEST_REQUI_FAIL_METRICS  ADD CONSTRAINT  H_RRF_MET_FK2 FOREIGN KEY (REQUEST_ID)
  REFERENCES D_REQUEST(REQUEST_ID) ON DELETE CASCADE; 
  
ALTER TABLE H_REQUEST_REQUI_METRICS_BLOCK  ADD CONSTRAINT  H_RRIBL_MET_FK1 FOREIGN KEY (REQUEST_ID)
  REFERENCES D_REQUEST(REQUEST_ID) ON DELETE CASCADE;
  
ALTER TABLE H_REQUEST_REQUI_METRICS_BLOCK  ADD CONSTRAINT  H_RRIBL_MET_FK2 FOREIGN KEY (REQUEST_METRIC_ID)
  REFERENCES F_REQUEST_REQUI_METRICS(REQUEST_METRIC_ID) ON DELETE CASCADE;
    
ALTER TABLE H_REQUEST_REQUI_METRICS_TOTAL  ADD CONSTRAINT  H_RRITO_MET_FK1 FOREIGN KEY (REQUEST_ID)
  REFERENCES D_REQUEST(REQUEST_ID) ON DELETE CASCADE;
  
ALTER TABLE H_REQUEST_REQUI_METRICS_TOTAL  ADD CONSTRAINT  H_RRITO_MET_FK2 FOREIGN KEY (REQUEST_METRIC_ID)
  REFERENCES F_REQUEST_REQUI_METRICS(REQUEST_METRIC_ID) ON DELETE CASCADE;
  
ALTER TABLE H_REQUEST_RES_REQUI_DT_METRICS  ADD CONSTRAINT  H_RRRQD_MET_FK1 FOREIGN KEY (REQDT_METRIC_ID)
  REFERENCES F_REQUEST_RES_REQUI_DT_METRICS(REQDT_METRIC_ID) ON DELETE CASCADE;
  
ALTER TABLE H_REQUEST_RES_REQUI_DT_METRICS  ADD CONSTRAINT  H_RRRQD_MET_FK2 FOREIGN KEY (REQUEST_ID)
  REFERENCES D_REQUEST(REQUEST_ID) ON DELETE CASCADE;
  
ALTER TABLE H_REQUEST_RES_TPLN_DT_METRICS  ADD CONSTRAINT  H_RRETD_MET_FK1 FOREIGN KEY (REQDT_METRIC_ID)
  REFERENCES F_REQUEST_RES_TPLN_DT_METRICS(REQDT_METRIC_ID) ON DELETE CASCADE;
  
ALTER TABLE H_REQUEST_RES_TPLN_DT_METRICS  ADD CONSTRAINT  H_RRETD_MET_FK2 FOREIGN KEY (REQUEST_ID)
  REFERENCES D_REQUEST(REQUEST_ID) ON DELETE CASCADE;
  
ALTER TABLE H_REQUEST_TPLN_FAIL_METRICS  ADD CONSTRAINT  H_RTF_MET_FK1 FOREIGN KEY (REQFAIL_METRIC_ID)
  REFERENCES F_REQUEST_TPLN_FAIL_METRICS(REQFAIL_METRIC_ID) ON DELETE CASCADE;
  
ALTER TABLE H_REQUEST_TPLN_FAIL_METRICS  ADD CONSTRAINT  H_RTF_MET_FK2 FOREIGN KEY (REQUEST_ID)
  REFERENCES D_REQUEST(REQUEST_ID) ON DELETE CASCADE; 
  
ALTER TABLE H_REQUEST_TPLN_METRICS_BLOCK  ADD CONSTRAINT  H_RQTPB_MET_FK1 FOREIGN KEY (REQUEST_ID)
  REFERENCES D_REQUEST(REQUEST_ID) ON DELETE CASCADE;
  
ALTER TABLE H_REQUEST_TPLN_METRICS_BLOCK  ADD CONSTRAINT  H_RQTPB_MET_FK2 FOREIGN KEY (REQUEST_METRIC_ID)
  REFERENCES F_REQUEST_TPLN_METRICS(REQUEST_METRIC_ID) ON DELETE CASCADE;
  
ALTER TABLE H_REQUEST_TPLN_METRICS_TOTAL  ADD CONSTRAINT  H_RQTPT_MET_FK1 FOREIGN KEY (REQUEST_ID)
  REFERENCES D_REQUEST(REQUEST_ID) ON DELETE CASCADE;
  
ALTER TABLE H_REQUEST_TPLN_METRICS_TOTAL  ADD CONSTRAINT  H_RQTPT_MET_FK2 FOREIGN KEY (REQUEST_METRIC_ID)
  REFERENCES F_REQUEST_TPLN_METRICS(REQUEST_METRIC_ID) ON DELETE CASCADE;
  
ALTER TABLE H_REQUEST_TPLN_TURNAROUND_MAX  ADD CONSTRAINT  H_RQTPT_MAX_FK1 FOREIGN KEY (REQUEST_ID)
  REFERENCES D_REQUEST(REQUEST_ID) ON DELETE CASCADE;
  
ALTER TABLE H_REQUEST_TPLN_TURNAROUND_MAX  ADD CONSTRAINT  H_RQTPT_MAX_FK2 FOREIGN KEY (TURNAROUND_METRIC_ID)
  REFERENCES F_REQUEST_TPLN_TURNAROUND(TURNAROUND_METRIC_ID) ON DELETE CASCADE;
  
ALTER TABLE H_REQUEST_TPLN_TURNAROUND_MIN  ADD CONSTRAINT  H_RQTPT_MIN_FK1 FOREIGN KEY (REQUEST_ID)
  REFERENCES D_REQUEST(REQUEST_ID) ON DELETE CASCADE;
  
ALTER TABLE H_REQUEST_TPLN_TURNAROUND_MIN  ADD CONSTRAINT  H_RQTPT_MIN_FK2 FOREIGN KEY (TURNAROUND_METRIC_ID)
  REFERENCES F_REQUEST_TPLN_TURNAROUND(TURNAROUND_METRIC_ID) ON DELETE CASCADE;
 
ALTER TABLE H_REQUEST_TPLN_TURNAROUND_TOT  ADD CONSTRAINT  H_RQTPT_TOT_FK1 FOREIGN KEY (REQUEST_ID)
  REFERENCES D_REQUEST(REQUEST_ID) ON DELETE CASCADE;
  
ALTER TABLE H_REQUEST_TPLN_TURNAROUND_TOT  ADD CONSTRAINT  H_RQTPT_TOT_FK2 FOREIGN KEY (TURNAROUND_METRIC_ID)
  REFERENCES F_REQUEST_TPLN_TURNAROUND(TURNAROUND_METRIC_ID) ON DELETE CASCADE;
 
ALTER TABLE H_REQUE_CLOSE_REQUI_DT_METRICS  ADD CONSTRAINT  H_RCRUD_MET_FK1 FOREIGN KEY (REQCDT_METRIC_ID)
  REFERENCES F_REQUE_CLOSE_REQUI_DT_METRICS(REQCDT_METRIC_ID) ON DELETE CASCADE;
 
ALTER TABLE H_REQUE_CLOSE_REQUI_DT_METRICS  ADD CONSTRAINT  H_RCRUD_MET_FK2 FOREIGN KEY (REQUEST_ID)
  REFERENCES D_REQUEST(REQUEST_ID) ON DELETE CASCADE;
  
ALTER TABLE H_REQUE_CLOSE_TPLN_DT_METRICS  ADD CONSTRAINT  H_RCTPD_MET_FK1 FOREIGN KEY (REQCDT_METRIC_ID)
  REFERENCES F_REQUE_CLOSE_TPLN_DT_METRICS(REQCDT_METRIC_ID) ON DELETE CASCADE;
 
ALTER TABLE H_REQUE_CLOSE_TPLN_DT_METRICS  ADD CONSTRAINT  H_RCTPD_MET_FK2 FOREIGN KEY (REQUEST_ID)
  REFERENCES D_REQUEST(REQUEST_ID) ON DELETE CASCADE; 
  
ALTER TABLE H_REQUI_TCASE_METRICS_CHANGES  ADD CONSTRAINT  H_RTCCH_MET_FK1 FOREIGN KEY (REQUIREMENT_ID)
  REFERENCES D_REQUIREMENT(REQUIREMENT_ID) ON DELETE CASCADE;
  
ALTER TABLE H_REQUI_TCASE_METRICS_CHANGES  ADD CONSTRAINT  H_RTCCH_MET_FK2 FOREIGN KEY (REQ_METRIC_ID)
  REFERENCES F_REQUI_TCASE_METRICS(REQ_METRIC_ID) ON DELETE CASCADE;
    
ALTER TABLE H_REQUI_TCASE_METRICS_TOTAL  ADD CONSTRAINT  H_RTCT_MET_FK1 FOREIGN KEY (REQUIREMENT_ID)
  REFERENCES D_REQUIREMENT(REQUIREMENT_ID) ON DELETE CASCADE;
  
ALTER TABLE H_REQUI_TCASE_METRICS_TOTAL  ADD CONSTRAINT  H_RTCT_MET_FK2 FOREIGN KEY (REQ_METRIC_ID)
  REFERENCES F_REQUI_TCASE_METRICS(REQ_METRIC_ID) ON DELETE CASCADE;
  
ALTER TABLE H_REQUI_TPLN_METRICS_CHANGES  ADD CONSTRAINT  H_RTPCH_MET_FK1 FOREIGN KEY (REQUIREMENT_ID)
  REFERENCES D_REQUIREMENT(REQUIREMENT_ID) ON DELETE CASCADE;
  
ALTER TABLE H_REQUI_TPLN_METRICS_CHANGES  ADD CONSTRAINT  H_RTPCH_MET_FK2 FOREIGN KEY (REQ_METRIC_ID)
  REFERENCES F_REQUIREMENT_TPLN_METRICS(REQ_METRIC_ID) ON DELETE CASCADE;
  
ALTER TABLE H_REQUI_TPLN_METRICS_TOTAL  ADD CONSTRAINT  H_RTPTO_MET_FK1 FOREIGN KEY (REQUIREMENT_ID)
  REFERENCES D_REQUIREMENT(REQUIREMENT_ID) ON DELETE CASCADE;
  
ALTER TABLE H_REQUI_TPLN_METRICS_TOTAL  ADD CONSTRAINT  H_RTPTO_MET_FK2 FOREIGN KEY (REQ_METRIC_ID)
  REFERENCES F_REQUIREMENT_TPLN_METRICS(REQ_METRIC_ID) ON DELETE CASCADE;
  
ALTER TABLE H_REQU_CREATI_REQUI_DT_METRICS  ADD CONSTRAINT  H_RCRD_MET_FK1 FOREIGN KEY (REQDT_METRIC_ID)
  REFERENCES F_REQU_CREATI_REQUI_DT_METRICS(REQDT_METRIC_ID) ON DELETE CASCADE;
  
ALTER TABLE H_REQU_CREATI_REQUI_DT_METRICS  ADD CONSTRAINT  H_RCRD_MET_FK2 FOREIGN KEY (REQUEST_ID)
  REFERENCES D_REQUEST(REQUEST_ID) ON DELETE CASCADE;
  
ALTER TABLE H_REQU_CREATI_TPLN_DT_METRICS  ADD CONSTRAINT  H_RCTTPD_MET_FK1 FOREIGN KEY (REQDT_METRIC_ID)
  REFERENCES F_REQU_CREATI_TPLN_DT_METRICS(REQDT_METRIC_ID) ON DELETE CASCADE;
  
ALTER TABLE H_REQU_CREATI_TPLN_DT_METRICS  ADD CONSTRAINT  H_RCTTPD_MET_FK2 FOREIGN KEY (REQUEST_ID)
  REFERENCES D_REQUEST(REQUEST_ID) ON DELETE CASCADE;
  
ALTER TABLE H_TASK_CLOSE_COMP_DT_METRICS  ADD CONSTRAINT  H_TCCMD_MET_FK1 FOREIGN KEY (TASKCLS_METRICS_ID)
  REFERENCES F_TASK_CLOSE_COMP_DT_METRICS(TASKCLS_METRICS_ID) ON DELETE CASCADE;
  
ALTER TABLE H_TASK_CLOSE_COMP_DT_METRICS  ADD CONSTRAINT  H_TCCMD_MET_FK2 FOREIGN KEY (TASK_ID)
  REFERENCES D_TASK(TASK_ID) ON DELETE CASCADE; 
 
ALTER TABLE H_TASK_COMP_METRICS  ADD CONSTRAINT  H_TKC_MET_FK1 FOREIGN KEY (TASK_ID)
  REFERENCES D_TASK(TASK_ID) ON DELETE CASCADE;
 
ALTER TABLE H_TASK_COMP_METRICS  ADD CONSTRAINT  H_TKC_MET_FK2 FOREIGN KEY (TASK_METRICS_ID)
  REFERENCES F_TASK_COMP_METRICS(TASK_METRICS_ID) ON DELETE CASCADE;
 
ALTER TABLE H_TASK_CREATE_COMP_DT_METRICS  ADD CONSTRAINT  H_TCRCMD_MET_FK1 FOREIGN KEY (TASKCRD_METRICS_ID)
  REFERENCES F_TASK_CREATE_COMP_DT_METRICS(TASKCRD_METRICS_ID) ON DELETE CASCADE;
 
ALTER TABLE H_TASK_CREATE_COMP_DT_METRICS  ADD CONSTRAINT  H_TCRCMD_MET_FK2 FOREIGN KEY (TASK_ID)
  REFERENCES D_TASK(TASK_ID) ON DELETE CASCADE;
 
ALTER TABLE H_TESTCASE_ITER_METRICS  ADD CONSTRAINT  H_TCI_MET_FK1 FOREIGN KEY (TESTCASE_ID)
  REFERENCES D_TESTCASE(TESTCASE_ID) ON DELETE CASCADE;
 
ALTER TABLE H_TESTCASE_ITER_METRICS  ADD CONSTRAINT  H_TCI_MET_FK2 FOREIGN KEY (TSTCASE_METRIC_ID)
  REFERENCES F_TESTCASE_ITER_METRICS(TSTCASE_METRIC_ID) ON DELETE CASCADE;
 
ALTER TABLE H_TESTCASE_REQUI_METRICS  ADD CONSTRAINT  H_TPJR_MET_FK1 FOREIGN KEY (TESTCASE_ID)
  REFERENCES D_TESTCASE(TESTCASE_ID) ON DELETE CASCADE;
 
ALTER TABLE H_TESTCASE_REQUI_METRICS  ADD CONSTRAINT  H_TPJR_MET_FK2 FOREIGN KEY (TSTCASE_METRIC_ID)
  REFERENCES F_TESTCASE_REQUI_METRICS(TSTCASE_METRIC_ID) ON DELETE CASCADE; 
 
ALTER TABLE H_TEXT_FILE_VERS_DT_METRICS_CH  ADD CONSTRAINT  H_TXFVDCH_MET_FK1 FOREIGN KEY (FILE_VERSION_ID)
  REFERENCES D_FILE_VERSION(FILE_VERSION_ID) ON DELETE CASCADE;
 
ALTER TABLE H_TEXT_FILE_VERS_DT_METRICS_CH  ADD CONSTRAINT  H_TXFVDCH_MET_FK2 FOREIGN KEY (SLOC_METRICS_ID)
  REFERENCES F_TEXT_FILE_VERSION_DT_METRICS(SLOC_METRICS_ID) ON DELETE CASCADE;
  
ALTER TABLE H_TEXT_FILE_VERS_DT_METRICS_TO  ADD CONSTRAINT  H_TXFVDTO_MET_FK1 FOREIGN KEY (FILE_VERSION_ID)
  REFERENCES D_FILE_VERSION(FILE_VERSION_ID) ON DELETE CASCADE;
 
ALTER TABLE H_TEXT_FILE_VERS_DT_METRICS_TO  ADD CONSTRAINT  H_TXFVDTO_MET_FK2 FOREIGN KEY (SLOC_METRICS_ID)
  REFERENCES F_TEXT_FILE_VERSION_DT_METRICS(SLOC_METRICS_ID) ON DELETE CASCADE;   
  
ALTER TABLE H_TEXT_FILE_VER_REQ_METRICS_CH  ADD CONSTRAINT  H_TXFVRCH_MET_FK1 FOREIGN KEY (FILE_VERSION_ID)
  REFERENCES D_FILE_VERSION(FILE_VERSION_ID) ON DELETE CASCADE;
 
ALTER TABLE H_TEXT_FILE_VER_REQ_METRICS_CH  ADD CONSTRAINT  H_TXFVRCH_MET_FK2 FOREIGN KEY (SLOC_METRICS_ID)
  REFERENCES F_TEXT_FILE_VER_REQU_METRICS(SLOC_METRICS_ID) ON DELETE CASCADE;
    
ALTER TABLE H_TEXT_FILE_VER_REQ_METRICS_TO  ADD CONSTRAINT  H_TXFVRTO_MET_FK1 FOREIGN KEY (FILE_VERSION_ID)
  REFERENCES D_FILE_VERSION(FILE_VERSION_ID) ON DELETE CASCADE;
 
ALTER TABLE H_TEXT_FILE_VER_REQ_METRICS_TO  ADD CONSTRAINT  H_TXFVRTO_MET_FK2 FOREIGN KEY (SLOC_METRICS_ID)
  REFERENCES F_TEXT_FILE_VER_REQU_METRICS(SLOC_METRICS_ID) ON DELETE CASCADE;
    
ALTER TABLE H_TXT_FILE_VERSREQ_DT_METR_CH  ADD CONSTRAINT  H_TXFVRDC_MET_FK1 FOREIGN KEY (FILE_VERSION_ID)
  REFERENCES D_FILE_VERSION(FILE_VERSION_ID) ON DELETE CASCADE;
 
ALTER TABLE H_TXT_FILE_VERSREQ_DT_METR_CH  ADD CONSTRAINT  H_TXFVRDC_MET_FK2 FOREIGN KEY (SLOC_METRICS_ID)
  REFERENCES F_TEXT_FILE_VERSREQ_DT_METRICS(SLOC_METRICS_ID) ON DELETE CASCADE;
    
ALTER TABLE H_TXT_FILE_VERSREQ_DT_METR_TO  ADD CONSTRAINT  H_TXFVRDT_MET_FK1 FOREIGN KEY (FILE_VERSION_ID)
  REFERENCES D_FILE_VERSION(FILE_VERSION_ID) ON DELETE CASCADE;
 
ALTER TABLE H_TXT_FILE_VERSREQ_DT_METR_TO  ADD CONSTRAINT  H_TXFVRDT_MET_FK2 FOREIGN KEY (SLOC_METRICS_ID)
  REFERENCES F_TEXT_FILE_VERSREQ_DT_METRICS(SLOC_METRICS_ID) ON DELETE CASCADE;
 
ALTER TABLE  H_ACTIVITY_COMP_METRICS ADD CONSTRAINT H_ACTCOMPM_FK1 FOREIGN KEY (ACTIVITY_METRICS_ID)
		REFERENCES F_ACTIVITY_COMP_METRICS (ACTIVITY_METRICS_ID) ON DELETE CASCADE;
		
ALTER TABLE  H_ACTIVITY_COMP_METRICS ADD CONSTRAINT H_ACTCOMPM_FK2 FOREIGN KEY (ACTIVITY_ID)
		REFERENCES D_ACTIVITY (ACTIVITY_ID) ON DELETE CASCADE;	
		
 ALTER TABLE H_ACT_COM_CREATION_DT_METRICS ADD CONSTRAINT	H_ACTCOMCRDM_FK1 FOREIGN KEY (ACTIVITYCRD_METRICS_ID)
		REFERENCES F_ACT_COM_CREATION_DT_METRICS (ACTIVITYCRD_METRICS_ID)  ON DELETE CASCADE;	
		
ALTER TABLE H_ACT_COM_CREATION_DT_METRICS ADD CONSTRAINT	H_ACTCOMCRDM_FK2 FOREIGN KEY (ACTIVITY_ID)
		REFERENCES D_ACTIVITY (ACTIVITY_ID) ON DELETE CASCADE;	

ALTER TABLE F_TEXT_FILE_VER_BSLN_METRICS ADD CONSTRAINT F_TFVBSLN_FK1 FOREIGN KEY (FILE_ID)
	REFERENCES D_FILE (FILE_ID);
	
ALTER TABLE F_TEXT_FILE_VER_BSLN_METRICS ADD CONSTRAINT F_TFVBSLN_FK2 FOREIGN KEY (RESOURCE_ID)
	REFERENCES D_RESOURCE (RESOURCE_ID);	
	
ALTER TABLE F_TEXT_FILE_VER_BSLN_METRICS ADD CONSTRAINT F_TFVBSLN_FK3 FOREIGN KEY (FILE_STREAM_ID)
	REFERENCES D_FILE_STREAM (FILE_STREAM_ID);	
	
ALTER TABLE F_TEXT_FILE_VER_BSLN_METRICS ADD CONSTRAINT F_TFVBSLN_FK4 FOREIGN KEY (PROJECT_ID)
	REFERENCES D_PROJECT (PROJECT_ID);	
	
ALTER TABLE F_TEXT_FILE_VER_BSLN_METRICS ADD CONSTRAINT F_TFVBSLN_FK6 FOREIGN KEY (COMPONENT_ID)
	REFERENCES D_COMPONENT (COMPONENT_ID);	
	
ALTER TABLE F_TEXT_FILE_VER_BSLN_METRICS ADD CONSTRAINT F_TFVBSLN_FK7 FOREIGN KEY (DATE_ID)
	REFERENCES D_DATE (DATE_ID);			

ALTER TABLE F_TEXT_FILE_VER_BSLN_METRICS ADD CONSTRAINT F_TFVBSLN_FK10 FOREIGN KEY (FILE_CLASS_ID)
	REFERENCES D_FILE_CLASSIFICATION (FILE_CLASS_ID);

ALTER TABLE F_TEXT_FILE_VER_BSLN_METRICS ADD CONSTRAINT F_TFVBSLN_FK11 FOREIGN KEY (FILE_BASELINE_ID)
	REFERENCES D_FILE_BASELINE (FILE_BASELINE_ID);	

ALTER TABLE F_C_TEXT_FILE_VERBSLN_METRICS  ADD CONSTRAINT  F_CTXFVBSLN_FK1  FOREIGN KEY (ACTIVITY_ID)
  REFERENCES D_ACTIVITY(ACTIVITY_ID);
 
ALTER TABLE F_C_TEXT_FILE_VERBSLN_METRICS  ADD CONSTRAINT  F_CTXFVBSLN_FK2  FOREIGN KEY (COMPONENT_ID)
  REFERENCES D_COMPONENT(COMPONENT_ID);
  
ALTER TABLE F_C_TEXT_FILE_VERBSLN_METRICS  ADD CONSTRAINT  F_CTXFVBSLN_FK3  FOREIGN KEY (DATE_ID)
  REFERENCES D_DATE(DATE_ID);
  
ALTER TABLE F_C_TEXT_FILE_VERBSLN_METRICS  ADD CONSTRAINT  F_CTXFVBSLN_FK5  FOREIGN KEY (FILE_CLASS_ID)
  REFERENCES D_FILE_CLASSIFICATION(FILE_CLASS_ID);
  
ALTER TABLE F_C_TEXT_FILE_VERBSLN_METRICS  ADD CONSTRAINT  F_CTXFVBSLN_FK6  FOREIGN KEY (FILE_ID)
  REFERENCES D_FILE(FILE_ID);
 
ALTER TABLE F_C_TEXT_FILE_VERBSLN_METRICS  ADD CONSTRAINT  F_CTXFVBSLN_FK7  FOREIGN KEY (FILE_STREAM_ID)
  REFERENCES D_FILE_STREAM(FILE_STREAM_ID);
  
ALTER TABLE F_C_TEXT_FILE_VERBSLN_METRICS  ADD CONSTRAINT  F_CTXFVBSLN_FK8  FOREIGN KEY (PROJECT_ID)
  REFERENCES D_PROJECT(PROJECT_ID);
  
ALTER TABLE F_C_TEXT_FILE_VERBSLN_METRICS  ADD CONSTRAINT  F_CTXFVBSLN_FK9  FOREIGN KEY (RESOURCE_ID)
  REFERENCES D_RESOURCE(RESOURCE_ID);
  
ALTER TABLE F_C_TEXT_FILE_VERBSLN_METRICS  ADD CONSTRAINT  F_CTXFVBSLN_FK10  FOREIGN KEY (FILE_BASELINE_ID)
  REFERENCES D_FILE_BASELINE (FILE_BASELINE_ID);  
	
ALTER TABLE H_TEXT_FILE_VERBSLN_METRICS_CH ADD CONSTRAINT H_TFVBSLNCH_FK1 FOREIGN KEY (SLOC_METRICS_ID)
	REFERENCES F_TEXT_FILE_VER_BSLN_METRICS (SLOC_METRICS_ID) ON DELETE CASCADE;
	
ALTER TABLE H_TEXT_FILE_VERBSLN_METRICS_CH ADD CONSTRAINT H_TFVBSLNCH_FK2 FOREIGN KEY (FILE_VERSION_ID)
	REFERENCES D_FILE_VERSION (FILE_VERSION_ID) ON DELETE CASCADE;	
		
ALTER TABLE H_TEXT_FILE_VERBSLN_METRICS_TO ADD CONSTRAINT H_TFVBSLNT_FK1 FOREIGN KEY (SLOC_METRICS_ID)
	REFERENCES F_TEXT_FILE_VER_BSLN_METRICS (SLOC_METRICS_ID) ON DELETE CASCADE;
	
ALTER TABLE H_TEXT_FILE_VERBSLN_METRICS_TO ADD CONSTRAINT H_TFVBSLNT_FK2 FOREIGN KEY (FILE_VERSION_ID)
	REFERENCES D_FILE_VERSION (FILE_VERSION_ID) ON DELETE CASCADE;	

ALTER TABLE F_MISSING_TIMESHEET_METRICS ADD CONSTRAINT F_MISSTIMSH_FK1 FOREIGN KEY (WEEK_ID)
	REFERENCES D_DATE (DATE_ID);
		
ALTER TABLE F_MISSING_TIMESHEET_METRICS ADD CONSTRAINT F_MISSTIMSH_FK3 FOREIGN KEY (RESOURCE_ID)
	REFERENCES D_RESOURCE (RESOURCE_ID);				
		
ALTER TABLE F_MISSING_TIMESHEET_METRICS ADD CONSTRAINT F_MISSTIMSH_FK4 FOREIGN KEY (PROJECT_ID)
	REFERENCES D_PROJECT (PROJECT_ID);				

ALTER TABLE F_MISSING_TIMESHEET_METRICS ADD CONSTRAINT F_MISSTIMSH_FK5 FOREIGN KEY (CHARGECODE_ID)
	REFERENCES D_CHARGECODE (CHARGECODE_ID);

ALTER TABLE F_MISSING_TIMESHEET_METRICS ADD CONSTRAINT F_MISSTIMSH_FK6 FOREIGN KEY (POOL_ID)
	REFERENCES D_POOL (POOL_ID);
		
ALTER TABLE F_MISSING_TIMESHEET_METRICS ADD CONSTRAINT F_MISSTIMSH_FK7 FOREIGN KEY (CITY_ID)
	REFERENCES D_CITY (CITY_ID);
	
ALTER TABLE F_MISSING_TIMESHEET_METRICS ADD CONSTRAINT F_MISSTIMSH_FK8 FOREIGN KEY (ORGANIZATION_ID)
	REFERENCES D_ORGANIZATION (ORGANIZATION_ID);
	
ALTER TABLE H_MISSING_TIMESHEET_METRICS ADD CONSTRAINT H_MISSTIMSH_FK1 FOREIGN KEY (TIMESHEET_METRICS_ID)
	REFERENCES F_MISSING_TIMESHEET_METRICS (TIMESHEET_METRICS_ID) ON DELETE CASCADE;
		
ALTER TABLE H_MISSING_TIMESHEET_METRICS ADD CONSTRAINT H_MISSTIMSH_FK2 FOREIGN KEY (ACTIVITY_ID)
	REFERENCES D_ACTIVITY (ACTIVITY_ID) ON DELETE CASCADE;
	
ALTER TABLE F_TIMESHEET_METRICS ADD CONSTRAINT F_TIMESH_FK1 FOREIGN KEY (DATE_ID)
	REFERENCES D_DATE (DATE_ID);

ALTER TABLE F_TIMESHEET_METRICS ADD CONSTRAINT F_TIMESH_FK2 FOREIGN KEY (STATE_ID)
	REFERENCES D_TIMESHEET_STATE (STATE_ID);
		
ALTER TABLE F_TIMESHEET_METRICS ADD CONSTRAINT F_TIMESH_FK3 FOREIGN KEY (RESOURCE_ID)
	REFERENCES D_RESOURCE (RESOURCE_ID);				
		
ALTER TABLE F_TIMESHEET_METRICS ADD CONSTRAINT F_TIMESH_FK4 FOREIGN KEY (PROJECT_ID)
	REFERENCES D_PROJECT (PROJECT_ID);				
			
ALTER TABLE F_TIMESHEET_METRICS ADD CONSTRAINT F_TIMESH_FK5 FOREIGN KEY (CHARGECODE_ID)
	REFERENCES D_CHARGECODE (CHARGECODE_ID);
	
ALTER TABLE F_TIMESHEET_METRICS ADD CONSTRAINT F_TIMESH_FK6 FOREIGN KEY (POOL_ID)
	REFERENCES D_POOL (POOL_ID);
	
ALTER TABLE F_TIMESHEET_METRICS ADD CONSTRAINT F_TIMESH_FK7 FOREIGN KEY (CITY_ID)
	REFERENCES D_CITY (CITY_ID);

ALTER TABLE F_TIMESHEET_METRICS ADD CONSTRAINT F_TIMESH_FK8 FOREIGN KEY (ORGANIZATION_ID)
	REFERENCES D_ORGANIZATION (ORGANIZATION_ID);	
				
ALTER TABLE H_TIMESHEET_METRICS ADD CONSTRAINT H_TIMESH_FK1 FOREIGN KEY (TIMESHEET_METRICS_ID)
	REFERENCES F_TIMESHEET_METRICS (TIMESHEET_METRICS_ID) ON DELETE CASCADE;
		
ALTER TABLE H_TIMESHEET_METRICS ADD CONSTRAINT H_TIMESH_FK2 FOREIGN KEY (ACTIVITY_ID)
	REFERENCES D_ACTIVITY (ACTIVITY_ID) ON DELETE CASCADE;
	
ALTER TABLE F_TIMESHEET_TIMECODE_METRICS ADD CONSTRAINT F_TIMESHTC_FK1 FOREIGN KEY (DATE_ID)
	REFERENCES D_DATE (DATE_ID);

ALTER TABLE F_TIMESHEET_TIMECODE_METRICS ADD CONSTRAINT F_TIMESHTC_FK2 FOREIGN KEY (STATE_ID)
	REFERENCES D_TIMESHEET_STATE (STATE_ID);
		
ALTER TABLE F_TIMESHEET_TIMECODE_METRICS ADD CONSTRAINT F_TIMESHTC_FK3 FOREIGN KEY (RESOURCE_ID)
	REFERENCES D_RESOURCE (RESOURCE_ID);				
		
ALTER TABLE F_TIMESHEET_TIMECODE_METRICS ADD CONSTRAINT F_TIMESHTC_FK4 FOREIGN KEY (PROJECT_ID)
	REFERENCES D_PROJECT (PROJECT_ID);				
			
ALTER TABLE F_TIMESHEET_TIMECODE_METRICS ADD CONSTRAINT F_TIMESHTC_FK5 FOREIGN KEY (CHARGECODE_ID)
	REFERENCES D_CHARGECODE (CHARGECODE_ID);
	
ALTER TABLE F_TIMESHEET_TIMECODE_METRICS ADD CONSTRAINT F_TIMESHTC_FK6 FOREIGN KEY (TIMECODE_ID)
	REFERENCES D_TIMECODE (TIMECODE_ID);
	
ALTER TABLE F_TIMESHEET_TIMECODE_METRICS ADD CONSTRAINT F_TIMESHTC_FK7 FOREIGN KEY (ORGANIZATION_ID)
	REFERENCES D_ORGANIZATION (ORGANIZATION_ID);	
	
ALTER TABLE F_TIMESHEET_TIMECODE_METRICS ADD CONSTRAINT F_TIMESHTC_FK8 FOREIGN KEY (POOL_ID)
	REFERENCES D_POOL (POOL_ID);
	
ALTER TABLE F_TIMESHEET_TIMECODE_METRICS ADD CONSTRAINT F_TIMESHTC_FK9 FOREIGN KEY (CITY_ID)
	REFERENCES D_CITY (CITY_ID);
				
ALTER TABLE H_TIMESHEET_TIMECODE_METRICS ADD CONSTRAINT H_TIMESHTC_FK1 FOREIGN KEY (TIMESHEET_METRICS_ID)
	REFERENCES F_TIMESHEET_TIMECODE_METRICS (TIMESHEET_METRICS_ID) ON DELETE CASCADE;
		
ALTER TABLE H_TIMESHEET_TIMECODE_METRICS ADD CONSTRAINT H_TIMESHTC_FK2 FOREIGN KEY (ACTIVITY_ID)
	REFERENCES D_ACTIVITY (ACTIVITY_ID) ON DELETE CASCADE;
		
ALTER TABLE F_WK_PROJ_RESDEMSUPP_METRICS ADD CONSTRAINT F_WPJRESDSMET_FK1 FOREIGN KEY (WEEK_ID)
	REFERENCES D_DATE (DATE_ID);

ALTER TABLE F_WK_PROJ_RESDEMSUPP_METRICS ADD CONSTRAINT F_WPJRESDSMET_FK2 FOREIGN KEY (PROJECT_ID)
	REFERENCES D_PROJECT (PROJECT_ID);

ALTER TABLE F_WK_PROJ_RESDEMSUPP_METRICS ADD CONSTRAINT F_WPJRESDSMET_FK3 FOREIGN KEY (CITY_ID)
	REFERENCES D_CITY (CITY_ID);
	
ALTER TABLE F_WK_PROJ_RESDEMSUPP_METRICS ADD CONSTRAINT F_WPJRESDSMET_FK4 FOREIGN KEY (ORGANIZATION_ID)
	REFERENCES D_ORGANIZATION (ORGANIZATION_ID);	
	
ALTER TABLE F_MO_PROJ_RESDEMSUPP_METRICS ADD CONSTRAINT F_MPJRESDSMET_FK1 FOREIGN KEY (MONTH_ID)
	REFERENCES D_DATE (DATE_ID);

ALTER TABLE F_MO_PROJ_RESDEMSUPP_METRICS ADD CONSTRAINT F_MPJRESDSMET_FK2 FOREIGN KEY (PROJECT_ID)
	REFERENCES D_PROJECT (PROJECT_ID);

ALTER TABLE F_MO_PROJ_RESDEMSUPP_METRICS ADD CONSTRAINT F_MPJRESDSMET_FK3 FOREIGN KEY (CITY_ID)
	REFERENCES D_CITY (CITY_ID);
	
ALTER TABLE F_MO_PROJ_RESDEMSUPP_METRICS ADD CONSTRAINT F_MPJRESDSMET_FK4 FOREIGN KEY (ORGANIZATION_ID)
	REFERENCES D_ORGANIZATION (ORGANIZATION_ID);	
	
ALTER TABLE F_WK_RESOURCE_UTIL_METRICS ADD CONSTRAINT F_WRESUTILMET_FK1 FOREIGN KEY (WEEK_ID)
	REFERENCES D_DATE (DATE_ID);
	
ALTER TABLE F_WK_RESOURCE_UTIL_METRICS ADD CONSTRAINT F_WRESUTILMET_FK2 FOREIGN KEY (POOL_ID)
	REFERENCES D_POOL (POOL_ID);		

ALTER TABLE F_WK_RESOURCE_UTIL_METRICS ADD CONSTRAINT F_WRESUTILMET_FK3 FOREIGN KEY (CITY_ID)
	REFERENCES D_CITY (CITY_ID);	
		
ALTER TABLE F_WK_RESOURCE_UTIL_METRICS ADD CONSTRAINT F_WRESUTILMET_FK4 FOREIGN KEY (ORGANIZATION_ID)
	REFERENCES D_ORGANIZATION (ORGANIZATION_ID);		
	
ALTER TABLE F_MO_RESOURCE_UTIL_METRICS ADD CONSTRAINT F_MRESUTILMETT_FK1 FOREIGN KEY (MONTH_ID)
	REFERENCES D_DATE (DATE_ID);
	
ALTER TABLE F_MO_RESOURCE_UTIL_METRICS ADD CONSTRAINT F_MRESUTILMET_FK2 FOREIGN KEY (POOL_ID)
	REFERENCES D_POOL (POOL_ID);		

ALTER TABLE F_MO_RESOURCE_UTIL_METRICS ADD CONSTRAINT F_MRESUTILMET_FK3 FOREIGN KEY (CITY_ID)
	REFERENCES D_CITY (CITY_ID);	
		
ALTER TABLE F_MO_RESOURCE_UTIL_METRICS ADD CONSTRAINT F_MRESUTILMET_FK4 FOREIGN KEY (ORGANIZATION_ID)
	REFERENCES D_ORGANIZATION (ORGANIZATION_ID);		
	
ALTER TABLE F_RISK_METRICS ADD CONSTRAINT F_RISKMET_FK1 FOREIGN KEY (DATE_ID)
	REFERENCES D_DATE (DATE_ID);
	
ALTER TABLE F_RISK_METRICS ADD CONSTRAINT F_RISKMET_FK2 FOREIGN KEY (PROJECT_ID)
	REFERENCES D_PROJECT (PROJECT_ID);	
	
ALTER TABLE F_RISK_METRICS ADD CONSTRAINT F_RISKMET_FK3 FOREIGN KEY (STATE_ID)
	REFERENCES D_RISK_STATE (STATE_ID);		
	
ALTER TABLE F_RISK_METRICS ADD CONSTRAINT F_RISKMET_FK4 FOREIGN KEY (PRIORITY_ID)
	REFERENCES D_PRIORITY (PRIORITY_ID);	
	
ALTER TABLE F_RISK_METRICS ADD CONSTRAINT F_RISKMET_FK5 FOREIGN KEY (OWNER_ID)
	REFERENCES D_RESOURCE (RESOURCE_ID);		
		
ALTER TABLE F_RISK_METRICS ADD CONSTRAINT F_RISKMET_FK6 FOREIGN KEY (RELEASE_ID)
	REFERENCES D_RELEASE (RELEASE_ID);	

ALTER TABLE F_RISK_METRICS ADD CONSTRAINT F_RISKMET_FK7 FOREIGN KEY (IMPACT_RANK_ID)
	REFERENCES D_IMPACT_RANK (IMPACT_RANK_ID);		
	
ALTER TABLE F_RISK_METRICS ADD CONSTRAINT F_RISKMET_FK8 FOREIGN KEY (PROBABILITY_RANK_ID)
	REFERENCES D_PROBABILITY_RANK (PROBABILITY_RANK_ID);		
	
ALTER TABLE F_RISK_METRICS ADD CONSTRAINT F_RISKMET_FK9 FOREIGN KEY (PROBABILITY_COST_RANK_ID)
	REFERENCES D_PROBABILITY_COST_RANK (PROBABILITY_COST_RANK_ID);

ALTER TABLE F_RISK_METRICS ADD CONSTRAINT F_RISKMET_FK10 FOREIGN KEY (SCORE_RANK_ID)
	REFERENCES D_SCORE_RANK (SCORE_RANK_ID);	
	
ALTER TABLE F_C_RISK_METRICS ADD CONSTRAINT F_C_RISKMET_FK1 FOREIGN KEY (DATE_ID)
	REFERENCES D_DATE (DATE_ID);
	
ALTER TABLE F_C_RISK_METRICS ADD CONSTRAINT F_C_RISKMET_FK2 FOREIGN KEY (PROJECT_ID)
	REFERENCES D_PROJECT (PROJECT_ID);	
	
ALTER TABLE F_C_RISK_METRICS ADD CONSTRAINT F_C_RISKMET_FK3 FOREIGN KEY (STATE_ID)
	REFERENCES D_RISK_STATE (STATE_ID);		
	
ALTER TABLE F_C_RISK_METRICS ADD CONSTRAINT F_C_RISKMET_FK4 FOREIGN KEY (PRIORITY_ID)
	REFERENCES D_PRIORITY (PRIORITY_ID);	
	
ALTER TABLE F_C_RISK_METRICS ADD CONSTRAINT F_C_RISKMET_FK5 FOREIGN KEY (OWNER_ID)
	REFERENCES D_RESOURCE (RESOURCE_ID);		
		
ALTER TABLE F_C_RISK_METRICS ADD CONSTRAINT F_C_RISKMET_FK6 FOREIGN KEY (RELEASE_ID)
	REFERENCES D_RELEASE (RELEASE_ID);	

ALTER TABLE F_C_RISK_METRICS ADD CONSTRAINT F_C_RISKMET_FK7 FOREIGN KEY (IMPACT_RANK_ID)
	REFERENCES D_IMPACT_RANK (IMPACT_RANK_ID);		
	
ALTER TABLE F_C_RISK_METRICS ADD CONSTRAINT F_C_RISKMET_FK8 FOREIGN KEY (PROBABILITY_RANK_ID)
	REFERENCES D_PROBABILITY_RANK (PROBABILITY_RANK_ID);		
	
ALTER TABLE F_C_RISK_METRICS ADD CONSTRAINT F_C_RISKMET_FK9 FOREIGN KEY (PROBABILITY_COST_RANK_ID)
	REFERENCES D_PROBABILITY_COST_RANK (PROBABILITY_COST_RANK_ID);

ALTER TABLE F_C_RISK_METRICS ADD CONSTRAINT F_C_RISKMET_FK10 FOREIGN KEY (SCORE_RANK_ID)
	REFERENCES D_SCORE_RANK (SCORE_RANK_ID);
		
ALTER TABLE H_WK_PROJ_RESDEMSUPP_METRICS ADD CONSTRAINT H_WPJRESDSMET_FK1 FOREIGN KEY (F_PROJDS_MET_ID)
	REFERENCES F_WK_PROJ_RESDEMSUPP_METRICS (F_PROJDS_MET_ID) ON DELETE CASCADE;

ALTER TABLE H_WK_PROJ_RESDEMSUPP_METRICS ADD CONSTRAINT H_WPJRESDSMET_FK2 FOREIGN KEY (PROJECT_ALLOCATION_ID)
	REFERENCES D_PROJECT_ALLOCATION (PROJECT_ALLOCATION_ID) ON DELETE CASCADE;
	
ALTER TABLE H_MO_PROJ_RESDEMSUPP_METRICS ADD CONSTRAINT H_MPJRESDSMET_FK1 FOREIGN KEY (F_PROJDS_MET_ID)
	REFERENCES F_MO_PROJ_RESDEMSUPP_METRICS (F_PROJDS_MET_ID) ON DELETE CASCADE;

ALTER TABLE H_MO_PROJ_RESDEMSUPP_METRICS ADD CONSTRAINT H_MPJRESDSMET_FK2 FOREIGN KEY (PROJECT_ALLOCATION_ID)
	REFERENCES D_PROJECT_ALLOCATION (PROJECT_ALLOCATION_ID) ON DELETE CASCADE;	
	
ALTER TABLE H_WK_RESOURCE_UTIL_METRICS ADD CONSTRAINT H_WRESUTILMET_FK1 FOREIGN KEY (F_RESUTIL_MET_ID)
	REFERENCES F_WK_RESOURCE_UTIL_METRICS (F_RESUTIL_MET_ID) ON DELETE CASCADE;

ALTER TABLE H_WK_RESOURCE_UTIL_METRICS ADD CONSTRAINT H_WRESUTILMET_FK2 FOREIGN KEY (RESOURCE_ID)
	REFERENCES D_RESOURCE (RESOURCE_ID) ON DELETE CASCADE;

ALTER TABLE H_MO_RESOURCE_UTIL_METRICS ADD CONSTRAINT H_MRESUTILMET_FK1 FOREIGN KEY (F_RESUTIL_MET_ID)
	REFERENCES F_MO_RESOURCE_UTIL_METRICS (F_RESUTIL_MET_ID) ON DELETE CASCADE;

ALTER TABLE H_MO_RESOURCE_UTIL_METRICS ADD CONSTRAINT H_MRESUTILMET_FK2 FOREIGN KEY (RESOURCE_ID)
	REFERENCES D_RESOURCE (RESOURCE_ID) ON DELETE CASCADE;	
	
ALTER TABLE H_RISK_METRICS ADD CONSTRAINT H_RISKMET_FK1 FOREIGN KEY (F_RISKMET_ID)
	REFERENCES F_RISK_METRICS (F_RISKMET_ID) ON DELETE CASCADE;

ALTER TABLE H_RISK_METRICS ADD CONSTRAINT H_RISKMET_FK2 FOREIGN KEY (RISK_ID)
	REFERENCES D_RISK (RISK_ID) ON DELETE CASCADE;	  	
	
ALTER TABLE F_TASK_ITER_VARIANCE_METRICS ADD CONSTRAINT FTSKITVARMET_FK1 FOREIGN KEY (DATE_ID)
	REFERENCES D_DATE (DATE_ID);
	
ALTER TABLE F_TASK_ITER_VARIANCE_METRICS ADD CONSTRAINT FTSKITVARMET_FK2 FOREIGN KEY (BASELINE_ID)
	REFERENCES D_BASELINE (BASELINE_ID);
	
ALTER TABLE F_TASK_ITER_VARIANCE_METRICS ADD CONSTRAINT FTSKITVARMET_FK3 FOREIGN KEY (ITERATION_ID)
	REFERENCES D_ITERATION (ITERATION_ID);
	
ALTER TABLE F_TASK_ITER_VARIANCE_METRICS ADD CONSTRAINT FTSKITVARMET_FK4 FOREIGN KEY (PROJECT_ID)
	REFERENCES D_PROJECT (PROJECT_ID);	
	
ALTER TABLE F_TASK_PROJ_VARIANCE_METRICS ADD CONSTRAINT FTSKPRJVARMET_FK1 FOREIGN KEY (DATE_ID)
	REFERENCES D_DATE (DATE_ID);
	
ALTER TABLE F_TASK_PROJ_VARIANCE_METRICS ADD CONSTRAINT FTSKPRJVARMET_FK2 FOREIGN KEY (BASELINE_ID)
	REFERENCES D_BASELINE (BASELINE_ID);
	
ALTER TABLE F_TASK_PROJ_VARIANCE_METRICS ADD CONSTRAINT FTSKPRJVARMET_FK3 FOREIGN KEY (PROJECT_ID)
	REFERENCES D_PROJECT (PROJECT_ID);

ALTER TABLE F_C_TASK_ITE_VARIANCE_METRICS ADD CONSTRAINT FCTSKITVARMET_FK1 FOREIGN KEY (DATE_ID)
	REFERENCES D_DATE (DATE_ID);
	
ALTER TABLE F_C_TASK_ITE_VARIANCE_METRICS ADD CONSTRAINT FCTSKITVARMET_FK2 FOREIGN KEY (BASELINE_ID)
	REFERENCES D_BASELINE (BASELINE_ID);
	
ALTER TABLE F_C_TASK_ITE_VARIANCE_METRICS ADD CONSTRAINT FCTSKITVARMET_FK3 FOREIGN KEY (ITERATION_ID)
	REFERENCES D_ITERATION (ITERATION_ID);
	
ALTER TABLE F_C_TASK_ITE_VARIANCE_METRICS ADD CONSTRAINT FCTSKITVARMET_FK4 FOREIGN KEY (PROJECT_ID)
	REFERENCES D_PROJECT (PROJECT_ID);	
	
ALTER TABLE F_C_TASK_PRO_VARIANCE_METRICS ADD CONSTRAINT FCTSKPRVARMET_FK1 FOREIGN KEY (DATE_ID)
	REFERENCES D_DATE (DATE_ID);
	
ALTER TABLE F_C_TASK_PRO_VARIANCE_METRICS ADD CONSTRAINT FCTSKPRVARMET_FK2 FOREIGN KEY (BASELINE_ID)
	REFERENCES D_BASELINE (BASELINE_ID);
	
ALTER TABLE F_C_TASK_PRO_VARIANCE_METRICS ADD CONSTRAINT FCTSKPRVARMET_FK3 FOREIGN KEY (PROJECT_ID)
	REFERENCES D_PROJECT (PROJECT_ID);
	
ALTER TABLE H_TASK_ITER_VARIANCE_METRICS ADD CONSTRAINT HTSKITVARMET_FK1 FOREIGN KEY (F_TASKVAR_MET_ID)
	REFERENCES F_TASK_ITER_VARIANCE_METRICS (F_TASKVAR_MET_ID) ON DELETE CASCADE;

ALTER TABLE H_TASK_ITER_VARIANCE_METRICS ADD CONSTRAINT HTSKITVARMET_FK2 FOREIGN KEY (TASK_ID)
	REFERENCES D_TASK (TASK_ID) ON DELETE CASCADE;
	
ALTER TABLE H_TASK_PROJ_VARIANCE_METRICS ADD CONSTRAINT HTSKPRJVARME_FK1 FOREIGN KEY (F_TASKVAR_MET_ID)
	REFERENCES F_TASK_PROJ_VARIANCE_METRICS (F_TASKVAR_MET_ID) ON DELETE CASCADE;

ALTER TABLE H_TASK_PROJ_VARIANCE_METRICS ADD CONSTRAINT HTSKPRJVARME_FK2 FOREIGN KEY (TASK_ID)
	REFERENCES D_TASK (TASK_ID) ON DELETE CASCADE;
		
ALTER TABLE F_WK_SCPROJ_RESDEMSUP_METRICS ADD CONSTRAINT F_WSCPRDSMET_FK1 FOREIGN KEY (WEEK_ID)
	REFERENCES D_DATE (DATE_ID);

ALTER TABLE F_WK_SCPROJ_RESDEMSUP_METRICS ADD CONSTRAINT F_WSCPRDSMET_FK2 FOREIGN KEY (PROJECT_ID)
	REFERENCES D_PROJECT (PROJECT_ID);

ALTER TABLE F_WK_SCPROJ_RESDEMSUP_METRICS ADD CONSTRAINT F_WSCPRDSMET_FK3 FOREIGN KEY (CITY_ID)
	REFERENCES D_CITY (CITY_ID);
	
ALTER TABLE F_WK_SCPROJ_RESDEMSUP_METRICS ADD CONSTRAINT F_WSCPRDSMET_FK4 FOREIGN KEY (ORGANIZATION_ID)
	REFERENCES D_ORGANIZATION (ORGANIZATION_ID);	
	
ALTER TABLE F_WK_SCPROJ_RESDEMSUP_METRICS ADD CONSTRAINT F_WSCPRDSMET_FK5 FOREIGN KEY (SKILL_ID)
	REFERENCES D_SKILL (SKILL_ID);

ALTER TABLE F_WK_SCPROJ_RESDEMSUP_METRICS ADD CONSTRAINT F_WSCPRDSMET_FK6 FOREIGN KEY (COMPETENCY_ID)
	REFERENCES D_COMPETENCY (COMPETENCY_ID);		
	
ALTER TABLE H_WK_SCPROJ_RESDEMSUP_METRICS ADD CONSTRAINT H_WSCPRDSMET_FK1 FOREIGN KEY (F_PROJDS_MET_ID)
	REFERENCES F_WK_SCPROJ_RESDEMSUP_METRICS (F_PROJDS_MET_ID) ON DELETE CASCADE;

ALTER TABLE H_WK_SCPROJ_RESDEMSUP_METRICS ADD CONSTRAINT H_WSCPRDSMET_FK2 FOREIGN KEY (PROJECT_ALLOCATION_ID)
	REFERENCES D_PROJECT_ALLOCATION (PROJECT_ALLOCATION_ID) ON DELETE CASCADE;

ALTER TABLE F_WK_SKPROJ_RESDEMSUP_METRICS ADD CONSTRAINT F_WSKPRDSMET_FK1 FOREIGN KEY (WEEK_ID)
	REFERENCES D_DATE (DATE_ID);

ALTER TABLE F_WK_SKPROJ_RESDEMSUP_METRICS ADD CONSTRAINT F_WSKPRDSMET_FK2 FOREIGN KEY (PROJECT_ID)
	REFERENCES D_PROJECT (PROJECT_ID);

ALTER TABLE F_WK_SKPROJ_RESDEMSUP_METRICS ADD CONSTRAINT F_WSKPRDSMET_FK3 FOREIGN KEY (CITY_ID)
	REFERENCES D_CITY (CITY_ID);
	
ALTER TABLE F_WK_SKPROJ_RESDEMSUP_METRICS ADD CONSTRAINT F_WSKPRDSMET_FK4 FOREIGN KEY (ORGANIZATION_ID)
	REFERENCES D_ORGANIZATION (ORGANIZATION_ID);	
	
ALTER TABLE F_WK_SKPROJ_RESDEMSUP_METRICS ADD CONSTRAINT F_WSKPRDSMET_FK5 FOREIGN KEY (SKILL_ID)
	REFERENCES D_SKILL (SKILL_ID);

ALTER TABLE H_WK_SKPROJ_RESDEMSUP_METRICS ADD CONSTRAINT H_WSKPRDSMET_FK1 FOREIGN KEY (F_PROJDS_MET_ID)
	REFERENCES F_WK_SKPROJ_RESDEMSUP_METRICS (F_PROJDS_MET_ID) ON DELETE CASCADE;

ALTER TABLE H_WK_SKPROJ_RESDEMSUP_METRICS ADD CONSTRAINT H_WSKPRDSMET_FK2 FOREIGN KEY (PROJECT_ALLOCATION_ID)
	REFERENCES D_PROJECT_ALLOCATION (PROJECT_ALLOCATION_ID) ON DELETE CASCADE;

ALTER TABLE F_WK_COPROJ_RESDEMSUP_METRICS ADD CONSTRAINT F_WCOPRDSMET_FK1 FOREIGN KEY (WEEK_ID)
	REFERENCES D_DATE (DATE_ID);

ALTER TABLE F_WK_COPROJ_RESDEMSUP_METRICS ADD CONSTRAINT F_WCOPRDSMET_FK2 FOREIGN KEY (PROJECT_ID)
	REFERENCES D_PROJECT (PROJECT_ID);

ALTER TABLE F_WK_COPROJ_RESDEMSUP_METRICS ADD CONSTRAINT F_WCOPRDSMET_FK3 FOREIGN KEY (CITY_ID)
	REFERENCES D_CITY (CITY_ID);
	
ALTER TABLE F_WK_COPROJ_RESDEMSUP_METRICS ADD CONSTRAINT F_WCOPRDSMET_FK4 FOREIGN KEY (ORGANIZATION_ID)
	REFERENCES D_ORGANIZATION (ORGANIZATION_ID);	
	
ALTER TABLE F_WK_COPROJ_RESDEMSUP_METRICS ADD CONSTRAINT F_WCOPRDSMET_FK5 FOREIGN KEY (COMPETENCY_ID)
	REFERENCES D_COMPETENCY (COMPETENCY_ID);

ALTER TABLE H_WK_COPROJ_RESDEMSUP_METRICS ADD CONSTRAINT H_WCOPRDSMET_FK1 FOREIGN KEY (F_PROJDS_MET_ID)
	REFERENCES F_WK_COPROJ_RESDEMSUP_METRICS (F_PROJDS_MET_ID) ON DELETE CASCADE;

ALTER TABLE H_WK_COPROJ_RESDEMSUP_METRICS ADD CONSTRAINT H_WCOPRDSMET_FK2 FOREIGN KEY (PROJECT_ALLOCATION_ID)
	REFERENCES D_PROJECT_ALLOCATION (PROJECT_ALLOCATION_ID) ON DELETE CASCADE;
					
ALTER TABLE F_MO_SCPROJ_RESDEMSUP_METRICS ADD CONSTRAINT F_MSCPRDSMET_FK1 FOREIGN KEY (MONTH_ID)
	REFERENCES D_DATE (DATE_ID);

ALTER TABLE F_MO_SCPROJ_RESDEMSUP_METRICS ADD CONSTRAINT F_MSCPRDSMET_FK2 FOREIGN KEY (PROJECT_ID)
	REFERENCES D_PROJECT (PROJECT_ID);

ALTER TABLE F_MO_SCPROJ_RESDEMSUP_METRICS ADD CONSTRAINT F_MSCPRDSMET_FK3 FOREIGN KEY (CITY_ID)
	REFERENCES D_CITY (CITY_ID);
	
ALTER TABLE F_MO_SCPROJ_RESDEMSUP_METRICS ADD CONSTRAINT F_MSCPRDSMET_FK4 FOREIGN KEY (ORGANIZATION_ID)
	REFERENCES D_ORGANIZATION (ORGANIZATION_ID);	
	
ALTER TABLE F_MO_SCPROJ_RESDEMSUP_METRICS ADD CONSTRAINT F_MSCPRDSMET_FK5 FOREIGN KEY (SKILL_ID)
	REFERENCES D_SKILL (SKILL_ID);

ALTER TABLE F_MO_SCPROJ_RESDEMSUP_METRICS ADD CONSTRAINT F_MSCPRDSMET_FK6 FOREIGN KEY (COMPETENCY_ID)
	REFERENCES D_COMPETENCY (COMPETENCY_ID);		
	
ALTER TABLE H_MO_SCPROJ_RESDEMSUP_METRICS ADD CONSTRAINT H_MSCPRDSMET_FK1 FOREIGN KEY (F_PROJDS_MET_ID)
	REFERENCES F_MO_SCPROJ_RESDEMSUP_METRICS (F_PROJDS_MET_ID) ON DELETE CASCADE;

ALTER TABLE H_MO_SCPROJ_RESDEMSUP_METRICS ADD CONSTRAINT H_MSCPRDSMET_FK2 FOREIGN KEY (PROJECT_ALLOCATION_ID)
	REFERENCES D_PROJECT_ALLOCATION (PROJECT_ALLOCATION_ID) ON DELETE CASCADE;

ALTER TABLE F_MO_SKPROJ_RESDEMSUP_METRICS ADD CONSTRAINT F_MSKPRDSMET_FK1 FOREIGN KEY (MONTH_ID)
	REFERENCES D_DATE (DATE_ID);

ALTER TABLE F_MO_SKPROJ_RESDEMSUP_METRICS ADD CONSTRAINT F_MSKPRDSMET_FK2 FOREIGN KEY (PROJECT_ID)
	REFERENCES D_PROJECT (PROJECT_ID);

ALTER TABLE F_MO_SKPROJ_RESDEMSUP_METRICS ADD CONSTRAINT F_MSKPRDSMET_FK3 FOREIGN KEY (CITY_ID)
	REFERENCES D_CITY (CITY_ID);
	
ALTER TABLE F_MO_SKPROJ_RESDEMSUP_METRICS ADD CONSTRAINT F_MSKPRDSMET_FK4 FOREIGN KEY (ORGANIZATION_ID)
	REFERENCES D_ORGANIZATION (ORGANIZATION_ID);	
	
ALTER TABLE F_MO_SKPROJ_RESDEMSUP_METRICS ADD CONSTRAINT F_MSKPRDSMET_FK5 FOREIGN KEY (SKILL_ID)
	REFERENCES D_SKILL (SKILL_ID);

ALTER TABLE H_MO_SKPROJ_RESDEMSUP_METRICS ADD CONSTRAINT H_MSKPRDSMET_FK1 FOREIGN KEY (F_PROJDS_MET_ID)
	REFERENCES F_MO_SKPROJ_RESDEMSUP_METRICS (F_PROJDS_MET_ID) ON DELETE CASCADE;

ALTER TABLE H_MO_SKPROJ_RESDEMSUP_METRICS ADD CONSTRAINT H_MSKPRDSMET_FK2 FOREIGN KEY (PROJECT_ALLOCATION_ID)
	REFERENCES D_PROJECT_ALLOCATION (PROJECT_ALLOCATION_ID) ON DELETE CASCADE;

ALTER TABLE F_MO_COPROJ_RESDEMSUP_METRICS ADD CONSTRAINT F_MCOPRDSMET_FK1 FOREIGN KEY (MONTH_ID)
	REFERENCES D_DATE (DATE_ID);

ALTER TABLE F_MO_COPROJ_RESDEMSUP_METRICS ADD CONSTRAINT F_MCOPRDSMET_FK2 FOREIGN KEY (PROJECT_ID)
	REFERENCES D_PROJECT (PROJECT_ID);

ALTER TABLE F_MO_COPROJ_RESDEMSUP_METRICS ADD CONSTRAINT F_MCOPRDSMET_FK3 FOREIGN KEY (CITY_ID)
	REFERENCES D_CITY (CITY_ID);
	
ALTER TABLE F_MO_COPROJ_RESDEMSUP_METRICS ADD CONSTRAINT F_MCOPRDSMET_FK4 FOREIGN KEY (ORGANIZATION_ID)
	REFERENCES D_ORGANIZATION (ORGANIZATION_ID);	
	
ALTER TABLE F_MO_COPROJ_RESDEMSUP_METRICS ADD CONSTRAINT F_MCOPRDSMET_FK5 FOREIGN KEY (COMPETENCY_ID)
	REFERENCES D_COMPETENCY (COMPETENCY_ID);

ALTER TABLE H_MO_COPROJ_RESDEMSUP_METRICS ADD CONSTRAINT H_MCOPRDSMET_FK1 FOREIGN KEY (F_PROJDS_MET_ID)
	REFERENCES F_MO_COPROJ_RESDEMSUP_METRICS (F_PROJDS_MET_ID) ON DELETE CASCADE;

ALTER TABLE H_MO_COPROJ_RESDEMSUP_METRICS ADD CONSTRAINT H_MCOPRDSMET_FK2 FOREIGN KEY (PROJECT_ALLOCATION_ID)
	REFERENCES D_PROJECT_ALLOCATION (PROJECT_ALLOCATION_ID) ON DELETE CASCADE;

ALTER TABLE F_WK_SCRESOURCE_UTIL_METRICS ADD CONSTRAINT F_WSCRESUTMET_FK1 FOREIGN KEY (WEEK_ID)
	REFERENCES D_DATE (DATE_ID);
	
ALTER TABLE F_WK_SCRESOURCE_UTIL_METRICS ADD CONSTRAINT F_WSCRESUTMET_FK2 FOREIGN KEY (POOL_ID)
	REFERENCES D_POOL (POOL_ID);			

ALTER TABLE F_WK_SCRESOURCE_UTIL_METRICS ADD CONSTRAINT F_WSCRESUTMET_FK3 FOREIGN KEY (CITY_ID)
	REFERENCES D_CITY (CITY_ID);	
		
ALTER TABLE F_WK_SCRESOURCE_UTIL_METRICS ADD CONSTRAINT F_WSCRESUTMET_FK4 FOREIGN KEY (ORGANIZATION_ID)
	REFERENCES D_ORGANIZATION (ORGANIZATION_ID);		
	
ALTER TABLE F_WK_SCRESOURCE_UTIL_METRICS ADD CONSTRAINT F_WSCRESUTMET_FK5 FOREIGN KEY (SKILL_ID)
	REFERENCES D_SKILL (SKILL_ID);	
		
ALTER TABLE F_WK_SCRESOURCE_UTIL_METRICS ADD CONSTRAINT F_WSCRESUTMET_FK6 FOREIGN KEY (COMPETENCY_ID)
	REFERENCES D_COMPETENCY (COMPETENCY_ID);	

ALTER TABLE H_WK_SCRESOURCE_UTIL_METRICS ADD CONSTRAINT H_WSCRESUTMET_FK1 FOREIGN KEY (F_RESUTIL_MET_ID)
	REFERENCES F_WK_SCRESOURCE_UTIL_METRICS (F_RESUTIL_MET_ID) ON DELETE CASCADE;

ALTER TABLE H_WK_SCRESOURCE_UTIL_METRICS ADD CONSTRAINT H_WSCRESUTMET_FK2 FOREIGN KEY (RESOURCE_ID)
	REFERENCES D_RESOURCE (RESOURCE_ID) ON DELETE CASCADE;

ALTER TABLE F_WK_SKRESOURCE_UTIL_METRICS ADD CONSTRAINT F_WSKRESUTMET_FK1 FOREIGN KEY (WEEK_ID)
	REFERENCES D_DATE (DATE_ID);
	
ALTER TABLE F_WK_SKRESOURCE_UTIL_METRICS ADD CONSTRAINT F_WSKRESUTMET_FK2 FOREIGN KEY (POOL_ID)
	REFERENCES D_POOL (POOL_ID);		

ALTER TABLE F_WK_SKRESOURCE_UTIL_METRICS ADD CONSTRAINT F_WSKRESUTMET_FK3 FOREIGN KEY (CITY_ID)
	REFERENCES D_CITY (CITY_ID);	
		
ALTER TABLE F_WK_SKRESOURCE_UTIL_METRICS ADD CONSTRAINT F_WSKRESUTMET_FK4 FOREIGN KEY (ORGANIZATION_ID)
	REFERENCES D_ORGANIZATION (ORGANIZATION_ID);		
	
ALTER TABLE F_WK_SKRESOURCE_UTIL_METRICS ADD CONSTRAINT F_WSKRESUTMET_FK5 FOREIGN KEY (SKILL_ID)
	REFERENCES D_SKILL (SKILL_ID);	
	
ALTER TABLE H_WK_SKRESOURCE_UTIL_METRICS ADD CONSTRAINT H_WSKRESUTMET_FK1 FOREIGN KEY (F_RESUTIL_MET_ID)
	REFERENCES F_WK_SKRESOURCE_UTIL_METRICS (F_RESUTIL_MET_ID) ON DELETE CASCADE;

ALTER TABLE H_WK_SKRESOURCE_UTIL_METRICS ADD CONSTRAINT H_WSKRESUTMET_FK2 FOREIGN KEY (RESOURCE_ID)
	REFERENCES D_RESOURCE (RESOURCE_ID) ON DELETE CASCADE;

ALTER TABLE F_WK_CORESOURCE_UTIL_METRICS ADD CONSTRAINT F_WCORESUTMET_FK1 FOREIGN KEY (WEEK_ID)
	REFERENCES D_DATE (DATE_ID);
	
ALTER TABLE F_WK_CORESOURCE_UTIL_METRICS ADD CONSTRAINT F_WCORESUTMET_FK2 FOREIGN KEY (POOL_ID)
	REFERENCES D_POOL (POOL_ID);		

ALTER TABLE F_WK_CORESOURCE_UTIL_METRICS ADD CONSTRAINT F_WCORESUTMET_FK3 FOREIGN KEY (CITY_ID)
	REFERENCES D_CITY (CITY_ID);	
		
ALTER TABLE F_WK_CORESOURCE_UTIL_METRICS ADD CONSTRAINT F_WCORESUTMET_FK4 FOREIGN KEY (ORGANIZATION_ID)
	REFERENCES D_ORGANIZATION (ORGANIZATION_ID);		
	
ALTER TABLE F_WK_CORESOURCE_UTIL_METRICS ADD CONSTRAINT F_WCORESUTMET_FK5 FOREIGN KEY (COMPETENCY_ID)
	REFERENCES D_COMPETENCY (COMPETENCY_ID);	

ALTER TABLE H_WK_CORESOURCE_UTIL_METRICS ADD CONSTRAINT H_WCORESUTMET_FK1 FOREIGN KEY (F_RESUTIL_MET_ID)
	REFERENCES F_WK_CORESOURCE_UTIL_METRICS (F_RESUTIL_MET_ID) ON DELETE CASCADE;

ALTER TABLE H_WK_CORESOURCE_UTIL_METRICS ADD CONSTRAINT H_WCORESUTMET_FK2 FOREIGN KEY (RESOURCE_ID)
	REFERENCES D_RESOURCE (RESOURCE_ID) ON DELETE CASCADE;
							
ALTER TABLE F_MO_SCRESOURCE_UTIL_METRICS ADD CONSTRAINT F_MSCRESUTMET_FK1 FOREIGN KEY (MONTH_ID)
	REFERENCES D_DATE (DATE_ID);
	
ALTER TABLE F_MO_SCRESOURCE_UTIL_METRICS ADD CONSTRAINT F_MSCRESUTMET_FK2 FOREIGN KEY (POOL_ID)
	REFERENCES D_POOL (POOL_ID);				

ALTER TABLE F_MO_SCRESOURCE_UTIL_METRICS ADD CONSTRAINT F_MSCRESUTMET_FK3 FOREIGN KEY (CITY_ID)
	REFERENCES D_CITY (CITY_ID);	
		
ALTER TABLE F_MO_SCRESOURCE_UTIL_METRICS ADD CONSTRAINT F_MSCRESUTMET_FK4 FOREIGN KEY (ORGANIZATION_ID)
	REFERENCES D_ORGANIZATION (ORGANIZATION_ID);		
	
ALTER TABLE F_MO_SCRESOURCE_UTIL_METRICS ADD CONSTRAINT F_MSCRESUTMET_FK5 FOREIGN KEY (SKILL_ID)
	REFERENCES D_SKILL (SKILL_ID);	
		
ALTER TABLE F_MO_SCRESOURCE_UTIL_METRICS ADD CONSTRAINT F_MSCRESUTMET_FK6 FOREIGN KEY (COMPETENCY_ID)
	REFERENCES D_COMPETENCY (COMPETENCY_ID);	

ALTER TABLE H_MO_SCRESOURCE_UTIL_METRICS ADD CONSTRAINT H_MSCRESUTMET_FK1 FOREIGN KEY (F_RESUTIL_MET_ID)
	REFERENCES F_MO_SCRESOURCE_UTIL_METRICS (F_RESUTIL_MET_ID) ON DELETE CASCADE;

ALTER TABLE H_MO_SCRESOURCE_UTIL_METRICS ADD CONSTRAINT H_MSCRESUTMET_FK2 FOREIGN KEY (RESOURCE_ID)
	REFERENCES D_RESOURCE (RESOURCE_ID) ON DELETE CASCADE;

ALTER TABLE F_MO_SKRESOURCE_UTIL_METRICS ADD CONSTRAINT F_MSKRESUTMET_FK1 FOREIGN KEY (MONTH_ID)
	REFERENCES D_DATE (DATE_ID);
	
ALTER TABLE F_MO_SKRESOURCE_UTIL_METRICS ADD CONSTRAINT F_MSKRESUTMET_FK2 FOREIGN KEY (POOL_ID)
	REFERENCES D_POOL (POOL_ID);			

ALTER TABLE F_MO_SKRESOURCE_UTIL_METRICS ADD CONSTRAINT F_MSKRESUTMET_FK3 FOREIGN KEY (CITY_ID)
	REFERENCES D_CITY (CITY_ID);	
		
ALTER TABLE F_MO_SKRESOURCE_UTIL_METRICS ADD CONSTRAINT F_MSKRESUTMET_FK4 FOREIGN KEY (ORGANIZATION_ID)
	REFERENCES D_ORGANIZATION (ORGANIZATION_ID);		
	
ALTER TABLE F_MO_SKRESOURCE_UTIL_METRICS ADD CONSTRAINT F_MSKRESUTMET_FK5 FOREIGN KEY (SKILL_ID)
	REFERENCES D_SKILL (SKILL_ID);	

ALTER TABLE H_MO_SKRESOURCE_UTIL_METRICS ADD CONSTRAINT H_MSKRESUTMET_FK1 FOREIGN KEY (F_RESUTIL_MET_ID)
	REFERENCES F_MO_SKRESOURCE_UTIL_METRICS (F_RESUTIL_MET_ID) ON DELETE CASCADE;

ALTER TABLE H_MO_SKRESOURCE_UTIL_METRICS ADD CONSTRAINT H_MSKRESUTMET_FK2 FOREIGN KEY (RESOURCE_ID)
	REFERENCES D_RESOURCE (RESOURCE_ID) ON DELETE CASCADE;

ALTER TABLE F_MO_CORESOURCE_UTIL_METRICS ADD CONSTRAINT F_MCORESUTMET_FK1 FOREIGN KEY (MONTH_ID)
	REFERENCES D_DATE (DATE_ID);
	
ALTER TABLE F_MO_CORESOURCE_UTIL_METRICS ADD CONSTRAINT F_MCORESUTMET_FK2 FOREIGN KEY (POOL_ID)
	REFERENCES D_POOL (POOL_ID);		

ALTER TABLE F_MO_CORESOURCE_UTIL_METRICS ADD CONSTRAINT F_MCORESUTMET_FK4 FOREIGN KEY (CITY_ID)
	REFERENCES D_CITY (CITY_ID);	
		
ALTER TABLE F_MO_CORESOURCE_UTIL_METRICS ADD CONSTRAINT F_MCORESUTMET_FK5 FOREIGN KEY (ORGANIZATION_ID)
	REFERENCES D_ORGANIZATION (ORGANIZATION_ID);		
	
ALTER TABLE F_MO_CORESOURCE_UTIL_METRICS ADD CONSTRAINT F_MCORESUTMET_FK6 FOREIGN KEY (COMPETENCY_ID)
	REFERENCES D_COMPETENCY (COMPETENCY_ID);	
	
ALTER TABLE H_MO_CORESOURCE_UTIL_METRICS ADD CONSTRAINT H_MCORESUTMET_FK1 FOREIGN KEY (F_RESUTIL_MET_ID)
	REFERENCES F_MO_CORESOURCE_UTIL_METRICS (F_RESUTIL_MET_ID) ON DELETE CASCADE;

ALTER TABLE H_MO_CORESOURCE_UTIL_METRICS ADD CONSTRAINT H_MCORESUTMET_FK2 FOREIGN KEY (RESOURCE_ID)
	REFERENCES D_RESOURCE (RESOURCE_ID) ON DELETE CASCADE;

ALTER TABLE H_BUILD_REQU_FAIL  ADD CONSTRAINT  H_BLD_REQUFAIL_FK1 FOREIGN KEY (BUILD_METRIC_ID)
 	REFERENCES F_BUILD_REQU_METRICS (BUILD_METRIC_ID) ON DELETE CASCADE;
 	
ALTER TABLE H_BUILD_REQU_FAIL  ADD CONSTRAINT  H_BLD_REQUFAIL_FK2 FOREIGN KEY (BUILD_ID) 
  REFERENCES D_BUILD (BUILD_ID) ON DELETE CASCADE;

ALTER TABLE H_BUILD_REQU_PASS  ADD CONSTRAINT  H_BLD_REQUPASS_FK1 FOREIGN KEY (BUILD_METRIC_ID) 
 	REFERENCES F_BUILD_REQU_METRICS (BUILD_METRIC_ID) ON DELETE CASCADE;

ALTER TABLE H_BUILD_REQU_PASS  ADD CONSTRAINT  H_BLD_REQUPASS_FK2 FOREIGN KEY (BUILD_ID) 
  REFERENCES D_BUILD (BUILD_ID) ON DELETE CASCADE;
													
ALTER TABLE F_STORY_METRICS ADD CONSTRAINT F_STORY_FK1 FOREIGN KEY (DATE_ID)
	REFERENCES D_DATE (DATE_ID);
	
ALTER TABLE F_STORY_METRICS ADD CONSTRAINT F_STORY_FK2 FOREIGN KEY (PROJECT_ID)
	REFERENCES D_PROJECT (PROJECT_ID);

ALTER TABLE F_STORY_METRICS ADD CONSTRAINT F_STORY_FK3 FOREIGN KEY (ITERATION_ID)
	REFERENCES D_ITERATION (ITERATION_ID);

ALTER TABLE F_STORY_METRICS ADD CONSTRAINT F_STORY_FK4 FOREIGN KEY (TEAM_ID)
	REFERENCES D_TEAM (TEAM_ID);

ALTER TABLE F_STORY_METRICS ADD CONSTRAINT F_STORY_FK5 FOREIGN KEY (OWNER_ID)
	REFERENCES D_RESOURCE (RESOURCE_ID);

ALTER TABLE F_STORY_METRICS ADD CONSTRAINT F_STORY_FK6 FOREIGN KEY (REQUEST_CLASS_ID)
	REFERENCES D_REQUEST_CLASSIFICATION (REQUEST_CLASS_ID);

ALTER TABLE F_STORY_METRICS ADD CONSTRAINT F_STORY_FK7 FOREIGN KEY (REQUEST_CATEGORY_ID)
	REFERENCES D_REQUEST_CATEGORY (REQUEST_CATEGORY_ID);

ALTER TABLE F_STORY_METRICS ADD CONSTRAINT F_STORY_FK8 FOREIGN KEY (REQUEST_TYPE_ID)
	REFERENCES D_REQUEST_TYPE (REQUEST_TYPE_ID);

ALTER TABLE F_STORY_METRICS ADD CONSTRAINT F_STORY_FK9 FOREIGN KEY (STATE_ID)
	REFERENCES D_REQUEST_STATE (STATE_ID);
	
ALTER TABLE F_STORY_METRICS ADD CONSTRAINT F_STORY_FK10 FOREIGN KEY (SEVERITY_ID)
	REFERENCES D_REQUEST_SEVERITY (SEVERITY_ID);	

ALTER TABLE F_STORY_METRICS ADD CONSTRAINT F_STORY_FK11 FOREIGN KEY (PRIORITY_ID)
	REFERENCES D_REQUEST_PRIORITY (PRIORITY_ID);	
	
ALTER TABLE F_C_STORY_METRICS ADD CONSTRAINT F_CSTORY_FK1 FOREIGN KEY (DATE_ID)
	REFERENCES D_DATE (DATE_ID);
	
ALTER TABLE F_C_STORY_METRICS ADD CONSTRAINT F_CSTORY_FK2 FOREIGN KEY (PROJECT_ID)
	REFERENCES D_PROJECT (PROJECT_ID);

ALTER TABLE F_C_STORY_METRICS ADD CONSTRAINT F_CSTORY_FK3 FOREIGN KEY (ITERATION_ID)
	REFERENCES D_ITERATION (ITERATION_ID);

ALTER TABLE F_C_STORY_METRICS ADD CONSTRAINT F_CSTORY_FK4 FOREIGN KEY (TEAM_ID)
	REFERENCES D_TEAM (TEAM_ID);

ALTER TABLE F_C_STORY_METRICS ADD CONSTRAINT F_CSTORY_FK5 FOREIGN KEY (OWNER_ID)
	REFERENCES D_RESOURCE (RESOURCE_ID);

ALTER TABLE F_C_STORY_METRICS ADD CONSTRAINT F_CSTORY_FK6 FOREIGN KEY (REQUEST_CLASS_ID)
	REFERENCES D_REQUEST_CLASSIFICATION (REQUEST_CLASS_ID);

ALTER TABLE F_C_STORY_METRICS ADD CONSTRAINT F_CSTORY_FK7 FOREIGN KEY (REQUEST_CATEGORY_ID)
	REFERENCES D_REQUEST_CATEGORY (REQUEST_CATEGORY_ID);

ALTER TABLE F_C_STORY_METRICS ADD CONSTRAINT F_CSTORY_FK8 FOREIGN KEY (REQUEST_TYPE_ID)
	REFERENCES D_REQUEST_TYPE (REQUEST_TYPE_ID);

ALTER TABLE F_C_STORY_METRICS ADD CONSTRAINT F_CSTORY_FK9 FOREIGN KEY (STATE_ID)
	REFERENCES D_REQUEST_STATE (STATE_ID);
	
ALTER TABLE F_C_STORY_METRICS ADD CONSTRAINT F_CSTORY_FK10 FOREIGN KEY (SEVERITY_ID)
	REFERENCES D_REQUEST_SEVERITY (SEVERITY_ID);		

ALTER TABLE F_C_STORY_METRICS ADD CONSTRAINT F_CSTORY_FK11 FOREIGN KEY (PRIORITY_ID)
	REFERENCES D_REQUEST_PRIORITY (PRIORITY_ID);	
	
ALTER TABLE H_STORY_METRICS ADD CONSTRAINT HSTORYPOINTS_FK1 FOREIGN KEY (F_STORY_METRIC_ID)
	REFERENCES F_STORY_METRICS (F_STORY_METRIC_ID) ON DELETE CASCADE;

ALTER TABLE H_STORY_METRICS ADD CONSTRAINT HSTORYPOINTS_FK2 FOREIGN KEY (REQUEST_ID)
	REFERENCES D_REQUEST (REQUEST_ID) ON DELETE CASCADE;

ALTER TABLE F_REQUEST_FAILURE_DT_METRICS ADD CONSTRAINT F_REQFAIL_DTM_FK1 FOREIGN KEY (FAIL_DATE_ID)
		REFERENCES D_DATE (DATE_ID);

ALTER TABLE F_REQUEST_FAILURE_DT_METRICS ADD CONSTRAINT F_REQFAIL_DTM_FK2 FOREIGN KEY (RELEASE_ID)
		REFERENCES D_RELEASE (RELEASE_ID);

ALTER TABLE F_REQUEST_FAILURE_DT_METRICS ADD CONSTRAINT F_REQFAIL_DTM_FK3 FOREIGN KEY (PROJECT_ID)
		REFERENCES D_PROJECT (PROJECT_ID);
		
ALTER TABLE F_REQUEST_FAILURE_DT_METRICS ADD CONSTRAINT F_REQFAIL_DTM_FK4 FOREIGN KEY (COMPONENT_ID)
		REFERENCES D_COMPONENT (COMPONENT_ID);

ALTER TABLE F_REQUEST_FAILURE_DT_METRICS ADD CONSTRAINT F_REQFAIL_DTM_FK5 FOREIGN KEY (ITERATION_ID)
		REFERENCES D_ITERATION (ITERATION_ID);

ALTER TABLE H_REQUEST_FAILURE_DT_METRICS ADD CONSTRAINT H_REQFAIL_DTM_FK1 FOREIGN KEY (REQFAIL_METRIC_ID)
		REFERENCES F_REQUEST_FAILURE_DT_METRICS (REQFAIL_METRIC_ID) ON DELETE CASCADE;										

ALTER TABLE H_REQUEST_FAILURE_DT_METRICS ADD CONSTRAINT H_REQFAIL_DTM_FK2 FOREIGN KEY (REQUEST_ID)
		REFERENCES D_REQUEST (REQUEST_ID) ON DELETE CASCADE;	

ALTER TABLE F_REQUEST_TPLN_FAILDT_METRICS ADD CONSTRAINT F_REQTPLN_FDT_FK1 FOREIGN KEY (FAIL_DATE_ID)
		REFERENCES D_DATE (DATE_ID);

ALTER TABLE F_REQUEST_TPLN_FAILDT_METRICS ADD CONSTRAINT F_REQTPLN_FDT_FK2 FOREIGN KEY (RELEASE_ID)
		REFERENCES D_RELEASE (RELEASE_ID);

ALTER TABLE F_REQUEST_TPLN_FAILDT_METRICS ADD CONSTRAINT F_REQTPLN_FDT_FK3 FOREIGN KEY (PROJECT_ID)
		REFERENCES D_PROJECT (PROJECT_ID);
		
ALTER TABLE F_REQUEST_TPLN_FAILDT_METRICS ADD CONSTRAINT F_REQTPLN_FDT_FK4 FOREIGN KEY (COMPONENT_ID)
		REFERENCES D_COMPONENT (COMPONENT_ID);

ALTER TABLE F_REQUEST_TPLN_FAILDT_METRICS ADD CONSTRAINT F_REQTPLN_FDT_FK5 FOREIGN KEY (ITERATION_ID)
		REFERENCES D_ITERATION (ITERATION_ID);

ALTER TABLE F_REQUEST_TPLN_FAILDT_METRICS ADD CONSTRAINT F_REQTPLN_FDT_FK6 FOREIGN KEY (TESTPLAN_ID)
		REFERENCES D_TESTPLAN (TESTPLAN_ID);

ALTER TABLE H_REQUEST_TPLN_FAILDT_METRICS ADD CONSTRAINT H_REQTPLN_FDT_FK1 FOREIGN KEY (REQFAIL_METRIC_ID)
		REFERENCES F_REQUEST_TPLN_FAILDT_METRICS (REQFAIL_METRIC_ID) ON DELETE CASCADE;										

ALTER TABLE H_REQUEST_TPLN_FAILDT_METRICS ADD CONSTRAINT H_REQTPLN_FDT_FK2 FOREIGN KEY (REQUEST_ID)
		REFERENCES D_REQUEST (REQUEST_ID) ON DELETE CASCADE;	

ALTER TABLE F_REQUEST_REQUI_FAILDT_METRICS ADD CONSTRAINT F_REQREQUI_FDT_FK1 FOREIGN KEY (DATE_ID)
		REFERENCES D_DATE (DATE_ID);

ALTER TABLE F_REQUEST_REQUI_FAILDT_METRICS ADD CONSTRAINT F_REQREQUI_FDT_FK2 FOREIGN KEY (RELEASE_ID)
		REFERENCES D_RELEASE (RELEASE_ID);

ALTER TABLE F_REQUEST_REQUI_FAILDT_METRICS ADD CONSTRAINT F_REQREQUI_FDT_FK3 FOREIGN KEY (PROJECT_ID)
		REFERENCES D_PROJECT (PROJECT_ID);
		
ALTER TABLE F_REQUEST_REQUI_FAILDT_METRICS ADD CONSTRAINT F_REQREQUI_FDT_FK4 FOREIGN KEY (COMPONENT_ID)
		REFERENCES D_COMPONENT (COMPONENT_ID);

ALTER TABLE F_REQUEST_REQUI_FAILDT_METRICS ADD CONSTRAINT F_REQREQUI_FDT_FK5 FOREIGN KEY (ITERATION_ID)
		REFERENCES D_ITERATION (ITERATION_ID);

ALTER TABLE F_REQUEST_REQUI_FAILDT_METRICS ADD CONSTRAINT F_REQREQUI_FDT_FK6 FOREIGN KEY (REQUIREMENT_ID)
		REFERENCES D_REQUIREMENT (REQUIREMENT_ID);

ALTER TABLE H_REQUEST_REQUI_FAILDT_METRICS ADD CONSTRAINT H_REQREQUI_FDT_FK1 FOREIGN KEY (REQFAIL_METRIC_ID)
		REFERENCES F_REQUEST_REQUI_FAILDT_METRICS (REQFAIL_METRIC_ID) ON DELETE CASCADE;										

ALTER TABLE H_REQUEST_REQUI_FAILDT_METRICS ADD CONSTRAINT H_REQREQUI_FDT_FK2 FOREIGN KEY (REQUEST_ID)
		REFERENCES D_REQUEST (REQUEST_ID) ON DELETE CASCADE;	

ALTER TABLE F_REQUIR_MODIF_DT_METRICS ADD CONSTRAINT F_REQMODI_DTM_FK1 FOREIGN KEY (MODIFICATION_DATE_ID)
		REFERENCES D_DATE (DATE_ID);
	
ALTER TABLE F_REQUIR_MODIF_DT_METRICS ADD CONSTRAINT F_REQMODI_DTM_FK2 FOREIGN KEY (REQUIREMENT_CLASS_ID)
	REFERENCES D_REQUIREMENT_CLASSIFICATION (REQUIREMENT_CLASS_ID);

ALTER TABLE F_REQUIR_MODIF_DT_METRICS ADD CONSTRAINT F_REQMODI_DTM_FK4 FOREIGN KEY (PROJECT_ID)
		REFERENCES D_PROJECT (PROJECT_ID);
		
ALTER TABLE F_REQUIR_MODIF_DT_METRICS ADD CONSTRAINT F_REQMODI_DTM_FK5 FOREIGN KEY (COMPONENT_ID)
		REFERENCES D_COMPONENT (COMPONENT_ID);

ALTER TABLE F_REQUIR_MODIF_DT_METRICS ADD CONSTRAINT F_REQMODI_DTM_FK6 FOREIGN KEY (ITERATION_ID)
		REFERENCES D_ITERATION (ITERATION_ID);

ALTER TABLE F_REQUIR_MODIF_DT_METRICS ADD CONSTRAINT F_REQMODI_DTM_FK7 FOREIGN KEY (RELEASE_ID)
	REFERENCES D_RELEASE (RELEASE_ID);

ALTER TABLE F_REQUIR_MODIF_DT_METRICS ADD CONSTRAINT F_REQMODI_DTM_FK8 FOREIGN KEY (RESOURCE_ID)
		REFERENCES D_RESOURCE (RESOURCE_ID);

ALTER TABLE F_REQUIR_MODIF_DT_METRICS ADD CONSTRAINT F_REQMODI_DTM_FK9 FOREIGN KEY (STATE_ID)
		REFERENCES D_REQUIREMENT_STATE (STATE_ID);

ALTER TABLE F_REQUIR_MODIF_DT_METRICS ADD CONSTRAINT F_REQMODI_DTM_FK10 FOREIGN KEY (STATUS_ID)
		REFERENCES D_STATUS (STATUS_ID);

ALTER TABLE F_REQUIR_MODIF_DT_METRICS ADD CONSTRAINT F_REQMODI_DTM_FK11 FOREIGN KEY (STABILITY_ID)
	REFERENCES D_STABILITY (STABILITY_ID);

ALTER TABLE F_REQUIR_MODIF_DT_METRICS ADD CONSTRAINT F_REQMODI_DTM_FK12 FOREIGN KEY (DIFFICULTY_ID)
	REFERENCES D_DIFFICULTY (DIFFICULTY_ID);

ALTER TABLE F_REQUIR_MODIF_DT_METRICS ADD CONSTRAINT F_REQMODI_DTM_FK13 FOREIGN KEY (PRIORITY_ID)
		REFERENCES D_PRIORITY (PRIORITY_ID);
		
ALTER TABLE F_REQUIR_MODIF_DT_METRICS ADD CONSTRAINT F_REQMODI_DTM_FK14 FOREIGN KEY (REQUIREMENT_TYPE_ID)
  REFERENCES D_REQUIREMENT_TYPE (REQUIREMENT_TYPE_ID);		

ALTER TABLE H_REQUIR_MODIF_DT_METRICS ADD CONSTRAINT H_REQMODI_DTM_FK1 FOREIGN KEY (REQ_METRIC_ID)
		REFERENCES F_REQUIR_MODIF_DT_METRICS (REQ_METRIC_ID) ON DELETE CASCADE;										

ALTER TABLE H_REQUIR_MODIF_DT_METRICS ADD CONSTRAINT H_REQMODI_DTM_FK2 FOREIGN KEY (REQUIREMENT_ID)
	REFERENCES D_REQUIREMENT (REQUIREMENT_ID) ON DELETE CASCADE;

ALTER TABLE BD_PORTFOLIO ADD CONSTRAINT BD_PORTFOLIO_FK1 FOREIGN KEY (PORTFOLIO_ID)
	REFERENCES D_PORTFOLIO (PORTFOLIO_ID);

ALTER TABLE BD_PORTFOLIO ADD CONSTRAINT BD_PORTFOLIO_FK2 FOREIGN KEY (PROGRAM_ID)
	REFERENCES D_PROGRAM (PROGRAM_ID);

ALTER TABLE BD_PORTFOLIO ADD CONSTRAINT BD_PORTFOLIO_FK3 FOREIGN KEY (PROJECT_ID)
	REFERENCES D_PROJECT (PROJECT_ID);

ALTER TABLE F_PROJECT_FINANCIAL_METRICS ADD CONSTRAINT F_PRJFINMET_FK1 FOREIGN KEY (DATE_ID)
	REFERENCES D_DATE(DATE_ID);
	
ALTER TABLE F_PROJECT_FINANCIAL_METRICS ADD CONSTRAINT F_PRJFINMET_FK2 FOREIGN KEY (PROJECT_ID)
	REFERENCES D_PROJECT (PROJECT_ID);
	
ALTER TABLE F_C_PROJECT_FINANCIAL_METRICS ADD CONSTRAINT F_CPRJFINMET_FK1 FOREIGN KEY (DATE_ID)
	REFERENCES D_DATE(DATE_ID);
	
ALTER TABLE F_C_PROJECT_FINANCIAL_METRICS ADD CONSTRAINT F_CPRJFINMET_FK2 FOREIGN KEY (PROJECT_ID)
	REFERENCES D_PROJECT (PROJECT_ID);

ALTER TABLE H_PROJECT_FINANCIAL_METRICS ADD CONSTRAINT H_PRJFINMET_FK1 FOREIGN KEY (F_PROJFIN_METRIC_ID)
	REFERENCES F_PROJECT_FINANCIAL_METRICS (F_PROJFIN_METRIC_ID);
	
ALTER TABLE H_PROJECT_FINANCIAL_METRICS ADD CONSTRAINT H_PRJFINMET_FK2 FOREIGN KEY (PROJECT_ID)
	REFERENCES D_PROJECT (PROJECT_ID);	
	
ALTER TABLE F_TP_PROJECT_FINANCIAL_METRICS ADD CONSTRAINT F_TPPRJFINMET_FK1 FOREIGN KEY (DATE_ID)
	REFERENCES D_DATE(DATE_ID);
	
ALTER TABLE F_TP_PROJECT_FINANCIAL_METRICS ADD CONSTRAINT F_TPPRJFINMET_FK2 FOREIGN KEY (PROJECT_ID)
	REFERENCES D_PROJECT (PROJECT_ID);
	
ALTER TABLE H_TP_PROJECT_FINANCIAL_METRICS ADD CONSTRAINT H_TPPRJFINMET_FK1 FOREIGN KEY (F_TPPROJFIN_METRIC_ID)
	REFERENCES F_TP_PROJECT_FINANCIAL_METRICS (F_TPPROJFIN_METRIC_ID);
	
ALTER TABLE H_TP_PROJECT_FINANCIAL_METRICS ADD CONSTRAINT H_TPPRJFINMET_FK2 FOREIGN KEY (PROJECT_ID)
	REFERENCES D_PROJECT (PROJECT_ID);	

ALTER TABLE F_ASSET_UTIL_DT_METRICS ADD CONSTRAINT F_ASTUTDT_FK1 FOREIGN KEY (DATE_ID)
	REFERENCES D_DATE (DATE_ID);       
		
ALTER TABLE F_ASSET_UTIL_DT_METRICS ADD CONSTRAINT F_ASTUTDT_FK2 FOREIGN KEY (PROJECT_ID)
	REFERENCES D_PROJECT (PROJECT_ID);
		
ALTER TABLE F_ASSET_UTIL_DT_METRICS ADD CONSTRAINT F_ASTUTDT_FK3 FOREIGN KEY (ACTION_TYPE_ID)
	REFERENCES D_ACTION_TYPE (ACTION_TYPE_ID);
		
ALTER TABLE F_ASSET_UTIL_DT_METRICS ADD CONSTRAINT F_ASTUTDT_FK4 FOREIGN KEY (RESOURCE_ID)
	REFERENCES D_RESOURCE (RESOURCE_ID);	
		
ALTER TABLE F_ASSET_UTIL_DT_METRICS ADD CONSTRAINT F_ASTUTDT_FK5 FOREIGN KEY (ASSET_ID)
	REFERENCES D_ASSET (ASSET_ID);	
	
ALTER TABLE F_ASSET_UTIL_DT_METRICS ADD CONSTRAINT F_ASTUTDT_FK6 FOREIGN KEY (ASSET_TYPE_ID)
	REFERENCES D_ASSET_TYPE (ASSET_TYPE_ID);		
		
ALTER TABLE F_LICENSE_DT_METRICS ADD CONSTRAINT F_LICDTMET_FK1 FOREIGN KEY (DATE_ID)
	REFERENCES D_DATE (DATE_ID);       
		
ALTER TABLE F_LICENSE_DT_METRICS ADD CONSTRAINT F_LICDTMET_FK2 FOREIGN KEY (PROJECT_ID)
	REFERENCES D_PROJECT (PROJECT_ID);
		
ALTER TABLE F_LICENSE_DT_METRICS ADD CONSTRAINT F_LICDTMET_FK3 FOREIGN KEY (ACTION_TYPE_ID)
	REFERENCES D_ACTION_TYPE (ACTION_TYPE_ID);
		
ALTER TABLE F_LICENSE_DT_METRICS ADD CONSTRAINT F_LICDTMET_FK4 FOREIGN KEY (RESOURCE_ID)
	REFERENCES D_RESOURCE (RESOURCE_ID);	

ALTER TABLE F_SC_BALLOT_TAB_RESULT_METRICS ADD CONSTRAINT F_BALLTABMET_FK1 FOREIGN KEY (DATE_ID)
	REFERENCES D_DATE (DATE_ID);		

ALTER TABLE F_SC_BALLOT_TAB_RESULT_METRICS ADD CONSTRAINT F_BALLTABMET_FK2 FOREIGN KEY (TEAM_ID)
	REFERENCES D_TEAM (TEAM_ID);
	
ALTER TABLE F_SC_BALLOT_TAB_RESULT_METRICS ADD CONSTRAINT F_BALLTABMET_FK3 FOREIGN KEY (BALLOT_TAB_ID)
	REFERENCES D_BALLOT_TAB (BALLOT_TAB_ID);

COMMIT;
